/**
 * @licstart The following is the entire license notice for the
 * Javascript code in this page
 *
 * Copyright 2021 Mozilla Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *
 * @licend The above is the entire license notice for the
 * Javascript code in this page
 */(()=>{"use strict";var __webpack_modules__=[,(__unused_webpack_module,exports)=>{function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}Object.defineProperty(exports,"__esModule",{value:!0}),exports.OptionKind=exports.compatibilityParams=exports.AppOptions=void 0;var compatibilityParams=Object.create(null);exports.compatibilityParams=compatibilityParams;var userAgent="undefined"!=typeof navigator&&navigator.userAgent||"",platform="undefined"!=typeof navigator&&navigator.platform||"",maxTouchPoints="undefined"!=typeof navigator&&navigator.maxTouchPoints||1,isAndroid=/Android/.test(userAgent),isIOS=/\b(iPad|iPhone|iPod)(?=;)/.test(userAgent)||"MacIntel"===platform&&maxTouchPoints>1;/CriOS/.test(userAgent)&&(compatibilityParams.disableCreateObjectURL=!0),(isIOS||isAndroid)&&(compatibilityParams.maxCanvasPixels=5242880);var OptionKind={VIEWER:2,API:4,WORKER:8,PREFERENCE:128};exports.OptionKind=OptionKind;var defaultOptions={annotationMode:{value:2,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},cursorToolOnLoad:{value:0,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},defaultUrl:{value:"compressed.tracemonkey-pldi-09.pdf",kind:OptionKind.VIEWER},defaultZoomValue:{value:"",kind:OptionKind.VIEWER+OptionKind.PREFERENCE},disableHistory:{value:!1,kind:OptionKind.VIEWER},disablePageLabels:{value:!1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},enablePermissions:{value:!1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},enablePrintAutoRotate:{value:!0,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},enableScripting:{value:!0,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},externalLinkRel:{value:"noopener noreferrer nofollow",kind:OptionKind.VIEWER},externalLinkTarget:{value:0,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},historyUpdateUrl:{value:!1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},ignoreDestinationZoom:{value:!1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},imageResourcesPath:{value:"./images/",kind:OptionKind.VIEWER},maxCanvasPixels:{value:16777216,compatibility:compatibilityParams.maxCanvasPixels,kind:OptionKind.VIEWER},pdfBugEnabled:{value:!1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},printResolution:{value:150,kind:OptionKind.VIEWER},renderer:{value:"canvas",kind:OptionKind.VIEWER},sidebarViewOnLoad:{value:-1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},scrollModeOnLoad:{value:-1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},spreadModeOnLoad:{value:-1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},textLayerMode:{value:1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},useOnlyCssZoom:{value:!1,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},viewerCssTheme:{value:0,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},viewOnLoad:{value:0,kind:OptionKind.VIEWER+OptionKind.PREFERENCE},cMapPacked:{value:!0,kind:OptionKind.API},cMapUrl:{value:"../web/cmaps/",kind:OptionKind.API},disableAutoFetch:{value:!1,kind:OptionKind.API+OptionKind.PREFERENCE},disableFontFace:{value:!1,kind:OptionKind.API+OptionKind.PREFERENCE},disableRange:{value:!1,kind:OptionKind.API+OptionKind.PREFERENCE},disableStream:{value:!1,kind:OptionKind.API+OptionKind.PREFERENCE},docBaseUrl:{value:"",kind:OptionKind.API},enableXfa:{value:!0,kind:OptionKind.API+OptionKind.PREFERENCE},fontExtraProperties:{value:!1,kind:OptionKind.API},isEvalSupported:{value:!0,kind:OptionKind.API},maxImageSize:{value:-1,kind:OptionKind.API},pdfBug:{value:!1,kind:OptionKind.API},standardFontDataUrl:{value:"../web/standard_fonts/",kind:OptionKind.API},verbosity:{value:1,kind:OptionKind.API},workerPort:{value:null,kind:OptionKind.WORKER},workerSrc:{value:"../build/pdf.worker.js",kind:OptionKind.WORKER}};defaultOptions.disablePreferences={value:!1,kind:OptionKind.VIEWER},defaultOptions.locale={value:"undefined"!=typeof navigator?navigator.language:"en-US",kind:OptionKind.VIEWER},defaultOptions.sandboxBundleSrc={value:"../build/pdf.sandbox.js",kind:OptionKind.VIEWER},defaultOptions.renderer.kind+=OptionKind.PREFERENCE;var userOptions=Object.create(null),AppOptions=function(){function AppOptions(){throw function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,AppOptions),new Error("Cannot initialize AppOptions.")}var Constructor,protoProps,staticProps;return Constructor=AppOptions,staticProps=[{key:"get",value:function(name){var userOption=userOptions[name];if(void 0!==userOption)return userOption;var _defaultOption$compat,defaultOption=defaultOptions[name];return void 0!==defaultOption?null!==(_defaultOption$compat=defaultOption.compatibility)&&void 0!==_defaultOption$compat?_defaultOption$compat:defaultOption.value:void 0}},{key:"getAll",value:function(){var kind=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null,options=Object.create(null);for(var name in defaultOptions){var _defaultOption$compat2,defaultOption=defaultOptions[name];if(kind){if(0==(kind&defaultOption.kind))continue;if(kind===OptionKind.PREFERENCE){var value=defaultOption.value,valueType=_typeof(value);if("boolean"===valueType||"string"===valueType||"number"===valueType&&Number.isInteger(value)){options[name]=value;continue}throw new Error("Invalid type for preference: ".concat(name))}}var userOption=userOptions[name];options[name]=void 0!==userOption?userOption:null!==(_defaultOption$compat2=defaultOption.compatibility)&&void 0!==_defaultOption$compat2?_defaultOption$compat2:defaultOption.value}return options}},{key:"set",value:function(name,value){userOptions[name]=value}},{key:"setAll",value:function(options){for(var name in options)userOptions[name]=options[name]}},{key:"remove",value:function(name){delete userOptions[name]}}],(protoProps=null)&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),AppOptions}();exports.AppOptions=AppOptions},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFViewerApplication=exports.PDFPrintServiceFactory=exports.DefaultExternalServices=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_ui_utils=__webpack_require__(5),_app_options=__webpack_require__(1),_pdfjsLib=__webpack_require__(6),_pdf_cursor_tools=__webpack_require__(7),_pdf_rendering_queue=__webpack_require__(9),_overlay_manager=__webpack_require__(10),_password_prompt=__webpack_require__(11),_pdf_attachment_viewer=__webpack_require__(12),_pdf_document_properties=__webpack_require__(14),_pdf_find_bar=__webpack_require__(15),_pdf_find_controller=__webpack_require__(16),_pdf_history=__webpack_require__(18),_pdf_layer_viewer=__webpack_require__(19),_pdf_link_service=__webpack_require__(20),_pdf_outline_viewer=__webpack_require__(21),_pdf_presentation_mode=__webpack_require__(22),_pdf_scripting_manager=__webpack_require__(23),_pdf_sidebar=__webpack_require__(24),_pdf_sidebar_resizer=__webpack_require__(25),_pdf_thumbnail_viewer=__webpack_require__(26),_pdf_viewer=__webpack_require__(28),_secondary_toolbar=__webpack_require__(37),_toolbar=__webpack_require__(39),_view_history=__webpack_require__(40);function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);enumerableOnly&&(symbols=symbols.filter((function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable}))),keys.push.apply(keys,symbols)}return keys}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=null!=arguments[i]?arguments[i]:{};i%2?ownKeys(Object(source),!0).forEach((function(key){_defineProperty(target,key,source[key])})):Object.getOwnPropertyDescriptors?Object.defineProperties(target,Object.getOwnPropertyDescriptors(source)):ownKeys(Object(source)).forEach((function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))}))}return target}function _defineProperty(obj,key,value){return key in obj?Object.defineProperty(obj,key,{value:value,enumerable:!0,configurable:!0,writable:!0}):obj[key]=value,obj}function _slicedToArray(arr,i){return function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null==_i)return;var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}(arr,i)||_unsupportedIterableToArray(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e2){throw _e2},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e3){didErr=!0,err=_e3},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _unsupportedIterableToArray(o,minLen){if(o){if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);return"Object"===n&&o.constructor&&(n=o.constructor.name),"Map"===n||"Set"===n?Array.from(o):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?_arrayLikeToArray(o,minLen):void 0}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var ViewOnLoad_UNKNOWN=-1,ViewOnLoad_INITIAL=1,ViewerCssTheme={AUTOMATIC:0,LIGHT:1,DARK:2},KNOWN_VERSIONS=["1.0","1.1","1.2","1.3","1.4","1.5","1.6","1.7","1.8","1.9","2.0","2.1","2.2","2.3"],KNOWN_GENERATORS=["acrobat distiller","acrobat pdfwriter","adobe livecycle","adobe pdf library","adobe photoshop","ghostscript","tcpdf","cairo","dvipdfm","dvips","pdftex","pdfkit","itext","prince","quarkxpress","mac os x","microsoft","openoffice","oracle","luradocument","pdf-xchange","antenna house","aspose.cells","fpdf"],DefaultExternalServices=function(){function DefaultExternalServices(){throw function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,DefaultExternalServices),new Error("Cannot initialize DefaultExternalServices.")}var Constructor,protoProps,staticProps,_fallback;return Constructor=DefaultExternalServices,protoProps=null,staticProps=[{key:"updateFindControlState",value:function(data){}},{key:"updateFindMatchesCount",value:function(data){}},{key:"initPassiveLoading",value:function(callbacks){}},{key:"fallback",value:(_fallback=_asyncToGenerator(_regenerator.default.mark((function _callee(data){return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:case"end":return _context.stop()}}),_callee)}))),function(_x){return _fallback.apply(this,arguments)})},{key:"reportTelemetry",value:function(data){}},{key:"createDownloadManager",value:function(options){throw new Error("Not implemented: createDownloadManager")}},{key:"createPreferences",value:function(){throw new Error("Not implemented: createPreferences")}},{key:"createL10n",value:function(options){throw new Error("Not implemented: createL10n")}},{key:"createScripting",value:function(options){throw new Error("Not implemented: createScripting")}},{key:"supportsIntegratedFind",get:function(){return(0,_pdfjsLib.shadow)(this,"supportsIntegratedFind",!1)}},{key:"supportsDocumentFonts",get:function(){return(0,_pdfjsLib.shadow)(this,"supportsDocumentFonts",!0)}},{key:"supportedMouseWheelZoomModifierKeys",get:function(){return(0,_pdfjsLib.shadow)(this,"supportedMouseWheelZoomModifierKeys",{ctrlKey:!0,metaKey:!0})}},{key:"isInAutomation",get:function(){return(0,_pdfjsLib.shadow)(this,"isInAutomation",!1)}}],protoProps&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),DefaultExternalServices}();exports.DefaultExternalServices=DefaultExternalServices;var validateFileURL,PDFViewerApplication={initialBookmark:document.location.hash.substring(1),_initializedCapability:(0,_pdfjsLib.createPromiseCapability)(),_fellback:!1,appConfig:null,pdfDocument:null,pdfLoadingTask:null,printService:null,pdfViewer:null,pdfThumbnailViewer:null,pdfRenderingQueue:null,pdfPresentationMode:null,pdfDocumentProperties:null,pdfLinkService:null,pdfHistory:null,pdfSidebar:null,pdfSidebarResizer:null,pdfOutlineViewer:null,pdfAttachmentViewer:null,pdfLayerViewer:null,pdfCursorTools:null,pdfScriptingManager:null,store:null,downloadManager:null,overlayManager:null,preferences:null,toolbar:null,secondaryToolbar:null,eventBus:null,l10n:null,isInitialViewSet:!1,downloadComplete:!1,isViewerEmbedded:window.parent!==window,url:"",baseUrl:"",externalServices:DefaultExternalServices,_boundEvents:Object.create(null),documentInfo:null,metadata:null,_contentDispositionFilename:null,_contentLength:null,_saveInProgress:!1,_wheelUnusedTicks:0,_idleCallbacks:new Set,initialize:function(appConfig){var _this=this;return _asyncToGenerator(_regenerator.default.mark((function _callee2(){var appContainer;return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:return _this.preferences=_this.externalServices.createPreferences(),_this.appConfig=appConfig,_context2.next=4,_this._readPreferences();case 4:return _context2.next=6,_this._parseHashParameters();case 6:return _this._forceCssTheme(),_context2.next=9,_this._initializeL10n();case 9:return _this.isViewerEmbedded&&_app_options.AppOptions.get("externalLinkTarget")===_pdfjsLib.LinkTarget.NONE&&_app_options.AppOptions.set("externalLinkTarget",_pdfjsLib.LinkTarget.TOP),_context2.next=12,_this._initializeViewerComponents();case 12:_this.bindEvents(),_this.bindWindowEvents(),appContainer=appConfig.appContainer||document.documentElement,_this.l10n.translate(appContainer).then((function(){_this.eventBus.dispatch("localized",{source:_this})})),_this._initializedCapability.resolve();case 17:case"end":return _context2.stop()}}),_callee2)})))()},_readPreferences:function(){var _this2=this;return _asyncToGenerator(_regenerator.default.mark((function _callee3(){return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:if(!_app_options.AppOptions.get("disablePreferences")){_context3.next=2;break}return _context3.abrupt("return");case 2:return _context3.prev=2,_context3.t0=_app_options.AppOptions,_context3.next=6,_this2.preferences.getAll();case 6:_context3.t1=_context3.sent,_context3.t0.setAll.call(_context3.t0,_context3.t1),_context3.next=13;break;case 10:_context3.prev=10,_context3.t2=_context3.catch(2),console.error('_readPreferences: "'.concat(null===_context3.t2||void 0===_context3.t2?void 0:_context3.t2.message,'".'));case 13:case"end":return _context3.stop()}}),_callee3,null,[[2,10]])})))()},_parseHashParameters:function(){var _this3=this;return _asyncToGenerator(_regenerator.default.mark((function _callee4(){var hash,params,waitOn,enabled;return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:if(_app_options.AppOptions.get("pdfBugEnabled")){_context4.next=2;break}return _context4.abrupt("return");case 2:if(hash=document.location.hash.substring(1)){_context4.next=5;break}return _context4.abrupt("return");case 5:if(params=(0,_ui_utils.parseQueryString)(hash),waitOn=[],"true"===params.get("disableworker")&&waitOn.push(loadFakeWorker()),params.has("disablerange")&&_app_options.AppOptions.set("disableRange","true"===params.get("disablerange")),params.has("disablestream")&&_app_options.AppOptions.set("disableStream","true"===params.get("disablestream")),params.has("disableautofetch")&&_app_options.AppOptions.set("disableAutoFetch","true"===params.get("disableautofetch")),params.has("disablefontface")&&_app_options.AppOptions.set("disableFontFace","true"===params.get("disablefontface")),params.has("disablehistory")&&_app_options.AppOptions.set("disableHistory","true"===params.get("disablehistory")),params.has("verbosity")&&_app_options.AppOptions.set("verbosity",0|params.get("verbosity")),!params.has("textlayer")){_context4.next=22;break}_context4.t0=params.get("textlayer"),_context4.next="off"===_context4.t0?17:"visible"===_context4.t0||"shadow"===_context4.t0||"hover"===_context4.t0?19:22;break;case 17:return _app_options.AppOptions.set("textLayerMode",_ui_utils.TextLayerMode.DISABLE),_context4.abrupt("break",22);case 19:return _this3.appConfig.viewerContainer.classList.add("textLayer-".concat(params.get("textlayer"))),_context4.abrupt("break",22);case 22:if(params.has("pdfbug")&&(_app_options.AppOptions.set("pdfBug",!0),_app_options.AppOptions.set("fontExtraProperties",!0),enabled=params.get("pdfbug").split(","),waitOn.push(initPDFBug(enabled))),params.has("locale")&&_app_options.AppOptions.set("locale",params.get("locale")),0!==waitOn.length){_context4.next=26;break}return _context4.abrupt("return");case 26:return _context4.prev=26,_context4.next=29,Promise.all(waitOn);case 29:_context4.next=34;break;case 31:_context4.prev=31,_context4.t1=_context4.catch(26),console.error('_parseHashParameters: "'.concat(_context4.t1.message,'".'));case 34:case"end":return _context4.stop()}}),_callee4,null,[[26,31]])})))()},_initializeL10n:function(){var _this4=this;return _asyncToGenerator(_regenerator.default.mark((function _callee5(){var dir;return _regenerator.default.wrap((function(_context5){for(;;)switch(_context5.prev=_context5.next){case 0:return _this4.l10n=_this4.externalServices.createL10n({locale:_app_options.AppOptions.get("locale")}),_context5.next=3,_this4.l10n.getDirection();case 3:dir=_context5.sent,document.getElementsByTagName("html")[0].dir=dir;case 5:case"end":return _context5.stop()}}),_callee5)})))()},_forceCssTheme:function(){var cssTheme=_app_options.AppOptions.get("viewerCssTheme");if(cssTheme!==ViewerCssTheme.AUTOMATIC&&Object.values(ViewerCssTheme).includes(cssTheme))try{for(var styleSheet=document.styleSheets[0],cssRules=(null==styleSheet?void 0:styleSheet.cssRules)||[],mediaRule="(".concat("prefers-color-scheme",": dark)"),mediaRegex=new RegExp("^@media \\(".concat("prefers-color-scheme",": dark\\) {\\n\\s*([\\w\\s-.,:;/\\\\{}()]+)\\n}$")),i=0,ii=cssRules.length;i<ii;i++){var _rule$media,rule=cssRules[i];if(rule instanceof CSSMediaRule&&(null===(_rule$media=rule.media)||void 0===_rule$media?void 0:_rule$media[0])===mediaRule){if(cssTheme===ViewerCssTheme.LIGHT)return void styleSheet.deleteRule(i);var darkRules=mediaRegex.exec(rule.cssText);return void(null!=darkRules&&darkRules[1]&&(styleSheet.deleteRule(i),styleSheet.insertRule(darkRules[1],i)))}}}catch(reason){console.error('_forceCssTheme: "'.concat(null==reason?void 0:reason.message,'".'))}},_initializeViewerComponents:function(){var _this5=this;return _asyncToGenerator(_regenerator.default.mark((function _callee6(){var appConfig,eventBus,pdfRenderingQueue,pdfLinkService,downloadManager,findController,pdfScriptingManager,container,viewer;return _regenerator.default.wrap((function(_context6){for(;;)switch(_context6.prev=_context6.next){case 0:appConfig=_this5.appConfig,eventBus=appConfig.eventBus||new _ui_utils.EventBus({isInAutomation:_this5.externalServices.isInAutomation}),_this5.eventBus=eventBus,_this5.overlayManager=new _overlay_manager.OverlayManager,(pdfRenderingQueue=new _pdf_rendering_queue.PDFRenderingQueue).onIdle=_this5._cleanup.bind(_this5),_this5.pdfRenderingQueue=pdfRenderingQueue,pdfLinkService=new _pdf_link_service.PDFLinkService({eventBus:eventBus,externalLinkTarget:_app_options.AppOptions.get("externalLinkTarget"),externalLinkRel:_app_options.AppOptions.get("externalLinkRel"),ignoreDestinationZoom:_app_options.AppOptions.get("ignoreDestinationZoom")}),_this5.pdfLinkService=pdfLinkService,downloadManager=_this5.externalServices.createDownloadManager(),_this5.downloadManager=downloadManager,findController=new _pdf_find_controller.PDFFindController({linkService:pdfLinkService,eventBus:eventBus}),_this5.findController=findController,pdfScriptingManager=new _pdf_scripting_manager.PDFScriptingManager({eventBus:eventBus,sandboxBundleSrc:_app_options.AppOptions.get("sandboxBundleSrc"),scriptingFactory:_this5.externalServices,docPropertiesLookup:_this5._scriptingDocProperties.bind(_this5)}),_this5.pdfScriptingManager=pdfScriptingManager,container=appConfig.mainContainer,viewer=appConfig.viewerContainer,_this5.pdfViewer=new _pdf_viewer.PDFViewer({container:container,viewer:viewer,eventBus:eventBus,renderingQueue:pdfRenderingQueue,linkService:pdfLinkService,downloadManager:downloadManager,findController:findController,scriptingManager:_app_options.AppOptions.get("enableScripting")&&pdfScriptingManager,renderer:_app_options.AppOptions.get("renderer"),l10n:_this5.l10n,textLayerMode:_app_options.AppOptions.get("textLayerMode"),annotationMode:_app_options.AppOptions.get("annotationMode"),imageResourcesPath:_app_options.AppOptions.get("imageResourcesPath"),enablePrintAutoRotate:_app_options.AppOptions.get("enablePrintAutoRotate"),useOnlyCssZoom:_app_options.AppOptions.get("useOnlyCssZoom"),maxCanvasPixels:_app_options.AppOptions.get("maxCanvasPixels")}),pdfRenderingQueue.setViewer(_this5.pdfViewer),pdfLinkService.setViewer(_this5.pdfViewer),pdfScriptingManager.setViewer(_this5.pdfViewer),_this5.pdfThumbnailViewer=new _pdf_thumbnail_viewer.PDFThumbnailViewer({container:appConfig.sidebar.thumbnailView,eventBus:eventBus,renderingQueue:pdfRenderingQueue,linkService:pdfLinkService,l10n:_this5.l10n}),pdfRenderingQueue.setThumbnailViewer(_this5.pdfThumbnailViewer),_this5.isViewerEmbedded||_app_options.AppOptions.get("disableHistory")||(_this5.pdfHistory=new _pdf_history.PDFHistory({linkService:pdfLinkService,eventBus:eventBus}),pdfLinkService.setHistory(_this5.pdfHistory)),_this5.supportsIntegratedFind||(_this5.findBar=new _pdf_find_bar.PDFFindBar(appConfig.findBar,eventBus,_this5.l10n)),_this5.pdfDocumentProperties=new _pdf_document_properties.PDFDocumentProperties(appConfig.documentProperties,_this5.overlayManager,eventBus,_this5.l10n),_this5.pdfCursorTools=new _pdf_cursor_tools.PDFCursorTools({container:container,eventBus:eventBus,cursorToolOnLoad:_app_options.AppOptions.get("cursorToolOnLoad")}),_this5.toolbar=new _toolbar.Toolbar(appConfig.toolbar,eventBus,_this5.l10n),_this5.secondaryToolbar=new _secondary_toolbar.SecondaryToolbar(appConfig.secondaryToolbar,container,eventBus),_this5.supportsFullscreen&&(_this5.pdfPresentationMode=new _pdf_presentation_mode.PDFPresentationMode({container:container,pdfViewer:_this5.pdfViewer,eventBus:eventBus})),_this5.passwordPrompt=new _password_prompt.PasswordPrompt(appConfig.passwordOverlay,_this5.overlayManager,_this5.l10n,_this5.isViewerEmbedded),_this5.pdfOutlineViewer=new _pdf_outline_viewer.PDFOutlineViewer({container:appConfig.sidebar.outlineView,eventBus:eventBus,linkService:pdfLinkService}),_this5.pdfAttachmentViewer=new _pdf_attachment_viewer.PDFAttachmentViewer({container:appConfig.sidebar.attachmentsView,eventBus:eventBus,downloadManager:downloadManager}),_this5.pdfLayerViewer=new _pdf_layer_viewer.PDFLayerViewer({container:appConfig.sidebar.layersView,eventBus:eventBus,l10n:_this5.l10n}),_this5.pdfSidebar=new _pdf_sidebar.PDFSidebar({elements:appConfig.sidebar,pdfViewer:_this5.pdfViewer,pdfThumbnailViewer:_this5.pdfThumbnailViewer,eventBus:eventBus,l10n:_this5.l10n}),_this5.pdfSidebar.onToggled=_this5.forceRendering.bind(_this5),_this5.pdfSidebarResizer=new _pdf_sidebar_resizer.PDFSidebarResizer(appConfig.sidebarResizer,eventBus,_this5.l10n);case 37:case"end":return _context6.stop()}}),_callee6)})))()},run:function(config){this.initialize(config).then(webViewerInitialized)},get initialized(){return this._initializedCapability.settled},get initializedPromise(){return this._initializedCapability.promise},zoomIn:function(ticks){if(!this.pdfViewer.isInPresentationMode){var newScale=this.pdfViewer.currentScale;do{newScale=(1.1*newScale).toFixed(2),newScale=Math.ceil(10*newScale)/10,newScale=Math.min(_ui_utils.MAX_SCALE,newScale)}while(--ticks>0&&newScale<_ui_utils.MAX_SCALE);this.pdfViewer.currentScaleValue=newScale}},zoomOut:function(ticks){if(!this.pdfViewer.isInPresentationMode){var newScale=this.pdfViewer.currentScale;do{newScale=(newScale/1.1).toFixed(2),newScale=Math.floor(10*newScale)/10,newScale=Math.max(_ui_utils.MIN_SCALE,newScale)}while(--ticks>0&&newScale>_ui_utils.MIN_SCALE);this.pdfViewer.currentScaleValue=newScale}},zoomReset:function(){this.pdfViewer.isInPresentationMode||(this.pdfViewer.currentScaleValue=_ui_utils.DEFAULT_SCALE_VALUE)},get pagesCount(){return this.pdfDocument?this.pdfDocument.numPages:0},get page(){return this.pdfViewer.currentPageNumber},set page(val){this.pdfViewer.currentPageNumber=val},get supportsPrinting(){return PDFPrintServiceFactory.instance.supportsPrinting},get supportsFullscreen(){return(0,_pdfjsLib.shadow)(this,"supportsFullscreen",document.fullscreenEnabled||document.mozFullScreenEnabled||document.webkitFullscreenEnabled)},get supportsIntegratedFind(){return this.externalServices.supportsIntegratedFind},get supportsDocumentFonts(){return this.externalServices.supportsDocumentFonts},get loadingBar(){var bar=new _ui_utils.ProgressBar("#loadingBar");return(0,_pdfjsLib.shadow)(this,"loadingBar",bar)},get supportedMouseWheelZoomModifierKeys(){return this.externalServices.supportedMouseWheelZoomModifierKeys},initPassiveLoading:function(){throw new Error("Not implemented: initPassiveLoading")},setTitleUsingUrl:function(){var url=arguments.length>0&&void 0!==arguments[0]?arguments[0]:"";this.url=url,this.baseUrl=url.split("#")[0];var title=(0,_pdfjsLib.getPdfFilenameFromUrl)(url,"");if(!title)try{title=decodeURIComponent((0,_pdfjsLib.getFilenameFromUrl)(url))||url}catch(ex){title=url}this.setTitle(title)},setTitle:function(title){this.isViewerEmbedded||(document.title=title)},get _docFilename(){return this._contentDispositionFilename||(0,_pdfjsLib.getPdfFilenameFromUrl)(this.url)},_cancelIdleCallbacks:function(){if(this._idleCallbacks.size){var _step,_iterator=_createForOfIteratorHelper(this._idleCallbacks);try{for(_iterator.s();!(_step=_iterator.n()).done;){var callback=_step.value;window.cancelIdleCallback(callback)}}catch(err){_iterator.e(err)}finally{_iterator.f()}this._idleCallbacks.clear()}},close:function(){var _this6=this;return _asyncToGenerator(_regenerator.default.mark((function _callee7(){var _this6$pdfDocument,_this6$pdfHistory,_this6$findBar,promises;return _regenerator.default.wrap((function(_context7){for(;;)switch(_context7.prev=_context7.next){case 0:if(_this6._unblockDocumentLoadEvent(),_this6.appConfig.errorWrapper.container.hidden=!0,_this6.pdfLoadingTask){_context7.next=5;break}return _context7.abrupt("return");case 5:if(!((null===(_this6$pdfDocument=_this6.pdfDocument)||void 0===_this6$pdfDocument?void 0:_this6$pdfDocument.annotationStorage.size)>0&&_this6._annotationStorageModified)){_context7.next=13;break}return _context7.prev=6,_context7.next=9,_this6.save({sourceEventType:"save"});case 9:_context7.next=13;break;case 11:_context7.prev=11,_context7.t0=_context7.catch(6);case 13:return(promises=[]).push(_this6.pdfLoadingTask.destroy()),_this6.pdfLoadingTask=null,_this6.pdfDocument&&(_this6.pdfDocument=null,_this6.pdfThumbnailViewer.setDocument(null),_this6.pdfViewer.setDocument(null),_this6.pdfLinkService.setDocument(null),_this6.pdfDocumentProperties.setDocument(null)),webViewerResetPermissions(),_this6.pdfLinkService.externalLinkEnabled=!0,_this6._fellback=!1,_this6.store=null,_this6.isInitialViewSet=!1,_this6.downloadComplete=!1,_this6.url="",_this6.baseUrl="",_this6.documentInfo=null,_this6.metadata=null,_this6._contentDispositionFilename=null,_this6._contentLength=null,_this6._saveInProgress=!1,_this6._cancelIdleCallbacks(),promises.push(_this6.pdfScriptingManager.destroyPromise),_this6.pdfSidebar.reset(),_this6.pdfOutlineViewer.reset(),_this6.pdfAttachmentViewer.reset(),_this6.pdfLayerViewer.reset(),null===(_this6$pdfHistory=_this6.pdfHistory)||void 0===_this6$pdfHistory||_this6$pdfHistory.reset(),null===(_this6$findBar=_this6.findBar)||void 0===_this6$findBar||_this6$findBar.reset(),_this6.toolbar.reset(),_this6.secondaryToolbar.reset(),"undefined"!=typeof PDFBug&&PDFBug.cleanup(),_context7.next=43,Promise.all(promises);case 43:case"end":return _context7.stop()}}),_callee7,null,[[6,11]])})))()},open:function(file,args){var _this7=this;return _asyncToGenerator(_regenerator.default.mark((function _callee8(){var workerParameters,key,parameters,apiParameters,_key,value,_key2,loadingTask;return _regenerator.default.wrap((function(_context8){for(;;)switch(_context8.prev=_context8.next){case 0:if(!_this7.pdfLoadingTask){_context8.next=3;break}return _context8.next=3,_this7.close();case 3:for(key in workerParameters=_app_options.AppOptions.getAll(_app_options.OptionKind.WORKER))_pdfjsLib.GlobalWorkerOptions[key]=workerParameters[key];for(_key in parameters=Object.create(null),"string"==typeof file?(_this7.setTitleUsingUrl(file),parameters.url=file):file&&"byteLength"in file?parameters.data=file:file.url&&file.originalUrl&&(_this7.setTitleUsingUrl(file.originalUrl),parameters.url=file.url),apiParameters=_app_options.AppOptions.getAll(_app_options.OptionKind.API))value=apiParameters[_key],parameters[_key]=value;if(args)for(_key2 in args)parameters[_key2]=args[_key2];return loadingTask=(0,_pdfjsLib.getDocument)(parameters),_this7.pdfLoadingTask=loadingTask,loadingTask.onPassword=function(updateCallback,reason){_this7.pdfLinkService.externalLinkEnabled=!1,_this7.passwordPrompt.setUpdateCallback(updateCallback,reason),_this7.passwordPrompt.open()},loadingTask.onProgress=function(_ref){var loaded=_ref.loaded,total=_ref.total;_this7.progress(loaded/total)},loadingTask.onUnsupportedFeature=_this7.fallback.bind(_this7),_context8.abrupt("return",loadingTask.promise.then((function(pdfDocument){_this7.load(pdfDocument)}),(function(exception){if(loadingTask===_this7.pdfLoadingTask){var key="loading_error";return exception instanceof _pdfjsLib.InvalidPDFException?key="invalid_file_error":exception instanceof _pdfjsLib.MissingPDFException?key="missing_file_error":exception instanceof _pdfjsLib.UnexpectedResponseException&&(key="unexpected_response_error"),_this7.l10n.get(key).then((function(msg){throw _this7._documentError(msg,{message:null==exception?void 0:exception.message}),exception}))}})));case 16:case"end":return _context8.stop()}}),_callee8)})))()},_ensureDownloadComplete:function(){if(!this.pdfDocument||!this.downloadComplete)throw new Error("PDF document not downloaded.")},download:function(){var _arguments=arguments,_this8=this;return _asyncToGenerator(_regenerator.default.mark((function _callee9(){var _ref2,_ref2$sourceEventType,sourceEventType,url,filename,data,blob;return _regenerator.default.wrap((function(_context9){for(;;)switch(_context9.prev=_context9.next){case 0:return _ref2=_arguments.length>0&&void 0!==_arguments[0]?_arguments[0]:{},_ref2$sourceEventType=_ref2.sourceEventType,sourceEventType=void 0===_ref2$sourceEventType?"download":_ref2$sourceEventType,url=_this8.baseUrl,filename=_this8._docFilename,_context9.prev=2,_this8._ensureDownloadComplete(),_context9.next=6,_this8.pdfDocument.getData();case 6:return data=_context9.sent,blob=new Blob([data],{type:"application/pdf"}),_context9.next=10,_this8.downloadManager.download(blob,url,filename,sourceEventType);case 10:_context9.next=16;break;case 12:return _context9.prev=12,_context9.t0=_context9.catch(2),_context9.next=16,_this8.downloadManager.downloadUrl(url,filename);case 16:case"end":return _context9.stop()}}),_callee9,null,[[2,12]])})))()},save:function(){var _arguments2=arguments,_this9=this;return _asyncToGenerator(_regenerator.default.mark((function _callee10(){var _ref3,_ref3$sourceEventType,sourceEventType,url,filename,data,blob;return _regenerator.default.wrap((function(_context10){for(;;)switch(_context10.prev=_context10.next){case 0:if(_ref3=_arguments2.length>0&&void 0!==_arguments2[0]?_arguments2[0]:{},_ref3$sourceEventType=_ref3.sourceEventType,sourceEventType=void 0===_ref3$sourceEventType?"download":_ref3$sourceEventType,!_this9._saveInProgress){_context10.next=3;break}return _context10.abrupt("return");case 3:return _this9._saveInProgress=!0,_context10.next=6,_this9.pdfScriptingManager.dispatchWillSave();case 6:return url=_this9.baseUrl,filename=_this9._docFilename,_context10.prev=7,_this9._ensureDownloadComplete(),_context10.next=11,_this9.pdfDocument.saveDocument();case 11:return data=_context10.sent,blob=new Blob([data],{type:"application/pdf"}),_context10.next=15,_this9.downloadManager.download(blob,url,filename,sourceEventType);case 15:_context10.next=21;break;case 17:return _context10.prev=17,_context10.t0=_context10.catch(7),_context10.next=21,_this9.download({sourceEventType:sourceEventType});case 21:return _context10.prev=21,_context10.next=24,_this9.pdfScriptingManager.dispatchDidSave();case 24:return _this9._saveInProgress=!1,_context10.finish(21);case 26:case"end":return _context10.stop()}}),_callee10,null,[[7,17,21,26]])})))()},downloadOrSave:function(options){var _this$pdfDocument;(null===(_this$pdfDocument=this.pdfDocument)||void 0===_this$pdfDocument?void 0:_this$pdfDocument.annotationStorage.size)>0?this.save(options):this.download(options)},fallback:function(featureId){var _this10=this;this.externalServices.reportTelemetry({type:"unsupportedFeature",featureId:featureId}),this._fellback||(this._fellback=!0,this.externalServices.fallback({featureId:featureId,url:this.baseUrl}).then((function(download){download&&_this10.download({sourceEventType:"download"})})))},_documentError:function(message){var moreInfo=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;this._unblockDocumentLoadEvent(),this._otherError(message,moreInfo)},_otherError:function(message){var moreInfo=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,moreInfoText=[this.l10n.get("error_version_info",{version:_pdfjsLib.version||"?",build:_pdfjsLib.build||"?"})];moreInfo&&(moreInfoText.push(this.l10n.get("error_message",{message:moreInfo.message})),moreInfo.stack?moreInfoText.push(this.l10n.get("error_stack",{stack:moreInfo.stack})):(moreInfo.filename&&moreInfoText.push(this.l10n.get("error_file",{file:moreInfo.filename})),moreInfo.lineNumber&&moreInfoText.push(this.l10n.get("error_line",{line:moreInfo.lineNumber}))));var errorWrapperConfig=this.appConfig.errorWrapper,errorWrapper=errorWrapperConfig.container;errorWrapper.hidden=!1;var errorMessage=errorWrapperConfig.errorMessage;errorMessage.textContent=message;var closeButton=errorWrapperConfig.closeButton;closeButton.onclick=function(){errorWrapper.hidden=!0};var errorMoreInfo=errorWrapperConfig.errorMoreInfo,moreInfoButton=errorWrapperConfig.moreInfoButton,lessInfoButton=errorWrapperConfig.lessInfoButton;moreInfoButton.onclick=function(){errorMoreInfo.hidden=!1,moreInfoButton.hidden=!0,lessInfoButton.hidden=!1,errorMoreInfo.style.height=errorMoreInfo.scrollHeight+"px"},lessInfoButton.onclick=function(){errorMoreInfo.hidden=!0,moreInfoButton.hidden=!1,lessInfoButton.hidden=!0},moreInfoButton.oncontextmenu=_ui_utils.noContextMenuHandler,lessInfoButton.oncontextmenu=_ui_utils.noContextMenuHandler,closeButton.oncontextmenu=_ui_utils.noContextMenuHandler,moreInfoButton.hidden=!1,lessInfoButton.hidden=!0,Promise.all(moreInfoText).then((function(parts){errorMoreInfo.value=parts.join("\n")}))},progress:function(level){var _this11=this;if(!this.downloadComplete){var percent=Math.round(100*level);if(percent>this.loadingBar.percent||isNaN(percent))this.loadingBar.percent=percent,(this.pdfDocument?this.pdfDocument.loadingParams.disableAutoFetch:_app_options.AppOptions.get("disableAutoFetch"))&&percent&&(this.disableAutoFetchLoadingBarTimeout&&(clearTimeout(this.disableAutoFetchLoadingBarTimeout),this.disableAutoFetchLoadingBarTimeout=null),this.loadingBar.show(),this.disableAutoFetchLoadingBarTimeout=setTimeout((function(){_this11.loadingBar.hide(),_this11.disableAutoFetchLoadingBarTimeout=null}),5e3))}},load:function(pdfDocument){var _this12=this;this.pdfDocument=pdfDocument,pdfDocument.getDownloadInfo().then((function(_ref4){var length=_ref4.length;_this12._contentLength=length,_this12.downloadComplete=!0,_this12.loadingBar.hide(),firstPagePromise.then((function(){_this12.eventBus.dispatch("documentloaded",{source:_this12})}))}));var pageLayoutPromise=pdfDocument.getPageLayout().catch((function(){})),pageModePromise=pdfDocument.getPageMode().catch((function(){})),openActionPromise=pdfDocument.getOpenAction().catch((function(){}));this.toolbar.setPagesCount(pdfDocument.numPages,!1),this.secondaryToolbar.setPagesCount(pdfDocument.numPages),this.pdfLinkService.setDocument(pdfDocument,null),this.pdfDocumentProperties.setDocument(pdfDocument,this.url);var pdfViewer=this.pdfViewer;pdfViewer.setDocument(pdfDocument);var firstPagePromise=pdfViewer.firstPagePromise,onePageRendered=pdfViewer.onePageRendered,pagesPromise=pdfViewer.pagesPromise;this.pdfThumbnailViewer.setDocument(pdfDocument);var storedPromise=(this.store=new _view_history.ViewHistory(pdfDocument.fingerprints[0])).getMultiple({page:null,zoom:_ui_utils.DEFAULT_SCALE_VALUE,scrollLeft:"0",scrollTop:"0",rotation:null,sidebarView:_ui_utils.SidebarView.UNKNOWN,scrollMode:_ui_utils.ScrollMode.UNKNOWN,spreadMode:_ui_utils.SpreadMode.UNKNOWN}).catch((function(){return Object.create(null)}));firstPagePromise.then((function(pdfPage){_this12.loadingBar.setWidth(_this12.appConfig.viewerContainer),_this12._initializeAnnotationStorageCallbacks(pdfDocument),Promise.all([_ui_utils.animationStarted,storedPromise,pageLayoutPromise,pageModePromise,openActionPromise]).then(function(){var _ref6=_asyncToGenerator(_regenerator.default.mark((function _callee11(_ref5){var _ref7,stored,pageLayout,pageMode,openAction,viewOnLoad,initialBookmark,zoom,hash,rotation,sidebarView,scrollMode,spreadMode;return _regenerator.default.wrap((function(_context11){for(;;)switch(_context11.prev=_context11.next){case 0:return _ref7=_slicedToArray(_ref5,5),_ref7[0],stored=_ref7[1],pageLayout=_ref7[2],pageMode=_ref7[3],openAction=_ref7[4],viewOnLoad=_app_options.AppOptions.get("viewOnLoad"),_this12._initializePdfHistory({fingerprint:pdfDocument.fingerprints[0],viewOnLoad:viewOnLoad,initialDest:null==openAction?void 0:openAction.dest}),initialBookmark=_this12.initialBookmark,zoom=_app_options.AppOptions.get("defaultZoomValue"),hash=zoom?"zoom=".concat(zoom):null,rotation=null,sidebarView=_app_options.AppOptions.get("sidebarViewOnLoad"),scrollMode=_app_options.AppOptions.get("scrollModeOnLoad"),spreadMode=_app_options.AppOptions.get("spreadModeOnLoad"),stored.page&&viewOnLoad!==ViewOnLoad_INITIAL&&(hash="page=".concat(stored.page,"&zoom=").concat(zoom||stored.zoom,",")+"".concat(stored.scrollLeft,",").concat(stored.scrollTop),rotation=parseInt(stored.rotation,10),sidebarView===_ui_utils.SidebarView.UNKNOWN&&(sidebarView=0|stored.sidebarView),scrollMode===_ui_utils.ScrollMode.UNKNOWN&&(scrollMode=0|stored.scrollMode),spreadMode===_ui_utils.SpreadMode.UNKNOWN&&(spreadMode=0|stored.spreadMode)),pageMode&&sidebarView===_ui_utils.SidebarView.UNKNOWN&&(sidebarView=(0,_ui_utils.apiPageModeToSidebarView)(pageMode)),pageLayout&&spreadMode===_ui_utils.SpreadMode.UNKNOWN&&(spreadMode=(0,_ui_utils.apiPageLayoutToSpreadMode)(pageLayout)),_this12.setInitialView(hash,{rotation:rotation,sidebarView:sidebarView,scrollMode:scrollMode,spreadMode:spreadMode}),_this12.eventBus.dispatch("documentinit",{source:_this12}),_this12.isViewerEmbedded||pdfViewer.focus(),_this12._initializePermissions(pdfDocument),_context11.next=19,Promise.race([pagesPromise,new Promise((function(resolve){setTimeout(resolve,1e4)}))]);case 19:if(initialBookmark||hash){_context11.next=21;break}return _context11.abrupt("return");case 21:if(!pdfViewer.hasEqualPageSizes){_context11.next=23;break}return _context11.abrupt("return");case 23:_this12.initialBookmark=initialBookmark,pdfViewer.currentScaleValue=pdfViewer.currentScaleValue,_this12.setInitialView(hash);case 26:case"end":return _context11.stop()}}),_callee11)})));return function(_x2){return _ref6.apply(this,arguments)}}()).catch((function(){_this12.setInitialView()})).then((function(){pdfViewer.update()}))})),pagesPromise.then((function(){_this12._unblockDocumentLoadEvent(),_this12._initializeAutoPrint(pdfDocument,openActionPromise)})),onePageRendered.then((function(){if(pdfDocument.getOutline().then((function(outline){pdfDocument===_this12.pdfDocument&&_this12.pdfOutlineViewer.render({outline:outline,pdfDocument:pdfDocument})})),pdfDocument.getAttachments().then((function(attachments){pdfDocument===_this12.pdfDocument&&_this12.pdfAttachmentViewer.render({attachments:attachments})})),pdfViewer.optionalContentConfigPromise.then((function(optionalContentConfig){pdfDocument===_this12.pdfDocument&&_this12.pdfLayerViewer.render({optionalContentConfig:optionalContentConfig,pdfDocument:pdfDocument})})),"requestIdleCallback"in window){var callback=window.requestIdleCallback((function(){_this12._collectTelemetry(pdfDocument),_this12._idleCallbacks.delete(callback)}),{timeout:1e3});_this12._idleCallbacks.add(callback)}})),this._initializePageLabels(pdfDocument),this._initializeMetadata(pdfDocument)},_scriptingDocProperties:function(pdfDocument){var _this13=this;return _asyncToGenerator(_regenerator.default.mark((function _callee12(){var _this13$metadata,_this13$metadata2;return _regenerator.default.wrap((function(_context12){for(;;)switch(_context12.prev=_context12.next){case 0:if(_this13.documentInfo){_context12.next=5;break}return _context12.next=3,new Promise((function(resolve){_this13.eventBus._on("metadataloaded",resolve,{once:!0})}));case 3:if(pdfDocument===_this13.pdfDocument){_context12.next=5;break}return _context12.abrupt("return",null);case 5:if(_this13._contentLength){_context12.next=10;break}return _context12.next=8,new Promise((function(resolve){_this13.eventBus._on("documentloaded",resolve,{once:!0})}));case 8:if(pdfDocument===_this13.pdfDocument){_context12.next=10;break}return _context12.abrupt("return",null);case 10:return _context12.abrupt("return",_objectSpread(_objectSpread({},_this13.documentInfo),{},{baseURL:_this13.baseUrl,filesize:_this13._contentLength,filename:_this13._docFilename,metadata:null===(_this13$metadata=_this13.metadata)||void 0===_this13$metadata?void 0:_this13$metadata.getRaw(),authors:null===(_this13$metadata2=_this13.metadata)||void 0===_this13$metadata2?void 0:_this13$metadata2.get("dc:creator"),numPages:_this13.pagesCount,URL:_this13.url}));case 11:case"end":return _context12.stop()}}),_callee12)})))()},_collectTelemetry:function(pdfDocument){var _this14=this;return _asyncToGenerator(_regenerator.default.mark((function _callee13(){var markInfo,tagged;return _regenerator.default.wrap((function(_context13){for(;;)switch(_context13.prev=_context13.next){case 0:return _context13.next=2,_this14.pdfDocument.getMarkInfo();case 2:if(markInfo=_context13.sent,pdfDocument===_this14.pdfDocument){_context13.next=5;break}return _context13.abrupt("return");case 5:tagged=(null==markInfo?void 0:markInfo.Marked)||!1,_this14.externalServices.reportTelemetry({type:"tagged",tagged:tagged});case 7:case"end":return _context13.stop()}}),_callee13)})))()},_initializeAutoPrint:function(pdfDocument,openActionPromise){var _this15=this;return _asyncToGenerator(_regenerator.default.mark((function _callee14(){var _yield$Promise$all,_yield$Promise$all2,openAction,javaScript,triggerAutoPrint,_iterator2,_step2,js;return _regenerator.default.wrap((function(_context14){for(;;)switch(_context14.prev=_context14.next){case 0:return _context14.next=2,Promise.all([openActionPromise,_this15.pdfViewer.enableScripting?null:pdfDocument.getJavaScript()]);case 2:if(_yield$Promise$all=_context14.sent,_yield$Promise$all2=_slicedToArray(_yield$Promise$all,2),openAction=_yield$Promise$all2[0],javaScript=_yield$Promise$all2[1],pdfDocument===_this15.pdfDocument){_context14.next=8;break}return _context14.abrupt("return");case 8:if(triggerAutoPrint=!1,"Print"===(null==openAction?void 0:openAction.action)&&(triggerAutoPrint=!0),!javaScript){_context14.next=31;break}if(javaScript.some((function(js){return!!js&&(console.warn("Warning: JavaScript support is not enabled"),_this15.fallback(_pdfjsLib.UNSUPPORTED_FEATURES.javaScript),!0)})),triggerAutoPrint){_context14.next=31;break}_iterator2=_createForOfIteratorHelper(javaScript),_context14.prev=14,_iterator2.s();case 16:if((_step2=_iterator2.n()).done){_context14.next=23;break}if(!(js=_step2.value)||!_ui_utils.AutoPrintRegExp.test(js)){_context14.next=21;break}return triggerAutoPrint=!0,_context14.abrupt("break",23);case 21:_context14.next=16;break;case 23:_context14.next=28;break;case 25:_context14.prev=25,_context14.t0=_context14.catch(14),_iterator2.e(_context14.t0);case 28:return _context14.prev=28,_iterator2.f(),_context14.finish(28);case 31:triggerAutoPrint&&_this15.triggerPrinting();case 32:case"end":return _context14.stop()}}),_callee14,null,[[14,25,28,31]])})))()},_initializeMetadata:function(pdfDocument){var _this16=this;return _asyncToGenerator(_regenerator.default.mark((function _callee15(){var _this16$_contentDispo,_this16$_contentLengt,_yield$pdfDocument$ge,info,metadata,contentDispositionFilename,contentLength,pdfTitle,metadataTitle,versionId,generatorId,producer,formType;return _regenerator.default.wrap((function(_context15){for(;;)switch(_context15.prev=_context15.next){case 0:return _context15.next=2,pdfDocument.getMetadata();case 2:if(_yield$pdfDocument$ge=_context15.sent,info=_yield$pdfDocument$ge.info,metadata=_yield$pdfDocument$ge.metadata,contentDispositionFilename=_yield$pdfDocument$ge.contentDispositionFilename,contentLength=_yield$pdfDocument$ge.contentLength,pdfDocument===_this16.pdfDocument){_context15.next=9;break}return _context15.abrupt("return");case 9:_this16.documentInfo=info,_this16.metadata=metadata,null!==(_this16$_contentDispo=_this16._contentDispositionFilename)&&void 0!==_this16$_contentDispo||(_this16._contentDispositionFilename=contentDispositionFilename),null!==(_this16$_contentLengt=_this16._contentLength)&&void 0!==_this16$_contentLengt||(_this16._contentLength=contentLength),console.log("PDF ".concat(pdfDocument.fingerprints[0]," [").concat(info.PDFFormatVersion," ")+"".concat((info.Producer||"-").trim()," / ").concat((info.Creator||"-").trim(),"] ")+"(PDF.js: ".concat(_pdfjsLib.version||"-",")")),pdfTitle=null==info?void 0:info.Title,(metadataTitle=null==metadata?void 0:metadata.get("dc:title"))&&("Untitled"===metadataTitle||/[\uFFF0-\uFFFF]/g.test(metadataTitle)||(pdfTitle=metadataTitle)),pdfTitle?_this16.setTitle("".concat(pdfTitle," - ").concat(contentDispositionFilename||document.title)):contentDispositionFilename&&_this16.setTitle(contentDispositionFilename),!info.IsXFAPresent||info.IsAcroFormPresent||pdfDocument.isPureXfa?!info.IsAcroFormPresent&&!info.IsXFAPresent||_this16.pdfViewer.renderForms||(console.warn("Warning: Interactive form support is not enabled"),_this16.fallback(_pdfjsLib.UNSUPPORTED_FEATURES.forms)):(console.warn("Warning: XFA support is not enabled"),_this16.fallback(_pdfjsLib.UNSUPPORTED_FEATURES.forms)),info.IsSignaturesPresent&&(console.warn("Warning: Digital signatures validation is not supported"),_this16.fallback(_pdfjsLib.UNSUPPORTED_FEATURES.signatures)),versionId="other",KNOWN_VERSIONS.includes(info.PDFFormatVersion)&&(versionId="v".concat(info.PDFFormatVersion.replace(".","_"))),generatorId="other",info.Producer&&(producer=info.Producer.toLowerCase(),KNOWN_GENERATORS.some((function(generator){return!!producer.includes(generator)&&(generatorId=generator.replace(/[ .-]/g,"_"),!0)}))),formType=null,info.IsXFAPresent?formType="xfa":info.IsAcroFormPresent&&(formType="acroform"),_this16.externalServices.reportTelemetry({type:"documentInfo",version:versionId,generator:generatorId,formType:formType}),_this16.eventBus.dispatch("metadataloaded",{source:_this16});case 28:case"end":return _context15.stop()}}),_callee15)})))()},_initializePageLabels:function(pdfDocument){var _this17=this;return _asyncToGenerator(_regenerator.default.mark((function _callee16(){var labels,numLabels,i,pdfViewer,pdfThumbnailViewer,toolbar;return _regenerator.default.wrap((function(_context16){for(;;)switch(_context16.prev=_context16.next){case 0:return _context16.next=2,pdfDocument.getPageLabels();case 2:if(labels=_context16.sent,pdfDocument===_this17.pdfDocument){_context16.next=5;break}return _context16.abrupt("return");case 5:if(labels&&!_app_options.AppOptions.get("disablePageLabels")){_context16.next=7;break}return _context16.abrupt("return");case 7:if((numLabels=labels.length)===_this17.pagesCount){_context16.next=11;break}return console.error("The number of Page Labels does not match the number of pages in the document."),_context16.abrupt("return");case 11:for(i=0;i<numLabels&&labels[i]===(i+1).toString();)i++;if(i!==numLabels){_context16.next=15;break}return _context16.abrupt("return");case 15:pdfViewer=_this17.pdfViewer,pdfThumbnailViewer=_this17.pdfThumbnailViewer,toolbar=_this17.toolbar,pdfViewer.setPageLabels(labels),pdfThumbnailViewer.setPageLabels(labels),toolbar.setPagesCount(numLabels,!0),toolbar.setPageNumber(pdfViewer.currentPageNumber,pdfViewer.currentPageLabel);case 20:case"end":return _context16.stop()}}),_callee16)})))()},_initializePdfHistory:function(_ref8){var fingerprint=_ref8.fingerprint,viewOnLoad=_ref8.viewOnLoad,_ref8$initialDest=_ref8.initialDest,initialDest=void 0===_ref8$initialDest?null:_ref8$initialDest;this.pdfHistory&&(this.pdfHistory.initialize({fingerprint:fingerprint,resetHistory:viewOnLoad===ViewOnLoad_INITIAL,updateUrl:_app_options.AppOptions.get("historyUpdateUrl")}),this.pdfHistory.initialBookmark&&(this.initialBookmark=this.pdfHistory.initialBookmark,this.initialRotation=this.pdfHistory.initialRotation),initialDest&&!this.initialBookmark&&viewOnLoad===ViewOnLoad_UNKNOWN&&(this.initialBookmark=JSON.stringify(initialDest),this.pdfHistory.push({explicitDest:initialDest,pageNumber:null})))},_initializePermissions:function(pdfDocument){var _this18=this;return _asyncToGenerator(_regenerator.default.mark((function _callee17(){var permissions;return _regenerator.default.wrap((function(_context17){for(;;)switch(_context17.prev=_context17.next){case 0:return _context17.next=2,pdfDocument.getPermissions();case 2:if(permissions=_context17.sent,pdfDocument===_this18.pdfDocument){_context17.next=5;break}return _context17.abrupt("return");case 5:if(permissions&&_app_options.AppOptions.get("enablePermissions")){_context17.next=7;break}return _context17.abrupt("return");case 7:permissions.includes(_pdfjsLib.PermissionFlag.COPY)||_this18.appConfig.viewerContainer.classList.add("enablePermissions");case 8:case"end":return _context17.stop()}}),_callee17)})))()},_initializeAnnotationStorageCallbacks:function(pdfDocument){var _this19=this;if(pdfDocument===this.pdfDocument){var annotationStorage=pdfDocument.annotationStorage;annotationStorage.onSetModified=function(){window.addEventListener("beforeunload",beforeUnload),_this19._annotationStorageModified=!0},annotationStorage.onResetModified=function(){window.removeEventListener("beforeunload",beforeUnload),delete _this19._annotationStorageModified}}},setInitialView:function(storedHash){var _this20=this,_ref9=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},rotation=_ref9.rotation,sidebarView=_ref9.sidebarView,scrollMode=_ref9.scrollMode,spreadMode=_ref9.spreadMode,setRotation=function(angle){(0,_ui_utils.isValidRotation)(angle)&&(_this20.pdfViewer.pagesRotation=angle)},setViewerModes=function(scroll,spread){(0,_ui_utils.isValidScrollMode)(scroll)&&(_this20.pdfViewer.scrollMode=scroll),(0,_ui_utils.isValidSpreadMode)(spread)&&(_this20.pdfViewer.spreadMode=spread)};this.isInitialViewSet=!0,this.pdfSidebar.setInitialView(sidebarView),setViewerModes(scrollMode,spreadMode),this.initialBookmark?(setRotation(this.initialRotation),delete this.initialRotation,this.pdfLinkService.setHash(this.initialBookmark),this.initialBookmark=null):storedHash&&(setRotation(rotation),this.pdfLinkService.setHash(storedHash)),this.toolbar.setPageNumber(this.pdfViewer.currentPageNumber,this.pdfViewer.currentPageLabel),this.secondaryToolbar.setPageNumber(this.pdfViewer.currentPageNumber),this.pdfViewer.currentScaleValue||(this.pdfViewer.currentScaleValue=_ui_utils.DEFAULT_SCALE_VALUE)},_cleanup:function(){this.pdfDocument&&(this.pdfViewer.cleanup(),this.pdfThumbnailViewer.cleanup(),this.pdfDocument.cleanup(this.pdfViewer.renderer===_ui_utils.RendererType.SVG))},forceRendering:function(){this.pdfRenderingQueue.printing=!!this.printService,this.pdfRenderingQueue.isThumbnailViewEnabled=this.pdfSidebar.isThumbnailViewVisible,this.pdfRenderingQueue.renderHighestPriority()},beforePrint:function(){var _this21=this;if(this.pdfScriptingManager.dispatchWillPrint(),!this.printService)if(this.supportsPrinting)if(this.pdfViewer.pageViewsReady){var pagesOverview=this.pdfViewer.getPagesOverview(),printContainer=this.appConfig.printContainer,printResolution=_app_options.AppOptions.get("printResolution"),optionalContentConfigPromise=this.pdfViewer.optionalContentConfigPromise,printService=PDFPrintServiceFactory.instance.createPrintService(this.pdfDocument,pagesOverview,printContainer,printResolution,optionalContentConfigPromise,this.l10n);this.printService=printService,this.forceRendering(),printService.layout(),this.externalServices.reportTelemetry({type:"print"})}else this.l10n.get("printing_not_ready").then((function(msg){window.alert(msg)}));else this.l10n.get("printing_not_supported").then((function(msg){_this21._otherError(msg)}))},afterPrint:function(){var _this$pdfDocument2;(this.pdfScriptingManager.dispatchDidPrint(),this.printService)&&(this.printService.destroy(),this.printService=null,null===(_this$pdfDocument2=this.pdfDocument)||void 0===_this$pdfDocument2||_this$pdfDocument2.annotationStorage.resetModified());this.forceRendering()},rotatePages:function(delta){this.pdfViewer.pagesRotation+=delta},requestPresentationMode:function(){var _this$pdfPresentation;null===(_this$pdfPresentation=this.pdfPresentationMode)||void 0===_this$pdfPresentation||_this$pdfPresentation.request()},triggerPrinting:function(){this.supportsPrinting&&window.print()},bindEvents:function(){var eventBus=this.eventBus,_boundEvents=this._boundEvents;_boundEvents.beforePrint=this.beforePrint.bind(this),_boundEvents.afterPrint=this.afterPrint.bind(this),eventBus._on("resize",webViewerResize),eventBus._on("hashchange",webViewerHashchange),eventBus._on("beforeprint",_boundEvents.beforePrint),eventBus._on("afterprint",_boundEvents.afterPrint),eventBus._on("pagerendered",webViewerPageRendered),eventBus._on("updateviewarea",webViewerUpdateViewarea),eventBus._on("pagechanging",webViewerPageChanging),eventBus._on("scalechanging",webViewerScaleChanging),eventBus._on("rotationchanging",webViewerRotationChanging),eventBus._on("sidebarviewchanged",webViewerSidebarViewChanged),eventBus._on("pagemode",webViewerPageMode),eventBus._on("namedaction",webViewerNamedAction),eventBus._on("presentationmodechanged",webViewerPresentationModeChanged),eventBus._on("presentationmode",webViewerPresentationMode),eventBus._on("print",webViewerPrint),eventBus._on("download",webViewerDownload),eventBus._on("save",webViewerSave),eventBus._on("firstpage",webViewerFirstPage),eventBus._on("lastpage",webViewerLastPage),eventBus._on("nextpage",webViewerNextPage),eventBus._on("previouspage",webViewerPreviousPage),eventBus._on("zoomin",webViewerZoomIn),eventBus._on("zoomout",webViewerZoomOut),eventBus._on("zoomreset",webViewerZoomReset),eventBus._on("pagenumberchanged",webViewerPageNumberChanged),eventBus._on("scalechanged",webViewerScaleChanged),eventBus._on("rotatecw",webViewerRotateCw),eventBus._on("rotateccw",webViewerRotateCcw),eventBus._on("optionalcontentconfig",webViewerOptionalContentConfig),eventBus._on("switchscrollmode",webViewerSwitchScrollMode),eventBus._on("scrollmodechanged",webViewerScrollModeChanged),eventBus._on("switchspreadmode",webViewerSwitchSpreadMode),eventBus._on("spreadmodechanged",webViewerSpreadModeChanged),eventBus._on("documentproperties",webViewerDocumentProperties),eventBus._on("find",webViewerFind),eventBus._on("findfromurlhash",webViewerFindFromUrlHash),eventBus._on("updatefindmatchescount",webViewerUpdateFindMatchesCount),eventBus._on("updatefindcontrolstate",webViewerUpdateFindControlState),_app_options.AppOptions.get("pdfBug")&&(_boundEvents.reportPageStatsPDFBug=reportPageStatsPDFBug,eventBus._on("pagerendered",_boundEvents.reportPageStatsPDFBug),eventBus._on("pagechanging",_boundEvents.reportPageStatsPDFBug)),eventBus._on("fileinputchange",webViewerFileInputChange),eventBus._on("openfile",webViewerOpenFile)},bindWindowEvents:function(){var eventBus=this.eventBus,_boundEvents=this._boundEvents;_boundEvents.windowResize=function(){eventBus.dispatch("resize",{source:window})},_boundEvents.windowHashChange=function(){eventBus.dispatch("hashchange",{source:window,hash:document.location.hash.substring(1)})},_boundEvents.windowBeforePrint=function(){eventBus.dispatch("beforeprint",{source:window})},_boundEvents.windowAfterPrint=function(){eventBus.dispatch("afterprint",{source:window})},_boundEvents.windowUpdateFromSandbox=function(event){eventBus.dispatch("updatefromsandbox",{source:window,detail:event.detail})},window.addEventListener("visibilitychange",webViewerVisibilityChange),window.addEventListener("wheel",webViewerWheel,{passive:!1}),window.addEventListener("touchstart",webViewerTouchStart,{passive:!1}),window.addEventListener("click",webViewerClick),window.addEventListener("keydown",webViewerKeyDown),window.addEventListener("resize",_boundEvents.windowResize),window.addEventListener("hashchange",_boundEvents.windowHashChange),window.addEventListener("beforeprint",_boundEvents.windowBeforePrint),window.addEventListener("afterprint",_boundEvents.windowAfterPrint),window.addEventListener("updatefromsandbox",_boundEvents.windowUpdateFromSandbox)},unbindEvents:function(){var eventBus=this.eventBus,_boundEvents=this._boundEvents;eventBus._off("resize",webViewerResize),eventBus._off("hashchange",webViewerHashchange),eventBus._off("beforeprint",_boundEvents.beforePrint),eventBus._off("afterprint",_boundEvents.afterPrint),eventBus._off("pagerendered",webViewerPageRendered),eventBus._off("updateviewarea",webViewerUpdateViewarea),eventBus._off("pagechanging",webViewerPageChanging),eventBus._off("scalechanging",webViewerScaleChanging),eventBus._off("rotationchanging",webViewerRotationChanging),eventBus._off("sidebarviewchanged",webViewerSidebarViewChanged),eventBus._off("pagemode",webViewerPageMode),eventBus._off("namedaction",webViewerNamedAction),eventBus._off("presentationmodechanged",webViewerPresentationModeChanged),eventBus._off("presentationmode",webViewerPresentationMode),eventBus._off("print",webViewerPrint),eventBus._off("download",webViewerDownload),eventBus._off("save",webViewerSave),eventBus._off("firstpage",webViewerFirstPage),eventBus._off("lastpage",webViewerLastPage),eventBus._off("nextpage",webViewerNextPage),eventBus._off("previouspage",webViewerPreviousPage),eventBus._off("zoomin",webViewerZoomIn),eventBus._off("zoomout",webViewerZoomOut),eventBus._off("zoomreset",webViewerZoomReset),eventBus._off("pagenumberchanged",webViewerPageNumberChanged),eventBus._off("scalechanged",webViewerScaleChanged),eventBus._off("rotatecw",webViewerRotateCw),eventBus._off("rotateccw",webViewerRotateCcw),eventBus._off("optionalcontentconfig",webViewerOptionalContentConfig),eventBus._off("switchscrollmode",webViewerSwitchScrollMode),eventBus._off("scrollmodechanged",webViewerScrollModeChanged),eventBus._off("switchspreadmode",webViewerSwitchSpreadMode),eventBus._off("spreadmodechanged",webViewerSpreadModeChanged),eventBus._off("documentproperties",webViewerDocumentProperties),eventBus._off("find",webViewerFind),eventBus._off("findfromurlhash",webViewerFindFromUrlHash),eventBus._off("updatefindmatchescount",webViewerUpdateFindMatchesCount),eventBus._off("updatefindcontrolstate",webViewerUpdateFindControlState),_boundEvents.reportPageStatsPDFBug&&(eventBus._off("pagerendered",_boundEvents.reportPageStatsPDFBug),eventBus._off("pagechanging",_boundEvents.reportPageStatsPDFBug),_boundEvents.reportPageStatsPDFBug=null),eventBus._off("fileinputchange",webViewerFileInputChange),eventBus._off("openfile",webViewerOpenFile),_boundEvents.beforePrint=null,_boundEvents.afterPrint=null},unbindWindowEvents:function(){var _boundEvents=this._boundEvents;window.removeEventListener("visibilitychange",webViewerVisibilityChange),window.removeEventListener("wheel",webViewerWheel,{passive:!1}),window.removeEventListener("touchstart",webViewerTouchStart,{passive:!1}),window.removeEventListener("click",webViewerClick),window.removeEventListener("keydown",webViewerKeyDown),window.removeEventListener("resize",_boundEvents.windowResize),window.removeEventListener("hashchange",_boundEvents.windowHashChange),window.removeEventListener("beforeprint",_boundEvents.windowBeforePrint),window.removeEventListener("afterprint",_boundEvents.windowAfterPrint),window.removeEventListener("updatefromsandbox",_boundEvents.windowUpdateFromSandbox),_boundEvents.windowResize=null,_boundEvents.windowHashChange=null,_boundEvents.windowBeforePrint=null,_boundEvents.windowAfterPrint=null,_boundEvents.windowUpdateFromSandbox=null},accumulateWheelTicks:function(ticks){(this._wheelUnusedTicks>0&&ticks<0||this._wheelUnusedTicks<0&&ticks>0)&&(this._wheelUnusedTicks=0),this._wheelUnusedTicks+=ticks;var wholeTicks=Math.sign(this._wheelUnusedTicks)*Math.floor(Math.abs(this._wheelUnusedTicks));return this._wheelUnusedTicks-=wholeTicks,wholeTicks},_unblockDocumentLoadEvent:function(){document.blockUnblockOnload&&document.blockUnblockOnload(!1),this._unblockDocumentLoadEvent=function(){}},get scriptingReady(){return this.pdfScriptingManager.ready}};exports.PDFViewerApplication=PDFViewerApplication;var webViewerFileInputChange,webViewerOpenFile,HOSTED_VIEWER_ORIGINS=["null","http://mozilla.github.io","https://mozilla.github.io"];function loadFakeWorker(){return _loadFakeWorker.apply(this,arguments)}function _loadFakeWorker(){return(_loadFakeWorker=_asyncToGenerator(_regenerator.default.mark((function _callee18(){return _regenerator.default.wrap((function(_context18){for(;;)switch(_context18.prev=_context18.next){case 0:return _pdfjsLib.GlobalWorkerOptions.workerSrc||(_pdfjsLib.GlobalWorkerOptions.workerSrc=_app_options.AppOptions.get("workerSrc")),_context18.next=3,(0,_pdfjsLib.loadScript)(_pdfjsLib.PDFWorker.workerSrc);case 3:case"end":return _context18.stop()}}),_callee18)})))).apply(this,arguments)}function initPDFBug(_x3){return _initPDFBug.apply(this,arguments)}function _initPDFBug(){return(_initPDFBug=_asyncToGenerator(_regenerator.default.mark((function _callee19(enabledTabs){var _PDFViewerApplication3,debuggerScriptPath,mainContainer;return _regenerator.default.wrap((function(_context19){for(;;)switch(_context19.prev=_context19.next){case 0:return _PDFViewerApplication3=PDFViewerApplication.appConfig,debuggerScriptPath=_PDFViewerApplication3.debuggerScriptPath,mainContainer=_PDFViewerApplication3.mainContainer,_context19.next=3,(0,_pdfjsLib.loadScript)(debuggerScriptPath);case 3:PDFBug.init({OPS:_pdfjsLib.OPS},mainContainer,enabledTabs);case 4:case"end":return _context19.stop()}}),_callee19)})))).apply(this,arguments)}function reportPageStatsPDFBug(_ref10){var _pageView$pdfPage,pageNumber=_ref10.pageNumber;if("undefined"!=typeof Stats&&Stats.enabled){var pageView=PDFViewerApplication.pdfViewer.getPageView(pageNumber-1),pageStats=null==pageView||null===(_pageView$pdfPage=pageView.pdfPage)||void 0===_pageView$pdfPage?void 0:_pageView$pdfPage.stats;pageStats&&Stats.add(pageNumber,pageStats)}}function webViewerInitialized(){var _params$get,file,appConfig=PDFViewerApplication.appConfig,queryString=document.location.search.substring(1);file=null!==(_params$get=(0,_ui_utils.parseQueryString)(queryString).get("file"))&&void 0!==_params$get?_params$get:_app_options.AppOptions.get("defaultUrl"),validateFileURL(file);var fileInput=document.createElement("input");fileInput.id=appConfig.openFileInputName,fileInput.className="fileInput",fileInput.setAttribute("type","file"),fileInput.oncontextmenu=_ui_utils.noContextMenuHandler,document.body.appendChild(fileInput),window.File&&window.FileReader&&window.FileList&&window.Blob?fileInput.value=null:(appConfig.toolbar.openFile.hidden=!0,appConfig.secondaryToolbar.openFileButton.hidden=!0),fileInput.addEventListener("change",(function(evt){var files=evt.target.files;files&&0!==files.length&&PDFViewerApplication.eventBus.dispatch("fileinputchange",{source:this,fileInput:evt.target})})),appConfig.mainContainer.addEventListener("dragover",(function(evt){evt.preventDefault(),evt.dataTransfer.dropEffect="move"})),appConfig.mainContainer.addEventListener("drop",(function(evt){evt.preventDefault();var files=evt.dataTransfer.files;files&&0!==files.length&&PDFViewerApplication.eventBus.dispatch("fileinputchange",{source:this,fileInput:evt.dataTransfer})})),PDFViewerApplication.supportsDocumentFonts||(_app_options.AppOptions.set("disableFontFace",!0),PDFViewerApplication.l10n.get("web_fonts_disabled").then((function(msg){console.warn(msg)}))),PDFViewerApplication.supportsPrinting||(appConfig.toolbar.print.classList.add("hidden"),appConfig.secondaryToolbar.printButton.classList.add("hidden")),PDFViewerApplication.supportsFullscreen||(appConfig.toolbar.presentationModeButton.classList.add("hidden"),appConfig.secondaryToolbar.presentationModeButton.classList.add("hidden")),PDFViewerApplication.supportsIntegratedFind&&appConfig.toolbar.viewFind.classList.add("hidden"),appConfig.mainContainer.addEventListener("transitionend",(function(evt){evt.target===this&&PDFViewerApplication.eventBus.dispatch("resize",{source:this})}),!0);try{!function(file){file&&PDFViewerApplication.open(file)}(file)}catch(reason){PDFViewerApplication.l10n.get("loading_error").then((function(msg){PDFViewerApplication._documentError(msg,reason)}))}}function webViewerResetPermissions(){var appConfig=PDFViewerApplication.appConfig;appConfig&&appConfig.viewerContainer.classList.remove("enablePermissions")}function webViewerPageRendered(_ref11){var pageNumber=_ref11.pageNumber,timestamp=_ref11.timestamp,error=_ref11.error;if(pageNumber===PDFViewerApplication.page&&PDFViewerApplication.toolbar.updateLoadingIndicatorState(!1),PDFViewerApplication.pdfSidebar.isThumbnailViewVisible){var pageView=PDFViewerApplication.pdfViewer.getPageView(pageNumber-1),thumbnailView=PDFViewerApplication.pdfThumbnailViewer.getThumbnail(pageNumber-1);pageView&&thumbnailView&&thumbnailView.setImage(pageView)}error&&PDFViewerApplication.l10n.get("rendering_error").then((function(msg){PDFViewerApplication._otherError(msg,error)})),PDFViewerApplication.externalServices.reportTelemetry({type:"pageInfo",timestamp:timestamp}),PDFViewerApplication.pdfDocument.getStats().then((function(stats){PDFViewerApplication.externalServices.reportTelemetry({type:"documentStats",stats:stats})}))}function webViewerPageMode(_ref12){var view,mode=_ref12.mode;switch(mode){case"thumbs":view=_ui_utils.SidebarView.THUMBS;break;case"bookmarks":case"outline":view=_ui_utils.SidebarView.OUTLINE;break;case"attachments":view=_ui_utils.SidebarView.ATTACHMENTS;break;case"layers":view=_ui_utils.SidebarView.LAYERS;break;case"none":view=_ui_utils.SidebarView.NONE;break;default:return void console.error('Invalid "pagemode" hash parameter: '+mode)}PDFViewerApplication.pdfSidebar.switchView(view,!0)}function webViewerNamedAction(evt){switch(evt.action){case"GoToPage":PDFViewerApplication.appConfig.toolbar.pageNumber.select();break;case"Find":PDFViewerApplication.supportsIntegratedFind||PDFViewerApplication.findBar.toggle();break;case"Print":PDFViewerApplication.triggerPrinting();break;case"SaveAs":webViewerSave()}}function webViewerPresentationModeChanged(evt){PDFViewerApplication.pdfViewer.presentationModeState=evt.state}function webViewerSidebarViewChanged(evt){PDFViewerApplication.pdfRenderingQueue.isThumbnailViewEnabled=PDFViewerApplication.pdfSidebar.isThumbnailViewVisible;var store=PDFViewerApplication.store;store&&PDFViewerApplication.isInitialViewSet&&store.set("sidebarView",evt.view).catch((function(){}))}function webViewerUpdateViewarea(evt){var location=evt.location,store=PDFViewerApplication.store;store&&PDFViewerApplication.isInitialViewSet&&store.setMultiple({page:location.pageNumber,zoom:location.scale,scrollLeft:location.left,scrollTop:location.top,rotation:location.rotation}).catch((function(){}));var href=PDFViewerApplication.pdfLinkService.getAnchorUrl(location.pdfOpenParams);PDFViewerApplication.appConfig.toolbar.viewBookmark.href=href,PDFViewerApplication.appConfig.secondaryToolbar.viewBookmarkButton.href=href;var currentPage=PDFViewerApplication.pdfViewer.getPageView(PDFViewerApplication.page-1),loading=(null==currentPage?void 0:currentPage.renderingState)!==_pdf_rendering_queue.RenderingStates.FINISHED;PDFViewerApplication.toolbar.updateLoadingIndicatorState(loading)}function webViewerScrollModeChanged(evt){var store=PDFViewerApplication.store;store&&PDFViewerApplication.isInitialViewSet&&store.set("scrollMode",evt.mode).catch((function(){}))}function webViewerSpreadModeChanged(evt){var store=PDFViewerApplication.store;store&&PDFViewerApplication.isInitialViewSet&&store.set("spreadMode",evt.mode).catch((function(){}))}function webViewerResize(){var pdfDocument=PDFViewerApplication.pdfDocument,pdfViewer=PDFViewerApplication.pdfViewer;if(pdfDocument){var currentScaleValue=pdfViewer.currentScaleValue;"auto"!==currentScaleValue&&"page-fit"!==currentScaleValue&&"page-width"!==currentScaleValue||(pdfViewer.currentScaleValue=currentScaleValue),pdfViewer.update()}}function webViewerHashchange(evt){var _PDFViewerApplication,hash=evt.hash;hash&&(PDFViewerApplication.isInitialViewSet?null!==(_PDFViewerApplication=PDFViewerApplication.pdfHistory)&&void 0!==_PDFViewerApplication&&_PDFViewerApplication.popStateInProgress||PDFViewerApplication.pdfLinkService.setHash(hash):PDFViewerApplication.initialBookmark=hash)}function webViewerPresentationMode(){PDFViewerApplication.requestPresentationMode()}function webViewerPrint(){PDFViewerApplication.triggerPrinting()}function webViewerDownload(){PDFViewerApplication.downloadOrSave({sourceEventType:"download"})}function webViewerSave(){PDFViewerApplication.downloadOrSave({sourceEventType:"save"})}function webViewerFirstPage(){PDFViewerApplication.pdfDocument&&(PDFViewerApplication.page=1)}function webViewerLastPage(){PDFViewerApplication.pdfDocument&&(PDFViewerApplication.page=PDFViewerApplication.pagesCount)}function webViewerNextPage(){PDFViewerApplication.pdfViewer.nextPage()}function webViewerPreviousPage(){PDFViewerApplication.pdfViewer.previousPage()}function webViewerZoomIn(){PDFViewerApplication.zoomIn()}function webViewerZoomOut(){PDFViewerApplication.zoomOut()}function webViewerZoomReset(){PDFViewerApplication.zoomReset()}function webViewerPageNumberChanged(evt){var pdfViewer=PDFViewerApplication.pdfViewer;""!==evt.value&&PDFViewerApplication.pdfLinkService.goToPage(evt.value),evt.value!==pdfViewer.currentPageNumber.toString()&&evt.value!==pdfViewer.currentPageLabel&&PDFViewerApplication.toolbar.setPageNumber(pdfViewer.currentPageNumber,pdfViewer.currentPageLabel)}function webViewerScaleChanged(evt){PDFViewerApplication.pdfViewer.currentScaleValue=evt.value}function webViewerRotateCw(){PDFViewerApplication.rotatePages(90)}function webViewerRotateCcw(){PDFViewerApplication.rotatePages(-90)}function webViewerOptionalContentConfig(evt){PDFViewerApplication.pdfViewer.optionalContentConfigPromise=evt.promise}function webViewerSwitchScrollMode(evt){PDFViewerApplication.pdfViewer.scrollMode=evt.mode}function webViewerSwitchSpreadMode(evt){PDFViewerApplication.pdfViewer.spreadMode=evt.mode}function webViewerDocumentProperties(){PDFViewerApplication.pdfDocumentProperties.open()}function webViewerFind(evt){PDFViewerApplication.findController.executeCommand("find"+evt.type,{query:evt.query,phraseSearch:evt.phraseSearch,caseSensitive:evt.caseSensitive,entireWord:evt.entireWord,highlightAll:evt.highlightAll,findPrevious:evt.findPrevious})}function webViewerFindFromUrlHash(evt){PDFViewerApplication.findController.executeCommand("find",{query:evt.query,phraseSearch:evt.phraseSearch,caseSensitive:!1,entireWord:!1,highlightAll:!0,findPrevious:!1})}function webViewerUpdateFindMatchesCount(_ref13){var matchesCount=_ref13.matchesCount;PDFViewerApplication.supportsIntegratedFind?PDFViewerApplication.externalServices.updateFindMatchesCount(matchesCount):PDFViewerApplication.findBar.updateResultsCount(matchesCount)}function webViewerUpdateFindControlState(_ref14){var state=_ref14.state,previous=_ref14.previous,matchesCount=_ref14.matchesCount,rawQuery=_ref14.rawQuery;PDFViewerApplication.supportsIntegratedFind?PDFViewerApplication.externalServices.updateFindControlState({result:state,findPrevious:previous,matchesCount:matchesCount,rawQuery:rawQuery}):PDFViewerApplication.findBar.updateUIState(state,previous,matchesCount)}function webViewerScaleChanging(evt){PDFViewerApplication.toolbar.setPageScale(evt.presetValue,evt.scale),PDFViewerApplication.pdfViewer.update()}function webViewerRotationChanging(evt){PDFViewerApplication.pdfThumbnailViewer.pagesRotation=evt.pagesRotation,PDFViewerApplication.forceRendering(),PDFViewerApplication.pdfViewer.currentPageNumber=evt.pageNumber}function webViewerPageChanging(_ref15){var pageNumber=_ref15.pageNumber,pageLabel=_ref15.pageLabel;PDFViewerApplication.toolbar.setPageNumber(pageNumber,pageLabel),PDFViewerApplication.secondaryToolbar.setPageNumber(pageNumber),PDFViewerApplication.pdfSidebar.isThumbnailViewVisible&&PDFViewerApplication.pdfThumbnailViewer.scrollThumbnailIntoView(pageNumber)}function webViewerVisibilityChange(evt){"visible"===document.visibilityState&&setZoomDisabledTimeout()}validateFileURL=function(file){if(void 0!==file)try{var viewerOrigin=new URL(window.location.href).origin||"null";if(HOSTED_VIEWER_ORIGINS.includes(viewerOrigin))return;var _URL=new URL(file,window.location.href),origin=_URL.origin,protocol=_URL.protocol;if(origin!==viewerOrigin&&"blob:"!==protocol)throw new Error("file origin does not match viewer's")}catch(ex){throw PDFViewerApplication.l10n.get("loading_error").then((function(msg){PDFViewerApplication._documentError(msg,{message:null==ex?void 0:ex.message})})),ex}},webViewerFileInputChange=function(evt){var _PDFViewerApplication2;if(null===(_PDFViewerApplication2=PDFViewerApplication.pdfViewer)||void 0===_PDFViewerApplication2||!_PDFViewerApplication2.isInPresentationMode){var file=evt.fileInput.files[0];if(_app_options.compatibilityParams.disableCreateObjectURL){PDFViewerApplication.setTitleUsingUrl(file.name);var fileReader=new FileReader;fileReader.onload=function(event){var buffer=event.target.result;PDFViewerApplication.open(new Uint8Array(buffer))},fileReader.readAsArrayBuffer(file)}else{var url=URL.createObjectURL(file);file.name&&(url={url:url,originalUrl:file.name}),PDFViewerApplication.open(url)}var appConfig=PDFViewerApplication.appConfig;appConfig.toolbar.viewBookmark.hidden=!0,appConfig.secondaryToolbar.viewBookmarkButton.hidden=!0,appConfig.toolbar.download.hidden=!0,appConfig.secondaryToolbar.downloadButton.hidden=!0}},webViewerOpenFile=function(evt){var openFileInputName=PDFViewerApplication.appConfig.openFileInputName;document.getElementById(openFileInputName).click()};var zoomDisabledTimeout=null;function setZoomDisabledTimeout(){zoomDisabledTimeout&&clearTimeout(zoomDisabledTimeout),zoomDisabledTimeout=setTimeout((function(){zoomDisabledTimeout=null}),1e3)}function webViewerWheel(evt){var pdfViewer=PDFViewerApplication.pdfViewer,supportedMouseWheelZoomModifierKeys=PDFViewerApplication.supportedMouseWheelZoomModifierKeys;if(!pdfViewer.isInPresentationMode)if(evt.ctrlKey&&supportedMouseWheelZoomModifierKeys.ctrlKey||evt.metaKey&&supportedMouseWheelZoomModifierKeys.metaKey){if(evt.preventDefault(),zoomDisabledTimeout||"hidden"===document.visibilityState)return;var previousScale=pdfViewer.currentScale,delta=(0,_ui_utils.normalizeWheelEventDirection)(evt),ticks=0;if(evt.deltaMode===WheelEvent.DOM_DELTA_LINE||evt.deltaMode===WheelEvent.DOM_DELTA_PAGE)ticks=Math.abs(delta)>=1?Math.sign(delta):PDFViewerApplication.accumulateWheelTicks(delta);else{ticks=PDFViewerApplication.accumulateWheelTicks(delta/30)}ticks<0?PDFViewerApplication.zoomOut(-ticks):ticks>0&&PDFViewerApplication.zoomIn(ticks);var currentScale=pdfViewer.currentScale;if(previousScale!==currentScale){var scaleCorrectionFactor=currentScale/previousScale-1,rect=pdfViewer.container.getBoundingClientRect(),dx=evt.clientX-rect.left,dy=evt.clientY-rect.top;pdfViewer.container.scrollLeft+=dx*scaleCorrectionFactor,pdfViewer.container.scrollTop+=dy*scaleCorrectionFactor}}else setZoomDisabledTimeout()}function webViewerTouchStart(evt){evt.touches.length>1&&evt.preventDefault()}function webViewerClick(evt){if(PDFViewerApplication.secondaryToolbar.isOpen){var appConfig=PDFViewerApplication.appConfig;(PDFViewerApplication.pdfViewer.containsElement(evt.target)||appConfig.toolbar.container.contains(evt.target)&&evt.target!==appConfig.secondaryToolbar.toggleButton)&&PDFViewerApplication.secondaryToolbar.close()}}function webViewerKeyDown(evt){if(!PDFViewerApplication.overlayManager.active){var handled=!1,ensureViewerFocused=!1,cmd=(evt.ctrlKey?1:0)|(evt.altKey?2:0)|(evt.shiftKey?4:0)|(evt.metaKey?8:0),pdfViewer=PDFViewerApplication.pdfViewer,isViewerInPresentationMode=null==pdfViewer?void 0:pdfViewer.isInPresentationMode;if(1===cmd||8===cmd||5===cmd||12===cmd)switch(evt.keyCode){case 70:PDFViewerApplication.supportsIntegratedFind||evt.shiftKey||(PDFViewerApplication.findBar.open(),handled=!0);break;case 71:if(!PDFViewerApplication.supportsIntegratedFind){var findState=PDFViewerApplication.findController.state;findState&&PDFViewerApplication.findController.executeCommand("findagain",{query:findState.query,phraseSearch:findState.phraseSearch,caseSensitive:findState.caseSensitive,entireWord:findState.entireWord,highlightAll:findState.highlightAll,findPrevious:5===cmd||12===cmd}),handled=!0}break;case 61:case 107:case 187:case 171:isViewerInPresentationMode||PDFViewerApplication.zoomIn(),handled=!0;break;case 173:case 109:case 189:isViewerInPresentationMode||PDFViewerApplication.zoomOut(),handled=!0;break;case 48:case 96:isViewerInPresentationMode||(setTimeout((function(){PDFViewerApplication.zoomReset()})),handled=!1);break;case 38:(isViewerInPresentationMode||PDFViewerApplication.page>1)&&(PDFViewerApplication.page=1,handled=!0,ensureViewerFocused=!0);break;case 40:(isViewerInPresentationMode||PDFViewerApplication.page<PDFViewerApplication.pagesCount)&&(PDFViewerApplication.page=PDFViewerApplication.pagesCount,handled=!0,ensureViewerFocused=!0)}var eventBus=PDFViewerApplication.eventBus;if(1===cmd||8===cmd)switch(evt.keyCode){case 83:eventBus.dispatch("download",{source:window}),handled=!0;break;case 79:eventBus.dispatch("openfile",{source:window}),handled=!0}if(3===cmd||10===cmd)switch(evt.keyCode){case 80:PDFViewerApplication.requestPresentationMode(),handled=!0;break;case 71:PDFViewerApplication.appConfig.toolbar.pageNumber.select(),handled=!0}if(handled)return ensureViewerFocused&&!isViewerInPresentationMode&&pdfViewer.focus(),void evt.preventDefault();var curElement=(0,_ui_utils.getActiveOrFocusedElement)(),curElementTagName=null==curElement?void 0:curElement.tagName.toUpperCase();if(!("INPUT"===curElementTagName||"TEXTAREA"===curElementTagName||"SELECT"===curElementTagName||null!=curElement&&curElement.isContentEditable)||27===evt.keyCode){if(0===cmd){var turnPage=0,turnOnlyIfPageFit=!1;switch(evt.keyCode){case 38:case 33:pdfViewer.isVerticalScrollbarEnabled&&(turnOnlyIfPageFit=!0),turnPage=-1;break;case 8:isViewerInPresentationMode||(turnOnlyIfPageFit=!0),turnPage=-1;break;case 37:pdfViewer.isHorizontalScrollbarEnabled&&(turnOnlyIfPageFit=!0);case 75:case 80:turnPage=-1;break;case 27:PDFViewerApplication.secondaryToolbar.isOpen&&(PDFViewerApplication.secondaryToolbar.close(),handled=!0),!PDFViewerApplication.supportsIntegratedFind&&PDFViewerApplication.findBar.opened&&(PDFViewerApplication.findBar.close(),handled=!0);break;case 40:case 34:pdfViewer.isVerticalScrollbarEnabled&&(turnOnlyIfPageFit=!0),turnPage=1;break;case 13:case 32:isViewerInPresentationMode||(turnOnlyIfPageFit=!0),turnPage=1;break;case 39:pdfViewer.isHorizontalScrollbarEnabled&&(turnOnlyIfPageFit=!0);case 74:case 78:turnPage=1;break;case 36:(isViewerInPresentationMode||PDFViewerApplication.page>1)&&(PDFViewerApplication.page=1,handled=!0,ensureViewerFocused=!0);break;case 35:(isViewerInPresentationMode||PDFViewerApplication.page<PDFViewerApplication.pagesCount)&&(PDFViewerApplication.page=PDFViewerApplication.pagesCount,handled=!0,ensureViewerFocused=!0);break;case 83:PDFViewerApplication.pdfCursorTools.switchTool(_pdf_cursor_tools.CursorTool.SELECT);break;case 72:PDFViewerApplication.pdfCursorTools.switchTool(_pdf_cursor_tools.CursorTool.HAND);break;case 82:PDFViewerApplication.rotatePages(90);break;case 115:PDFViewerApplication.pdfSidebar.toggle()}0===turnPage||turnOnlyIfPageFit&&"page-fit"!==pdfViewer.currentScaleValue||(turnPage>0?pdfViewer.nextPage():pdfViewer.previousPage(),handled=!0)}if(4===cmd)switch(evt.keyCode){case 13:case 32:if(!isViewerInPresentationMode&&"page-fit"!==pdfViewer.currentScaleValue)break;PDFViewerApplication.page>1&&PDFViewerApplication.page--,handled=!0;break;case 82:PDFViewerApplication.rotatePages(-90)}handled||isViewerInPresentationMode||(evt.keyCode>=33&&evt.keyCode<=40||32===evt.keyCode&&"BUTTON"!==curElementTagName)&&(ensureViewerFocused=!0),ensureViewerFocused&&!pdfViewer.containsElement(curElement)&&pdfViewer.focus(),handled&&evt.preventDefault()}}}function beforeUnload(evt){return evt.preventDefault(),evt.returnValue="",!1}var PDFPrintServiceFactory={instance:{supportsPrinting:!1,createPrintService:function(){throw new Error("Not implemented: createPrintService")}}};exports.PDFPrintServiceFactory=PDFPrintServiceFactory},(module,__unused_webpack_exports,__webpack_require__)=>{module.exports=__webpack_require__(4)},(module,__unused_webpack_exports,__webpack_require__)=>{function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}var runtime=function(exports){var Op=Object.prototype,hasOwn=Op.hasOwnProperty,$Symbol="function"==typeof Symbol?Symbol:{},iteratorSymbol=$Symbol.iterator||"@@iterator",asyncIteratorSymbol=$Symbol.asyncIterator||"@@asyncIterator",toStringTagSymbol=$Symbol.toStringTag||"@@toStringTag";function define(obj,key,value){return Object.defineProperty(obj,key,{value:value,enumerable:!0,configurable:!0,writable:!0}),obj[key]}try{define({},"")}catch(err){define=function(obj,key,value){return obj[key]=value}}function wrap(innerFn,outerFn,self,tryLocsList){var protoGenerator=outerFn&&outerFn.prototype instanceof Generator?outerFn:Generator,generator=Object.create(protoGenerator.prototype),context=new Context(tryLocsList||[]);return generator._invoke=function(innerFn,self,context){var state="suspendedStart";return function(method,arg){if("executing"===state)throw new Error("Generator is already running");if("completed"===state){if("throw"===method)throw arg;return doneResult()}for(context.method=method,context.arg=arg;;){var delegate=context.delegate;if(delegate){var delegateResult=maybeInvokeDelegate(delegate,context);if(delegateResult){if(delegateResult===ContinueSentinel)continue;return delegateResult}}if("next"===context.method)context.sent=context._sent=context.arg;else if("throw"===context.method){if("suspendedStart"===state)throw state="completed",context.arg;context.dispatchException(context.arg)}else"return"===context.method&&context.abrupt("return",context.arg);state="executing";var record=tryCatch(innerFn,self,context);if("normal"===record.type){if(state=context.done?"completed":"suspendedYield",record.arg===ContinueSentinel)continue;return{value:record.arg,done:context.done}}"throw"===record.type&&(state="completed",context.method="throw",context.arg=record.arg)}}}(innerFn,self,context),generator}function tryCatch(fn,obj,arg){try{return{type:"normal",arg:fn.call(obj,arg)}}catch(err){return{type:"throw",arg:err}}}exports.wrap=wrap;var ContinueSentinel={};function Generator(){}function GeneratorFunction(){}function GeneratorFunctionPrototype(){}var IteratorPrototype={};define(IteratorPrototype,iteratorSymbol,(function(){return this}));var getProto=Object.getPrototypeOf,NativeIteratorPrototype=getProto&&getProto(getProto(values([])));NativeIteratorPrototype&&NativeIteratorPrototype!==Op&&hasOwn.call(NativeIteratorPrototype,iteratorSymbol)&&(IteratorPrototype=NativeIteratorPrototype);var Gp=GeneratorFunctionPrototype.prototype=Generator.prototype=Object.create(IteratorPrototype);function defineIteratorMethods(prototype){["next","throw","return"].forEach((function(method){define(prototype,method,(function(arg){return this._invoke(method,arg)}))}))}function AsyncIterator(generator,PromiseImpl){function invoke(method,arg,resolve,reject){var record=tryCatch(generator[method],generator,arg);if("throw"!==record.type){var result=record.arg,value=result.value;return value&&"object"===_typeof(value)&&hasOwn.call(value,"__await")?PromiseImpl.resolve(value.__await).then((function(value){invoke("next",value,resolve,reject)}),(function(err){invoke("throw",err,resolve,reject)})):PromiseImpl.resolve(value).then((function(unwrapped){result.value=unwrapped,resolve(result)}),(function(error){return invoke("throw",error,resolve,reject)}))}reject(record.arg)}var previousPromise;this._invoke=function(method,arg){function callInvokeWithMethodAndArg(){return new PromiseImpl((function(resolve,reject){invoke(method,arg,resolve,reject)}))}return previousPromise=previousPromise?previousPromise.then(callInvokeWithMethodAndArg,callInvokeWithMethodAndArg):callInvokeWithMethodAndArg()}}function maybeInvokeDelegate(delegate,context){var method=delegate.iterator[context.method];if(undefined===method){if(context.delegate=null,"throw"===context.method){if(delegate.iterator.return&&(context.method="return",context.arg=undefined,maybeInvokeDelegate(delegate,context),"throw"===context.method))return ContinueSentinel;context.method="throw",context.arg=new TypeError("The iterator does not provide a 'throw' method")}return ContinueSentinel}var record=tryCatch(method,delegate.iterator,context.arg);if("throw"===record.type)return context.method="throw",context.arg=record.arg,context.delegate=null,ContinueSentinel;var info=record.arg;return info?info.done?(context[delegate.resultName]=info.value,context.next=delegate.nextLoc,"return"!==context.method&&(context.method="next",context.arg=undefined),context.delegate=null,ContinueSentinel):info:(context.method="throw",context.arg=new TypeError("iterator result is not an object"),context.delegate=null,ContinueSentinel)}function pushTryEntry(locs){var entry={tryLoc:locs[0]};1 in locs&&(entry.catchLoc=locs[1]),2 in locs&&(entry.finallyLoc=locs[2],entry.afterLoc=locs[3]),this.tryEntries.push(entry)}function resetTryEntry(entry){var record=entry.completion||{};record.type="normal",delete record.arg,entry.completion=record}function Context(tryLocsList){this.tryEntries=[{tryLoc:"root"}],tryLocsList.forEach(pushTryEntry,this),this.reset(!0)}function values(iterable){if(iterable){var iteratorMethod=iterable[iteratorSymbol];if(iteratorMethod)return iteratorMethod.call(iterable);if("function"==typeof iterable.next)return iterable;if(!isNaN(iterable.length)){var i=-1,next=function next(){for(;++i<iterable.length;)if(hasOwn.call(iterable,i))return next.value=iterable[i],next.done=!1,next;return next.value=undefined,next.done=!0,next};return next.next=next}}return{next:doneResult}}function doneResult(){return{value:undefined,done:!0}}return GeneratorFunction.prototype=GeneratorFunctionPrototype,define(Gp,"constructor",GeneratorFunctionPrototype),define(GeneratorFunctionPrototype,"constructor",GeneratorFunction),GeneratorFunction.displayName=define(GeneratorFunctionPrototype,toStringTagSymbol,"GeneratorFunction"),exports.isGeneratorFunction=function(genFun){var ctor="function"==typeof genFun&&genFun.constructor;return!!ctor&&(ctor===GeneratorFunction||"GeneratorFunction"===(ctor.displayName||ctor.name))},exports.mark=function(genFun){return Object.setPrototypeOf?Object.setPrototypeOf(genFun,GeneratorFunctionPrototype):(genFun.__proto__=GeneratorFunctionPrototype,define(genFun,toStringTagSymbol,"GeneratorFunction")),genFun.prototype=Object.create(Gp),genFun},exports.awrap=function(arg){return{__await:arg}},defineIteratorMethods(AsyncIterator.prototype),define(AsyncIterator.prototype,asyncIteratorSymbol,(function(){return this})),exports.AsyncIterator=AsyncIterator,exports.async=function(innerFn,outerFn,self,tryLocsList,PromiseImpl){void 0===PromiseImpl&&(PromiseImpl=Promise);var iter=new AsyncIterator(wrap(innerFn,outerFn,self,tryLocsList),PromiseImpl);return exports.isGeneratorFunction(outerFn)?iter:iter.next().then((function(result){return result.done?result.value:iter.next()}))},defineIteratorMethods(Gp),define(Gp,toStringTagSymbol,"Generator"),define(Gp,iteratorSymbol,(function(){return this})),define(Gp,"toString",(function(){return"[object Generator]"})),exports.keys=function(object){var keys=[];for(var key in object)keys.push(key);return keys.reverse(),function next(){for(;keys.length;){var key=keys.pop();if(key in object)return next.value=key,next.done=!1,next}return next.done=!0,next}},exports.values=values,Context.prototype={constructor:Context,reset:function(skipTempReset){if(this.prev=0,this.next=0,this.sent=this._sent=undefined,this.done=!1,this.delegate=null,this.method="next",this.arg=undefined,this.tryEntries.forEach(resetTryEntry),!skipTempReset)for(var name in this)"t"===name.charAt(0)&&hasOwn.call(this,name)&&!isNaN(+name.slice(1))&&(this[name]=undefined)},stop:function(){this.done=!0;var rootRecord=this.tryEntries[0].completion;if("throw"===rootRecord.type)throw rootRecord.arg;return this.rval},dispatchException:function(exception){if(this.done)throw exception;var context=this;function handle(loc,caught){return record.type="throw",record.arg=exception,context.next=loc,caught&&(context.method="next",context.arg=undefined),!!caught}for(var i=this.tryEntries.length-1;i>=0;--i){var entry=this.tryEntries[i],record=entry.completion;if("root"===entry.tryLoc)return handle("end");if(entry.tryLoc<=this.prev){var hasCatch=hasOwn.call(entry,"catchLoc"),hasFinally=hasOwn.call(entry,"finallyLoc");if(hasCatch&&hasFinally){if(this.prev<entry.catchLoc)return handle(entry.catchLoc,!0);if(this.prev<entry.finallyLoc)return handle(entry.finallyLoc)}else if(hasCatch){if(this.prev<entry.catchLoc)return handle(entry.catchLoc,!0)}else{if(!hasFinally)throw new Error("try statement without catch or finally");if(this.prev<entry.finallyLoc)return handle(entry.finallyLoc)}}}},abrupt:function(type,arg){for(var i=this.tryEntries.length-1;i>=0;--i){var entry=this.tryEntries[i];if(entry.tryLoc<=this.prev&&hasOwn.call(entry,"finallyLoc")&&this.prev<entry.finallyLoc){var finallyEntry=entry;break}}finallyEntry&&("break"===type||"continue"===type)&&finallyEntry.tryLoc<=arg&&arg<=finallyEntry.finallyLoc&&(finallyEntry=null);var record=finallyEntry?finallyEntry.completion:{};return record.type=type,record.arg=arg,finallyEntry?(this.method="next",this.next=finallyEntry.finallyLoc,ContinueSentinel):this.complete(record)},complete:function(record,afterLoc){if("throw"===record.type)throw record.arg;return"break"===record.type||"continue"===record.type?this.next=record.arg:"return"===record.type?(this.rval=this.arg=record.arg,this.method="return",this.next="end"):"normal"===record.type&&afterLoc&&(this.next=afterLoc),ContinueSentinel},finish:function(finallyLoc){for(var i=this.tryEntries.length-1;i>=0;--i){var entry=this.tryEntries[i];if(entry.finallyLoc===finallyLoc)return this.complete(entry.completion,entry.afterLoc),resetTryEntry(entry),ContinueSentinel}},catch:function(tryLoc){for(var i=this.tryEntries.length-1;i>=0;--i){var entry=this.tryEntries[i];if(entry.tryLoc===tryLoc){var record=entry.completion;if("throw"===record.type){var thrown=record.arg;resetTryEntry(entry)}return thrown}}throw new Error("illegal catch attempt")},delegateYield:function(iterable,resultName,nextLoc){return this.delegate={iterator:values(iterable),resultName:resultName,nextLoc:nextLoc},"next"===this.method&&(this.arg=undefined),ContinueSentinel}},exports}("object"===_typeof(module=__webpack_require__.nmd(module))?module.exports:{});try{regeneratorRuntime=runtime}catch(accidentalStrictMode){"object"===("undefined"==typeof globalThis?"undefined":_typeof(globalThis))?globalThis.regeneratorRuntime=runtime:Function("r","regeneratorRuntime = r")(runtime)}},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.apiPageLayoutToSpreadMode=function(layout){switch(layout){case"SinglePage":case"OneColumn":return SpreadMode.NONE;case"TwoColumnLeft":case"TwoPageLeft":return SpreadMode.ODD;case"TwoColumnRight":case"TwoPageRight":return SpreadMode.EVEN}return SpreadMode.NONE},exports.apiPageModeToSidebarView=function(mode){switch(mode){case"UseNone":return SidebarView.NONE;case"UseThumbs":return SidebarView.THUMBS;case"UseOutlines":return SidebarView.OUTLINE;case"UseAttachments":return SidebarView.ATTACHMENTS;case"UseOC":return SidebarView.LAYERS}return SidebarView.NONE},exports.approximateFraction=function(x){if(Math.floor(x)===x)return[x,1];var xinv=1/x;if(xinv>8)return[1,8];if(Math.floor(xinv)===xinv)return[1,xinv];var result,x_=x>1?xinv:x,a=0,b=1,c=1,d=1;for(;;){var p=a+c,q=b+d;if(q>8)break;x_<=p/q?(c=p,d=q):(a=p,b=q)}result=x_-a/b<c/d-x_?x_===x?[a,b]:[b,a]:x_===x?[c,d]:[d,c];return result},exports.backtrackBeforeAllVisibleElements=backtrackBeforeAllVisibleElements,exports.binarySearchFirstItem=binarySearchFirstItem,exports.getActiveOrFocusedElement=function(){var curRoot=document,curActiveOrFocused=curRoot.activeElement||curRoot.querySelector(":focus");for(;null!==(_curActiveOrFocused=curActiveOrFocused)&&void 0!==_curActiveOrFocused&&_curActiveOrFocused.shadowRoot;){var _curActiveOrFocused;curRoot=curActiveOrFocused.shadowRoot,curActiveOrFocused=curRoot.activeElement||curRoot.querySelector(":focus")}return curActiveOrFocused},exports.getOutputScale=function(ctx){var devicePixelRatio=window.devicePixelRatio||1,backingStoreRatio=ctx.webkitBackingStorePixelRatio||ctx.mozBackingStorePixelRatio||ctx.backingStorePixelRatio||1,pixelRatio=devicePixelRatio/backingStoreRatio;return{sx:pixelRatio,sy:pixelRatio,scaled:1!==pixelRatio}},exports.getPageSizeInches=function(_ref){var view=_ref.view,userUnit=_ref.userUnit,rotate=_ref.rotate,_view=(arr=view,i=4,function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null!=_i){var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}}(arr,i)||_unsupportedIterableToArray(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()),x1=_view[0],y1=_view[1],x2=_view[2],y2=_view[3],changeOrientation=rotate%180!=0,width=(x2-x1)/72*userUnit,height=(y2-y1)/72*userUnit;var arr,i;return{width:changeOrientation?height:width,height:changeOrientation?width:height}},exports.getVisibleElements=function(_ref2){var scrollEl=_ref2.scrollEl,views=_ref2.views,_ref2$sortByVisibilit=_ref2.sortByVisibility,sortByVisibility=void 0!==_ref2$sortByVisibilit&&_ref2$sortByVisibilit,_ref2$horizontal=_ref2.horizontal,horizontal=void 0!==_ref2$horizontal&&_ref2$horizontal,_ref2$rtl=_ref2.rtl,rtl=void 0!==_ref2$rtl&&_ref2$rtl,top=scrollEl.scrollTop,bottom=top+scrollEl.clientHeight,left=scrollEl.scrollLeft,right=left+scrollEl.clientWidth;var visible=[],numViews=views.length,firstVisibleElementInd=binarySearchFirstItem(views,horizontal?function(view){var element=view.div,elementLeft=element.offsetLeft+element.clientLeft,elementRight=elementLeft+element.clientWidth;return rtl?elementLeft<right:elementRight>left}:function(view){var element=view.div;return element.offsetTop+element.clientTop+element.clientHeight>top});firstVisibleElementInd>0&&firstVisibleElementInd<numViews&&!horizontal&&(firstVisibleElementInd=backtrackBeforeAllVisibleElements(firstVisibleElementInd,views,top));for(var lastEdge=horizontal?right:-1,i=firstVisibleElementInd;i<numViews;i++){var view=views[i],element=view.div,currentWidth=element.offsetLeft+element.clientLeft,currentHeight=element.offsetTop+element.clientTop,viewWidth=element.clientWidth,viewHeight=element.clientHeight,viewRight=currentWidth+viewWidth,viewBottom=currentHeight+viewHeight;if(-1===lastEdge)viewBottom>=bottom&&(lastEdge=viewBottom);else if((horizontal?currentWidth:currentHeight)>lastEdge)break;if(!(viewBottom<=top||currentHeight>=bottom||viewRight<=left||currentWidth>=right)){var hiddenHeight=Math.max(0,top-currentHeight)+Math.max(0,viewBottom-bottom),hiddenWidth=Math.max(0,left-currentWidth)+Math.max(0,viewRight-right),fractionWidth=(viewWidth-hiddenWidth)/viewWidth,percent=(viewHeight-hiddenHeight)/viewHeight*fractionWidth*100|0;visible.push({id:view.id,x:currentWidth,y:currentHeight,view:view,percent:percent,widthPercent:100*fractionWidth|0})}}var first=visible[0],last=visible[visible.length-1];sortByVisibility&&visible.sort((function(a,b){var pc=a.percent-b.percent;return Math.abs(pc)>.001?-pc:a.id-b.id}));return{first:first,last:last,views:visible}},exports.isPortraitOrientation=function(size){return size.width<=size.height},exports.isValidRotation=function(angle){return Number.isInteger(angle)&&angle%90==0},exports.isValidScrollMode=function(mode){return Number.isInteger(mode)&&Object.values(ScrollMode).includes(mode)&&mode!==ScrollMode.UNKNOWN},exports.isValidSpreadMode=function(mode){return Number.isInteger(mode)&&Object.values(SpreadMode).includes(mode)&&mode!==SpreadMode.UNKNOWN},exports.moveToEndOfArray=function(arr,condition){for(var moved=[],len=arr.length,write=0,read=0;read<len;++read)condition(arr[read])?moved.push(arr[read]):(arr[write]=arr[read],++write);for(var _read=0;write<len;++_read,++write)arr[write]=moved[_read]},exports.noContextMenuHandler=function(evt){evt.preventDefault()},exports.normalizeWheelEventDelta=function(evt){var delta=normalizeWheelEventDirection(evt);0===evt.deltaMode?delta/=900:1===evt.deltaMode&&(delta/=30);return delta},exports.normalizeWheelEventDirection=normalizeWheelEventDirection,exports.parseQueryString=function(query){var _step,params=new Map,_iterator=_createForOfIteratorHelper(query.split("&"));try{for(_iterator.s();!(_step=_iterator.n()).done;){var param=_step.value.split("="),key=param[0].toLowerCase(),value=param.length>1?param[1]:"";params.set(decodeURIComponent(key),decodeURIComponent(value))}}catch(err){_iterator.e(err)}finally{_iterator.f()}return params},exports.roundToDivide=function(x,div){var r=x%div;return 0===r?x:Math.round(x-r+div)},exports.scrollIntoView=function(element,spot){var scrollMatches=arguments.length>2&&void 0!==arguments[2]&&arguments[2],parent=element.offsetParent;if(!parent)return void console.error("offsetParent is not set -- cannot scroll");var offsetY=element.offsetTop+element.clientTop,offsetX=element.offsetLeft+element.clientLeft;for(;parent.clientHeight===parent.scrollHeight&&parent.clientWidth===parent.scrollWidth||scrollMatches&&(parent.classList.contains("markedContent")||"hidden"===getComputedStyle(parent).overflow);)if(offsetY+=parent.offsetTop,offsetX+=parent.offsetLeft,!(parent=parent.offsetParent))return;spot&&(void 0!==spot.top&&(offsetY+=spot.top),void 0!==spot.left&&(offsetX+=spot.left,parent.scrollLeft=offsetX));parent.scrollTop=offsetY},exports.waitOnEventOrTimeout=function(_ref3){var target=_ref3.target,name=_ref3.name,_ref3$delay=_ref3.delay,delay=void 0===_ref3$delay?0:_ref3$delay;return new Promise((function(resolve,reject){if("object"!==_typeof(target)||!name||"string"!=typeof name||!(Number.isInteger(delay)&&delay>=0))throw new Error("waitOnEventOrTimeout - invalid parameters.");function handler(type){target instanceof EventBus?target._off(name,eventHandler):target.removeEventListener(name,eventHandler),timeout&&clearTimeout(timeout),resolve(type)}var eventHandler=handler.bind(null,WaitOnType.EVENT);target instanceof EventBus?target._on(name,eventHandler):target.addEventListener(name,eventHandler);var timeoutHandler=handler.bind(null,WaitOnType.TIMEOUT),timeout=setTimeout(timeoutHandler,delay)}))},exports.watchScroll=function(viewAreaElement,callback){var debounceScroll=function(evt){rAF||(rAF=window.requestAnimationFrame((function(){rAF=null;var currentX=viewAreaElement.scrollLeft,lastX=state.lastX;currentX!==lastX&&(state.right=currentX>lastX),state.lastX=currentX;var currentY=viewAreaElement.scrollTop,lastY=state.lastY;currentY!==lastY&&(state.down=currentY>lastY),state.lastY=currentY,callback(state)})))},state={right:!0,down:!0,lastX:viewAreaElement.scrollLeft,lastY:viewAreaElement.scrollTop,_eventHandler:debounceScroll},rAF=null;return viewAreaElement.addEventListener("scroll",debounceScroll,!0),state},exports.WaitOnType=exports.VERTICAL_PADDING=exports.UNKNOWN_SCALE=exports.TextLayerMode=exports.SpreadMode=exports.SidebarView=exports.ScrollMode=exports.SCROLLBAR_PADDING=exports.RendererType=exports.ProgressBar=exports.PresentationModeState=exports.MIN_SCALE=exports.MAX_SCALE=exports.MAX_AUTO_SCALE=exports.EventBus=exports.DEFAULT_SCALE_VALUE=exports.DEFAULT_SCALE=exports.CSS_UNITS=exports.AutoPrintRegExp=exports.animationStarted=void 0;var _pdfjsLib=__webpack_require__(6);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _createClass(Constructor,protoProps,staticProps){return protoProps&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),Constructor}function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e2){throw _e2},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e3){didErr=!0,err=_e3},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _unsupportedIterableToArray(o,minLen){if(o){if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);return"Object"===n&&o.constructor&&(n=o.constructor.name),"Map"===n||"Set"===n?Array.from(o):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?_arrayLikeToArray(o,minLen):void 0}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}var CSS_UNITS=_pdfjsLib.PixelsPerInch.CSS/_pdfjsLib.PixelsPerInch.PDF;exports.CSS_UNITS=CSS_UNITS;exports.DEFAULT_SCALE_VALUE="auto";exports.DEFAULT_SCALE=1;exports.MIN_SCALE=.1;exports.MAX_SCALE=10;exports.UNKNOWN_SCALE=0;exports.MAX_AUTO_SCALE=1.25;exports.SCROLLBAR_PADDING=40;exports.VERTICAL_PADDING=5;exports.PresentationModeState={UNKNOWN:0,NORMAL:1,CHANGING:2,FULLSCREEN:3};var SidebarView={UNKNOWN:-1,NONE:0,THUMBS:1,OUTLINE:2,ATTACHMENTS:3,LAYERS:4};exports.SidebarView=SidebarView;exports.RendererType={CANVAS:"canvas",SVG:"svg"};exports.TextLayerMode={DISABLE:0,ENABLE:1,ENABLE_ENHANCE:2};var ScrollMode={UNKNOWN:-1,VERTICAL:0,HORIZONTAL:1,WRAPPED:2};exports.ScrollMode=ScrollMode;var SpreadMode={UNKNOWN:-1,NONE:0,ODD:1,EVEN:2};exports.SpreadMode=SpreadMode;function binarySearchFirstItem(items,condition){var minIndex=0,maxIndex=items.length-1;if(maxIndex<0||!condition(items[maxIndex]))return items.length;if(condition(items[minIndex]))return minIndex;for(;minIndex<maxIndex;){var currentIndex=minIndex+maxIndex>>1;condition(items[currentIndex])?maxIndex=currentIndex:minIndex=currentIndex+1}return minIndex}function backtrackBeforeAllVisibleElements(index,views,top){if(index<2)return index;var elt=views[index].div,pageTop=elt.offsetTop+elt.clientTop;pageTop>=top&&(pageTop=(elt=views[index-1].div).offsetTop+elt.clientTop);for(var i=index-2;i>=0&&!((elt=views[i].div).offsetTop+elt.clientTop+elt.clientHeight<=pageTop);--i)index=i;return index}function normalizeWheelEventDirection(evt){var delta=Math.hypot(evt.deltaX,evt.deltaY),angle=Math.atan2(evt.deltaY,evt.deltaX);return-.25*Math.PI<angle&&angle<.75*Math.PI&&(delta=-delta),delta}exports.AutoPrintRegExp=/\bprint\s*\(/;var WaitOnType={EVENT:"event",TIMEOUT:"timeout"};exports.WaitOnType=WaitOnType;var animationStarted=new Promise((function(resolve){window.requestAnimationFrame(resolve)}));exports.animationStarted=animationStarted;var EventBus=function(){function EventBus(options){_classCallCheck(this,EventBus),this._listeners=Object.create(null)}return _createClass(EventBus,[{key:"on",value:function(eventName,listener){var options=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;this._on(eventName,listener,{external:!0,once:null==options?void 0:options.once})}},{key:"off",value:function(eventName,listener){var options=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;this._off(eventName,listener,{external:!0,once:null==options?void 0:options.once})}},{key:"dispatch",value:function(eventName){var eventListeners=this._listeners[eventName];if(eventListeners&&0!==eventListeners.length){var externalListeners,_step2,args=Array.prototype.slice.call(arguments,1),_iterator2=_createForOfIteratorHelper(eventListeners.slice(0));try{for(_iterator2.s();!(_step2=_iterator2.n()).done;){var _step2$value=_step2.value,_listener=_step2$value.listener,external=_step2$value.external,once=_step2$value.once;once&&this._off(eventName,_listener),external?(externalListeners||(externalListeners=[])).push(_listener):_listener.apply(null,args)}}catch(err){_iterator2.e(err)}finally{_iterator2.f()}if(externalListeners){var _step3,_iterator3=_createForOfIteratorHelper(externalListeners);try{for(_iterator3.s();!(_step3=_iterator3.n()).done;){var listener=_step3.value;listener.apply(null,args)}}catch(err){_iterator3.e(err)}finally{_iterator3.f()}externalListeners=null}}}},{key:"_on",value:function(eventName,listener){var _this$_listeners,options=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,eventListeners=(_this$_listeners=this._listeners)[eventName]||(_this$_listeners[eventName]=[]);eventListeners.push({listener:listener,external:!0===(null==options?void 0:options.external),once:!0===(null==options?void 0:options.once)})}},{key:"_off",value:function(eventName,listener){var eventListeners=this._listeners[eventName];if(eventListeners)for(var i=0,ii=eventListeners.length;i<ii;i++)if(eventListeners[i].listener===listener)return void eventListeners.splice(i,1)}}]),EventBus}();exports.EventBus=EventBus;var ProgressBar=function(){function ProgressBar(id){var _ref4=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{},height=_ref4.height,width=_ref4.width,units=_ref4.units;_classCallCheck(this,ProgressBar),this.visible=!0,this.div=document.querySelector(id+" .progress"),this.bar=this.div.parentNode,this.height=height||100,this.width=width||100,this.units=units||"%",this.div.style.height=this.height+this.units,this.percent=0}return _createClass(ProgressBar,[{key:"_updateBar",value:function(){if(this._indeterminate)return this.div.classList.add("indeterminate"),void(this.div.style.width=this.width+this.units);this.div.classList.remove("indeterminate");var progressSize=this.width*this._percent/100;this.div.style.width=progressSize+this.units}},{key:"percent",get:function(){return this._percent},set:function(val){var v,min,max;this._indeterminate=isNaN(val),this._percent=(v=val,min=0,max=100,Math.min(Math.max(v,min),max)),this._updateBar()}},{key:"setWidth",value:function(viewer){if(viewer){var scrollbarWidth=viewer.parentNode.offsetWidth-viewer.offsetWidth;if(scrollbarWidth>0)document.documentElement.style.setProperty("--loadingBar-end-offset","".concat(scrollbarWidth,"px"))}}},{key:"hide",value:function(){this.visible&&(this.visible=!1,this.bar.classList.add("hidden"))}},{key:"show",value:function(){this.visible||(this.visible=!0,this.bar.classList.remove("hidden"))}}]),ProgressBar}();exports.ProgressBar=ProgressBar},module=>{var pdfjsLib;pdfjsLib="undefined"!=typeof window&&window["pdfjs-dist/build/pdf"]?window["pdfjs-dist/build/pdf"]:require("../build/pdf.js"),module.exports=pdfjsLib},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFCursorTools=exports.CursorTool=void 0;var _grab_to_pan=__webpack_require__(8),_ui_utils=__webpack_require__(5);function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var CursorTool={SELECT:0,HAND:1,ZOOM:2};exports.CursorTool=CursorTool;var PDFCursorTools=function(){function PDFCursorTools(_ref){var _this=this,container=_ref.container,eventBus=_ref.eventBus,_ref$cursorToolOnLoad=_ref.cursorToolOnLoad,cursorToolOnLoad=void 0===_ref$cursorToolOnLoad?CursorTool.SELECT:_ref$cursorToolOnLoad;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFCursorTools),this.container=container,this.eventBus=eventBus,this.active=CursorTool.SELECT,this.activeBeforePresentationMode=null,this.handTool=new _grab_to_pan.GrabToPan({element:this.container}),this._addEventListeners(),Promise.resolve().then((function(){_this.switchTool(cursorToolOnLoad)}))}var Constructor,protoProps,staticProps;return Constructor=PDFCursorTools,(protoProps=[{key:"activeTool",get:function(){return this.active}},{key:"switchTool",value:function(tool){var _this2=this;if(null===this.activeBeforePresentationMode&&tool!==this.active){var disableActiveTool=function(){switch(_this2.active){case CursorTool.SELECT:break;case CursorTool.HAND:_this2.handTool.deactivate()}};switch(tool){case CursorTool.SELECT:disableActiveTool();break;case CursorTool.HAND:disableActiveTool(),this.handTool.activate();break;case CursorTool.ZOOM:default:return void console.error('switchTool: "'.concat(tool,'" is an unsupported value.'))}this.active=tool,this._dispatchEvent()}}},{key:"_dispatchEvent",value:function(){this.eventBus.dispatch("cursortoolchanged",{source:this,tool:this.active})}},{key:"_addEventListeners",value:function(){var _this3=this;this.eventBus._on("switchcursortool",(function(evt){_this3.switchTool(evt.tool)})),this.eventBus._on("presentationmodechanged",(function(evt){switch(evt.state){case _ui_utils.PresentationModeState.FULLSCREEN:var previouslyActive=_this3.active;_this3.switchTool(CursorTool.SELECT),_this3.activeBeforePresentationMode=previouslyActive;break;case _ui_utils.PresentationModeState.NORMAL:var _previouslyActive=_this3.activeBeforePresentationMode;_this3.activeBeforePresentationMode=null,_this3.switchTool(_previouslyActive)}}))}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFCursorTools}();exports.PDFCursorTools=PDFCursorTools},(__unused_webpack_module,exports)=>{function GrabToPan(options){this.element=options.element,this.document=options.element.ownerDocument,"function"==typeof options.ignoreTarget&&(this.ignoreTarget=options.ignoreTarget),this.onActiveChanged=options.onActiveChanged,this.activate=this.activate.bind(this),this.deactivate=this.deactivate.bind(this),this.toggle=this.toggle.bind(this),this._onmousedown=this._onmousedown.bind(this),this._onmousemove=this._onmousemove.bind(this),this._endPan=this._endPan.bind(this),(this.overlay=document.createElement("div")).className="grab-to-pan-grabbing"}Object.defineProperty(exports,"__esModule",{value:!0}),exports.GrabToPan=GrabToPan,GrabToPan.prototype={CSS_CLASS_GRAB:"grab-to-pan-grab",activate:function(){this.active||(this.active=!0,this.element.addEventListener("mousedown",this._onmousedown,!0),this.element.classList.add(this.CSS_CLASS_GRAB),this.onActiveChanged&&this.onActiveChanged(!0))},deactivate:function(){this.active&&(this.active=!1,this.element.removeEventListener("mousedown",this._onmousedown,!0),this._endPan(),this.element.classList.remove(this.CSS_CLASS_GRAB),this.onActiveChanged&&this.onActiveChanged(!1))},toggle:function(){this.active?this.deactivate():this.activate()},ignoreTarget:function(node){return node.matches("a[href], a[href] *, input, textarea, button, button *, select, option")},_onmousedown:function(event){if(0===event.button&&!this.ignoreTarget(event.target)){if(event.originalTarget)try{event.originalTarget.tagName}catch(e){return}this.scrollLeftStart=this.element.scrollLeft,this.scrollTopStart=this.element.scrollTop,this.clientXStart=event.clientX,this.clientYStart=event.clientY,this.document.addEventListener("mousemove",this._onmousemove,!0),this.document.addEventListener("mouseup",this._endPan,!0),this.element.addEventListener("scroll",this._endPan,!0),event.preventDefault(),event.stopPropagation();var focusedElement=document.activeElement;focusedElement&&!focusedElement.contains(event.target)&&focusedElement.blur()}},_onmousemove:function(event){if(this.element.removeEventListener("scroll",this._endPan,!0),function(event){if("buttons"in event)return!(1&event.buttons);var chrome=window.chrome,isChrome15OrOpera15plus=chrome&&(chrome.webstore||chrome.app),isSafari6plus=/Apple/.test(navigator.vendor)&&/Version\/([6-9]\d*|[1-5]\d+)/.test(navigator.userAgent);if(isChrome15OrOpera15plus||isSafari6plus)return 0===event.which;return!1}(event))this._endPan();else{var xDiff=event.clientX-this.clientXStart,yDiff=event.clientY-this.clientYStart,scrollTop=this.scrollTopStart-yDiff,scrollLeft=this.scrollLeftStart-xDiff;this.element.scrollTo?this.element.scrollTo({top:scrollTop,left:scrollLeft,behavior:"instant"}):(this.element.scrollTop=scrollTop,this.element.scrollLeft=scrollLeft),this.overlay.parentNode||document.body.appendChild(this.overlay)}},_endPan:function(){this.element.removeEventListener("scroll",this._endPan,!0),this.document.removeEventListener("mousemove",this._onmousemove,!0),this.document.removeEventListener("mouseup",this._endPan,!0),this.overlay.remove()}}},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.RenderingStates=exports.PDFRenderingQueue=void 0;var _pdfjsLib=__webpack_require__(6);function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var RenderingStates={INITIAL:0,RUNNING:1,PAUSED:2,FINISHED:3};exports.RenderingStates=RenderingStates;var PDFRenderingQueue=function(){function PDFRenderingQueue(){!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFRenderingQueue),this.pdfViewer=null,this.pdfThumbnailViewer=null,this.onIdle=null,this.highestPriorityPage=null,this.idleTimeout=null,this.printing=!1,this.isThumbnailViewEnabled=!1}var Constructor,protoProps,staticProps;return Constructor=PDFRenderingQueue,(protoProps=[{key:"setViewer",value:function(pdfViewer){this.pdfViewer=pdfViewer}},{key:"setThumbnailViewer",value:function(pdfThumbnailViewer){this.pdfThumbnailViewer=pdfThumbnailViewer}},{key:"isHighestPriority",value:function(view){return this.highestPriorityPage===view.renderingId}},{key:"hasViewer",value:function(){return!!this.pdfViewer}},{key:"renderHighestPriority",value:function(currentlyVisiblePages){this.idleTimeout&&(clearTimeout(this.idleTimeout),this.idleTimeout=null),this.pdfViewer.forceRendering(currentlyVisiblePages)||this.pdfThumbnailViewer&&this.isThumbnailViewEnabled&&this.pdfThumbnailViewer.forceRendering()||this.printing||this.onIdle&&(this.idleTimeout=setTimeout(this.onIdle.bind(this),3e4))}},{key:"getHighestPriority",value:function(visible,views,scrolledDown){var visibleViews=visible.views,numVisible=visibleViews.length;if(0===numVisible)return null;for(var i=0;i<numVisible;++i){var view=visibleViews[i].view;if(!this.isViewFinished(view))return view}if(scrolledDown){var nextPageIndex=visible.last.id;if(views[nextPageIndex]&&!this.isViewFinished(views[nextPageIndex]))return views[nextPageIndex]}else{var previousPageIndex=visible.first.id-2;if(views[previousPageIndex]&&!this.isViewFinished(views[previousPageIndex]))return views[previousPageIndex]}return null}},{key:"isViewFinished",value:function(view){return view.renderingState===RenderingStates.FINISHED}},{key:"renderView",value:function(view){var _this=this;switch(view.renderingState){case RenderingStates.FINISHED:return!1;case RenderingStates.PAUSED:this.highestPriorityPage=view.renderingId,view.resume();break;case RenderingStates.RUNNING:this.highestPriorityPage=view.renderingId;break;case RenderingStates.INITIAL:this.highestPriorityPage=view.renderingId,view.draw().finally((function(){_this.renderHighestPriority()})).catch((function(reason){reason instanceof _pdfjsLib.RenderingCancelledException||console.error('renderView: "'.concat(reason,'"'))}))}return!0}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFRenderingQueue}();exports.PDFRenderingQueue=PDFRenderingQueue},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.OverlayManager=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj};function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var OverlayManager=function(){function OverlayManager(){!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,OverlayManager),this._overlays={},this._active=null,this._keyDownBound=this._keyDown.bind(this)}var Constructor,protoProps,staticProps,_close,_open,_unregister,_register;return Constructor=OverlayManager,(protoProps=[{key:"active",get:function(){return this._active}},{key:"register",value:(_register=_asyncToGenerator(_regenerator.default.mark((function _callee(name,element){var callerCloseMethod,canForceClose,container,_args=arguments;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:if(callerCloseMethod=_args.length>2&&void 0!==_args[2]?_args[2]:null,canForceClose=_args.length>3&&void 0!==_args[3]&&_args[3],name&&element&&(container=element.parentNode)){_context.next=6;break}throw new Error("Not enough parameters.");case 6:if(!this._overlays[name]){_context.next=8;break}throw new Error("The overlay is already registered.");case 8:this._overlays[name]={element:element,container:container,callerCloseMethod:callerCloseMethod,canForceClose:canForceClose};case 9:case"end":return _context.stop()}}),_callee,this)}))),function(_x,_x2){return _register.apply(this,arguments)})},{key:"unregister",value:(_unregister=_asyncToGenerator(_regenerator.default.mark((function _callee2(name){return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:if(this._overlays[name]){_context2.next=4;break}throw new Error("The overlay does not exist.");case 4:if(this._active!==name){_context2.next=6;break}throw new Error("The overlay cannot be removed while it is active.");case 6:delete this._overlays[name];case 7:case"end":return _context2.stop()}}),_callee2,this)}))),function(_x3){return _unregister.apply(this,arguments)})},{key:"open",value:(_open=_asyncToGenerator(_regenerator.default.mark((function _callee3(name){return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:if(this._overlays[name]){_context3.next=4;break}throw new Error("The overlay does not exist.");case 4:if(!this._active){_context3.next=14;break}if(!this._overlays[name].canForceClose){_context3.next=9;break}this._closeThroughCaller(),_context3.next=14;break;case 9:if(this._active!==name){_context3.next=13;break}throw new Error("The overlay is already active.");case 13:throw new Error("Another overlay is currently active.");case 14:this._active=name,this._overlays[this._active].element.classList.remove("hidden"),this._overlays[this._active].container.classList.remove("hidden"),window.addEventListener("keydown",this._keyDownBound);case 18:case"end":return _context3.stop()}}),_callee3,this)}))),function(_x4){return _open.apply(this,arguments)})},{key:"close",value:(_close=_asyncToGenerator(_regenerator.default.mark((function _callee4(name){return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:if(this._overlays[name]){_context4.next=4;break}throw new Error("The overlay does not exist.");case 4:if(this._active){_context4.next=8;break}throw new Error("The overlay is currently not active.");case 8:if(this._active===name){_context4.next=10;break}throw new Error("Another overlay is currently active.");case 10:this._overlays[this._active].container.classList.add("hidden"),this._overlays[this._active].element.classList.add("hidden"),this._active=null,window.removeEventListener("keydown",this._keyDownBound);case 14:case"end":return _context4.stop()}}),_callee4,this)}))),function(_x5){return _close.apply(this,arguments)})},{key:"_keyDown",value:function(evt){this._active&&27===evt.keyCode&&(this._closeThroughCaller(),evt.preventDefault())}},{key:"_closeThroughCaller",value:function(){this._overlays[this._active].callerCloseMethod&&this._overlays[this._active].callerCloseMethod(),this._active&&this.close(this._active)}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),OverlayManager}();exports.OverlayManager=OverlayManager},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PasswordPrompt=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_pdfjsLib=__webpack_require__(6);function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var PasswordPrompt=function(){function PasswordPrompt(options,overlayManager,l10n){var _this=this,isViewerEmbedded=arguments.length>3&&void 0!==arguments[3]&&arguments[3];_classCallCheck(this,PasswordPrompt),this.overlayName=options.overlayName,this.container=options.container,this.label=options.label,this.input=options.input,this.submitButton=options.submitButton,this.cancelButton=options.cancelButton,this.overlayManager=overlayManager,this.l10n=l10n,this._isViewerEmbedded=isViewerEmbedded,this.updateCallback=null,this.reason=null,this.submitButton.addEventListener("click",this.verify.bind(this)),this.cancelButton.addEventListener("click",this.close.bind(this)),this.input.addEventListener("keydown",(function(e){13===e.keyCode&&_this.verify()})),this.overlayManager.register(this.overlayName,this.container,this.close.bind(this),!0)}var Constructor,protoProps,staticProps,fn,_open;return Constructor=PasswordPrompt,(protoProps=[{key:"open",value:(fn=_regenerator.default.mark((function _callee(){var passwordIncorrect;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:return _context.next=2,this.overlayManager.open(this.overlayName);case 2:return passwordIncorrect=this.reason===_pdfjsLib.PasswordResponses.INCORRECT_PASSWORD,this._isViewerEmbedded&&!passwordIncorrect||this.input.focus(),_context.next=6,this.l10n.get("password_".concat(passwordIncorrect?"invalid":"label"));case 6:this.label.textContent=_context.sent;case 7:case"end":return _context.stop()}}),_callee,this)})),_open=function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))},function(){return _open.apply(this,arguments)})},{key:"close",value:function(){var _this2=this;this.overlayManager.close(this.overlayName).then((function(){_this2.input.value=""}))}},{key:"verify",value:function(){var password=this.input.value;(null==password?void 0:password.length)>0&&(this.close(),this.updateCallback(password))}},{key:"setUpdateCallback",value:function(updateCallback,reason){this.updateCallback=updateCallback,this.reason=reason}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PasswordPrompt}();exports.PasswordPrompt=PasswordPrompt},(__unused_webpack_module,exports,__webpack_require__)=>{function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFAttachmentViewer=void 0;var _pdfjsLib=__webpack_require__(6);function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _get(target,property,receiver){return(_get="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(target,property,receiver){var base=function(object,property){for(;!Object.prototype.hasOwnProperty.call(object,property)&&null!==(object=_getPrototypeOf(object)););return object}(target,property);if(base){var desc=Object.getOwnPropertyDescriptor(base,property);return desc.get?desc.get.call(receiver):desc.value}})(target,property,receiver||target)}function _setPrototypeOf(o,p){return(_setPrototypeOf=Object.setPrototypeOf||function(o,p){return o.__proto__=p,o})(o,p)}function _createSuper(Derived){var hasNativeReflectConstruct=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var result,Super=_getPrototypeOf(Derived);if(hasNativeReflectConstruct){var NewTarget=_getPrototypeOf(this).constructor;result=Reflect.construct(Super,arguments,NewTarget)}else result=Super.apply(this,arguments);return _possibleConstructorReturn(this,result)}}function _possibleConstructorReturn(self,call){if(call&&("object"===_typeof(call)||"function"==typeof call))return call;if(void 0!==call)throw new TypeError("Derived constructors may only return object or undefined");return _assertThisInitialized(self)}function _assertThisInitialized(self){if(void 0===self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return self}function _getPrototypeOf(o){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(o){return o.__proto__||Object.getPrototypeOf(o)})(o)}var PDFAttachmentViewer=function(_BaseTreeViewer){!function(subClass,superClass){if("function"!=typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function");subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,writable:!0,configurable:!0}}),superClass&&_setPrototypeOf(subClass,superClass)}(PDFAttachmentViewer,_BaseTreeViewer);var Constructor,protoProps,staticProps,_super=_createSuper(PDFAttachmentViewer);function PDFAttachmentViewer(options){var _this;return function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFAttachmentViewer),(_this=_super.call(this,options)).downloadManager=options.downloadManager,_this.eventBus._on("fileattachmentannotation",_this._appendAttachment.bind(_assertThisInitialized(_this))),_this}return Constructor=PDFAttachmentViewer,(protoProps=[{key:"reset",value:function(){var keepRenderedCapability=arguments.length>0&&void 0!==arguments[0]&&arguments[0];_get(_getPrototypeOf(PDFAttachmentViewer.prototype),"reset",this).call(this),this._attachments=null,keepRenderedCapability||(this._renderedCapability=(0,_pdfjsLib.createPromiseCapability)()),this._pendingDispatchEvent&&clearTimeout(this._pendingDispatchEvent),this._pendingDispatchEvent=null}},{key:"_dispatchEvent",value:function(attachmentsCount){var _this2=this;this._renderedCapability.resolve(),this._pendingDispatchEvent&&(clearTimeout(this._pendingDispatchEvent),this._pendingDispatchEvent=null),0!==attachmentsCount?this.eventBus.dispatch("attachmentsloaded",{source:this,attachmentsCount:attachmentsCount}):this._pendingDispatchEvent=setTimeout((function(){_this2.eventBus.dispatch("attachmentsloaded",{source:_this2,attachmentsCount:0}),_this2._pendingDispatchEvent=null}))}},{key:"_bindLink",value:function(element,_ref){var _this3=this,content=_ref.content,filename=_ref.filename;element.onclick=function(){return _this3.downloadManager.openOrDownloadData(element,content,filename),!1}}},{key:"render",value:function(_ref2){var attachments=_ref2.attachments,_ref2$keepRenderedCap=_ref2.keepRenderedCapability,keepRenderedCapability=void 0!==_ref2$keepRenderedCap&&_ref2$keepRenderedCap;if(this._attachments&&this.reset(keepRenderedCapability),this._attachments=attachments||null,attachments){var _step,names=Object.keys(attachments).sort((function(a,b){return a.toLowerCase().localeCompare(b.toLowerCase())})),fragment=document.createDocumentFragment(),attachmentsCount=0,_iterator=_createForOfIteratorHelper(names);try{for(_iterator.s();!(_step=_iterator.n()).done;){var item=attachments[_step.value],content=item.content,filename=(0,_pdfjsLib.getFilenameFromUrl)(item.filename),div=document.createElement("div");div.className="treeItem";var element=document.createElement("a");this._bindLink(element,{content:content,filename:filename}),element.textContent=this._normalizeTextContent(filename),div.appendChild(element),fragment.appendChild(div),attachmentsCount++}}catch(err){_iterator.e(err)}finally{_iterator.f()}this._finishRendering(fragment,attachmentsCount)}else this._dispatchEvent(0)}},{key:"_appendAttachment",value:function(_ref3){var _this4=this,id=_ref3.id,filename=_ref3.filename,content=_ref3.content,renderedPromise=this._renderedCapability.promise;renderedPromise.then((function(){if(renderedPromise===_this4._renderedCapability.promise){var attachments=_this4._attachments;if(attachments){for(var name in attachments)if(id===name)return}else attachments=Object.create(null);attachments[id]={filename:filename,content:content},_this4.render({attachments:attachments,keepRenderedCapability:!0})}}))}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFAttachmentViewer}(__webpack_require__(13).BaseTreeViewer);exports.PDFAttachmentViewer=PDFAttachmentViewer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.BaseTreeViewer=void 0;var _pdfjsLib=__webpack_require__(6);function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var BaseTreeViewer=function(){function BaseTreeViewer(options){if(function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,BaseTreeViewer),this.constructor===BaseTreeViewer)throw new Error("Cannot initialize BaseTreeViewer.");this.container=options.container,this.eventBus=options.eventBus,this.reset()}var Constructor,protoProps,staticProps;return Constructor=BaseTreeViewer,(protoProps=[{key:"reset",value:function(){this._pdfDocument=null,this._lastToggleIsShow=!0,this._currentTreeItem=null,this.container.textContent="",this.container.classList.remove("treeWithDeepNesting")}},{key:"_dispatchEvent",value:function(count){throw new Error("Not implemented: _dispatchEvent")}},{key:"_bindLink",value:function(element,params){throw new Error("Not implemented: _bindLink")}},{key:"_normalizeTextContent",value:function(str){return(0,_pdfjsLib.removeNullCharacters)(str)||"–"}},{key:"_addToggleButton",value:function(div){var _this=this,hidden=arguments.length>1&&void 0!==arguments[1]&&arguments[1],toggler=document.createElement("div");toggler.className="treeItemToggler",hidden&&toggler.classList.add("treeItemsHidden"),toggler.onclick=function(evt){if(evt.stopPropagation(),toggler.classList.toggle("treeItemsHidden"),evt.shiftKey){var shouldShowAll=!toggler.classList.contains("treeItemsHidden");_this._toggleTreeItem(div,shouldShowAll)}},div.insertBefore(toggler,div.firstChild)}},{key:"_toggleTreeItem",value:function(root){var show=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._lastToggleIsShow=show;var _step,_iterator=_createForOfIteratorHelper(root.querySelectorAll(".treeItemToggler"));try{for(_iterator.s();!(_step=_iterator.n()).done;){var toggler=_step.value;toggler.classList.toggle("treeItemsHidden",!show)}}catch(err){_iterator.e(err)}finally{_iterator.f()}}},{key:"_toggleAllTreeItems",value:function(){this._toggleTreeItem(this.container,!this._lastToggleIsShow)}},{key:"_finishRendering",value:function(fragment,count){var hasAnyNesting=arguments.length>2&&void 0!==arguments[2]&&arguments[2];hasAnyNesting&&(this.container.classList.add("treeWithDeepNesting"),this._lastToggleIsShow=!fragment.querySelector(".treeItemsHidden")),this.container.appendChild(fragment),this._dispatchEvent(count)}},{key:"render",value:function(params){throw new Error("Not implemented: render")}},{key:"_updateCurrentTreeItem",value:function(){var treeItem=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this._currentTreeItem&&(this._currentTreeItem.classList.remove("selected"),this._currentTreeItem=null),treeItem&&(treeItem.classList.add("selected"),this._currentTreeItem=treeItem)}},{key:"_scrollToCurrentTreeItem",value:function(treeItem){if(treeItem){for(var currentNode=treeItem.parentNode;currentNode&&currentNode!==this.container;){if(currentNode.classList.contains("treeItem")){var toggler=currentNode.firstElementChild;null==toggler||toggler.classList.remove("treeItemsHidden")}currentNode=currentNode.parentNode}this._updateCurrentTreeItem(treeItem),this.container.scrollTo(treeItem.offsetLeft,treeItem.offsetTop+-100)}}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),BaseTreeViewer}();exports.BaseTreeViewer=BaseTreeViewer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFDocumentProperties=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_pdfjsLib=__webpack_require__(6),_ui_utils=__webpack_require__(5);function _slicedToArray(arr,i){return function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null==_i)return;var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}(arr,i)||function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var NON_METRIC_LOCALES=["en-us","en-lr","my"],US_PAGE_NAMES={"8.5x11":"Letter","8.5x14":"Legal"},METRIC_PAGE_NAMES={"297x420":"A3","210x297":"A4"};function getPageName(size,isPortrait,pageNames){var width=isPortrait?size.width:size.height,height=isPortrait?size.height:size.width;return pageNames["".concat(width,"x").concat(height)]}var PDFDocumentProperties=function(){function PDFDocumentProperties(_ref,overlayManager,eventBus,l10n){var _this=this,overlayName=_ref.overlayName,fields=_ref.fields,container=_ref.container,closeButton=_ref.closeButton;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFDocumentProperties),this.overlayName=overlayName,this.fields=fields,this.container=container,this.overlayManager=overlayManager,this.l10n=l10n,this._reset(),closeButton.addEventListener("click",this.close.bind(this)),this.overlayManager.register(this.overlayName,this.container,this.close.bind(this)),eventBus._on("pagechanging",(function(evt){_this._currentPageNumber=evt.pageNumber})),eventBus._on("rotationchanging",(function(evt){_this._pagesRotation=evt.pagesRotation})),this._isNonMetricLocale=!0,l10n.getLanguage().then((function(locale){_this._isNonMetricLocale=NON_METRIC_LOCALES.includes(locale)}))}var Constructor,protoProps,staticProps,_parseDate2,_parsePageSize2,_parseFileSize2,_open;return Constructor=PDFDocumentProperties,(protoProps=[{key:"open",value:(_open=_asyncToGenerator(_regenerator.default.mark((function _callee(){var freezeFieldData,currentPageNumber,pagesRotation,_yield$this$pdfDocume,info,contentDispositionFilename,contentLength,_yield$Promise$all,_yield$Promise$all2,fileName,fileSize,creationDate,modificationDate,pageSize,isLinearized,_yield$this$pdfDocume2,length,data,_this2=this;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:return freezeFieldData=function(data){Object.defineProperty(_this2,"fieldData",{value:Object.freeze(data),writable:!1,enumerable:!0,configurable:!0})},_context.next=3,Promise.all([this.overlayManager.open(this.overlayName),this._dataAvailableCapability.promise]);case 3:if(currentPageNumber=this._currentPageNumber,pagesRotation=this._pagesRotation,!this.fieldData||currentPageNumber!==this.fieldData._currentPageNumber||pagesRotation!==this.fieldData._pagesRotation){_context.next=8;break}return this._updateUI(),_context.abrupt("return");case 8:return _context.next=10,this.pdfDocument.getMetadata();case 10:return _yield$this$pdfDocume=_context.sent,info=_yield$this$pdfDocume.info,contentDispositionFilename=_yield$this$pdfDocume.contentDispositionFilename,contentLength=_yield$this$pdfDocume.contentLength,_context.next=16,Promise.all([contentDispositionFilename||(0,_pdfjsLib.getPdfFilenameFromUrl)(this.url),this._parseFileSize(contentLength),this._parseDate(info.CreationDate),this._parseDate(info.ModDate),this.pdfDocument.getPage(currentPageNumber).then((function(pdfPage){return _this2._parsePageSize((0,_ui_utils.getPageSizeInches)(pdfPage),pagesRotation)})),this._parseLinearization(info.IsLinearized)]);case 16:return _yield$Promise$all=_context.sent,_yield$Promise$all2=_slicedToArray(_yield$Promise$all,6),fileName=_yield$Promise$all2[0],fileSize=_yield$Promise$all2[1],creationDate=_yield$Promise$all2[2],modificationDate=_yield$Promise$all2[3],pageSize=_yield$Promise$all2[4],isLinearized=_yield$Promise$all2[5],freezeFieldData({fileName:fileName,fileSize:fileSize,title:info.Title,author:info.Author,subject:info.Subject,keywords:info.Keywords,creationDate:creationDate,modificationDate:modificationDate,creator:info.Creator,producer:info.Producer,version:info.PDFFormatVersion,pageCount:this.pdfDocument.numPages,pageSize:pageSize,linearized:isLinearized,_currentPageNumber:currentPageNumber,_pagesRotation:pagesRotation}),this._updateUI(),_context.next=28,this.pdfDocument.getDownloadInfo();case 28:if(_yield$this$pdfDocume2=_context.sent,length=_yield$this$pdfDocume2.length,contentLength!==length){_context.next=32;break}return _context.abrupt("return");case 32:return data=Object.assign(Object.create(null),this.fieldData),_context.next=35,this._parseFileSize(length);case 35:data.fileSize=_context.sent,freezeFieldData(data),this._updateUI();case 38:case"end":return _context.stop()}}),_callee,this)}))),function(){return _open.apply(this,arguments)})},{key:"close",value:function(){this.overlayManager.close(this.overlayName)}},{key:"setDocument",value:function(pdfDocument){var url=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;this.pdfDocument&&(this._reset(),this._updateUI(!0)),pdfDocument&&(this.pdfDocument=pdfDocument,this.url=url,this._dataAvailableCapability.resolve())}},{key:"_reset",value:function(){this.pdfDocument=null,this.url=null,delete this.fieldData,this._dataAvailableCapability=(0,_pdfjsLib.createPromiseCapability)(),this._currentPageNumber=1,this._pagesRotation=0}},{key:"_updateUI",value:function(){var reset=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(!reset&&this.fieldData){if(this.overlayManager.active===this.overlayName)for(var _id in this.fields){var content=this.fieldData[_id];this.fields[_id].textContent=content||0===content?content:"-"}}else for(var id in this.fields)this.fields[id].textContent="-"}},{key:"_parseFileSize",value:(_parseFileSize2=_asyncToGenerator(_regenerator.default.mark((function _callee2(){var fileSize,kb,mb,_args2=arguments;return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:if(fileSize=_args2.length>0&&void 0!==_args2[0]?_args2[0]:0,mb=(kb=fileSize/1024)/1024,kb){_context2.next=4;break}return _context2.abrupt("return",void 0);case 4:return _context2.abrupt("return",this.l10n.get("document_properties_".concat(mb>=1?"mb":"kb"),{size_mb:mb>=1&&(+mb.toPrecision(3)).toLocaleString(),size_kb:mb<1&&(+kb.toPrecision(3)).toLocaleString(),size_b:fileSize.toLocaleString()}));case 5:case"end":return _context2.stop()}}),_callee2,this)}))),function(){return _parseFileSize2.apply(this,arguments)})},{key:"_parsePageSize",value:(_parsePageSize2=_asyncToGenerator(_regenerator.default.mark((function _callee3(pageSizeInches,pagesRotation){var isPortrait,sizeInches,sizeMillimeters,rawName,exactMillimeters,intMillimeters,_yield$Promise$all3,_yield$Promise$all4,_yield$Promise$all4$,width,height,unit,name,orientation;return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:if(pageSizeInches){_context3.next=2;break}return _context3.abrupt("return",void 0);case 2:return pagesRotation%180!=0&&(pageSizeInches={width:pageSizeInches.height,height:pageSizeInches.width}),isPortrait=(0,_ui_utils.isPortraitOrientation)(pageSizeInches),sizeInches={width:Math.round(100*pageSizeInches.width)/100,height:Math.round(100*pageSizeInches.height)/100},sizeMillimeters={width:Math.round(25.4*pageSizeInches.width*10)/10,height:Math.round(25.4*pageSizeInches.height*10)/10},(rawName=getPageName(sizeInches,isPortrait,US_PAGE_NAMES)||getPageName(sizeMillimeters,isPortrait,METRIC_PAGE_NAMES))||Number.isInteger(sizeMillimeters.width)&&Number.isInteger(sizeMillimeters.height)||(exactMillimeters={width:25.4*pageSizeInches.width,height:25.4*pageSizeInches.height},intMillimeters={width:Math.round(sizeMillimeters.width),height:Math.round(sizeMillimeters.height)},Math.abs(exactMillimeters.width-intMillimeters.width)<.1&&Math.abs(exactMillimeters.height-intMillimeters.height)<.1&&(rawName=getPageName(intMillimeters,isPortrait,METRIC_PAGE_NAMES))&&(sizeInches={width:Math.round(intMillimeters.width/25.4*100)/100,height:Math.round(intMillimeters.height/25.4*100)/100},sizeMillimeters=intMillimeters)),_context3.next=10,Promise.all([this._isNonMetricLocale?sizeInches:sizeMillimeters,this.l10n.get("document_properties_page_size_unit_".concat(this._isNonMetricLocale?"inches":"millimeters")),rawName&&this.l10n.get("document_properties_page_size_name_".concat(rawName.toLowerCase())),this.l10n.get("document_properties_page_size_orientation_".concat(isPortrait?"portrait":"landscape"))]);case 10:return _yield$Promise$all3=_context3.sent,_yield$Promise$all4=_slicedToArray(_yield$Promise$all3,4),_yield$Promise$all4$=_yield$Promise$all4[0],width=_yield$Promise$all4$.width,height=_yield$Promise$all4$.height,unit=_yield$Promise$all4[1],name=_yield$Promise$all4[2],orientation=_yield$Promise$all4[3],_context3.abrupt("return",this.l10n.get("document_properties_page_size_dimension_".concat(name?"name_":"","string"),{width:width.toLocaleString(),height:height.toLocaleString(),unit:unit,name:name,orientation:orientation}));case 19:case"end":return _context3.stop()}}),_callee3,this)}))),function(_x,_x2){return _parsePageSize2.apply(this,arguments)})},{key:"_parseDate",value:(_parseDate2=_asyncToGenerator(_regenerator.default.mark((function _callee4(inputDate){var dateObject;return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:if(dateObject=_pdfjsLib.PDFDateString.toDateObject(inputDate)){_context4.next=3;break}return _context4.abrupt("return",void 0);case 3:return _context4.abrupt("return",this.l10n.get("document_properties_date_string",{date:dateObject.toLocaleDateString(),time:dateObject.toLocaleTimeString()}));case 4:case"end":return _context4.stop()}}),_callee4,this)}))),function(_x3){return _parseDate2.apply(this,arguments)})},{key:"_parseLinearization",value:function(isLinearized){return this.l10n.get("document_properties_linearized_".concat(isLinearized?"yes":"no"))}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFDocumentProperties}();exports.PDFDocumentProperties=PDFDocumentProperties},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFFindBar=void 0;var _pdf_find_controller=__webpack_require__(16);function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var PDFFindBar=function(){function PDFFindBar(options,eventBus,l10n){var _this=this;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFFindBar),this.opened=!1,this.bar=options.bar,this.toggleButton=options.toggleButton,this.findField=options.findField,this.highlightAll=options.highlightAllCheckbox,this.caseSensitive=options.caseSensitiveCheckbox,this.entireWord=options.entireWordCheckbox,this.findMsg=options.findMsg,this.findResultsCount=options.findResultsCount,this.findPreviousButton=options.findPreviousButton,this.findNextButton=options.findNextButton,this.eventBus=eventBus,this.l10n=l10n,this.toggleButton.addEventListener("click",(function(){_this.toggle()})),this.findField.addEventListener("input",(function(){_this.dispatchEvent("")})),this.bar.addEventListener("keydown",(function(e){switch(e.keyCode){case 13:e.target===_this.findField&&_this.dispatchEvent("again",e.shiftKey);break;case 27:_this.close()}})),this.findPreviousButton.addEventListener("click",(function(){_this.dispatchEvent("again",!0)})),this.findNextButton.addEventListener("click",(function(){_this.dispatchEvent("again",!1)})),this.highlightAll.addEventListener("click",(function(){_this.dispatchEvent("highlightallchange")})),this.caseSensitive.addEventListener("click",(function(){_this.dispatchEvent("casesensitivitychange")})),this.entireWord.addEventListener("click",(function(){_this.dispatchEvent("entirewordchange")})),this.eventBus._on("resize",this._adjustWidth.bind(this))}var Constructor,protoProps,staticProps;return Constructor=PDFFindBar,(protoProps=[{key:"reset",value:function(){this.updateUIState()}},{key:"dispatchEvent",value:function(type,findPrev){this.eventBus.dispatch("find",{source:this,type:type,query:this.findField.value,phraseSearch:!0,caseSensitive:this.caseSensitive.checked,entireWord:this.entireWord.checked,highlightAll:this.highlightAll.checked,findPrevious:findPrev})}},{key:"updateUIState",value:function(state,previous,matchesCount){var _this2=this,findMsg=Promise.resolve(""),status="";switch(state){case _pdf_find_controller.FindState.FOUND:break;case _pdf_find_controller.FindState.PENDING:status="pending";break;case _pdf_find_controller.FindState.NOT_FOUND:findMsg=this.l10n.get("find_not_found"),status="notFound";break;case _pdf_find_controller.FindState.WRAPPED:findMsg=this.l10n.get("find_reached_".concat(previous?"top":"bottom"))}this.findField.setAttribute("data-status",status),findMsg.then((function(msg){_this2.findMsg.textContent=msg,_this2._adjustWidth()})),this.updateResultsCount(matchesCount)}},{key:"updateResultsCount",value:function(){var _this3=this,_ref=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},_ref$current=_ref.current,current=void 0===_ref$current?0:_ref$current,_ref$total=_ref.total,total=void 0===_ref$total?0:_ref$total,limit=1e3,matchCountMsg=Promise.resolve("");if(total>0)if(total>limit){var key="find_match_count_limit";matchCountMsg=this.l10n.get(key,{limit:limit})}else{var _key="find_match_count";matchCountMsg=this.l10n.get(_key,{current:current,total:total})}matchCountMsg.then((function(msg){_this3.findResultsCount.textContent=msg,_this3.findResultsCount.classList.toggle("hidden",!total),_this3._adjustWidth()}))}},{key:"open",value:function(){this.opened||(this.opened=!0,this.toggleButton.classList.add("toggled"),this.toggleButton.setAttribute("aria-expanded","true"),this.bar.classList.remove("hidden")),this.findField.select(),this.findField.focus(),this._adjustWidth()}},{key:"close",value:function(){this.opened&&(this.opened=!1,this.toggleButton.classList.remove("toggled"),this.toggleButton.setAttribute("aria-expanded","false"),this.bar.classList.add("hidden"),this.eventBus.dispatch("findbarclose",{source:this}))}},{key:"toggle",value:function(){this.opened?this.close():this.open()}},{key:"_adjustWidth",value:function(){this.opened&&(this.bar.classList.remove("wrapContainers"),this.bar.clientHeight>this.bar.firstElementChild.clientHeight&&this.bar.classList.add("wrapContainers"))}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFFindBar}();exports.PDFFindBar=PDFFindBar},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFFindController=exports.FindState=void 0;var _pdfjsLib=__webpack_require__(6),_pdf_find_utils=__webpack_require__(17),_ui_utils=__webpack_require__(5);function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _slicedToArray(arr,i){return function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null==_i)return;var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}(arr,i)||_unsupportedIterableToArray(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e2){throw _e2},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e3){didErr=!0,err=_e3},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _unsupportedIterableToArray(o,minLen){if(o){if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);return"Object"===n&&o.constructor&&(n=o.constructor.name),"Map"===n||"Set"===n?Array.from(o):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?_arrayLikeToArray(o,minLen):void 0}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}var FindState={FOUND:0,NOT_FOUND:1,WRAPPED:2,PENDING:3};exports.FindState=FindState;var CHARACTERS_TO_NORMALIZE={"‐":"-","‘":"'","’":"'","‚":"'","‛":"'","“":'"',"”":'"',"„":'"',"‟":'"',"¼":"1/4","½":"1/2","¾":"3/4"},normalizationRegex=null;function normalize(text){if(!normalizationRegex){var replace=Object.keys(CHARACTERS_TO_NORMALIZE).join("");normalizationRegex=new RegExp("[".concat(replace,"]"),"g")}var diffs=null;return[text.replace(normalizationRegex,(function(ch,index){var normalizedCh=CHARACTERS_TO_NORMALIZE[ch],diff=normalizedCh.length-ch.length;return 0!==diff&&(diffs||(diffs=[])).push([index,diff]),normalizedCh})),diffs]}function getOriginalIndex(matchIndex){var diffs=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;if(!diffs)return matchIndex;var _step,totalDiff=0,_iterator=_createForOfIteratorHelper(diffs);try{for(_iterator.s();!(_step=_iterator.n()).done;){var _step$value=_slicedToArray(_step.value,2),index=_step$value[0],diff=_step$value[1],currentIndex=index+totalDiff;if(currentIndex>=matchIndex)break;if(currentIndex+diff>matchIndex){totalDiff+=matchIndex-currentIndex;break}totalDiff+=diff}}catch(err){_iterator.e(err)}finally{_iterator.f()}return matchIndex-totalDiff}var PDFFindController=function(){function PDFFindController(_ref){var linkService=_ref.linkService,eventBus=_ref.eventBus;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFFindController),this._linkService=linkService,this._eventBus=eventBus,this._reset(),eventBus._on("findbarclose",this._onFindBarClose.bind(this))}var Constructor,protoProps,staticProps;return Constructor=PDFFindController,(protoProps=[{key:"highlightMatches",get:function(){return this._highlightMatches}},{key:"pageMatches",get:function(){return this._pageMatches}},{key:"pageMatchesLength",get:function(){return this._pageMatchesLength}},{key:"selected",get:function(){return this._selected}},{key:"state",get:function(){return this._state}},{key:"setDocument",value:function(pdfDocument){this._pdfDocument&&this._reset(),pdfDocument&&(this._pdfDocument=pdfDocument,this._firstPageCapability.resolve())}},{key:"executeCommand",value:function(cmd,state){var _this=this;if(state){var pdfDocument=this._pdfDocument;(null===this._state||this._shouldDirtyMatch(cmd,state))&&(this._dirtyMatch=!0),this._state=state,"findhighlightallchange"!==cmd&&this._updateUIState(FindState.PENDING),this._firstPageCapability.promise.then((function(){if(_this._pdfDocument&&(!pdfDocument||_this._pdfDocument===pdfDocument)){_this._extractText();var findbarClosed=!_this._highlightMatches,pendingTimeout=!!_this._findTimeout;_this._findTimeout&&(clearTimeout(_this._findTimeout),_this._findTimeout=null),"find"===cmd?_this._findTimeout=setTimeout((function(){_this._nextMatch(),_this._findTimeout=null}),250):_this._dirtyMatch?_this._nextMatch():"findagain"===cmd?(_this._nextMatch(),findbarClosed&&_this._state.highlightAll&&_this._updateAllPages()):"findhighlightallchange"===cmd?(pendingTimeout?_this._nextMatch():_this._highlightMatches=!0,_this._updateAllPages()):_this._nextMatch()}}))}}},{key:"scrollMatchIntoView",value:function(_ref2){var _ref2$element=_ref2.element,element=void 0===_ref2$element?null:_ref2$element,_ref2$selectedLeft=_ref2.selectedLeft,selectedLeft=void 0===_ref2$selectedLeft?0:_ref2$selectedLeft,_ref2$pageIndex=_ref2.pageIndex,pageIndex=void 0===_ref2$pageIndex?-1:_ref2$pageIndex,_ref2$matchIndex=_ref2.matchIndex,matchIndex=void 0===_ref2$matchIndex?-1:_ref2$matchIndex;if(this._scrollMatches&&element&&-1!==matchIndex&&matchIndex===this._selected.matchIdx&&-1!==pageIndex&&pageIndex===this._selected.pageIdx){this._scrollMatches=!1;var spot={top:-50,left:selectedLeft+-400};(0,_ui_utils.scrollIntoView)(element,spot,!0)}}},{key:"_reset",value:function(){this._highlightMatches=!1,this._scrollMatches=!1,this._pdfDocument=null,this._pageMatches=[],this._pageMatchesLength=[],this._state=null,this._selected={pageIdx:-1,matchIdx:-1},this._offset={pageIdx:null,matchIdx:null,wrapped:!1},this._extractTextPromises=[],this._pageContents=[],this._pageDiffs=[],this._matchesCountTotal=0,this._pagesToSearch=null,this._pendingFindMatches=new Set,this._resumePageIdx=null,this._dirtyMatch=!1,clearTimeout(this._findTimeout),this._findTimeout=null,this._firstPageCapability=(0,_pdfjsLib.createPromiseCapability)()}},{key:"_query",get:function(){if(this._state.query!==this._rawQuery){this._rawQuery=this._state.query;var _normalize2=_slicedToArray(normalize(this._state.query),1);this._normalizedQuery=_normalize2[0]}return this._normalizedQuery}},{key:"_shouldDirtyMatch",value:function(cmd,state){if(state.query!==this._state.query)return!0;switch(cmd){case"findagain":var pageNumber=this._selected.pageIdx+1,linkService=this._linkService;return pageNumber>=1&&pageNumber<=linkService.pagesCount&&pageNumber!==linkService.page&&!linkService.isPageVisible(pageNumber);case"findhighlightallchange":return!1}return!0}},{key:"_prepareMatches",value:function(matchesWithLength,matches,matchesLength){function isSubTerm(currentIndex){var currentElem=matchesWithLength[currentIndex],nextElem=matchesWithLength[currentIndex+1];if(currentIndex<matchesWithLength.length-1&&currentElem.match===nextElem.match)return currentElem.skipped=!0,!0;for(var i=currentIndex-1;i>=0;i--){var prevElem=matchesWithLength[i];if(!prevElem.skipped){if(prevElem.match+prevElem.matchLength<currentElem.match)break;if(prevElem.match+prevElem.matchLength>=currentElem.match+currentElem.matchLength)return currentElem.skipped=!0,!0}}return!1}matchesWithLength.sort((function(a,b){return a.match===b.match?a.matchLength-b.matchLength:a.match-b.match}));for(var i=0,len=matchesWithLength.length;i<len;i++)isSubTerm(i)||(matches.push(matchesWithLength[i].match),matchesLength.push(matchesWithLength[i].matchLength))}},{key:"_isEntireWord",value:function(content,startIdx,length){if(startIdx>0){var first=content.charCodeAt(startIdx),limit=content.charCodeAt(startIdx-1);if((0,_pdf_find_utils.getCharacterType)(first)===(0,_pdf_find_utils.getCharacterType)(limit))return!1}var endIdx=startIdx+length-1;if(endIdx<content.length-1){var last=content.charCodeAt(endIdx),_limit=content.charCodeAt(endIdx+1);if((0,_pdf_find_utils.getCharacterType)(last)===(0,_pdf_find_utils.getCharacterType)(_limit))return!1}return!0}},{key:"_calculatePhraseMatch",value:function(query,pageIndex,pageContent,pageDiffs,entireWord){for(var matches=[],matchesLength=[],queryLen=query.length,matchIdx=-queryLen;-1!==(matchIdx=pageContent.indexOf(query,matchIdx+queryLen));)if(!entireWord||this._isEntireWord(pageContent,matchIdx,queryLen)){var originalMatchIdx=getOriginalIndex(matchIdx,pageDiffs),originalQueryLen=getOriginalIndex(matchIdx+queryLen-1,pageDiffs)-originalMatchIdx+1;matches.push(originalMatchIdx),matchesLength.push(originalQueryLen)}this._pageMatches[pageIndex]=matches,this._pageMatchesLength[pageIndex]=matchesLength}},{key:"_calculateWordMatch",value:function(query,pageIndex,pageContent,pageDiffs,entireWord){for(var matchesWithLength=[],queryArray=query.match(/\S+/g),i=0,len=queryArray.length;i<len;i++)for(var subquery=queryArray[i],subqueryLen=subquery.length,matchIdx=-subqueryLen;-1!==(matchIdx=pageContent.indexOf(subquery,matchIdx+subqueryLen));)if(!entireWord||this._isEntireWord(pageContent,matchIdx,subqueryLen)){var originalMatchIdx=getOriginalIndex(matchIdx,pageDiffs),originalQueryLen=getOriginalIndex(matchIdx+subqueryLen-1,pageDiffs)-originalMatchIdx+1;matchesWithLength.push({match:originalMatchIdx,matchLength:originalQueryLen,skipped:!1})}this._pageMatchesLength[pageIndex]=[],this._pageMatches[pageIndex]=[],this._prepareMatches(matchesWithLength,this._pageMatches[pageIndex],this._pageMatchesLength[pageIndex])}},{key:"_calculateMatch",value:function(pageIndex){var pageContent=this._pageContents[pageIndex],pageDiffs=this._pageDiffs[pageIndex],query=this._query,_this$_state=this._state,caseSensitive=_this$_state.caseSensitive,entireWord=_this$_state.entireWord,phraseSearch=_this$_state.phraseSearch;if(0!==query.length){caseSensitive||(pageContent=pageContent.toLowerCase(),query=query.toLowerCase()),phraseSearch?this._calculatePhraseMatch(query,pageIndex,pageContent,pageDiffs,entireWord):this._calculateWordMatch(query,pageIndex,pageContent,pageDiffs,entireWord),this._state.highlightAll&&this._updatePage(pageIndex),this._resumePageIdx===pageIndex&&(this._resumePageIdx=null,this._nextPageMatch());var pageMatchesCount=this._pageMatches[pageIndex].length;pageMatchesCount>0&&(this._matchesCountTotal+=pageMatchesCount,this._updateUIResultsCount())}}},{key:"_extractText",value:function(){var _this2=this;if(!(this._extractTextPromises.length>0))for(var promise=Promise.resolve(),_loop=function(i,ii){var extractTextCapability=(0,_pdfjsLib.createPromiseCapability)();_this2._extractTextPromises[i]=extractTextCapability.promise,promise=promise.then((function(){return _this2._pdfDocument.getPage(i+1).then((function(pdfPage){return pdfPage.getTextContent({normalizeWhitespace:!0})})).then((function(textContent){for(var textItems=textContent.items,strBuf=[],j=0,jj=textItems.length;j<jj;j++)strBuf.push(textItems[j].str);var _normalize4=_slicedToArray(normalize(strBuf.join("")),2);_this2._pageContents[i]=_normalize4[0],_this2._pageDiffs[i]=_normalize4[1],extractTextCapability.resolve(i)}),(function(reason){console.error("Unable to get text content for page ".concat(i+1),reason),_this2._pageContents[i]="",_this2._pageDiffs[i]=null,extractTextCapability.resolve(i)}))}))},i=0,ii=this._linkService.pagesCount;i<ii;i++)_loop(i)}},{key:"_updatePage",value:function(index){this._scrollMatches&&this._selected.pageIdx===index&&(this._linkService.page=index+1),this._eventBus.dispatch("updatetextlayermatches",{source:this,pageIndex:index})}},{key:"_updateAllPages",value:function(){this._eventBus.dispatch("updatetextlayermatches",{source:this,pageIndex:-1})}},{key:"_nextMatch",value:function(){var _this3=this,previous=this._state.findPrevious,currentPageIndex=this._linkService.page-1,numPages=this._linkService.pagesCount;if(this._highlightMatches=!0,this._dirtyMatch){this._dirtyMatch=!1,this._selected.pageIdx=this._selected.matchIdx=-1,this._offset.pageIdx=currentPageIndex,this._offset.matchIdx=null,this._offset.wrapped=!1,this._resumePageIdx=null,this._pageMatches.length=0,this._pageMatchesLength.length=0,this._matchesCountTotal=0,this._updateAllPages();for(var i=0;i<numPages;i++)this._pendingFindMatches.has(i)||(this._pendingFindMatches.add(i),this._extractTextPromises[i].then((function(pageIdx){_this3._pendingFindMatches.delete(pageIdx),_this3._calculateMatch(pageIdx)})))}if(""!==this._query){if(!this._resumePageIdx){var offset=this._offset;if(this._pagesToSearch=numPages,null!==offset.matchIdx){var numPageMatches=this._pageMatches[offset.pageIdx].length;if(!previous&&offset.matchIdx+1<numPageMatches||previous&&offset.matchIdx>0)return offset.matchIdx=previous?offset.matchIdx-1:offset.matchIdx+1,void this._updateMatch(!0);this._advanceOffsetPage(previous)}this._nextPageMatch()}}else this._updateUIState(FindState.FOUND)}},{key:"_matchesReady",value:function(matches){var offset=this._offset,numMatches=matches.length,previous=this._state.findPrevious;return numMatches?(offset.matchIdx=previous?numMatches-1:0,this._updateMatch(!0),!0):(this._advanceOffsetPage(previous),!!(offset.wrapped&&(offset.matchIdx=null,this._pagesToSearch<0))&&(this._updateMatch(!1),!0))}},{key:"_nextPageMatch",value:function(){null!==this._resumePageIdx&&console.error("There can only be one pending page.");var matches=null;do{var pageIdx=this._offset.pageIdx;if(!(matches=this._pageMatches[pageIdx])){this._resumePageIdx=pageIdx;break}}while(!this._matchesReady(matches))}},{key:"_advanceOffsetPage",value:function(previous){var offset=this._offset,numPages=this._linkService.pagesCount;offset.pageIdx=previous?offset.pageIdx-1:offset.pageIdx+1,offset.matchIdx=null,this._pagesToSearch--,(offset.pageIdx>=numPages||offset.pageIdx<0)&&(offset.pageIdx=previous?numPages-1:0,offset.wrapped=!0)}},{key:"_updateMatch",value:function(){var found=arguments.length>0&&void 0!==arguments[0]&&arguments[0],state=FindState.NOT_FOUND,wrapped=this._offset.wrapped;if(this._offset.wrapped=!1,found){var previousPage=this._selected.pageIdx;this._selected.pageIdx=this._offset.pageIdx,this._selected.matchIdx=this._offset.matchIdx,state=wrapped?FindState.WRAPPED:FindState.FOUND,-1!==previousPage&&previousPage!==this._selected.pageIdx&&this._updatePage(previousPage)}this._updateUIState(state,this._state.findPrevious),-1!==this._selected.pageIdx&&(this._scrollMatches=!0,this._updatePage(this._selected.pageIdx))}},{key:"_onFindBarClose",value:function(evt){var _this4=this,pdfDocument=this._pdfDocument;this._firstPageCapability.promise.then((function(){!_this4._pdfDocument||pdfDocument&&_this4._pdfDocument!==pdfDocument||(_this4._findTimeout&&(clearTimeout(_this4._findTimeout),_this4._findTimeout=null),_this4._resumePageIdx&&(_this4._resumePageIdx=null,_this4._dirtyMatch=!0),_this4._updateUIState(FindState.FOUND),_this4._highlightMatches=!1,_this4._updateAllPages())}))}},{key:"_requestMatchesCount",value:function(){var _this$_selected=this._selected,pageIdx=_this$_selected.pageIdx,matchIdx=_this$_selected.matchIdx,current=0,total=this._matchesCountTotal;if(-1!==matchIdx){for(var i=0;i<pageIdx;i++){var _this$_pageMatches$i;current+=(null===(_this$_pageMatches$i=this._pageMatches[i])||void 0===_this$_pageMatches$i?void 0:_this$_pageMatches$i.length)||0}current+=matchIdx+1}return(current<1||current>total)&&(current=total=0),{current:current,total:total}}},{key:"_updateUIResultsCount",value:function(){this._eventBus.dispatch("updatefindmatchescount",{source:this,matchesCount:this._requestMatchesCount()})}},{key:"_updateUIState",value:function(state,previous){var _this$_state$query,_this$_state2;this._eventBus.dispatch("updatefindcontrolstate",{source:this,state:state,previous:previous,matchesCount:this._requestMatchesCount(),rawQuery:null!==(_this$_state$query=null===(_this$_state2=this._state)||void 0===_this$_state2?void 0:_this$_state2.query)&&void 0!==_this$_state$query?_this$_state$query:null})}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFFindController}();exports.PDFFindController=PDFFindController},(__unused_webpack_module,exports)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.getCharacterType=function(charCode){if(function(charCode){return charCode<11904}(charCode))return function(charCode){return 0==(65408&charCode)}(charCode)?function(charCode){return 32===charCode||9===charCode||13===charCode||10===charCode}(charCode)?CharacterType.SPACE:function(charCode){return charCode>=97&&charCode<=122||charCode>=65&&charCode<=90}(charCode)||function(charCode){return charCode>=48&&charCode<=57}(charCode)||95===charCode?CharacterType.ALPHA_LETTER:CharacterType.PUNCT:function(charCode){return 3584==(65408&charCode)}(charCode)?CharacterType.THAI_LETTER:160===charCode?CharacterType.SPACE:CharacterType.ALPHA_LETTER;if(function(charCode){return charCode>=13312&&charCode<=40959||charCode>=63744&&charCode<=64255}(charCode))return CharacterType.HAN_LETTER;if(function(charCode){return charCode>=12448&&charCode<=12543}(charCode))return CharacterType.KATAKANA_LETTER;if(function(charCode){return charCode>=12352&&charCode<=12447}(charCode))return CharacterType.HIRAGANA_LETTER;if(function(charCode){return charCode>=65376&&charCode<=65439}(charCode))return CharacterType.HALFWIDTH_KATAKANA_LETTER;return CharacterType.ALPHA_LETTER},exports.CharacterType=void 0;var CharacterType={SPACE:0,ALPHA_LETTER:1,PUNCT:2,HAN_LETTER:3,KATAKANA_LETTER:4,HIRAGANA_LETTER:5,HALFWIDTH_KATAKANA_LETTER:6,THAI_LETTER:7};exports.CharacterType=CharacterType},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.isDestArraysEqual=isDestArraysEqual,exports.isDestHashesEqual=isDestHashesEqual,exports.PDFHistory=void 0;var _ui_utils=__webpack_require__(5);function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _slicedToArray(arr,i){return function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null==_i)return;var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}(arr,i)||function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function getCurrentHash(){return document.location.hash}var PDFHistory=function(){function PDFHistory(_ref){var _this=this,linkService=_ref.linkService,eventBus=_ref.eventBus;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFHistory),this.linkService=linkService,this.eventBus=eventBus,this._initialized=!1,this._fingerprint="",this.reset(),this._boundEvents=null,this._isViewerInPresentationMode=!1,this.eventBus._on("presentationmodechanged",(function(evt){_this._isViewerInPresentationMode=evt.state!==_ui_utils.PresentationModeState.NORMAL})),this.eventBus._on("pagesinit",(function(){_this._isPagesLoaded=!1,_this.eventBus._on("pagesloaded",(function(evt){_this._isPagesLoaded=!!evt.pagesCount}),{once:!0})}))}var Constructor,protoProps,staticProps;return Constructor=PDFHistory,(protoProps=[{key:"initialize",value:function(_ref2){var fingerprint=_ref2.fingerprint,_ref2$resetHistory=_ref2.resetHistory,resetHistory=void 0!==_ref2$resetHistory&&_ref2$resetHistory,_ref2$updateUrl=_ref2.updateUrl,updateUrl=void 0!==_ref2$updateUrl&&_ref2$updateUrl;if(fingerprint&&"string"==typeof fingerprint){this._initialized&&this.reset();var reInitialized=""!==this._fingerprint&&this._fingerprint!==fingerprint;this._fingerprint=fingerprint,this._updateUrl=!0===updateUrl,this._initialized=!0,this._bindEvents();var state=window.history.state;if(this._popStateInProgress=!1,this._blockHashChange=0,this._currentHash=getCurrentHash(),this._numPositionUpdates=0,this._uid=this._maxUid=0,this._destination=null,this._position=null,!this._isValidState(state,!0)||resetHistory){var _this$_parseCurrentHa=this._parseCurrentHash(!0),hash=_this$_parseCurrentHa.hash,page=_this$_parseCurrentHa.page,rotation=_this$_parseCurrentHa.rotation;return!hash||reInitialized||resetHistory?void this._pushOrReplaceState(null,!0):void this._pushOrReplaceState({hash:hash,page:page,rotation:rotation},!0)}var destination=state.destination;this._updateInternalState(destination,state.uid,!0),void 0!==destination.rotation&&(this._initialRotation=destination.rotation),destination.dest?(this._initialBookmark=JSON.stringify(destination.dest),this._destination.page=null):destination.hash?this._initialBookmark=destination.hash:destination.page&&(this._initialBookmark="page=".concat(destination.page))}else console.error('PDFHistory.initialize: The "fingerprint" must be a non-empty string.')}},{key:"reset",value:function(){this._initialized&&(this._pageHide(),this._initialized=!1,this._unbindEvents()),this._updateViewareaTimeout&&(clearTimeout(this._updateViewareaTimeout),this._updateViewareaTimeout=null),this._initialBookmark=null,this._initialRotation=null}},{key:"push",value:function(_ref3){var _this2=this,_ref3$namedDest=_ref3.namedDest,namedDest=void 0===_ref3$namedDest?null:_ref3$namedDest,explicitDest=_ref3.explicitDest,pageNumber=_ref3.pageNumber;if(this._initialized)if(namedDest&&"string"!=typeof namedDest)console.error("PDFHistory.push: "+'"'.concat(namedDest,'" is not a valid namedDest parameter.'));else if(Array.isArray(explicitDest))if(this._isValidPage(pageNumber)||null===pageNumber&&!this._destination){var hash=namedDest||JSON.stringify(explicitDest);if(hash){var forceReplace=!1;if(this._destination&&(isDestHashesEqual(this._destination.hash,hash)||isDestArraysEqual(this._destination.dest,explicitDest))){if(this._destination.page)return;forceReplace=!0}this._popStateInProgress&&!forceReplace||(this._pushOrReplaceState({dest:explicitDest,hash:hash,page:pageNumber,rotation:this.linkService.rotation},forceReplace),this._popStateInProgress||(this._popStateInProgress=!0,Promise.resolve().then((function(){_this2._popStateInProgress=!1}))))}}else console.error("PDFHistory.push: "+'"'.concat(pageNumber,'" is not a valid pageNumber parameter.'));else console.error("PDFHistory.push: "+'"'.concat(explicitDest,'" is not a valid explicitDest parameter.'))}},{key:"pushPage",value:function(pageNumber){var _this$_destination,_this3=this;this._initialized&&(this._isValidPage(pageNumber)?(null===(_this$_destination=this._destination)||void 0===_this$_destination?void 0:_this$_destination.page)!==pageNumber&&(this._popStateInProgress||(this._pushOrReplaceState({dest:null,hash:"page=".concat(pageNumber),page:pageNumber,rotation:this.linkService.rotation}),this._popStateInProgress||(this._popStateInProgress=!0,Promise.resolve().then((function(){_this3._popStateInProgress=!1}))))):console.error('PDFHistory.pushPage: "'.concat(pageNumber,'" is not a valid page number.')))}},{key:"pushCurrentPosition",value:function(){this._initialized&&!this._popStateInProgress&&this._tryPushCurrentPosition()}},{key:"back",value:function(){if(this._initialized&&!this._popStateInProgress){var state=window.history.state;this._isValidState(state)&&state.uid>0&&window.history.back()}}},{key:"forward",value:function(){if(this._initialized&&!this._popStateInProgress){var state=window.history.state;this._isValidState(state)&&state.uid<this._maxUid&&window.history.forward()}}},{key:"popStateInProgress",get:function(){return this._initialized&&(this._popStateInProgress||this._blockHashChange>0)}},{key:"initialBookmark",get:function(){return this._initialized?this._initialBookmark:null}},{key:"initialRotation",get:function(){return this._initialized?this._initialRotation:null}},{key:"_pushOrReplaceState",value:function(destination){var newUrl,forceReplace=arguments.length>1&&void 0!==arguments[1]&&arguments[1],shouldReplace=forceReplace||!this._destination,newState={fingerprint:this._fingerprint,uid:shouldReplace?this._uid:this._uid+1,destination:destination};if(this._updateInternalState(destination,newState.uid),this._updateUrl&&null!=destination&&destination.hash){var baseUrl=document.location.href.split("#")[0];baseUrl.startsWith("file://")||(newUrl="".concat(baseUrl,"#").concat(destination.hash))}shouldReplace?window.history.replaceState(newState,"",newUrl):window.history.pushState(newState,"",newUrl)}},{key:"_tryPushCurrentPosition",value:function(){var temporary=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this._position){var position=this._position;if(temporary&&((position=Object.assign(Object.create(null),this._position)).temporary=!0),this._destination){if(this._destination.temporary)this._pushOrReplaceState(position,!0);else if(this._destination.hash!==position.hash&&(this._destination.page||!(this._numPositionUpdates<=50))){var forceReplace=!1;if(this._destination.page>=position.first&&this._destination.page<=position.page){if(void 0!==this._destination.dest||!this._destination.first)return;forceReplace=!0}this._pushOrReplaceState(position,forceReplace)}}else this._pushOrReplaceState(position)}}},{key:"_isValidPage",value:function(val){return Number.isInteger(val)&&val>0&&val<=this.linkService.pagesCount}},{key:"_isValidState",value:function(state){var checkReload=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(!state)return!1;if(state.fingerprint!==this._fingerprint){if(!checkReload)return!1;if("string"!=typeof state.fingerprint||state.fingerprint.length!==this._fingerprint.length)return!1;var _performance$getEntri=performance.getEntriesByType("navigation"),_performance$getEntri2=_slicedToArray(_performance$getEntri,1),perfEntry=_performance$getEntri2[0];if("reload"!==(null==perfEntry?void 0:perfEntry.type))return!1}return!(!Number.isInteger(state.uid)||state.uid<0)&&null!==state.destination&&"object"===_typeof(state.destination)}},{key:"_updateInternalState",value:function(destination,uid){var removeTemporary=arguments.length>2&&void 0!==arguments[2]&&arguments[2];this._updateViewareaTimeout&&(clearTimeout(this._updateViewareaTimeout),this._updateViewareaTimeout=null),removeTemporary&&null!=destination&&destination.temporary&&delete destination.temporary,this._destination=destination,this._uid=uid,this._maxUid=Math.max(this._maxUid,uid),this._numPositionUpdates=0}},{key:"_parseCurrentHash",value:function(){var checkNameddest=arguments.length>0&&void 0!==arguments[0]&&arguments[0],hash=unescape(getCurrentHash()).substring(1),params=(0,_ui_utils.parseQueryString)(hash),nameddest=params.get("nameddest")||"",page=0|params.get("page");return(!this._isValidPage(page)||checkNameddest&&nameddest.length>0)&&(page=null),{hash:hash,page:page,rotation:this.linkService.rotation}}},{key:"_updateViewarea",value:function(_ref4){var _this4=this,location=_ref4.location;this._updateViewareaTimeout&&(clearTimeout(this._updateViewareaTimeout),this._updateViewareaTimeout=null),this._position={hash:this._isViewerInPresentationMode?"page=".concat(location.pageNumber):location.pdfOpenParams.substring(1),page:this.linkService.page,first:location.pageNumber,rotation:location.rotation},this._popStateInProgress||(this._isPagesLoaded&&this._destination&&!this._destination.page&&this._numPositionUpdates++,this._updateViewareaTimeout=setTimeout((function(){_this4._popStateInProgress||_this4._tryPushCurrentPosition(!0),_this4._updateViewareaTimeout=null}),1e3))}},{key:"_popState",value:function(_ref5){var _this5=this,state=_ref5.state,newHash=getCurrentHash(),hashChanged=this._currentHash!==newHash;if(this._currentHash=newHash,state){if(this._isValidState(state)){this._popStateInProgress=!0,hashChanged&&(this._blockHashChange++,(0,_ui_utils.waitOnEventOrTimeout)({target:window,name:"hashchange",delay:1e3}).then((function(){_this5._blockHashChange--})));var destination=state.destination;this._updateInternalState(destination,state.uid,!0),(0,_ui_utils.isValidRotation)(destination.rotation)&&(this.linkService.rotation=destination.rotation),destination.dest?this.linkService.goToDestination(destination.dest):destination.hash?this.linkService.setHash(destination.hash):destination.page&&(this.linkService.page=destination.page),Promise.resolve().then((function(){_this5._popStateInProgress=!1}))}}else{this._uid++;var _this$_parseCurrentHa2=this._parseCurrentHash(),hash=_this$_parseCurrentHa2.hash,page=_this$_parseCurrentHa2.page,rotation=_this$_parseCurrentHa2.rotation;this._pushOrReplaceState({hash:hash,page:page,rotation:rotation},!0)}}},{key:"_pageHide",value:function(){this._destination&&!this._destination.temporary||this._tryPushCurrentPosition()}},{key:"_bindEvents",value:function(){this._boundEvents||(this._boundEvents={updateViewarea:this._updateViewarea.bind(this),popState:this._popState.bind(this),pageHide:this._pageHide.bind(this)},this.eventBus._on("updateviewarea",this._boundEvents.updateViewarea),window.addEventListener("popstate",this._boundEvents.popState),window.addEventListener("pagehide",this._boundEvents.pageHide))}},{key:"_unbindEvents",value:function(){this._boundEvents&&(this.eventBus._off("updateviewarea",this._boundEvents.updateViewarea),window.removeEventListener("popstate",this._boundEvents.popState),window.removeEventListener("pagehide",this._boundEvents.pageHide),this._boundEvents=null)}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFHistory}();function isDestHashesEqual(destHash,pushHash){return"string"==typeof destHash&&"string"==typeof pushHash&&(destHash===pushHash||(0,_ui_utils.parseQueryString)(destHash).get("nameddest")===pushHash)}function isDestArraysEqual(firstDest,secondDest){function isEntryEqual(first,second){if(_typeof(first)!==_typeof(second))return!1;if(Array.isArray(first)||Array.isArray(second))return!1;if(null!==first&&"object"===_typeof(first)&&null!==second){if(Object.keys(first).length!==Object.keys(second).length)return!1;for(var key in first)if(!isEntryEqual(first[key],second[key]))return!1;return!0}return first===second||Number.isNaN(first)&&Number.isNaN(second)}if(!Array.isArray(firstDest)||!Array.isArray(secondDest))return!1;if(firstDest.length!==secondDest.length)return!1;for(var i=0,ii=firstDest.length;i<ii;i++)if(!isEntryEqual(firstDest[i],secondDest[i]))return!1;return!0}exports.PDFHistory=PDFHistory},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFLayerViewer=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj};function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _get(target,property,receiver){return(_get="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(target,property,receiver){var base=function(object,property){for(;!Object.prototype.hasOwnProperty.call(object,property)&&null!==(object=_getPrototypeOf(object)););return object}(target,property);if(base){var desc=Object.getOwnPropertyDescriptor(base,property);return desc.get?desc.get.call(receiver):desc.value}})(target,property,receiver||target)}function _setPrototypeOf(o,p){return(_setPrototypeOf=Object.setPrototypeOf||function(o,p){return o.__proto__=p,o})(o,p)}function _createSuper(Derived){var hasNativeReflectConstruct=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var result,Super=_getPrototypeOf(Derived);if(hasNativeReflectConstruct){var NewTarget=_getPrototypeOf(this).constructor;result=Reflect.construct(Super,arguments,NewTarget)}else result=Super.apply(this,arguments);return _possibleConstructorReturn(this,result)}}function _possibleConstructorReturn(self,call){if(call&&("object"===_typeof(call)||"function"==typeof call))return call;if(void 0!==call)throw new TypeError("Derived constructors may only return object or undefined");return _assertThisInitialized(self)}function _assertThisInitialized(self){if(void 0===self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return self}function _getPrototypeOf(o){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(o){return o.__proto__||Object.getPrototypeOf(o)})(o)}var PDFLayerViewer=function(_BaseTreeViewer){!function(subClass,superClass){if("function"!=typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function");subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,writable:!0,configurable:!0}}),superClass&&_setPrototypeOf(subClass,superClass)}(PDFLayerViewer,_BaseTreeViewer);var Constructor,protoProps,staticProps,_resetLayers2,_setNestedName2,_super=_createSuper(PDFLayerViewer);function PDFLayerViewer(options){var _this;return function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFLayerViewer),(_this=_super.call(this,options)).l10n=options.l10n,_this.eventBus._on("resetlayers",_this._resetLayers.bind(_assertThisInitialized(_this))),_this.eventBus._on("togglelayerstree",_this._toggleAllTreeItems.bind(_assertThisInitialized(_this))),_this}return Constructor=PDFLayerViewer,(protoProps=[{key:"reset",value:function(){_get(_getPrototypeOf(PDFLayerViewer.prototype),"reset",this).call(this),this._optionalContentConfig=null}},{key:"_dispatchEvent",value:function(layersCount){this.eventBus.dispatch("layersloaded",{source:this,layersCount:layersCount})}},{key:"_bindLink",value:function(element,_ref){var _this2=this,groupId=_ref.groupId,input=_ref.input,setVisibility=function(){_this2._optionalContentConfig.setVisibility(groupId,input.checked),_this2.eventBus.dispatch("optionalcontentconfig",{source:_this2,promise:Promise.resolve(_this2._optionalContentConfig)})};element.onclick=function(evt){return evt.target===input?(setVisibility(),!0):evt.target!==element||(input.checked=!input.checked,setVisibility(),!1)}}},{key:"_setNestedName",value:(_setNestedName2=_asyncToGenerator(_regenerator.default.mark((function _callee(element,_ref2){var _ref2$name,name;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:if(_ref2$name=_ref2.name,"string"!=typeof(name=void 0===_ref2$name?null:_ref2$name)){_context.next=4;break}return element.textContent=this._normalizeTextContent(name),_context.abrupt("return");case 4:return _context.next=6,this.l10n.get("additional_layers");case 6:element.textContent=_context.sent,element.style.fontStyle="italic";case 8:case"end":return _context.stop()}}),_callee,this)}))),function(_x,_x2){return _setNestedName2.apply(this,arguments)})},{key:"_addToggleButton",value:function(div,_ref3){var _ref3$name=_ref3.name,name=void 0===_ref3$name?null:_ref3$name;_get(_getPrototypeOf(PDFLayerViewer.prototype),"_addToggleButton",this).call(this,div,null===name)}},{key:"_toggleAllTreeItems",value:function(){this._optionalContentConfig&&_get(_getPrototypeOf(PDFLayerViewer.prototype),"_toggleAllTreeItems",this).call(this)}},{key:"render",value:function(_ref4){var optionalContentConfig=_ref4.optionalContentConfig,pdfDocument=_ref4.pdfDocument;this._optionalContentConfig&&this.reset(),this._optionalContentConfig=optionalContentConfig||null,this._pdfDocument=pdfDocument||null;var groups=null==optionalContentConfig?void 0:optionalContentConfig.getOrder();if(groups){for(var fragment=document.createDocumentFragment(),queue=[{parent:fragment,groups:groups}],layersCount=0,hasAnyNesting=!1;queue.length>0;){var _step,levelData=queue.shift(),_iterator=_createForOfIteratorHelper(levelData.groups);try{for(_iterator.s();!(_step=_iterator.n()).done;){var groupId=_step.value,div=document.createElement("div");div.className="treeItem";var element=document.createElement("a");if(div.appendChild(element),"object"===_typeof(groupId)){hasAnyNesting=!0,this._addToggleButton(div,groupId),this._setNestedName(element,groupId);var itemsDiv=document.createElement("div");itemsDiv.className="treeItems",div.appendChild(itemsDiv),queue.push({parent:itemsDiv,groups:groupId.order})}else{var group=optionalContentConfig.getGroup(groupId),input=document.createElement("input");this._bindLink(element,{groupId:groupId,input:input}),input.type="checkbox",input.id=groupId,input.checked=group.visible;var label=document.createElement("label");label.setAttribute("for",groupId),label.textContent=this._normalizeTextContent(group.name),element.appendChild(input),element.appendChild(label),layersCount++}levelData.parent.appendChild(div)}}catch(err){_iterator.e(err)}finally{_iterator.f()}}this._finishRendering(fragment,layersCount,hasAnyNesting)}else this._dispatchEvent(0)}},{key:"_resetLayers",value:(_resetLayers2=_asyncToGenerator(_regenerator.default.mark((function _callee2(){var optionalContentConfig;return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:if(this._optionalContentConfig){_context2.next=2;break}return _context2.abrupt("return");case 2:return _context2.next=4,this._pdfDocument.getOptionalContentConfig();case 4:optionalContentConfig=_context2.sent,this.eventBus.dispatch("optionalcontentconfig",{source:this,promise:Promise.resolve(optionalContentConfig)}),this.render({optionalContentConfig:optionalContentConfig,pdfDocument:this._pdfDocument});case 7:case"end":return _context2.stop()}}),_callee2,this)}))),function(){return _resetLayers2.apply(this,arguments)})}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFLayerViewer}(__webpack_require__(13).BaseTreeViewer);exports.PDFLayerViewer=PDFLayerViewer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.SimpleLinkService=exports.PDFLinkService=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_ui_utils=__webpack_require__(5);function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _createClass(Constructor,protoProps,staticProps){return protoProps&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),Constructor}var PDFLinkService=function(){function PDFLinkService(){var _ref=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},eventBus=_ref.eventBus,_ref$externalLinkTarg=_ref.externalLinkTarget,externalLinkTarget=void 0===_ref$externalLinkTarg?null:_ref$externalLinkTarg,_ref$externalLinkRel=_ref.externalLinkRel,externalLinkRel=void 0===_ref$externalLinkRel?null:_ref$externalLinkRel,_ref$ignoreDestinatio=_ref.ignoreDestinationZoom,ignoreDestinationZoom=void 0!==_ref$ignoreDestinatio&&_ref$ignoreDestinatio;_classCallCheck(this,PDFLinkService),this.eventBus=eventBus,this.externalLinkTarget=externalLinkTarget,this.externalLinkRel=externalLinkRel,this.externalLinkEnabled=!0,this._ignoreDestinationZoom=ignoreDestinationZoom,this.baseUrl=null,this.pdfDocument=null,this.pdfViewer=null,this.pdfHistory=null,this._pagesRefCache=null}var _goToDestination;return _createClass(PDFLinkService,[{key:"setDocument",value:function(pdfDocument){var baseUrl=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null;this.baseUrl=baseUrl,this.pdfDocument=pdfDocument,this._pagesRefCache=Object.create(null)}},{key:"setViewer",value:function(pdfViewer){this.pdfViewer=pdfViewer}},{key:"setHistory",value:function(pdfHistory){this.pdfHistory=pdfHistory}},{key:"pagesCount",get:function(){return this.pdfDocument?this.pdfDocument.numPages:0}},{key:"page",get:function(){return this.pdfViewer.currentPageNumber},set:function(value){this.pdfViewer.currentPageNumber=value}},{key:"rotation",get:function(){return this.pdfViewer.pagesRotation},set:function(value){this.pdfViewer.pagesRotation=value}},{key:"_goToDestinationHelper",value:function(rawDest){var pageNumber,_this=this,namedDest=arguments.length>1&&void 0!==arguments[1]?arguments[1]:null,explicitDest=arguments.length>2?arguments[2]:void 0,destRef=explicitDest[0];if("object"===_typeof(destRef)&&null!==destRef){if(null===(pageNumber=this._cachedPageNumber(destRef)))return void this.pdfDocument.getPageIndex(destRef).then((function(pageIndex){_this.cachePageRef(pageIndex+1,destRef),_this._goToDestinationHelper(rawDest,namedDest,explicitDest)})).catch((function(){console.error('PDFLinkService._goToDestinationHelper: "'.concat(destRef,'" is not ')+'a valid page reference, for dest="'.concat(rawDest,'".'))}))}else{if(!Number.isInteger(destRef))return void console.error('PDFLinkService._goToDestinationHelper: "'.concat(destRef,'" is not ')+'a valid destination reference, for dest="'.concat(rawDest,'".'));pageNumber=destRef+1}!pageNumber||pageNumber<1||pageNumber>this.pagesCount?console.error('PDFLinkService._goToDestinationHelper: "'.concat(pageNumber,'" is not ')+'a valid page number, for dest="'.concat(rawDest,'".')):(this.pdfHistory&&(this.pdfHistory.pushCurrentPosition(),this.pdfHistory.push({namedDest:namedDest,explicitDest:explicitDest,pageNumber:pageNumber})),this.pdfViewer.scrollPageIntoView({pageNumber:pageNumber,destArray:explicitDest,ignoreDestinationZoom:this._ignoreDestinationZoom}))}},{key:"goToDestination",value:(_goToDestination=_asyncToGenerator(_regenerator.default.mark((function _callee(dest){var namedDest,explicitDest;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:if(this.pdfDocument){_context.next=2;break}return _context.abrupt("return");case 2:if("string"!=typeof dest){_context.next=9;break}return namedDest=dest,_context.next=6,this.pdfDocument.getDestination(dest);case 6:explicitDest=_context.sent,_context.next=13;break;case 9:return namedDest=null,_context.next=12,dest;case 12:explicitDest=_context.sent;case 13:if(Array.isArray(explicitDest)){_context.next=16;break}return console.error('PDFLinkService.goToDestination: "'.concat(explicitDest,'" is not ')+'a valid destination array, for dest="'.concat(dest,'".')),_context.abrupt("return");case 16:this._goToDestinationHelper(dest,namedDest,explicitDest);case 17:case"end":return _context.stop()}}),_callee,this)}))),function(_x){return _goToDestination.apply(this,arguments)})},{key:"goToPage",value:function(val){if(this.pdfDocument){var pageNumber="string"==typeof val&&this.pdfViewer.pageLabelToPageNumber(val)||0|val;Number.isInteger(pageNumber)&&pageNumber>0&&pageNumber<=this.pagesCount?(this.pdfHistory&&(this.pdfHistory.pushCurrentPosition(),this.pdfHistory.pushPage(pageNumber)),this.pdfViewer.scrollPageIntoView({pageNumber:pageNumber})):console.error('PDFLinkService.goToPage: "'.concat(val,'" is not a valid page.'))}}},{key:"getDestinationHash",value:function(dest){if("string"==typeof dest){if(dest.length>0)return this.getAnchorUrl("#"+escape(dest))}else if(Array.isArray(dest)){var str=JSON.stringify(dest);if(str.length>0)return this.getAnchorUrl("#"+escape(str))}return this.getAnchorUrl("")}},{key:"getAnchorUrl",value:function(anchor){return(this.baseUrl||"")+anchor}},{key:"setHash",value:function(hash){var pageNumber,dest;if(this.pdfDocument)if(hash.includes("=")){var params=(0,_ui_utils.parseQueryString)(hash);if(params.has("search")&&this.eventBus.dispatch("findfromurlhash",{source:this,query:params.get("search").replace(/"/g,""),phraseSearch:"true"===params.get("phrase")}),params.has("page")&&(pageNumber=0|params.get("page")||1),params.has("zoom")){var zoomArgs=params.get("zoom").split(","),zoomArg=zoomArgs[0],zoomArgNumber=parseFloat(zoomArg);zoomArg.includes("Fit")?"Fit"===zoomArg||"FitB"===zoomArg?dest=[null,{name:zoomArg}]:"FitH"===zoomArg||"FitBH"===zoomArg||"FitV"===zoomArg||"FitBV"===zoomArg?dest=[null,{name:zoomArg},zoomArgs.length>1?0|zoomArgs[1]:null]:"FitR"===zoomArg?5!==zoomArgs.length?console.error('PDFLinkService.setHash: Not enough parameters for "FitR".'):dest=[null,{name:zoomArg},0|zoomArgs[1],0|zoomArgs[2],0|zoomArgs[3],0|zoomArgs[4]]:console.error('PDFLinkService.setHash: "'.concat(zoomArg,'" is not ')+"a valid zoom value."):dest=[null,{name:"XYZ"},zoomArgs.length>1?0|zoomArgs[1]:null,zoomArgs.length>2?0|zoomArgs[2]:null,zoomArgNumber?zoomArgNumber/100:zoomArg]}dest?this.pdfViewer.scrollPageIntoView({pageNumber:pageNumber||this.page,destArray:dest,allowNegativeOffset:!0}):pageNumber&&(this.page=pageNumber),params.has("pagemode")&&this.eventBus.dispatch("pagemode",{source:this,mode:params.get("pagemode")}),params.has("nameddest")&&this.goToDestination(params.get("nameddest"))}else{dest=unescape(hash);try{dest=JSON.parse(dest),Array.isArray(dest)||(dest=dest.toString())}catch(ex){}if("string"==typeof dest||function(dest){if(!Array.isArray(dest))return!1;var destLength=dest.length;if(destLength<2)return!1;var page=dest[0];if(!("object"===_typeof(page)&&Number.isInteger(page.num)&&Number.isInteger(page.gen)||Number.isInteger(page)&&page>=0))return!1;var zoom=dest[1];if("object"!==_typeof(zoom)||"string"!=typeof zoom.name)return!1;var allowNull=!0;switch(zoom.name){case"XYZ":if(5!==destLength)return!1;break;case"Fit":case"FitB":return 2===destLength;case"FitH":case"FitBH":case"FitV":case"FitBV":if(3!==destLength)return!1;break;case"FitR":if(6!==destLength)return!1;allowNull=!1;break;default:return!1}for(var i=2;i<destLength;i++){var param=dest[i];if(!("number"==typeof param||allowNull&&null===param))return!1}return!0}(dest))return void this.goToDestination(dest);console.error('PDFLinkService.setHash: "'.concat(unescape(hash),'" is not ')+"a valid destination.")}}},{key:"executeNamedAction",value:function(action){var _this$pdfHistory,_this$pdfHistory2;switch(action){case"GoBack":null===(_this$pdfHistory=this.pdfHistory)||void 0===_this$pdfHistory||_this$pdfHistory.back();break;case"GoForward":null===(_this$pdfHistory2=this.pdfHistory)||void 0===_this$pdfHistory2||_this$pdfHistory2.forward();break;case"NextPage":this.pdfViewer.nextPage();break;case"PrevPage":this.pdfViewer.previousPage();break;case"LastPage":this.page=this.pagesCount;break;case"FirstPage":this.page=1}this.eventBus.dispatch("namedaction",{source:this,action:action})}},{key:"cachePageRef",value:function(pageNum,pageRef){if(pageRef){var refStr=0===pageRef.gen?"".concat(pageRef.num,"R"):"".concat(pageRef.num,"R").concat(pageRef.gen);this._pagesRefCache[refStr]=pageNum}}},{key:"_cachedPageNumber",value:function(pageRef){var _this$_pagesRefCache,refStr=0===pageRef.gen?"".concat(pageRef.num,"R"):"".concat(pageRef.num,"R").concat(pageRef.gen);return(null===(_this$_pagesRefCache=this._pagesRefCache)||void 0===_this$_pagesRefCache?void 0:_this$_pagesRefCache[refStr])||null}},{key:"isPageVisible",value:function(pageNumber){return this.pdfViewer.isPageVisible(pageNumber)}},{key:"isPageCached",value:function(pageNumber){return this.pdfViewer.isPageCached(pageNumber)}}]),PDFLinkService}();exports.PDFLinkService=PDFLinkService;var SimpleLinkService=function(){function SimpleLinkService(){_classCallCheck(this,SimpleLinkService),this.externalLinkTarget=null,this.externalLinkRel=null,this.externalLinkEnabled=!0,this._ignoreDestinationZoom=!1}var _goToDestination2;return _createClass(SimpleLinkService,[{key:"pagesCount",get:function(){return 0}},{key:"page",get:function(){return 0},set:function(value){}},{key:"rotation",get:function(){return 0},set:function(value){}},{key:"goToDestination",value:(_goToDestination2=_asyncToGenerator(_regenerator.default.mark((function _callee2(dest){return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:case"end":return _context2.stop()}}),_callee2)}))),function(_x2){return _goToDestination2.apply(this,arguments)})},{key:"goToPage",value:function(val){}},{key:"getDestinationHash",value:function(dest){return"#"}},{key:"getAnchorUrl",value:function(hash){return"#"}},{key:"setHash",value:function(hash){}},{key:"executeNamedAction",value:function(action){}},{key:"cachePageRef",value:function(pageNum,pageRef){}},{key:"isPageVisible",value:function(pageNumber){return!0}},{key:"isPageCached",value:function(pageNumber){return!0}}]),SimpleLinkService}();exports.SimpleLinkService=SimpleLinkService},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFOutlineViewer=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_pdfjsLib=__webpack_require__(6),_base_tree_viewer=__webpack_require__(13),_ui_utils=__webpack_require__(5);function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _slicedToArray(arr,i){return function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null==_i)return;var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}(arr,i)||_unsupportedIterableToArray(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e2){throw _e2},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e3){didErr=!0,err=_e3},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _toConsumableArray(arr){return function(arr){if(Array.isArray(arr))return _arrayLikeToArray(arr)}(arr)||function(iter){if("undefined"!=typeof Symbol&&null!=iter[Symbol.iterator]||null!=iter["@@iterator"])return Array.from(iter)}(arr)||_unsupportedIterableToArray(arr)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _unsupportedIterableToArray(o,minLen){if(o){if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);return"Object"===n&&o.constructor&&(n=o.constructor.name),"Map"===n||"Set"===n?Array.from(o):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?_arrayLikeToArray(o,minLen):void 0}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _get(target,property,receiver){return(_get="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(target,property,receiver){var base=function(object,property){for(;!Object.prototype.hasOwnProperty.call(object,property)&&null!==(object=_getPrototypeOf(object)););return object}(target,property);if(base){var desc=Object.getOwnPropertyDescriptor(base,property);return desc.get?desc.get.call(receiver):desc.value}})(target,property,receiver||target)}function _setPrototypeOf(o,p){return(_setPrototypeOf=Object.setPrototypeOf||function(o,p){return o.__proto__=p,o})(o,p)}function _createSuper(Derived){var hasNativeReflectConstruct=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var result,Super=_getPrototypeOf(Derived);if(hasNativeReflectConstruct){var NewTarget=_getPrototypeOf(this).constructor;result=Reflect.construct(Super,arguments,NewTarget)}else result=Super.apply(this,arguments);return _possibleConstructorReturn(this,result)}}function _possibleConstructorReturn(self,call){if(call&&("object"===_typeof(call)||"function"==typeof call))return call;if(void 0!==call)throw new TypeError("Derived constructors may only return object or undefined");return _assertThisInitialized(self)}function _assertThisInitialized(self){if(void 0===self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return self}function _getPrototypeOf(o){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(o){return o.__proto__||Object.getPrototypeOf(o)})(o)}var PDFOutlineViewer=function(_BaseTreeViewer){!function(subClass,superClass){if("function"!=typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function");subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,writable:!0,configurable:!0}}),superClass&&_setPrototypeOf(subClass,superClass)}(PDFOutlineViewer,_BaseTreeViewer);var Constructor,protoProps,staticProps,_getPageNumberToDestHash2,_currentOutlineItem2,_super=_createSuper(PDFOutlineViewer);function PDFOutlineViewer(options){var _this;return function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFOutlineViewer),(_this=_super.call(this,options)).linkService=options.linkService,_this.eventBus._on("toggleoutlinetree",_this._toggleAllTreeItems.bind(_assertThisInitialized(_this))),_this.eventBus._on("currentoutlineitem",_this._currentOutlineItem.bind(_assertThisInitialized(_this))),_this.eventBus._on("pagechanging",(function(evt){_this._currentPageNumber=evt.pageNumber})),_this.eventBus._on("pagesloaded",(function(evt){_this._isPagesLoaded=!!evt.pagesCount,_this._currentOutlineItemCapability&&!_this._currentOutlineItemCapability.settled&&_this._currentOutlineItemCapability.resolve(_this._isPagesLoaded)})),_this.eventBus._on("sidebarviewchanged",(function(evt){_this._sidebarView=evt.view})),_this}return Constructor=PDFOutlineViewer,(protoProps=[{key:"reset",value:function(){_get(_getPrototypeOf(PDFOutlineViewer.prototype),"reset",this).call(this),this._outline=null,this._pageNumberToDestHashCapability=null,this._currentPageNumber=1,this._isPagesLoaded=!1,this._currentOutlineItemCapability&&!this._currentOutlineItemCapability.settled&&this._currentOutlineItemCapability.resolve(!1),this._currentOutlineItemCapability=null}},{key:"_dispatchEvent",value:function(outlineCount){var _this$_pdfDocument;this._currentOutlineItemCapability=(0,_pdfjsLib.createPromiseCapability)(),0===outlineCount||null!==(_this$_pdfDocument=this._pdfDocument)&&void 0!==_this$_pdfDocument&&_this$_pdfDocument.loadingParams.disableAutoFetch?this._currentOutlineItemCapability.resolve(!1):this._isPagesLoaded&&this._currentOutlineItemCapability.resolve(!0),this.eventBus.dispatch("outlineloaded",{source:this,outlineCount:outlineCount,currentOutlineItemPromise:this._currentOutlineItemCapability.promise})}},{key:"_bindLink",value:function(element,_ref){var _this2=this,url=_ref.url,newWindow=_ref.newWindow,dest=_ref.dest,linkService=this.linkService;url?(0,_pdfjsLib.addLinkAttributes)(element,{url:url,target:newWindow?_pdfjsLib.LinkTarget.BLANK:linkService.externalLinkTarget,rel:linkService.externalLinkRel,enabled:linkService.externalLinkEnabled}):(element.href=linkService.getDestinationHash(dest),element.onclick=function(evt){return _this2._updateCurrentTreeItem(evt.target.parentNode),dest&&linkService.goToDestination(dest),!1})}},{key:"_setStyles",value:function(element,_ref2){var bold=_ref2.bold,italic=_ref2.italic;bold&&(element.style.fontWeight="bold"),italic&&(element.style.fontStyle="italic")}},{key:"_addToggleButton",value:function(div,_ref3){var count=_ref3.count,items=_ref3.items,hidden=!1;if(count<0){var totalCount=items.length;if(totalCount>0)for(var queue=_toConsumableArray(items);queue.length>0;){var _queue$shift=queue.shift(),nestedCount=_queue$shift.count,nestedItems=_queue$shift.items;nestedCount>0&&nestedItems.length>0&&(totalCount+=nestedItems.length,queue.push.apply(queue,_toConsumableArray(nestedItems)))}Math.abs(count)===totalCount&&(hidden=!0)}_get(_getPrototypeOf(PDFOutlineViewer.prototype),"_addToggleButton",this).call(this,div,hidden)}},{key:"_toggleAllTreeItems",value:function(){this._outline&&_get(_getPrototypeOf(PDFOutlineViewer.prototype),"_toggleAllTreeItems",this).call(this)}},{key:"render",value:function(_ref4){var outline=_ref4.outline,pdfDocument=_ref4.pdfDocument;if(this._outline&&this.reset(),this._outline=outline||null,this._pdfDocument=pdfDocument||null,outline){for(var fragment=document.createDocumentFragment(),queue=[{parent:fragment,items:outline}],outlineCount=0,hasAnyNesting=!1;queue.length>0;){var _step,levelData=queue.shift(),_iterator=_createForOfIteratorHelper(levelData.items);try{for(_iterator.s();!(_step=_iterator.n()).done;){var item=_step.value,div=document.createElement("div");div.className="treeItem";var element=document.createElement("a");if(this._bindLink(element,item),this._setStyles(element,item),element.textContent=this._normalizeTextContent(item.title),div.appendChild(element),item.items.length>0){hasAnyNesting=!0,this._addToggleButton(div,item);var itemsDiv=document.createElement("div");itemsDiv.className="treeItems",div.appendChild(itemsDiv),queue.push({parent:itemsDiv,items:item.items})}levelData.parent.appendChild(div),outlineCount++}}catch(err){_iterator.e(err)}finally{_iterator.f()}}this._finishRendering(fragment,outlineCount,hasAnyNesting)}else this._dispatchEvent(0)}},{key:"_currentOutlineItem",value:(_currentOutlineItem2=_asyncToGenerator(_regenerator.default.mark((function _callee(){var pageNumberToDestHash,i,destHash,linkElement;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:if(this._isPagesLoaded){_context.next=2;break}throw new Error("_currentOutlineItem: All pages have not been loaded.");case 2:if(this._outline&&this._pdfDocument){_context.next=4;break}return _context.abrupt("return");case 4:return _context.next=6,this._getPageNumberToDestHash(this._pdfDocument);case 6:if(pageNumberToDestHash=_context.sent){_context.next=9;break}return _context.abrupt("return");case 9:if(this._updateCurrentTreeItem(null),this._sidebarView===_ui_utils.SidebarView.OUTLINE){_context.next=12;break}return _context.abrupt("return");case 12:i=this._currentPageNumber;case 13:if(!(i>0)){_context.next=25;break}if(destHash=pageNumberToDestHash.get(i)){_context.next=17;break}return _context.abrupt("continue",22);case 17:if(linkElement=this.container.querySelector('a[href="'.concat(destHash,'"]'))){_context.next=20;break}return _context.abrupt("continue",22);case 20:return this._scrollToCurrentTreeItem(linkElement.parentNode),_context.abrupt("break",25);case 22:i--,_context.next=13;break;case 25:case"end":return _context.stop()}}),_callee,this)}))),function(){return _currentOutlineItem2.apply(this,arguments)})},{key:"_getPageNumberToDestHash",value:(_getPageNumberToDestHash2=_asyncToGenerator(_regenerator.default.mark((function _callee2(pdfDocument){var pageNumberToDestHash,pageNumberNesting,queue,levelData,currentNesting,_iterator2,_step2,_step2$value,dest,items,explicitDest,pageNumber,_explicitDest2,destRef,destHash;return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:if(!this._pageNumberToDestHashCapability){_context2.next=2;break}return _context2.abrupt("return",this._pageNumberToDestHashCapability.promise);case 2:this._pageNumberToDestHashCapability=(0,_pdfjsLib.createPromiseCapability)(),pageNumberToDestHash=new Map,pageNumberNesting=new Map,queue=[{nesting:0,items:this._outline}];case 5:if(!(queue.length>0)){_context2.next=56;break}levelData=queue.shift(),currentNesting=levelData.nesting,_iterator2=_createForOfIteratorHelper(levelData.items),_context2.prev=8,_iterator2.s();case 10:if((_step2=_iterator2.n()).done){_context2.next=46;break}if(_step2$value=_step2.value,dest=_step2$value.dest,items=_step2$value.items,explicitDest=void 0,pageNumber=void 0,"string"!=typeof dest){_context2.next=21;break}return _context2.next=16,pdfDocument.getDestination(dest);case 16:if(explicitDest=_context2.sent,pdfDocument===this._pdfDocument){_context2.next=19;break}return _context2.abrupt("return",null);case 19:_context2.next=22;break;case 21:explicitDest=dest;case 22:if(!Array.isArray(explicitDest)){_context2.next=43;break}if(_explicitDest2=_slicedToArray(explicitDest,1),"object"!==_typeof(destRef=_explicitDest2[0])||null===destRef){_context2.next=41;break}if(pageNumber=this.linkService._cachedPageNumber(destRef)){_context2.next=39;break}return _context2.prev=27,_context2.next=30,pdfDocument.getPageIndex(destRef);case 30:if(_context2.t0=_context2.sent,pageNumber=_context2.t0+1,pdfDocument===this._pdfDocument){_context2.next=34;break}return _context2.abrupt("return",null);case 34:this.linkService.cachePageRef(pageNumber,destRef),_context2.next=39;break;case 37:_context2.prev=37,_context2.t1=_context2.catch(27);case 39:_context2.next=42;break;case 41:Number.isInteger(destRef)&&(pageNumber=destRef+1);case 42:Number.isInteger(pageNumber)&&(!pageNumberToDestHash.has(pageNumber)||currentNesting>pageNumberNesting.get(pageNumber))&&(destHash=this.linkService.getDestinationHash(dest),pageNumberToDestHash.set(pageNumber,destHash),pageNumberNesting.set(pageNumber,currentNesting));case 43:items.length>0&&queue.push({nesting:currentNesting+1,items:items});case 44:_context2.next=10;break;case 46:_context2.next=51;break;case 48:_context2.prev=48,_context2.t2=_context2.catch(8),_iterator2.e(_context2.t2);case 51:return _context2.prev=51,_iterator2.f(),_context2.finish(51);case 54:_context2.next=5;break;case 56:return this._pageNumberToDestHashCapability.resolve(pageNumberToDestHash.size>0?pageNumberToDestHash:null),_context2.abrupt("return",this._pageNumberToDestHashCapability.promise);case 58:case"end":return _context2.stop()}}),_callee2,this,[[8,48,51,54],[27,37]])}))),function(_x){return _getPageNumberToDestHash2.apply(this,arguments)})}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFOutlineViewer}(_base_tree_viewer.BaseTreeViewer);exports.PDFOutlineViewer=PDFOutlineViewer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFPresentationMode=void 0;var _ui_utils=__webpack_require__(5);function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var SWIPE_ANGLE_THRESHOLD=Math.PI/6,PDFPresentationMode=function(){function PDFPresentationMode(_ref){var container=_ref.container,pdfViewer=_ref.pdfViewer,eventBus=_ref.eventBus;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFPresentationMode),this.container=container,this.pdfViewer=pdfViewer,this.eventBus=eventBus,this.active=!1,this.args=null,this.contextMenuOpen=!1,this.mouseScrollTimeStamp=0,this.mouseScrollDelta=0,this.touchSwipeState=null}var Constructor,protoProps,staticProps;return Constructor=PDFPresentationMode,(protoProps=[{key:"request",value:function(){if(this.switchInProgress||this.active||!this.pdfViewer.pagesCount)return!1;if(this._addFullscreenChangeListeners(),this._setSwitchInProgress(),this._notifyStateChange(),this.container.requestFullscreen)this.container.requestFullscreen();else if(this.container.mozRequestFullScreen)this.container.mozRequestFullScreen();else{if(!this.container.webkitRequestFullscreen)return!1;this.container.webkitRequestFullscreen(Element.ALLOW_KEYBOARD_INPUT)}return this.args={page:this.pdfViewer.currentPageNumber,previousScale:this.pdfViewer.currentScaleValue},!0}},{key:"_mouseWheel",value:function(evt){if(this.active){evt.preventDefault();var delta=(0,_ui_utils.normalizeWheelEventDelta)(evt),currentTime=Date.now(),storedTime=this.mouseScrollTimeStamp;if(!(currentTime>storedTime&&currentTime-storedTime<50)&&((this.mouseScrollDelta>0&&delta<0||this.mouseScrollDelta<0&&delta>0)&&this._resetMouseScrollState(),this.mouseScrollDelta+=delta,Math.abs(this.mouseScrollDelta)>=.1)){var totalDelta=this.mouseScrollDelta;this._resetMouseScrollState(),(totalDelta>0?this.pdfViewer.previousPage():this.pdfViewer.nextPage())&&(this.mouseScrollTimeStamp=currentTime)}}}},{key:"isFullscreen",get:function(){return!!(document.fullscreenElement||document.mozFullScreen||document.webkitIsFullScreen)}},{key:"_notifyStateChange",value:function(){var state=_ui_utils.PresentationModeState.NORMAL;this.switchInProgress?state=_ui_utils.PresentationModeState.CHANGING:this.active&&(state=_ui_utils.PresentationModeState.FULLSCREEN),this.eventBus.dispatch("presentationmodechanged",{source:this,state:state})}},{key:"_setSwitchInProgress",value:function(){var _this=this;this.switchInProgress&&clearTimeout(this.switchInProgress),this.switchInProgress=setTimeout((function(){_this._removeFullscreenChangeListeners(),delete _this.switchInProgress,_this._notifyStateChange()}),1500)}},{key:"_resetSwitchInProgress",value:function(){this.switchInProgress&&(clearTimeout(this.switchInProgress),delete this.switchInProgress)}},{key:"_enter",value:function(){var _this2=this;this.active=!0,this._resetSwitchInProgress(),this._notifyStateChange(),this.container.classList.add("pdfPresentationMode"),setTimeout((function(){_this2.pdfViewer.currentPageNumber=_this2.args.page,_this2.pdfViewer.currentScaleValue="page-fit"}),0),this._addWindowListeners(),this._showControls(),this.contextMenuOpen=!1,window.getSelection().removeAllRanges()}},{key:"_exit",value:function(){var _this3=this,page=this.pdfViewer.currentPageNumber;this.container.classList.remove("pdfPresentationMode"),setTimeout((function(){_this3.active=!1,_this3._removeFullscreenChangeListeners(),_this3._notifyStateChange(),_this3.pdfViewer.currentScaleValue=_this3.args.previousScale,_this3.pdfViewer.currentPageNumber=page,_this3.args=null}),0),this._removeWindowListeners(),this._hideControls(),this._resetMouseScrollState(),this.contextMenuOpen=!1}},{key:"_mouseDown",value:function(evt){if(this.contextMenuOpen)return this.contextMenuOpen=!1,void evt.preventDefault();0===evt.button&&(evt.target.href&&evt.target.classList.contains("internalLink")||(evt.preventDefault(),evt.shiftKey?this.pdfViewer.previousPage():this.pdfViewer.nextPage()))}},{key:"_contextMenu",value:function(){this.contextMenuOpen=!0}},{key:"_showControls",value:function(){var _this4=this;this.controlsTimeout?clearTimeout(this.controlsTimeout):this.container.classList.add("pdfPresentationModeControls"),this.controlsTimeout=setTimeout((function(){_this4.container.classList.remove("pdfPresentationModeControls"),delete _this4.controlsTimeout}),3e3)}},{key:"_hideControls",value:function(){this.controlsTimeout&&(clearTimeout(this.controlsTimeout),this.container.classList.remove("pdfPresentationModeControls"),delete this.controlsTimeout)}},{key:"_resetMouseScrollState",value:function(){this.mouseScrollTimeStamp=0,this.mouseScrollDelta=0}},{key:"_touchSwipe",value:function(evt){if(this.active)if(evt.touches.length>1)this.touchSwipeState=null;else switch(evt.type){case"touchstart":this.touchSwipeState={startX:evt.touches[0].pageX,startY:evt.touches[0].pageY,endX:evt.touches[0].pageX,endY:evt.touches[0].pageY};break;case"touchmove":if(null===this.touchSwipeState)return;this.touchSwipeState.endX=evt.touches[0].pageX,this.touchSwipeState.endY=evt.touches[0].pageY,evt.preventDefault();break;case"touchend":if(null===this.touchSwipeState)return;var delta=0,dx=this.touchSwipeState.endX-this.touchSwipeState.startX,dy=this.touchSwipeState.endY-this.touchSwipeState.startY,absAngle=Math.abs(Math.atan2(dy,dx));Math.abs(dx)>50&&(absAngle<=SWIPE_ANGLE_THRESHOLD||absAngle>=Math.PI-SWIPE_ANGLE_THRESHOLD)?delta=dx:Math.abs(dy)>50&&Math.abs(absAngle-Math.PI/2)<=SWIPE_ANGLE_THRESHOLD&&(delta=dy),delta>0?this.pdfViewer.previousPage():delta<0&&this.pdfViewer.nextPage()}}},{key:"_addWindowListeners",value:function(){this.showControlsBind=this._showControls.bind(this),this.mouseDownBind=this._mouseDown.bind(this),this.mouseWheelBind=this._mouseWheel.bind(this),this.resetMouseScrollStateBind=this._resetMouseScrollState.bind(this),this.contextMenuBind=this._contextMenu.bind(this),this.touchSwipeBind=this._touchSwipe.bind(this),window.addEventListener("mousemove",this.showControlsBind),window.addEventListener("mousedown",this.mouseDownBind),window.addEventListener("wheel",this.mouseWheelBind,{passive:!1}),window.addEventListener("keydown",this.resetMouseScrollStateBind),window.addEventListener("contextmenu",this.contextMenuBind),window.addEventListener("touchstart",this.touchSwipeBind),window.addEventListener("touchmove",this.touchSwipeBind),window.addEventListener("touchend",this.touchSwipeBind)}},{key:"_removeWindowListeners",value:function(){window.removeEventListener("mousemove",this.showControlsBind),window.removeEventListener("mousedown",this.mouseDownBind),window.removeEventListener("wheel",this.mouseWheelBind,{passive:!1}),window.removeEventListener("keydown",this.resetMouseScrollStateBind),window.removeEventListener("contextmenu",this.contextMenuBind),window.removeEventListener("touchstart",this.touchSwipeBind),window.removeEventListener("touchmove",this.touchSwipeBind),window.removeEventListener("touchend",this.touchSwipeBind),delete this.showControlsBind,delete this.mouseDownBind,delete this.mouseWheelBind,delete this.resetMouseScrollStateBind,delete this.contextMenuBind,delete this.touchSwipeBind}},{key:"_fullscreenChange",value:function(){this.isFullscreen?this._enter():this._exit()}},{key:"_addFullscreenChangeListeners",value:function(){this.fullscreenChangeBind=this._fullscreenChange.bind(this),window.addEventListener("fullscreenchange",this.fullscreenChangeBind),window.addEventListener("mozfullscreenchange",this.fullscreenChangeBind),window.addEventListener("webkitfullscreenchange",this.fullscreenChangeBind)}},{key:"_removeFullscreenChangeListeners",value:function(){window.removeEventListener("fullscreenchange",this.fullscreenChangeBind),window.removeEventListener("mozfullscreenchange",this.fullscreenChangeBind),window.removeEventListener("webkitfullscreenchange",this.fullscreenChangeBind),delete this.fullscreenChangeBind}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFPresentationMode}();exports.PDFPresentationMode=PDFPresentationMode},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFScriptingManager=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_pdfjsLib=__webpack_require__(6),_ui_utils=__webpack_require__(5),_pdf_rendering_queue=__webpack_require__(9);function _toConsumableArray(arr){return function(arr){if(Array.isArray(arr))return _arrayLikeToArray(arr)}(arr)||function(iter){if("undefined"!=typeof Symbol&&null!=iter[Symbol.iterator]||null!=iter["@@iterator"])return Array.from(iter)}(arr)||_unsupportedIterableToArray(arr)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);enumerableOnly&&(symbols=symbols.filter((function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable}))),keys.push.apply(keys,symbols)}return keys}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=null!=arguments[i]?arguments[i]:{};i%2?ownKeys(Object(source),!0).forEach((function(key){_defineProperty(target,key,source[key])})):Object.getOwnPropertyDescriptors?Object.defineProperties(target,Object.getOwnPropertyDescriptors(source)):ownKeys(Object(source)).forEach((function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))}))}return target}function _defineProperty(obj,key,value){return key in obj?Object.defineProperty(obj,key,{value:value,enumerable:!0,configurable:!0,writable:!0}):obj[key]=value,obj}function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=_unsupportedIterableToArray(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e2){throw _e2},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e3){didErr=!0,err=_e3},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _slicedToArray(arr,i){return function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null==_i)return;var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}(arr,i)||_unsupportedIterableToArray(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _unsupportedIterableToArray(o,minLen){if(o){if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);return"Object"===n&&o.constructor&&(n=o.constructor.name),"Map"===n||"Set"===n?Array.from(o):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?_arrayLikeToArray(o,minLen):void 0}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var PDFScriptingManager=function(){function PDFScriptingManager(_ref){var eventBus=_ref.eventBus,_ref$sandboxBundleSrc=_ref.sandboxBundleSrc,sandboxBundleSrc=void 0===_ref$sandboxBundleSrc?null:_ref$sandboxBundleSrc,_ref$scriptingFactory=_ref.scriptingFactory,scriptingFactory=void 0===_ref$scriptingFactory?null:_ref$scriptingFactory,_ref$docPropertiesLoo=_ref.docPropertiesLookup,docPropertiesLookup=void 0===_ref$docPropertiesLoo?null:_ref$docPropertiesLoo;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFScriptingManager),this._pdfDocument=null,this._pdfViewer=null,this._closeCapability=null,this._destroyCapability=null,this._scripting=null,this._mouseState=Object.create(null),this._ready=!1,this._eventBus=eventBus,this._sandboxBundleSrc=sandboxBundleSrc,this._scriptingFactory=scriptingFactory,this._docPropertiesLookup=docPropertiesLookup}var Constructor,protoProps,staticProps,_destroyScripting2,_getDocProperties2,_dispatchPageClose2,_dispatchPageOpen2,_updateFromSandbox2,_dispatchDidPrint,_dispatchWillPrint,_dispatchDidSave,_dispatchWillSave,_setDocument;return Constructor=PDFScriptingManager,(protoProps=[{key:"setViewer",value:function(pdfViewer){this._pdfViewer=pdfViewer}},{key:"setDocument",value:(_setDocument=_asyncToGenerator(_regenerator.default.mark((function _callee2(pdfDocument){var _this$_scripting3,_yield$Promise$all,_yield$Promise$all2,objects,calculationOrder,docActions,_iterator,_step,_step$value,name,listener,_iterator2,_step2,_step2$value,_name,_listener,docProperties,_this=this;return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:if(!this._pdfDocument){_context2.next=3;break}return _context2.next=3,this._destroyScripting();case 3:if(this._pdfDocument=pdfDocument,pdfDocument){_context2.next=6;break}return _context2.abrupt("return");case 6:return _context2.next=8,Promise.all([pdfDocument.getFieldObjects(),pdfDocument.getCalculationOrderIds(),pdfDocument.getJSActions()]);case 8:if(_yield$Promise$all=_context2.sent,_yield$Promise$all2=_slicedToArray(_yield$Promise$all,3),objects=_yield$Promise$all2[0],calculationOrder=_yield$Promise$all2[1],docActions=_yield$Promise$all2[2],objects||docActions){_context2.next=17;break}return _context2.next=16,this._destroyScripting();case 16:return _context2.abrupt("return");case 17:if(pdfDocument===this._pdfDocument){_context2.next=19;break}return _context2.abrupt("return");case 19:_context2.prev=19,this._scripting=this._createScripting(),_context2.next=29;break;case 23:return _context2.prev=23,_context2.t0=_context2.catch(19),console.error('PDFScriptingManager.setDocument: "'.concat(null===_context2.t0||void 0===_context2.t0?void 0:_context2.t0.message,'".')),_context2.next=28,this._destroyScripting();case 28:return _context2.abrupt("return");case 29:this._internalEvents.set("updatefromsandbox",(function(event){(null==event?void 0:event.source)===window&&_this._updateFromSandbox(event.detail)})),this._internalEvents.set("dispatcheventinsandbox",(function(event){var _this$_scripting;null===(_this$_scripting=_this._scripting)||void 0===_this$_scripting||_this$_scripting.dispatchEventInSandbox(event.detail)})),this._internalEvents.set("pagechanging",(function(_ref2){var pageNumber=_ref2.pageNumber,previous=_ref2.previous;pageNumber!==previous&&(_this._dispatchPageClose(previous),_this._dispatchPageOpen(pageNumber))})),this._internalEvents.set("pagerendered",(function(_ref3){var pageNumber=_ref3.pageNumber;_this._pageOpenPending.has(pageNumber)&&pageNumber===_this._pdfViewer.currentPageNumber&&_this._dispatchPageOpen(pageNumber)})),this._internalEvents.set("pagesdestroy",function(){var _ref4=_asyncToGenerator(_regenerator.default.mark((function _callee(event){var _this$_scripting2,_this$_closeCapabilit;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:return _context.next=2,_this._dispatchPageClose(_this._pdfViewer.currentPageNumber);case 2:return _context.next=4,null===(_this$_scripting2=_this._scripting)||void 0===_this$_scripting2?void 0:_this$_scripting2.dispatchEventInSandbox({id:"doc",name:"WillClose"});case 4:null===(_this$_closeCapabilit=_this._closeCapability)||void 0===_this$_closeCapabilit||_this$_closeCapabilit.resolve();case 5:case"end":return _context.stop()}}),_callee)})));return function(_x2){return _ref4.apply(this,arguments)}}()),this._domEvents.set("mousedown",(function(event){_this._mouseState.isDown=!0})),this._domEvents.set("mouseup",(function(event){_this._mouseState.isDown=!1})),_iterator=_createForOfIteratorHelper(this._internalEvents);try{for(_iterator.s();!(_step=_iterator.n()).done;)_step$value=_slicedToArray(_step.value,2),name=_step$value[0],listener=_step$value[1],this._eventBus._on(name,listener)}catch(err){_iterator.e(err)}finally{_iterator.f()}_iterator2=_createForOfIteratorHelper(this._domEvents);try{for(_iterator2.s();!(_step2=_iterator2.n()).done;)_step2$value=_slicedToArray(_step2.value,2),_name=_step2$value[0],_listener=_step2$value[1],window.addEventListener(_name,_listener)}catch(err){_iterator2.e(err)}finally{_iterator2.f()}return _context2.prev=40,_context2.next=43,this._getDocProperties();case 43:if(docProperties=_context2.sent,pdfDocument===this._pdfDocument){_context2.next=46;break}return _context2.abrupt("return");case 46:return _context2.next=48,this._scripting.createSandbox({objects:objects,calculationOrder:calculationOrder,appInfo:{platform:navigator.platform,language:navigator.language},docInfo:_objectSpread(_objectSpread({},docProperties),{},{actions:docActions})});case 48:this._eventBus.dispatch("sandboxcreated",{source:this}),_context2.next=57;break;case 51:return _context2.prev=51,_context2.t1=_context2.catch(40),console.error('PDFScriptingManager.setDocument: "'.concat(null===_context2.t1||void 0===_context2.t1?void 0:_context2.t1.message,'".')),_context2.next=56,this._destroyScripting();case 56:return _context2.abrupt("return");case 57:return _context2.next=59,null===(_this$_scripting3=this._scripting)||void 0===_this$_scripting3?void 0:_this$_scripting3.dispatchEventInSandbox({id:"doc",name:"Open"});case 59:return _context2.next=61,this._dispatchPageOpen(this._pdfViewer.currentPageNumber,!0);case 61:Promise.resolve().then((function(){pdfDocument===_this._pdfDocument&&(_this._ready=!0)}));case 62:case"end":return _context2.stop()}}),_callee2,this,[[19,23],[40,51]])}))),function(_x){return _setDocument.apply(this,arguments)})},{key:"dispatchWillSave",value:(_dispatchWillSave=_asyncToGenerator(_regenerator.default.mark((function _callee3(detail){var _this$_scripting4;return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:return _context3.abrupt("return",null===(_this$_scripting4=this._scripting)||void 0===_this$_scripting4?void 0:_this$_scripting4.dispatchEventInSandbox({id:"doc",name:"WillSave"}));case 1:case"end":return _context3.stop()}}),_callee3,this)}))),function(_x3){return _dispatchWillSave.apply(this,arguments)})},{key:"dispatchDidSave",value:(_dispatchDidSave=_asyncToGenerator(_regenerator.default.mark((function _callee4(detail){var _this$_scripting5;return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:return _context4.abrupt("return",null===(_this$_scripting5=this._scripting)||void 0===_this$_scripting5?void 0:_this$_scripting5.dispatchEventInSandbox({id:"doc",name:"DidSave"}));case 1:case"end":return _context4.stop()}}),_callee4,this)}))),function(_x4){return _dispatchDidSave.apply(this,arguments)})},{key:"dispatchWillPrint",value:(_dispatchWillPrint=_asyncToGenerator(_regenerator.default.mark((function _callee5(detail){var _this$_scripting6;return _regenerator.default.wrap((function(_context5){for(;;)switch(_context5.prev=_context5.next){case 0:return _context5.abrupt("return",null===(_this$_scripting6=this._scripting)||void 0===_this$_scripting6?void 0:_this$_scripting6.dispatchEventInSandbox({id:"doc",name:"WillPrint"}));case 1:case"end":return _context5.stop()}}),_callee5,this)}))),function(_x5){return _dispatchWillPrint.apply(this,arguments)})},{key:"dispatchDidPrint",value:(_dispatchDidPrint=_asyncToGenerator(_regenerator.default.mark((function _callee6(detail){var _this$_scripting7;return _regenerator.default.wrap((function(_context6){for(;;)switch(_context6.prev=_context6.next){case 0:return _context6.abrupt("return",null===(_this$_scripting7=this._scripting)||void 0===_this$_scripting7?void 0:_this$_scripting7.dispatchEventInSandbox({id:"doc",name:"DidPrint"}));case 1:case"end":return _context6.stop()}}),_callee6,this)}))),function(_x6){return _dispatchDidPrint.apply(this,arguments)})},{key:"mouseState",get:function(){return this._mouseState}},{key:"destroyPromise",get:function(){var _this$_destroyCapabil;return(null===(_this$_destroyCapabil=this._destroyCapability)||void 0===_this$_destroyCapabil?void 0:_this$_destroyCapabil.promise)||null}},{key:"ready",get:function(){return this._ready}},{key:"_internalEvents",get:function(){return(0,_pdfjsLib.shadow)(this,"_internalEvents",new Map)}},{key:"_domEvents",get:function(){return(0,_pdfjsLib.shadow)(this,"_domEvents",new Map)}},{key:"_pageOpenPending",get:function(){return(0,_pdfjsLib.shadow)(this,"_pageOpenPending",new Set)}},{key:"_visitedPages",get:function(){return(0,_pdfjsLib.shadow)(this,"_visitedPages",new Map)}},{key:"_updateFromSandbox",value:(_updateFromSandbox2=_asyncToGenerator(_regenerator.default.mark((function _callee7(detail){var isInPresentationMode,id,siblings,command,value,ids,_iterator3,_step3,elementId,element,_this$_pdfDocument;return _regenerator.default.wrap((function(_context7){for(;;)switch(_context7.prev=_context7.next){case 0:if(isInPresentationMode=this._pdfViewer.isInPresentationMode||this._pdfViewer.isChangingPresentationMode,id=detail.id,siblings=detail.siblings,command=detail.command,value=detail.value,id){_context7.next=25;break}_context7.t0=command,_context7.next="clear"===_context7.t0?6:"error"===_context7.t0?8:"layout"===_context7.t0?10:"page-num"===_context7.t0?12:"print"===_context7.t0?14:"println"===_context7.t0?18:"zoom"===_context7.t0?20:24;break;case 6:return console.clear(),_context7.abrupt("break",24);case 8:return console.error(value),_context7.abrupt("break",24);case 10:return this._pdfViewer.spreadMode=(0,_ui_utils.apiPageLayoutToSpreadMode)(value),_context7.abrupt("break",24);case 12:return this._pdfViewer.currentPageNumber=value+1,_context7.abrupt("break",24);case 14:return _context7.next=16,this._pdfViewer.pagesPromise;case 16:return this._eventBus.dispatch("print",{source:this}),_context7.abrupt("break",24);case 18:return console.log(value),_context7.abrupt("break",24);case 20:if(!isInPresentationMode){_context7.next=22;break}return _context7.abrupt("return");case 22:return this._pdfViewer.currentScaleValue=value,_context7.abrupt("break",24);case 24:return _context7.abrupt("return");case 25:if(!isInPresentationMode){_context7.next=28;break}if(!detail.focus){_context7.next=28;break}return _context7.abrupt("return");case 28:delete detail.id,delete detail.siblings,ids=siblings?[id].concat(_toConsumableArray(siblings)):[id],_iterator3=_createForOfIteratorHelper(ids);try{for(_iterator3.s();!(_step3=_iterator3.n()).done;)elementId=_step3.value,(element=document.getElementById(elementId))?element.dispatchEvent(new CustomEvent("updatefromsandbox",{detail:detail})):null===(_this$_pdfDocument=this._pdfDocument)||void 0===_this$_pdfDocument||_this$_pdfDocument.annotationStorage.setValue(elementId,detail)}catch(err){_iterator3.e(err)}finally{_iterator3.f()}case 33:case"end":return _context7.stop()}}),_callee7,this)}))),function(_x7){return _updateFromSandbox2.apply(this,arguments)})},{key:"_dispatchPageOpen",value:(_dispatchPageOpen2=_asyncToGenerator(_regenerator.default.mark((function _callee9(pageNumber){var initialize,pdfDocument,visitedPages,pageView,actionsPromise,_this2=this,_args9=arguments;return _regenerator.default.wrap((function(_context9){for(;;)switch(_context9.prev=_context9.next){case 0:if(initialize=_args9.length>1&&void 0!==_args9[1]&&_args9[1],pdfDocument=this._pdfDocument,visitedPages=this._visitedPages,initialize&&(this._closeCapability=(0,_pdfjsLib.createPromiseCapability)()),this._closeCapability){_context9.next=5;break}return _context9.abrupt("return");case 5:if((null==(pageView=this._pdfViewer.getPageView(pageNumber-1))?void 0:pageView.renderingState)===_pdf_rendering_queue.RenderingStates.FINISHED){_context9.next=9;break}return this._pageOpenPending.add(pageNumber),_context9.abrupt("return");case 9:this._pageOpenPending.delete(pageNumber),actionsPromise=_asyncToGenerator(_regenerator.default.mark((function _callee8(){var _pageView$pdfPage,_this2$_scripting,actions;return _regenerator.default.wrap((function(_context8){for(;;)switch(_context8.prev=_context8.next){case 0:return _context8.next=2,visitedPages.has(pageNumber)?null:null===(_pageView$pdfPage=pageView.pdfPage)||void 0===_pageView$pdfPage?void 0:_pageView$pdfPage.getJSActions();case 2:if(actions=_context8.sent,pdfDocument===_this2._pdfDocument){_context8.next=5;break}return _context8.abrupt("return");case 5:return _context8.next=7,null===(_this2$_scripting=_this2._scripting)||void 0===_this2$_scripting?void 0:_this2$_scripting.dispatchEventInSandbox({id:"page",name:"PageOpen",pageNumber:pageNumber,actions:actions});case 7:case"end":return _context8.stop()}}),_callee8)})))(),visitedPages.set(pageNumber,actionsPromise);case 12:case"end":return _context9.stop()}}),_callee9,this)}))),function(_x8){return _dispatchPageOpen2.apply(this,arguments)})},{key:"_dispatchPageClose",value:(_dispatchPageClose2=_asyncToGenerator(_regenerator.default.mark((function _callee10(pageNumber){var _this$_scripting8,pdfDocument,visitedPages,actionsPromise;return _regenerator.default.wrap((function(_context10){for(;;)switch(_context10.prev=_context10.next){case 0:if(pdfDocument=this._pdfDocument,visitedPages=this._visitedPages,this._closeCapability){_context10.next=3;break}return _context10.abrupt("return");case 3:if(!this._pageOpenPending.has(pageNumber)){_context10.next=5;break}return _context10.abrupt("return");case 5:if(actionsPromise=visitedPages.get(pageNumber)){_context10.next=8;break}return _context10.abrupt("return");case 8:return visitedPages.set(pageNumber,null),_context10.next=11,actionsPromise;case 11:if(pdfDocument===this._pdfDocument){_context10.next=13;break}return _context10.abrupt("return");case 13:return _context10.next=15,null===(_this$_scripting8=this._scripting)||void 0===_this$_scripting8?void 0:_this$_scripting8.dispatchEventInSandbox({id:"page",name:"PageClose",pageNumber:pageNumber});case 15:case"end":return _context10.stop()}}),_callee10,this)}))),function(_x9){return _dispatchPageClose2.apply(this,arguments)})},{key:"_getDocProperties",value:(_getDocProperties2=_asyncToGenerator(_regenerator.default.mark((function _callee11(){return _regenerator.default.wrap((function(_context11){for(;;)switch(_context11.prev=_context11.next){case 0:if(!this._docPropertiesLookup){_context11.next=2;break}return _context11.abrupt("return",this._docPropertiesLookup(this._pdfDocument));case 2:throw new Error("_getDocProperties: Unable to lookup properties.");case 3:case"end":return _context11.stop()}}),_callee11,this)}))),function(){return _getDocProperties2.apply(this,arguments)})},{key:"_createScripting",value:function(){if(this._destroyCapability=(0,_pdfjsLib.createPromiseCapability)(),this._scripting)throw new Error("_createScripting: Scripting already exists.");if(this._scriptingFactory)return this._scriptingFactory.createScripting({sandboxBundleSrc:this._sandboxBundleSrc});throw new Error("_createScripting: Cannot create scripting.")}},{key:"_destroyScripting",value:(_destroyScripting2=_asyncToGenerator(_regenerator.default.mark((function _callee12(){var _this$_destroyCapabil3,_this$_destroyCapabil2,_iterator4,_step4,_step4$value,name,listener,_iterator5,_step5,_step5$value,_name2,_listener2;return _regenerator.default.wrap((function(_context12){for(;;)switch(_context12.prev=_context12.next){case 0:if(this._scripting){_context12.next=4;break}return this._pdfDocument=null,null===(_this$_destroyCapabil2=this._destroyCapability)||void 0===_this$_destroyCapabil2||_this$_destroyCapabil2.resolve(),_context12.abrupt("return");case 4:if(!this._closeCapability){_context12.next=8;break}return _context12.next=7,Promise.race([this._closeCapability.promise,new Promise((function(resolve){setTimeout(resolve,1e3)}))]).catch((function(reason){}));case 7:this._closeCapability=null;case 8:return this._pdfDocument=null,_context12.prev=9,_context12.next=12,this._scripting.destroySandbox();case 12:_context12.next=16;break;case 14:_context12.prev=14,_context12.t0=_context12.catch(9);case 16:_iterator4=_createForOfIteratorHelper(this._internalEvents);try{for(_iterator4.s();!(_step4=_iterator4.n()).done;)_step4$value=_slicedToArray(_step4.value,2),name=_step4$value[0],listener=_step4$value[1],this._eventBus._off(name,listener)}catch(err){_iterator4.e(err)}finally{_iterator4.f()}this._internalEvents.clear(),_iterator5=_createForOfIteratorHelper(this._domEvents);try{for(_iterator5.s();!(_step5=_iterator5.n()).done;)_step5$value=_slicedToArray(_step5.value,2),_name2=_step5$value[0],_listener2=_step5$value[1],window.removeEventListener(_name2,_listener2)}catch(err){_iterator5.e(err)}finally{_iterator5.f()}this._domEvents.clear(),this._pageOpenPending.clear(),this._visitedPages.clear(),this._scripting=null,delete this._mouseState.isDown,this._ready=!1,null===(_this$_destroyCapabil3=this._destroyCapability)||void 0===_this$_destroyCapabil3||_this$_destroyCapabil3.resolve();case 28:case"end":return _context12.stop()}}),_callee12,this,[[9,14]])}))),function(){return _destroyScripting2.apply(this,arguments)})}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFScriptingManager}();exports.PDFScriptingManager=PDFScriptingManager},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFSidebar=void 0;var _ui_utils=__webpack_require__(5),_pdf_rendering_queue=__webpack_require__(9);function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var PDFSidebar=function(){function PDFSidebar(_ref){var elements=_ref.elements,pdfViewer=_ref.pdfViewer,pdfThumbnailViewer=_ref.pdfThumbnailViewer,eventBus=_ref.eventBus,l10n=_ref.l10n;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFSidebar),this.isOpen=!1,this.active=_ui_utils.SidebarView.THUMBS,this.isInitialViewSet=!1,this.onToggled=null,this.pdfViewer=pdfViewer,this.pdfThumbnailViewer=pdfThumbnailViewer,this.outerContainer=elements.outerContainer,this.viewerContainer=elements.viewerContainer,this.toggleButton=elements.toggleButton,this.thumbnailButton=elements.thumbnailButton,this.outlineButton=elements.outlineButton,this.attachmentsButton=elements.attachmentsButton,this.layersButton=elements.layersButton,this.thumbnailView=elements.thumbnailView,this.outlineView=elements.outlineView,this.attachmentsView=elements.attachmentsView,this.layersView=elements.layersView,this._outlineOptionsContainer=elements.outlineOptionsContainer,this._currentOutlineItemButton=elements.currentOutlineItemButton,this.eventBus=eventBus,this.l10n=l10n,this._addEventListeners()}var Constructor,protoProps,staticProps;return Constructor=PDFSidebar,(protoProps=[{key:"reset",value:function(){this.isInitialViewSet=!1,this._hideUINotification(!0),this.switchView(_ui_utils.SidebarView.THUMBS),this.outlineButton.disabled=!1,this.attachmentsButton.disabled=!1,this.layersButton.disabled=!1,this._currentOutlineItemButton.disabled=!0}},{key:"visibleView",get:function(){return this.isOpen?this.active:_ui_utils.SidebarView.NONE}},{key:"isThumbnailViewVisible",get:function(){return this.isOpen&&this.active===_ui_utils.SidebarView.THUMBS}},{key:"isOutlineViewVisible",get:function(){return this.isOpen&&this.active===_ui_utils.SidebarView.OUTLINE}},{key:"isAttachmentsViewVisible",get:function(){return this.isOpen&&this.active===_ui_utils.SidebarView.ATTACHMENTS}},{key:"isLayersViewVisible",get:function(){return this.isOpen&&this.active===_ui_utils.SidebarView.LAYERS}},{key:"setInitialView",value:function(){var view=arguments.length>0&&void 0!==arguments[0]?arguments[0]:_ui_utils.SidebarView.NONE;this.isInitialViewSet||(this.isInitialViewSet=!0,view!==_ui_utils.SidebarView.NONE&&view!==_ui_utils.SidebarView.UNKNOWN&&this._switchView(view,!0)||this._dispatchEvent())}},{key:"switchView",value:function(view){var forceOpen=arguments.length>1&&void 0!==arguments[1]&&arguments[1];this._switchView(view,forceOpen)}},{key:"_switchView",value:function(view){var forceOpen=arguments.length>1&&void 0!==arguments[1]&&arguments[1],isViewChanged=view!==this.active,shouldForceRendering=!1;switch(view){case _ui_utils.SidebarView.NONE:return!!this.isOpen&&(this.close(),!0);case _ui_utils.SidebarView.THUMBS:this.isOpen&&isViewChanged&&(shouldForceRendering=!0);break;case _ui_utils.SidebarView.OUTLINE:if(this.outlineButton.disabled)return!1;break;case _ui_utils.SidebarView.ATTACHMENTS:if(this.attachmentsButton.disabled)return!1;break;case _ui_utils.SidebarView.LAYERS:if(this.layersButton.disabled)return!1;break;default:return console.error('PDFSidebar._switchView: "'.concat(view,'" is not a valid view.')),!1}return this.active=view,this.thumbnailButton.classList.toggle("toggled",view===_ui_utils.SidebarView.THUMBS),this.outlineButton.classList.toggle("toggled",view===_ui_utils.SidebarView.OUTLINE),this.attachmentsButton.classList.toggle("toggled",view===_ui_utils.SidebarView.ATTACHMENTS),this.layersButton.classList.toggle("toggled",view===_ui_utils.SidebarView.LAYERS),this.thumbnailView.classList.toggle("hidden",view!==_ui_utils.SidebarView.THUMBS),this.outlineView.classList.toggle("hidden",view!==_ui_utils.SidebarView.OUTLINE),this.attachmentsView.classList.toggle("hidden",view!==_ui_utils.SidebarView.ATTACHMENTS),this.layersView.classList.toggle("hidden",view!==_ui_utils.SidebarView.LAYERS),this._outlineOptionsContainer.classList.toggle("hidden",view!==_ui_utils.SidebarView.OUTLINE),forceOpen&&!this.isOpen?(this.open(),!0):(shouldForceRendering&&(this._updateThumbnailViewer(),this._forceRendering()),isViewChanged&&this._dispatchEvent(),isViewChanged)}},{key:"open",value:function(){this.isOpen||(this.isOpen=!0,this.toggleButton.classList.add("toggled"),this.toggleButton.setAttribute("aria-expanded","true"),this.outerContainer.classList.add("sidebarMoving","sidebarOpen"),this.active===_ui_utils.SidebarView.THUMBS&&this._updateThumbnailViewer(),this._forceRendering(),this._dispatchEvent(),this._hideUINotification())}},{key:"close",value:function(){this.isOpen&&(this.isOpen=!1,this.toggleButton.classList.remove("toggled"),this.toggleButton.setAttribute("aria-expanded","false"),this.outerContainer.classList.add("sidebarMoving"),this.outerContainer.classList.remove("sidebarOpen"),this._forceRendering(),this._dispatchEvent())}},{key:"toggle",value:function(){this.isOpen?this.close():this.open()}},{key:"_dispatchEvent",value:function(){this.eventBus.dispatch("sidebarviewchanged",{source:this,view:this.visibleView})}},{key:"_forceRendering",value:function(){this.onToggled?this.onToggled():(this.pdfViewer.forceRendering(),this.pdfThumbnailViewer.forceRendering())}},{key:"_updateThumbnailViewer",value:function(){for(var pdfViewer=this.pdfViewer,pdfThumbnailViewer=this.pdfThumbnailViewer,pagesCount=pdfViewer.pagesCount,pageIndex=0;pageIndex<pagesCount;pageIndex++){var pageView=pdfViewer.getPageView(pageIndex);(null==pageView?void 0:pageView.renderingState)===_pdf_rendering_queue.RenderingStates.FINISHED&&pdfThumbnailViewer.getThumbnail(pageIndex).setImage(pageView)}pdfThumbnailViewer.scrollThumbnailIntoView(pdfViewer.currentPageNumber)}},{key:"_showUINotification",value:function(){var _this=this;this.l10n.get("toggle_sidebar_notification2.title").then((function(msg){_this.toggleButton.title=msg})),this.isOpen||this.toggleButton.classList.add("pdfSidebarNotification")}},{key:"_hideUINotification",value:function(){var _this2=this,reset=arguments.length>0&&void 0!==arguments[0]&&arguments[0];(this.isOpen||reset)&&this.toggleButton.classList.remove("pdfSidebarNotification"),reset&&this.l10n.get("toggle_sidebar.title").then((function(msg){_this2.toggleButton.title=msg}))}},{key:"_addEventListeners",value:function(){var _this3=this;this.viewerContainer.addEventListener("transitionend",(function(evt){evt.target===_this3.viewerContainer&&_this3.outerContainer.classList.remove("sidebarMoving")})),this.toggleButton.addEventListener("click",(function(){_this3.toggle()})),this.thumbnailButton.addEventListener("click",(function(){_this3.switchView(_ui_utils.SidebarView.THUMBS)})),this.outlineButton.addEventListener("click",(function(){_this3.switchView(_ui_utils.SidebarView.OUTLINE)})),this.outlineButton.addEventListener("dblclick",(function(){_this3.eventBus.dispatch("toggleoutlinetree",{source:_this3})})),this.attachmentsButton.addEventListener("click",(function(){_this3.switchView(_ui_utils.SidebarView.ATTACHMENTS)})),this.layersButton.addEventListener("click",(function(){_this3.switchView(_ui_utils.SidebarView.LAYERS)})),this.layersButton.addEventListener("dblclick",(function(){_this3.eventBus.dispatch("resetlayers",{source:_this3})})),this._currentOutlineItemButton.addEventListener("click",(function(){_this3.eventBus.dispatch("currentoutlineitem",{source:_this3})}));var onTreeLoaded=function(count,button,view){button.disabled=!count,count?_this3._showUINotification():_this3.active===view&&_this3.switchView(_ui_utils.SidebarView.THUMBS)};this.eventBus._on("outlineloaded",(function(evt){onTreeLoaded(evt.outlineCount,_this3.outlineButton,_ui_utils.SidebarView.OUTLINE),evt.currentOutlineItemPromise.then((function(enabled){_this3.isInitialViewSet&&(_this3._currentOutlineItemButton.disabled=!enabled)}))})),this.eventBus._on("attachmentsloaded",(function(evt){onTreeLoaded(evt.attachmentsCount,_this3.attachmentsButton,_ui_utils.SidebarView.ATTACHMENTS)})),this.eventBus._on("layersloaded",(function(evt){onTreeLoaded(evt.layersCount,_this3.layersButton,_ui_utils.SidebarView.LAYERS)})),this.eventBus._on("presentationmodechanged",(function(evt){evt.state===_ui_utils.PresentationModeState.NORMAL&&_this3.isThumbnailViewVisible&&_this3._updateThumbnailViewer()}))}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFSidebar}();exports.PDFSidebar=PDFSidebar},(__unused_webpack_module,exports)=>{function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFSidebarResizer=void 0;var PDFSidebarResizer=function(){function PDFSidebarResizer(options,eventBus,l10n){var _this=this;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFSidebarResizer),this.isRTL=!1,this.sidebarOpen=!1,this.doc=document.documentElement,this._width=null,this._outerContainerWidth=null,this._boundEvents=Object.create(null),this.outerContainer=options.outerContainer,this.resizer=options.resizer,this.eventBus=eventBus,l10n.getDirection().then((function(dir){_this.isRTL="rtl"===dir})),this._addEventListeners()}var Constructor,protoProps,staticProps;return Constructor=PDFSidebarResizer,(protoProps=[{key:"outerContainerWidth",get:function(){return this._outerContainerWidth||(this._outerContainerWidth=this.outerContainer.clientWidth)}},{key:"_updateWidth",value:function(){var width=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0,maxWidth=Math.floor(this.outerContainerWidth/2);return width>maxWidth&&(width=maxWidth),width<200&&(width=200),width!==this._width&&(this._width=width,this.doc.style.setProperty("--sidebar-width","".concat(width,"px")),!0)}},{key:"_mouseMove",value:function(evt){var width=evt.clientX;this.isRTL&&(width=this.outerContainerWidth-width),this._updateWidth(width)}},{key:"_mouseUp",value:function(evt){this.outerContainer.classList.remove("sidebarResizing"),this.eventBus.dispatch("resize",{source:this});var _boundEvents=this._boundEvents;window.removeEventListener("mousemove",_boundEvents.mouseMove),window.removeEventListener("mouseup",_boundEvents.mouseUp)}},{key:"_addEventListeners",value:function(){var _this2=this,_boundEvents=this._boundEvents;_boundEvents.mouseMove=this._mouseMove.bind(this),_boundEvents.mouseUp=this._mouseUp.bind(this),this.resizer.addEventListener("mousedown",(function(evt){0===evt.button&&(_this2.outerContainer.classList.add("sidebarResizing"),window.addEventListener("mousemove",_boundEvents.mouseMove),window.addEventListener("mouseup",_boundEvents.mouseUp))})),this.eventBus._on("sidebarviewchanged",(function(evt){_this2.sidebarOpen=!(null==evt||!evt.view)})),this.eventBus._on("resize",(function(evt){if((null==evt?void 0:evt.source)===window&&(_this2._outerContainerWidth=null,_this2._width))if(_this2.sidebarOpen){_this2.outerContainer.classList.add("sidebarResizing");var updated=_this2._updateWidth(_this2._width);Promise.resolve().then((function(){_this2.outerContainer.classList.remove("sidebarResizing"),updated&&_this2.eventBus.dispatch("resize",{source:_this2})}))}else _this2._updateWidth(_this2._width)}))}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFSidebarResizer}();exports.PDFSidebarResizer=PDFSidebarResizer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFThumbnailViewer=void 0;var _ui_utils=__webpack_require__(5),_pdf_thumbnail_view=__webpack_require__(27),_pdf_rendering_queue=__webpack_require__(9);function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var PDFThumbnailViewer=function(){function PDFThumbnailViewer(_ref){var _this=this,container=_ref.container,eventBus=_ref.eventBus,linkService=_ref.linkService,renderingQueue=_ref.renderingQueue,l10n=_ref.l10n;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFThumbnailViewer),this.container=container,this.linkService=linkService,this.renderingQueue=renderingQueue,this.l10n=l10n,this.scroll=(0,_ui_utils.watchScroll)(this.container,this._scrollUpdated.bind(this)),this._resetView(),eventBus._on("optionalcontentconfigchanged",(function(){_this._setImageDisabled=!0}))}var Constructor,protoProps,staticProps;return Constructor=PDFThumbnailViewer,(protoProps=[{key:"_scrollUpdated",value:function(){this.renderingQueue.renderHighestPriority()}},{key:"getThumbnail",value:function(index){return this._thumbnails[index]}},{key:"_getVisibleThumbs",value:function(){return(0,_ui_utils.getVisibleElements)({scrollEl:this.container,views:this._thumbnails})}},{key:"scrollThumbnailIntoView",value:function(pageNumber){if(this.pdfDocument){var thumbnailView=this._thumbnails[pageNumber-1];if(thumbnailView){pageNumber!==this._currentPageNumber&&(this._thumbnails[this._currentPageNumber-1].div.classList.remove("selected"),thumbnailView.div.classList.add("selected"));var visibleThumbs=this._getVisibleThumbs(),numVisibleThumbs=visibleThumbs.views.length;if(numVisibleThumbs>0){var first=visibleThumbs.first.id,last=numVisibleThumbs>1?visibleThumbs.last.id:first,shouldScroll=!1;pageNumber<=first||pageNumber>=last?shouldScroll=!0:visibleThumbs.views.some((function(view){return view.id===pageNumber&&(shouldScroll=view.percent<100,!0)})),shouldScroll&&(0,_ui_utils.scrollIntoView)(thumbnailView.div,{top:-19})}this._currentPageNumber=pageNumber}else console.error('scrollThumbnailIntoView: Invalid "pageNumber" parameter.')}}},{key:"pagesRotation",get:function(){return this._pagesRotation},set:function(rotation){if(!(0,_ui_utils.isValidRotation)(rotation))throw new Error("Invalid thumbnails rotation angle.");if(this.pdfDocument&&this._pagesRotation!==rotation){this._pagesRotation=rotation;var _step,updateArgs={rotation:rotation},_iterator=_createForOfIteratorHelper(this._thumbnails);try{for(_iterator.s();!(_step=_iterator.n()).done;)_step.value.update(updateArgs)}catch(err){_iterator.e(err)}finally{_iterator.f()}}}},{key:"cleanup",value:function(){for(var i=0,ii=this._thumbnails.length;i<ii;i++)this._thumbnails[i]&&this._thumbnails[i].renderingState!==_pdf_rendering_queue.RenderingStates.FINISHED&&this._thumbnails[i].reset();_pdf_thumbnail_view.TempImageFactory.destroyCanvas()}},{key:"_resetView",value:function(){this._thumbnails=[],this._currentPageNumber=1,this._pageLabels=null,this._pagesRotation=0,this._optionalContentConfigPromise=null,this._pagesRequests=new WeakMap,this._setImageDisabled=!1,this.container.textContent=""}},{key:"setDocument",value:function(pdfDocument){var _this2=this;if(this.pdfDocument&&(this._cancelRendering(),this._resetView()),this.pdfDocument=pdfDocument,pdfDocument){var firstPagePromise=pdfDocument.getPage(1),optionalContentConfigPromise=pdfDocument.getOptionalContentConfig();firstPagePromise.then((function(firstPdfPage){_this2._optionalContentConfigPromise=optionalContentConfigPromise;for(var pagesCount=pdfDocument.numPages,viewport=firstPdfPage.getViewport({scale:1}),checkSetImageDisabled=function(){return _this2._setImageDisabled},pageNum=1;pageNum<=pagesCount;++pageNum){var thumbnail=new _pdf_thumbnail_view.PDFThumbnailView({container:_this2.container,id:pageNum,defaultViewport:viewport.clone(),optionalContentConfigPromise:optionalContentConfigPromise,linkService:_this2.linkService,renderingQueue:_this2.renderingQueue,checkSetImageDisabled:checkSetImageDisabled,l10n:_this2.l10n});_this2._thumbnails.push(thumbnail)}var firstThumbnailView=_this2._thumbnails[0];firstThumbnailView&&firstThumbnailView.setPdfPage(firstPdfPage),_this2._thumbnails[_this2._currentPageNumber-1].div.classList.add("selected")})).catch((function(reason){console.error("Unable to initialize thumbnail viewer",reason)}))}}},{key:"_cancelRendering",value:function(){for(var i=0,ii=this._thumbnails.length;i<ii;i++)this._thumbnails[i]&&this._thumbnails[i].cancelRendering()}},{key:"setPageLabels",value:function(labels){if(this.pdfDocument){labels?Array.isArray(labels)&&this.pdfDocument.numPages===labels.length?this._pageLabels=labels:(this._pageLabels=null,console.error("PDFThumbnailViewer_setPageLabels: Invalid page labels.")):this._pageLabels=null;for(var i=0,ii=this._thumbnails.length;i<ii;i++){var _this$_pageLabels$i,_this$_pageLabels;this._thumbnails[i].setPageLabel(null!==(_this$_pageLabels$i=null===(_this$_pageLabels=this._pageLabels)||void 0===_this$_pageLabels?void 0:_this$_pageLabels[i])&&void 0!==_this$_pageLabels$i?_this$_pageLabels$i:null)}}}},{key:"_ensurePdfPageLoaded",value:function(thumbView){var _this3=this;if(thumbView.pdfPage)return Promise.resolve(thumbView.pdfPage);if(this._pagesRequests.has(thumbView))return this._pagesRequests.get(thumbView);var promise=this.pdfDocument.getPage(thumbView.id).then((function(pdfPage){return thumbView.pdfPage||thumbView.setPdfPage(pdfPage),_this3._pagesRequests.delete(thumbView),pdfPage})).catch((function(reason){console.error("Unable to get page for thumb view",reason),_this3._pagesRequests.delete(thumbView)}));return this._pagesRequests.set(thumbView,promise),promise}},{key:"forceRendering",value:function(){var _this4=this,visibleThumbs=this._getVisibleThumbs(),thumbView=this.renderingQueue.getHighestPriority(visibleThumbs,this._thumbnails,this.scroll.down);return!!thumbView&&(this._ensurePdfPageLoaded(thumbView).then((function(){_this4.renderingQueue.renderView(thumbView)})),!0)}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFThumbnailViewer}();exports.PDFThumbnailViewer=PDFThumbnailViewer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.TempImageFactory=exports.PDFThumbnailView=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_ui_utils=__webpack_require__(5),_pdfjsLib=__webpack_require__(6),_pdf_rendering_queue=__webpack_require__(9);function _slicedToArray(arr,i){return function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null==_i)return;var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}(arr,i)||function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var tempCanvasCache,TempImageFactory=(tempCanvasCache=null,{getCanvas:function(width,height){var tempCanvas=tempCanvasCache;tempCanvas||(tempCanvas=document.createElement("canvas"),tempCanvasCache=tempCanvas),tempCanvas.width=width,tempCanvas.height=height,tempCanvas.mozOpaque=!0;var ctx=tempCanvas.getContext("2d",{alpha:!1});return ctx.save(),ctx.fillStyle="rgb(255, 255, 255)",ctx.fillRect(0,0,width,height),ctx.restore(),[tempCanvas,tempCanvas.getContext("2d")]},destroyCanvas:function(){var tempCanvas=tempCanvasCache;tempCanvas&&(tempCanvas.width=0,tempCanvas.height=0),tempCanvasCache=null}});exports.TempImageFactory=TempImageFactory;var PDFThumbnailView=function(){function PDFThumbnailView(_ref){var container=_ref.container,id=_ref.id,defaultViewport=_ref.defaultViewport,optionalContentConfigPromise=_ref.optionalContentConfigPromise,linkService=_ref.linkService,renderingQueue=_ref.renderingQueue,checkSetImageDisabled=_ref.checkSetImageDisabled,l10n=_ref.l10n;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFThumbnailView),this.id=id,this.renderingId="thumbnail"+id,this.pageLabel=null,this.pdfPage=null,this.rotation=0,this.viewport=defaultViewport,this.pdfPageRotate=defaultViewport.rotation,this._optionalContentConfigPromise=optionalContentConfigPromise||null,this.linkService=linkService,this.renderingQueue=renderingQueue,this.renderTask=null,this.renderingState=_pdf_rendering_queue.RenderingStates.INITIAL,this.resume=null,this._checkSetImageDisabled=checkSetImageDisabled||function(){return!1};var pageWidth=this.viewport.width,pageRatio=pageWidth/this.viewport.height;this.canvasWidth=98,this.canvasHeight=this.canvasWidth/pageRatio|0,this.scale=this.canvasWidth/pageWidth,this.l10n=l10n;var anchor=document.createElement("a");anchor.href=linkService.getAnchorUrl("#page="+id),this._thumbPageTitle.then((function(msg){anchor.title=msg})),anchor.onclick=function(){return linkService.goToPage(id),!1},this.anchor=anchor;var div=document.createElement("div");div.className="thumbnail",div.setAttribute("data-page-number",this.id),this.div=div;var ring=document.createElement("div");ring.className="thumbnailSelectionRing";ring.style.width=this.canvasWidth+2+"px",ring.style.height=this.canvasHeight+2+"px",this.ring=ring,div.appendChild(ring),anchor.appendChild(div),container.appendChild(anchor)}var Constructor,protoProps,staticProps;return Constructor=PDFThumbnailView,(protoProps=[{key:"setPdfPage",value:function(pdfPage){this.pdfPage=pdfPage,this.pdfPageRotate=pdfPage.rotate;var totalRotation=(this.rotation+this.pdfPageRotate)%360;this.viewport=pdfPage.getViewport({scale:1,rotation:totalRotation}),this.reset()}},{key:"reset",value:function(){this.cancelRendering(),this.renderingState=_pdf_rendering_queue.RenderingStates.INITIAL;var pageWidth=this.viewport.width,pageRatio=pageWidth/this.viewport.height;this.canvasHeight=this.canvasWidth/pageRatio|0,this.scale=this.canvasWidth/pageWidth,this.div.removeAttribute("data-loaded");var ring=this.ring;ring.textContent="",ring.style.width=this.canvasWidth+2+"px",ring.style.height=this.canvasHeight+2+"px",this.canvas&&(this.canvas.width=0,this.canvas.height=0,delete this.canvas),this.image&&(this.image.removeAttribute("src"),delete this.image)}},{key:"update",value:function(_ref2){var _ref2$rotation=_ref2.rotation,rotation=void 0===_ref2$rotation?null:_ref2$rotation;"number"==typeof rotation&&(this.rotation=rotation);var totalRotation=(this.rotation+this.pdfPageRotate)%360;this.viewport=this.viewport.clone({scale:1,rotation:totalRotation}),this.reset()}},{key:"cancelRendering",value:function(){this.renderTask&&(this.renderTask.cancel(),this.renderTask=null),this.resume=null}},{key:"_getPageDrawContext",value:function(){var upscaleFactor=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1,canvas=document.createElement("canvas");canvas.mozOpaque=!0;var ctx=canvas.getContext("2d",{alpha:!1}),outputScale=(0,_ui_utils.getOutputScale)(ctx);canvas.width=upscaleFactor*this.canvasWidth*outputScale.sx|0,canvas.height=upscaleFactor*this.canvasHeight*outputScale.sy|0;var transform=outputScale.scaled?[outputScale.sx,0,0,outputScale.sy,0,0]:null;return{ctx:ctx,canvas:canvas,transform:transform}}},{key:"_convertCanvasToImage",value:function(canvas){if(this.renderingState!==_pdf_rendering_queue.RenderingStates.FINISHED)throw new Error("_convertCanvasToImage: Rendering has not finished.");var reducedCanvas=this._reduceImage(canvas),image=document.createElement("img");image.className="thumbnailImage",this._thumbPageCanvas.then((function(msg){image.setAttribute("aria-label",msg)})),image.style.width=this.canvasWidth+"px",image.style.height=this.canvasHeight+"px",image.src=reducedCanvas.toDataURL(),this.image=image,this.div.setAttribute("data-loaded",!0),this.ring.appendChild(image),reducedCanvas.width=0,reducedCanvas.height=0}},{key:"draw",value:function(){var _this=this;if(this.renderingState!==_pdf_rendering_queue.RenderingStates.INITIAL)return console.error("Must be in new state before drawing"),Promise.resolve(void 0);var pdfPage=this.pdfPage;if(!pdfPage)return this.renderingState=_pdf_rendering_queue.RenderingStates.FINISHED,Promise.reject(new Error("pdfPage is not loaded"));this.renderingState=_pdf_rendering_queue.RenderingStates.RUNNING;var finishRenderTask=function(){var fn,_ref3=(fn=_regenerator.default.mark((function _callee(){var error,_args=arguments;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:if(error=_args.length>0&&void 0!==_args[0]?_args[0]:null,renderTask===_this.renderTask&&(_this.renderTask=null),!(error instanceof _pdfjsLib.RenderingCancelledException)){_context.next=4;break}return _context.abrupt("return");case 4:if(_this.renderingState=_pdf_rendering_queue.RenderingStates.FINISHED,_this._convertCanvasToImage(canvas),!error){_context.next=8;break}throw error;case 8:case"end":return _context.stop()}}),_callee)})),function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))});return function(){return _ref3.apply(this,arguments)}}(),_this$_getPageDrawCon=this._getPageDrawContext(2),ctx=_this$_getPageDrawCon.ctx,canvas=_this$_getPageDrawCon.canvas,renderContext={canvasContext:ctx,transform:_this$_getPageDrawCon.transform,viewport:this.viewport.clone({scale:2*this.scale}),optionalContentConfigPromise:this._optionalContentConfigPromise},renderTask=this.renderTask=pdfPage.render(renderContext);renderTask.onContinue=function(cont){if(!_this.renderingQueue.isHighestPriority(_this))return _this.renderingState=_pdf_rendering_queue.RenderingStates.PAUSED,void(_this.resume=function(){_this.renderingState=_pdf_rendering_queue.RenderingStates.RUNNING,cont()});cont()};var resultPromise=renderTask.promise.then((function(){return finishRenderTask(null)}),(function(error){return finishRenderTask(error)}));return resultPromise.finally((function(){var _this$pdfPage;canvas.width=0,canvas.height=0,_this.linkService.isPageCached(_this.id)||null===(_this$pdfPage=_this.pdfPage)||void 0===_this$pdfPage||_this$pdfPage.cleanup()})),resultPromise}},{key:"setImage",value:function(pageView){if(!this._checkSetImageDisabled()&&this.renderingState===_pdf_rendering_queue.RenderingStates.INITIAL){var canvas=pageView.canvas,pdfPage=pageView.pdfPage;canvas&&(this.pdfPage||this.setPdfPage(pdfPage),this.renderingState=_pdf_rendering_queue.RenderingStates.FINISHED,this._convertCanvasToImage(canvas))}}},{key:"_reduceImage",value:function(img){var _this$_getPageDrawCon2=this._getPageDrawContext(),ctx=_this$_getPageDrawCon2.ctx,canvas=_this$_getPageDrawCon2.canvas;if(img.width<=2*canvas.width)return ctx.drawImage(img,0,0,img.width,img.height,0,0,canvas.width,canvas.height),canvas;for(var reducedWidth=canvas.width<<3,reducedHeight=canvas.height<<3,_TempImageFactory$get2=_slicedToArray(TempImageFactory.getCanvas(reducedWidth,reducedHeight),2),reducedImage=_TempImageFactory$get2[0],reducedImageCtx=_TempImageFactory$get2[1];reducedWidth>img.width||reducedHeight>img.height;)reducedWidth>>=1,reducedHeight>>=1;for(reducedImageCtx.drawImage(img,0,0,img.width,img.height,0,0,reducedWidth,reducedHeight);reducedWidth>2*canvas.width;)reducedImageCtx.drawImage(reducedImage,0,0,reducedWidth,reducedHeight,0,0,reducedWidth>>1,reducedHeight>>1),reducedWidth>>=1,reducedHeight>>=1;return ctx.drawImage(reducedImage,0,0,reducedWidth,reducedHeight,0,0,canvas.width,canvas.height),canvas}},{key:"_thumbPageTitle",get:function(){var _this$pageLabel;return this.l10n.get("thumb_page_title",{page:null!==(_this$pageLabel=this.pageLabel)&&void 0!==_this$pageLabel?_this$pageLabel:this.id})}},{key:"_thumbPageCanvas",get:function(){var _this$pageLabel2;return this.l10n.get("thumb_page_canvas",{page:null!==(_this$pageLabel2=this.pageLabel)&&void 0!==_this$pageLabel2?_this$pageLabel2:this.id})}},{key:"setPageLabel",value:function(label){var _this2=this;this.pageLabel="string"==typeof label?label:null,this._thumbPageTitle.then((function(msg){_this2.anchor.title=msg})),this.renderingState===_pdf_rendering_queue.RenderingStates.FINISHED&&this._thumbPageCanvas.then((function(msg){var _this2$image;null===(_this2$image=_this2.image)||void 0===_this2$image||_this2$image.setAttribute("aria-label",msg)}))}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFThumbnailView}();exports.PDFThumbnailView=PDFThumbnailView},(__unused_webpack_module,exports,__webpack_require__)=>{function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFViewer=void 0;var _ui_utils=__webpack_require__(5),_base_viewer=__webpack_require__(29),_pdfjsLib=__webpack_require__(6);function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _get(target,property,receiver){return(_get="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(target,property,receiver){var base=function(object,property){for(;!Object.prototype.hasOwnProperty.call(object,property)&&null!==(object=_getPrototypeOf(object)););return object}(target,property);if(base){var desc=Object.getOwnPropertyDescriptor(base,property);return desc.get?desc.get.call(receiver):desc.value}})(target,property,receiver||target)}function _setPrototypeOf(o,p){return(_setPrototypeOf=Object.setPrototypeOf||function(o,p){return o.__proto__=p,o})(o,p)}function _createSuper(Derived){var hasNativeReflectConstruct=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var result,Super=_getPrototypeOf(Derived);if(hasNativeReflectConstruct){var NewTarget=_getPrototypeOf(this).constructor;result=Reflect.construct(Super,arguments,NewTarget)}else result=Super.apply(this,arguments);return _possibleConstructorReturn(this,result)}}function _possibleConstructorReturn(self,call){if(call&&("object"===_typeof(call)||"function"==typeof call))return call;if(void 0!==call)throw new TypeError("Derived constructors may only return object or undefined");return function(self){if(void 0===self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return self}(self)}function _getPrototypeOf(o){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(o){return o.__proto__||Object.getPrototypeOf(o)})(o)}var PDFViewer=function(_BaseViewer){!function(subClass,superClass){if("function"!=typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function");subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,writable:!0,configurable:!0}}),superClass&&_setPrototypeOf(subClass,superClass)}(PDFViewer,_BaseViewer);var Constructor,protoProps,staticProps,_super=_createSuper(PDFViewer);function PDFViewer(){return _classCallCheck(this,PDFViewer),_super.apply(this,arguments)}return Constructor=PDFViewer,(protoProps=[{key:"_viewerElement",get:function(){return(0,_pdfjsLib.shadow)(this,"_viewerElement",this.viewer)}},{key:"_scrollIntoView",value:function(_ref){var pageDiv=_ref.pageDiv,_ref$pageSpot=_ref.pageSpot,pageSpot=void 0===_ref$pageSpot?null:_ref$pageSpot,_ref$pageNumber=_ref.pageNumber,pageNumber=void 0===_ref$pageNumber?null:_ref$pageNumber;if(!pageSpot&&!this.isInPresentationMode){var left=pageDiv.offsetLeft+pageDiv.clientLeft,right=left+pageDiv.clientWidth,_this$container=this.container,scrollLeft=_this$container.scrollLeft,clientWidth=_this$container.clientWidth;(this._isScrollModeHorizontal||left<scrollLeft||right>scrollLeft+clientWidth)&&(pageSpot={left:0,top:0})}_get(_getPrototypeOf(PDFViewer.prototype),"_scrollIntoView",this).call(this,{pageDiv:pageDiv,pageSpot:pageSpot,pageNumber:pageNumber})}},{key:"_getVisiblePages",value:function(){return this.isInPresentationMode?this._getCurrentVisiblePage():_get(_getPrototypeOf(PDFViewer.prototype),"_getVisiblePages",this).call(this)}},{key:"_updateHelper",value:function(visiblePages){if(!this.isInPresentationMode){var _step,currentId=this._currentPageNumber,stillFullyVisible=!1,_iterator=_createForOfIteratorHelper(visiblePages);try{for(_iterator.s();!(_step=_iterator.n()).done;){var page=_step.value;if(page.percent<100)break;if(page.id===currentId&&this._scrollMode===_ui_utils.ScrollMode.VERTICAL&&this._spreadMode===_ui_utils.SpreadMode.NONE){stillFullyVisible=!0;break}}}catch(err){_iterator.e(err)}finally{_iterator.f()}stillFullyVisible||(currentId=visiblePages[0].id),this._setCurrentPageNumber(currentId)}}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFViewer}(_base_viewer.BaseViewer);exports.PDFViewer=PDFViewer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.BaseViewer=void 0;var _pdfjsLib=__webpack_require__(6),_ui_utils=__webpack_require__(5),_pdf_rendering_queue=__webpack_require__(9),_annotation_layer_builder=__webpack_require__(30),_l10n_utils=__webpack_require__(31),_pdf_page_view=__webpack_require__(32),_pdf_link_service=__webpack_require__(20),_struct_tree_layer_builder=__webpack_require__(33),_text_highlighter=__webpack_require__(34),_text_layer_builder=__webpack_require__(35),_xfa_layer_builder=__webpack_require__(36);function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function PDFPageViewBuffer(size){var data=[];this.push=function(view){var i=data.indexOf(view);i>=0&&data.splice(i,1),data.push(view),data.length>size&&data.shift().destroy()},this.resize=function(newSize,pagesToKeep){if(size=newSize,pagesToKeep){for(var pageIdsToKeep=new Set,i=0,iMax=pagesToKeep.length;i<iMax;++i)pageIdsToKeep.add(pagesToKeep[i].id);(0,_ui_utils.moveToEndOfArray)(data,(function(page){return pageIdsToKeep.has(page.id)}))}for(;data.length>size;)data.shift().destroy()},this.has=function(view){return data.includes(view)}}function isSameScale(oldScale,newScale){return newScale===oldScale||Math.abs(newScale-oldScale)<1e-15}var BaseViewer=function(){function BaseViewer(options){var _this$container,_this$viewer,_options$textLayerMod,_options$annotationMo,_this=this;if(function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,BaseViewer),this.constructor===BaseViewer)throw new Error("Cannot initialize BaseViewer.");if("2.11.249"!==_pdfjsLib.version)throw new Error('The API version "'.concat(_pdfjsLib.version,'" does not match the Viewer version "').concat("2.11.249",'".'));if(this.container=options.container,this.viewer=options.viewer||options.container.firstElementChild,"DIV"!==(null===(_this$container=this.container)||void 0===_this$container?void 0:_this$container.tagName.toUpperCase())||"DIV"!==(null===(_this$viewer=this.viewer)||void 0===_this$viewer?void 0:_this$viewer.tagName.toUpperCase()))throw new Error("Invalid `container` and/or `viewer` option.");if(this.container.offsetParent&&"absolute"!==getComputedStyle(this.container).position)throw new Error("The `container` must be absolutely positioned.");this.eventBus=options.eventBus,this.linkService=options.linkService||new _pdf_link_service.SimpleLinkService,this.downloadManager=options.downloadManager||null,this.findController=options.findController||null,this._scriptingManager=options.scriptingManager||null,this.removePageBorders=options.removePageBorders||!1,this.textLayerMode=null!==(_options$textLayerMod=options.textLayerMode)&&void 0!==_options$textLayerMod?_options$textLayerMod:_ui_utils.TextLayerMode.ENABLE,this._annotationMode=null!==(_options$annotationMo=options.annotationMode)&&void 0!==_options$annotationMo?_options$annotationMo:_pdfjsLib.AnnotationMode.ENABLE_FORMS,this.imageResourcesPath=options.imageResourcesPath||"",this.enablePrintAutoRotate=options.enablePrintAutoRotate||!1,this.renderer=options.renderer||_ui_utils.RendererType.CANVAS,this.useOnlyCssZoom=options.useOnlyCssZoom||!1,this.maxCanvasPixels=options.maxCanvasPixels,this.l10n=options.l10n||_l10n_utils.NullL10n,this.defaultRenderingQueue=!options.renderingQueue,this.defaultRenderingQueue?(this.renderingQueue=new _pdf_rendering_queue.PDFRenderingQueue,this.renderingQueue.setViewer(this)):this.renderingQueue=options.renderingQueue,this._doc=document.documentElement,this.scroll=(0,_ui_utils.watchScroll)(this.container,this._scrollUpdate.bind(this)),this.presentationModeState=_ui_utils.PresentationModeState.UNKNOWN,this._onBeforeDraw=this._onAfterDraw=null,this._resetView(),this.removePageBorders&&this.viewer.classList.add("removePageBorders"),Promise.resolve().then((function(){_this.eventBus.dispatch("baseviewerinit",{source:_this})}))}var Constructor,protoProps,staticProps;return Constructor=BaseViewer,(protoProps=[{key:"pagesCount",get:function(){return this._pages.length}},{key:"getPageView",value:function(index){return this._pages[index]}},{key:"pageViewsReady",get:function(){return!!this._pagesCapability.settled&&this._pages.every((function(pageView){return null==pageView?void 0:pageView.pdfPage}))}},{key:"renderForms",get:function(){return this._annotationMode===_pdfjsLib.AnnotationMode.ENABLE_FORMS}},{key:"enableScripting",get:function(){return!!this._scriptingManager}},{key:"currentPageNumber",get:function(){return this._currentPageNumber},set:function(val){if(!Number.isInteger(val))throw new Error("Invalid page number.");this.pdfDocument&&(this._setCurrentPageNumber(val,!0)||console.error('currentPageNumber: "'.concat(val,'" is not a valid page.')))}},{key:"_setCurrentPageNumber",value:function(val){var _this$_pageLabels,_this$_pageLabels2,resetCurrentPageView=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(this._currentPageNumber===val)return resetCurrentPageView&&this._resetCurrentPageView(),!0;if(!(0<val&&val<=this.pagesCount))return!1;var previous=this._currentPageNumber;return this._currentPageNumber=val,this.eventBus.dispatch("pagechanging",{source:this,pageNumber:val,pageLabel:null!==(_this$_pageLabels=null===(_this$_pageLabels2=this._pageLabels)||void 0===_this$_pageLabels2?void 0:_this$_pageLabels2[val-1])&&void 0!==_this$_pageLabels?_this$_pageLabels:null,previous:previous}),resetCurrentPageView&&this._resetCurrentPageView(),!0}},{key:"currentPageLabel",get:function(){var _this$_pageLabels3,_this$_pageLabels4;return null!==(_this$_pageLabels3=null===(_this$_pageLabels4=this._pageLabels)||void 0===_this$_pageLabels4?void 0:_this$_pageLabels4[this._currentPageNumber-1])&&void 0!==_this$_pageLabels3?_this$_pageLabels3:null},set:function(val){if(this.pdfDocument){var page=0|val;if(this._pageLabels){var i=this._pageLabels.indexOf(val);i>=0&&(page=i+1)}this._setCurrentPageNumber(page,!0)||console.error('currentPageLabel: "'.concat(val,'" is not a valid page.'))}}},{key:"currentScale",get:function(){return this._currentScale!==_ui_utils.UNKNOWN_SCALE?this._currentScale:_ui_utils.DEFAULT_SCALE},set:function(val){if(isNaN(val))throw new Error("Invalid numeric scale.");this.pdfDocument&&this._setScale(val,!1)}},{key:"currentScaleValue",get:function(){return this._currentScaleValue},set:function(val){this.pdfDocument&&this._setScale(val,!1)}},{key:"pagesRotation",get:function(){return this._pagesRotation},set:function(rotation){if(!(0,_ui_utils.isValidRotation)(rotation))throw new Error("Invalid pages rotation angle.");if(this.pdfDocument&&((rotation%=360)<0&&(rotation+=360),this._pagesRotation!==rotation)){this._pagesRotation=rotation;var _step,pageNumber=this._currentPageNumber,updateArgs={rotation:rotation},_iterator=_createForOfIteratorHelper(this._pages);try{for(_iterator.s();!(_step=_iterator.n()).done;)_step.value.update(updateArgs)}catch(err){_iterator.e(err)}finally{_iterator.f()}this._currentScaleValue&&this._setScale(this._currentScaleValue,!0),this.eventBus.dispatch("rotationchanging",{source:this,pagesRotation:rotation,pageNumber:pageNumber}),this.defaultRenderingQueue&&this.update()}}},{key:"firstPagePromise",get:function(){return this.pdfDocument?this._firstPageCapability.promise:null}},{key:"onePageRendered",get:function(){return this.pdfDocument?this._onePageRenderedCapability.promise:null}},{key:"pagesPromise",get:function(){return this.pdfDocument?this._pagesCapability.promise:null}},{key:"_viewerElement",get:function(){throw new Error("Not implemented: _viewerElement")}},{key:"_onePageRenderedOrForceFetch",value:function(){return this.container.offsetParent&&0!==this._getVisiblePages().views.length?this._onePageRenderedCapability.promise:Promise.resolve()}},{key:"setDocument",value:function(pdfDocument){var _this2=this;if(this.pdfDocument&&(this.eventBus.dispatch("pagesdestroy",{source:this}),this._cancelRendering(),this._resetView(),this.findController&&this.findController.setDocument(null),this._scriptingManager&&this._scriptingManager.setDocument(null)),this.pdfDocument=pdfDocument,pdfDocument){var isPureXfa=pdfDocument.isPureXfa,pagesCount=pdfDocument.numPages,firstPagePromise=pdfDocument.getPage(1),optionalContentConfigPromise=pdfDocument.getOptionalContentConfig();this._pagesCapability.promise.then((function(){_this2.eventBus.dispatch("pagesloaded",{source:_this2,pagesCount:pagesCount})})),this._onBeforeDraw=function(evt){var pageView=_this2._pages[evt.pageNumber-1];pageView&&_this2._buffer.push(pageView)},this.eventBus._on("pagerender",this._onBeforeDraw),this._onAfterDraw=function(evt){evt.cssTransform||_this2._onePageRenderedCapability.settled||(_this2._onePageRenderedCapability.resolve(),_this2.eventBus._off("pagerendered",_this2._onAfterDraw),_this2._onAfterDraw=null)},this.eventBus._on("pagerendered",this._onAfterDraw),firstPagePromise.then((function(firstPdfPage){_this2._firstPageCapability.resolve(firstPdfPage),_this2._optionalContentConfigPromise=optionalContentConfigPromise;for(var scale=_this2.currentScale,viewport=firstPdfPage.getViewport({scale:scale*_ui_utils.CSS_UNITS}),textLayerFactory=_this2.textLayerMode===_ui_utils.TextLayerMode.DISABLE||isPureXfa?null:_this2,annotationLayerFactory=_this2._annotationMode!==_pdfjsLib.AnnotationMode.DISABLE?_this2:null,xfaLayerFactory=isPureXfa?_this2:null,pageNum=1;pageNum<=pagesCount;++pageNum){var pageView=new _pdf_page_view.PDFPageView({container:_this2._viewerElement,eventBus:_this2.eventBus,id:pageNum,scale:scale,defaultViewport:viewport.clone(),optionalContentConfigPromise:optionalContentConfigPromise,renderingQueue:_this2.renderingQueue,textLayerFactory:textLayerFactory,textLayerMode:_this2.textLayerMode,annotationLayerFactory:annotationLayerFactory,annotationMode:_this2._annotationMode,xfaLayerFactory:xfaLayerFactory,textHighlighterFactory:_this2,structTreeLayerFactory:_this2,imageResourcesPath:_this2.imageResourcesPath,renderer:_this2.renderer,useOnlyCssZoom:_this2.useOnlyCssZoom,maxCanvasPixels:_this2.maxCanvasPixels,l10n:_this2.l10n});_this2._pages.push(pageView)}var firstPageView=_this2._pages[0];firstPageView&&(firstPageView.setPdfPage(firstPdfPage),_this2.linkService.cachePageRef(1,firstPdfPage.ref)),_this2._spreadMode!==_ui_utils.SpreadMode.NONE&&_this2._updateSpreadMode(),_this2._onePageRenderedOrForceFetch().then((function(){if(_this2.findController&&_this2.findController.setDocument(pdfDocument),_this2._scriptingManager&&_this2._scriptingManager.setDocument(pdfDocument),pdfDocument.loadingParams.disableAutoFetch||pagesCount>7500)_this2._pagesCapability.resolve();else{var getPagesLeft=pagesCount-1;if(getPagesLeft<=0)_this2._pagesCapability.resolve();else for(var _loop=function(_pageNum){pdfDocument.getPage(_pageNum).then((function(pdfPage){var pageView=_this2._pages[_pageNum-1];pageView.pdfPage||pageView.setPdfPage(pdfPage),_this2.linkService.cachePageRef(_pageNum,pdfPage.ref),0==--getPagesLeft&&_this2._pagesCapability.resolve()}),(function(reason){console.error("Unable to get page ".concat(_pageNum," to initialize viewer"),reason),0==--getPagesLeft&&_this2._pagesCapability.resolve()}))},_pageNum=2;_pageNum<=pagesCount;++_pageNum)_loop(_pageNum)}})),_this2.eventBus.dispatch("pagesinit",{source:_this2}),_this2.defaultRenderingQueue&&_this2.update()})).catch((function(reason){console.error("Unable to initialize viewer",reason)}))}}},{key:"setPageLabels",value:function(labels){if(this.pdfDocument){labels?Array.isArray(labels)&&this.pdfDocument.numPages===labels.length?this._pageLabels=labels:(this._pageLabels=null,console.error("setPageLabels: Invalid page labels.")):this._pageLabels=null;for(var i=0,ii=this._pages.length;i<ii;i++){var _this$_pageLabels$i,_this$_pageLabels5;this._pages[i].setPageLabel(null!==(_this$_pageLabels$i=null===(_this$_pageLabels5=this._pageLabels)||void 0===_this$_pageLabels5?void 0:_this$_pageLabels5[i])&&void 0!==_this$_pageLabels$i?_this$_pageLabels$i:null)}}}},{key:"_resetView",value:function(){this._pages=[],this._currentPageNumber=1,this._currentScale=_ui_utils.UNKNOWN_SCALE,this._currentScaleValue=null,this._pageLabels=null,this._buffer=new PDFPageViewBuffer(10),this._location=null,this._pagesRotation=0,this._optionalContentConfigPromise=null,this._pagesRequests=new WeakMap,this._firstPageCapability=(0,_pdfjsLib.createPromiseCapability)(),this._onePageRenderedCapability=(0,_pdfjsLib.createPromiseCapability)(),this._pagesCapability=(0,_pdfjsLib.createPromiseCapability)(),this._scrollMode=_ui_utils.ScrollMode.VERTICAL,this._spreadMode=_ui_utils.SpreadMode.NONE,this._onBeforeDraw&&(this.eventBus._off("pagerender",this._onBeforeDraw),this._onBeforeDraw=null),this._onAfterDraw&&(this.eventBus._off("pagerendered",this._onAfterDraw),this._onAfterDraw=null),this.viewer.textContent="",this._updateScrollMode()}},{key:"_scrollUpdate",value:function(){0!==this.pagesCount&&this.update()}},{key:"_scrollIntoView",value:function(_ref){var pageDiv=_ref.pageDiv,_ref$pageSpot=_ref.pageSpot,pageSpot=void 0===_ref$pageSpot?null:_ref$pageSpot;_ref.pageNumber,(0,_ui_utils.scrollIntoView)(pageDiv,pageSpot)}},{key:"_setScaleUpdatePages",value:function(newScale,newValue){var noScroll=arguments.length>2&&void 0!==arguments[2]&&arguments[2],preset=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(this._currentScaleValue=newValue.toString(),isSameScale(this._currentScale,newScale))preset&&this.eventBus.dispatch("scalechanging",{source:this,scale:newScale,presetValue:newValue});else{this._doc.style.setProperty("--zoom-factor",newScale);var _step2,updateArgs={scale:newScale},_iterator2=_createForOfIteratorHelper(this._pages);try{for(_iterator2.s();!(_step2=_iterator2.n()).done;){var pageView=_step2.value;pageView.update(updateArgs)}}catch(err){_iterator2.e(err)}finally{_iterator2.f()}if(this._currentScale=newScale,!noScroll){var dest,page=this._currentPageNumber;!this._location||this.isInPresentationMode||this.isChangingPresentationMode||(page=this._location.pageNumber,dest=[null,{name:"XYZ"},this._location.left,this._location.top,null]),this.scrollPageIntoView({pageNumber:page,destArray:dest,allowNegativeOffset:!0})}this.eventBus.dispatch("scalechanging",{source:this,scale:newScale,presetValue:preset?newValue:void 0}),this.defaultRenderingQueue&&this.update()}}},{key:"_pageWidthScaleFactor",get:function(){return this._spreadMode===_ui_utils.SpreadMode.NONE||this._scrollMode===_ui_utils.ScrollMode.HORIZONTAL||this.isInPresentationMode?1:2}},{key:"_setScale",value:function(value){var noScroll=arguments.length>1&&void 0!==arguments[1]&&arguments[1],scale=parseFloat(value);if(scale>0)this._setScaleUpdatePages(scale,value,noScroll,!1);else{var currentPage=this._pages[this._currentPageNumber-1];if(!currentPage)return;var noPadding=this.isInPresentationMode||this.removePageBorders,hPadding=noPadding?0:_ui_utils.SCROLLBAR_PADDING,vPadding=noPadding?0:_ui_utils.VERTICAL_PADDING;if(!noPadding&&this._isScrollModeHorizontal){var _ref2=[vPadding,hPadding];hPadding=_ref2[0],vPadding=_ref2[1]}var pageWidthScale=(this.container.clientWidth-hPadding)/currentPage.width*currentPage.scale/this._pageWidthScaleFactor,pageHeightScale=(this.container.clientHeight-vPadding)/currentPage.height*currentPage.scale;switch(value){case"page-actual":scale=1;break;case"page-width":scale=pageWidthScale;break;case"page-height":scale=pageHeightScale;break;case"page-fit":scale=Math.min(pageWidthScale,pageHeightScale);break;case"auto":var horizontalScale=(0,_ui_utils.isPortraitOrientation)(currentPage)?pageWidthScale:Math.min(pageHeightScale,pageWidthScale);scale=Math.min(_ui_utils.MAX_AUTO_SCALE,horizontalScale);break;default:return void console.error('_setScale: "'.concat(value,'" is an unknown zoom value.'))}this._setScaleUpdatePages(scale,value,noScroll,!0)}}},{key:"_resetCurrentPageView",value:function(){this.isInPresentationMode&&this._setScale(this._currentScaleValue,!0);var pageView=this._pages[this._currentPageNumber-1];this._scrollIntoView({pageDiv:pageView.div})}},{key:"pageLabelToPageNumber",value:function(label){if(!this._pageLabels)return null;var i=this._pageLabels.indexOf(label);return i<0?null:i+1}},{key:"scrollPageIntoView",value:function(_ref3){var pageNumber=_ref3.pageNumber,_ref3$destArray=_ref3.destArray,destArray=void 0===_ref3$destArray?null:_ref3$destArray,_ref3$allowNegativeOf=_ref3.allowNegativeOffset,allowNegativeOffset=void 0!==_ref3$allowNegativeOf&&_ref3$allowNegativeOf,_ref3$ignoreDestinati=_ref3.ignoreDestinationZoom,ignoreDestinationZoom=void 0!==_ref3$ignoreDestinati&&_ref3$ignoreDestinati;if(this.pdfDocument){var pageView=Number.isInteger(pageNumber)&&this._pages[pageNumber-1];if(pageView)if(!this.isInPresentationMode&&destArray){var widthScale,heightScale,x=0,y=0,width=0,height=0,changeOrientation=pageView.rotation%180!=0,pageWidth=(changeOrientation?pageView.height:pageView.width)/pageView.scale/_ui_utils.CSS_UNITS,pageHeight=(changeOrientation?pageView.width:pageView.height)/pageView.scale/_ui_utils.CSS_UNITS,scale=0;switch(destArray[1].name){case"XYZ":x=destArray[2],y=destArray[3],scale=destArray[4],x=null!==x?x:0,y=null!==y?y:pageHeight;break;case"Fit":case"FitB":scale="page-fit";break;case"FitH":case"FitBH":scale="page-width",null===(y=destArray[2])&&this._location?(x=this._location.left,y=this._location.top):"number"!=typeof y&&(y=pageHeight);break;case"FitV":case"FitBV":x=destArray[2],width=pageWidth,height=pageHeight,scale="page-height";break;case"FitR":x=destArray[2],y=destArray[3],width=destArray[4]-x,height=destArray[5]-y;var hPadding=this.removePageBorders?0:_ui_utils.SCROLLBAR_PADDING,vPadding=this.removePageBorders?0:_ui_utils.VERTICAL_PADDING;widthScale=(this.container.clientWidth-hPadding)/width/_ui_utils.CSS_UNITS,heightScale=(this.container.clientHeight-vPadding)/height/_ui_utils.CSS_UNITS,scale=Math.min(Math.abs(widthScale),Math.abs(heightScale));break;default:return void console.error('scrollPageIntoView: "'.concat(destArray[1].name,'" is not a valid destination type.'))}if(ignoreDestinationZoom||(scale&&scale!==this._currentScale?this.currentScaleValue=scale:this._currentScale===_ui_utils.UNKNOWN_SCALE&&(this.currentScaleValue=_ui_utils.DEFAULT_SCALE_VALUE)),"page-fit"!==scale||destArray[4]){var boundingRect=[pageView.viewport.convertToViewportPoint(x,y),pageView.viewport.convertToViewportPoint(x+width,y+height)],left=Math.min(boundingRect[0][0],boundingRect[1][0]),top=Math.min(boundingRect[0][1],boundingRect[1][1]);allowNegativeOffset||(left=Math.max(left,0),top=Math.max(top,0)),this._scrollIntoView({pageDiv:pageView.div,pageSpot:{left:left,top:top},pageNumber:pageNumber})}else this._scrollIntoView({pageDiv:pageView.div,pageNumber:pageNumber})}else this._setCurrentPageNumber(pageNumber,!0);else console.error('scrollPageIntoView: "'.concat(pageNumber,'" is not a valid pageNumber parameter.'))}}},{key:"_updateLocation",value:function(firstPage){var currentScale=this._currentScale,currentScaleValue=this._currentScaleValue,normalizedScaleValue=parseFloat(currentScaleValue)===currentScale?Math.round(1e4*currentScale)/100:currentScaleValue,pageNumber=firstPage.id,pdfOpenParams="#page="+pageNumber;pdfOpenParams+="&zoom="+normalizedScaleValue;var currentPageView=this._pages[pageNumber-1],container=this.container,topLeft=currentPageView.getPagePoint(container.scrollLeft-firstPage.x,container.scrollTop-firstPage.y),intLeft=Math.round(topLeft[0]),intTop=Math.round(topLeft[1]);pdfOpenParams+=","+intLeft+","+intTop,this._location={pageNumber:pageNumber,scale:normalizedScaleValue,top:intTop,left:intLeft,rotation:this._pagesRotation,pdfOpenParams:pdfOpenParams}}},{key:"_updateHelper",value:function(visiblePages){throw new Error("Not implemented: _updateHelper")}},{key:"update",value:function(){var visible=this._getVisiblePages(),visiblePages=visible.views,numVisiblePages=visiblePages.length;if(0!==numVisiblePages){var newCacheSize=Math.max(10,2*numVisiblePages+1);this._buffer.resize(newCacheSize,visiblePages),this.renderingQueue.renderHighestPriority(visible),this._updateHelper(visiblePages),this._updateLocation(visible.first),this.eventBus.dispatch("updateviewarea",{source:this,location:this._location})}}},{key:"containsElement",value:function(element){return this.container.contains(element)}},{key:"focus",value:function(){this.container.focus()}},{key:"_isScrollModeHorizontal",get:function(){return!this.isInPresentationMode&&this._scrollMode===_ui_utils.ScrollMode.HORIZONTAL}},{key:"_isContainerRtl",get:function(){return"rtl"===getComputedStyle(this.container).direction}},{key:"isInPresentationMode",get:function(){return this.presentationModeState===_ui_utils.PresentationModeState.FULLSCREEN}},{key:"isChangingPresentationMode",get:function(){return this.presentationModeState===_ui_utils.PresentationModeState.CHANGING}},{key:"isHorizontalScrollbarEnabled",get:function(){return!this.isInPresentationMode&&this.container.scrollWidth>this.container.clientWidth}},{key:"isVerticalScrollbarEnabled",get:function(){return!this.isInPresentationMode&&this.container.scrollHeight>this.container.clientHeight}},{key:"_getCurrentVisiblePage",value:function(){if(!this.pagesCount)return{views:[]};var pageView=this._pages[this._currentPageNumber-1],element=pageView.div,view={id:pageView.id,x:element.offsetLeft+element.clientLeft,y:element.offsetTop+element.clientTop,view:pageView};return{first:view,last:view,views:[view]}}},{key:"_getVisiblePages",value:function(){return(0,_ui_utils.getVisibleElements)({scrollEl:this.container,views:this._pages,sortByVisibility:!0,horizontal:this._isScrollModeHorizontal,rtl:this._isScrollModeHorizontal&&this._isContainerRtl})}},{key:"isPageVisible",value:function(pageNumber){return!!this.pdfDocument&&(Number.isInteger(pageNumber)&&pageNumber>0&&pageNumber<=this.pagesCount?this._getVisiblePages().views.some((function(view){return view.id===pageNumber})):(console.error('isPageVisible: "'.concat(pageNumber,'" is not a valid page.')),!1))}},{key:"isPageCached",value:function(pageNumber){if(!this.pdfDocument||!this._buffer)return!1;if(!(Number.isInteger(pageNumber)&&pageNumber>0&&pageNumber<=this.pagesCount))return console.error('isPageCached: "'.concat(pageNumber,'" is not a valid page.')),!1;var pageView=this._pages[pageNumber-1];return!!pageView&&this._buffer.has(pageView)}},{key:"cleanup",value:function(){for(var i=0,ii=this._pages.length;i<ii;i++)this._pages[i]&&this._pages[i].renderingState!==_pdf_rendering_queue.RenderingStates.FINISHED&&this._pages[i].reset()}},{key:"_cancelRendering",value:function(){for(var i=0,ii=this._pages.length;i<ii;i++)this._pages[i]&&this._pages[i].cancelRendering()}},{key:"_ensurePdfPageLoaded",value:function(pageView){var _this3=this;if(pageView.pdfPage)return Promise.resolve(pageView.pdfPage);if(this._pagesRequests.has(pageView))return this._pagesRequests.get(pageView);var promise=this.pdfDocument.getPage(pageView.id).then((function(pdfPage){return pageView.pdfPage||pageView.setPdfPage(pdfPage),_this3._pagesRequests.delete(pageView),pdfPage})).catch((function(reason){console.error("Unable to get page for page view",reason),_this3._pagesRequests.delete(pageView)}));return this._pagesRequests.set(pageView,promise),promise}},{key:"forceRendering",value:function(currentlyVisiblePages){var _this4=this,visiblePages=currentlyVisiblePages||this._getVisiblePages(),scrollAhead=this._isScrollModeHorizontal?this.scroll.right:this.scroll.down,pageView=this.renderingQueue.getHighestPriority(visiblePages,this._pages,scrollAhead);return!!pageView&&(this._ensurePdfPageLoaded(pageView).then((function(){_this4.renderingQueue.renderView(pageView)})),!0)}},{key:"createTextLayerBuilder",value:function(textLayerDiv,pageIndex,viewport){var enhanceTextSelection=arguments.length>3&&void 0!==arguments[3]&&arguments[3],eventBus=arguments.length>4?arguments[4]:void 0,highlighter=arguments.length>5?arguments[5]:void 0;return new _text_layer_builder.TextLayerBuilder({textLayerDiv:textLayerDiv,eventBus:eventBus,pageIndex:pageIndex,viewport:viewport,enhanceTextSelection:!this.isInPresentationMode&&enhanceTextSelection,highlighter:highlighter})}},{key:"createTextHighlighter",value:function(pageIndex,eventBus){return new _text_highlighter.TextHighlighter({eventBus:eventBus,pageIndex:pageIndex,findController:this.isInPresentationMode?null:this.findController})}},{key:"createAnnotationLayerBuilder",value:function(pageDiv,pdfPage){var _this$pdfDocument,_this$pdfDocument2,_this$_scriptingManag,annotationStorage=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,imageResourcesPath=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"",renderForms=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],l10n=arguments.length>5&&void 0!==arguments[5]?arguments[5]:_l10n_utils.NullL10n,enableScripting=arguments.length>6&&void 0!==arguments[6]?arguments[6]:null,hasJSActionsPromise=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,mouseState=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null;return new _annotation_layer_builder.AnnotationLayerBuilder({pageDiv:pageDiv,pdfPage:pdfPage,annotationStorage:annotationStorage||(null===(_this$pdfDocument=this.pdfDocument)||void 0===_this$pdfDocument?void 0:_this$pdfDocument.annotationStorage),imageResourcesPath:imageResourcesPath,renderForms:renderForms,linkService:this.linkService,downloadManager:this.downloadManager,l10n:l10n,enableScripting:null!=enableScripting?enableScripting:this.enableScripting,hasJSActionsPromise:hasJSActionsPromise||(null===(_this$pdfDocument2=this.pdfDocument)||void 0===_this$pdfDocument2?void 0:_this$pdfDocument2.hasJSActions()),mouseState:mouseState||(null===(_this$_scriptingManag=this._scriptingManager)||void 0===_this$_scriptingManag?void 0:_this$_scriptingManag.mouseState)})}},{key:"createXfaLayerBuilder",value:function(pageDiv,pdfPage){var _this$pdfDocument3,annotationStorage=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null;return new _xfa_layer_builder.XfaLayerBuilder({pageDiv:pageDiv,pdfPage:pdfPage,annotationStorage:annotationStorage||(null===(_this$pdfDocument3=this.pdfDocument)||void 0===_this$pdfDocument3?void 0:_this$pdfDocument3.annotationStorage)})}},{key:"createStructTreeLayerBuilder",value:function(pdfPage){return new _struct_tree_layer_builder.StructTreeLayerBuilder({pdfPage:pdfPage})}},{key:"hasEqualPageSizes",get:function(){for(var firstPageView=this._pages[0],i=1,ii=this._pages.length;i<ii;++i){var pageView=this._pages[i];if(pageView.width!==firstPageView.width||pageView.height!==firstPageView.height)return!1}return!0}},{key:"getPagesOverview",value:function(){var _this5=this;return this._pages.map((function(pageView){var viewport=pageView.pdfPage.getViewport({scale:1});return!_this5.enablePrintAutoRotate||(0,_ui_utils.isPortraitOrientation)(viewport)?{width:viewport.width,height:viewport.height,rotation:viewport.rotation}:{width:viewport.height,height:viewport.width,rotation:(viewport.rotation-90)%360}}))}},{key:"optionalContentConfigPromise",get:function(){return this.pdfDocument?this._optionalContentConfigPromise?this._optionalContentConfigPromise:this.pdfDocument.getOptionalContentConfig():Promise.resolve(null)},set:function(promise){if(!(promise instanceof Promise))throw new Error("Invalid optionalContentConfigPromise: ".concat(promise));if(this.pdfDocument&&this._optionalContentConfigPromise){this._optionalContentConfigPromise=promise;var _step3,updateArgs={optionalContentConfigPromise:promise},_iterator3=_createForOfIteratorHelper(this._pages);try{for(_iterator3.s();!(_step3=_iterator3.n()).done;)_step3.value.update(updateArgs)}catch(err){_iterator3.e(err)}finally{_iterator3.f()}this.update(),this.eventBus.dispatch("optionalcontentconfigchanged",{source:this,promise:promise})}}},{key:"scrollMode",get:function(){return this._scrollMode},set:function(mode){if(this._scrollMode!==mode){if(!(0,_ui_utils.isValidScrollMode)(mode))throw new Error("Invalid scroll mode: ".concat(mode));this._scrollMode=mode,this.eventBus.dispatch("scrollmodechanged",{source:this,mode:mode}),this._updateScrollMode(this._currentPageNumber)}}},{key:"_updateScrollMode",value:function(){var pageNumber=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null,scrollMode=this._scrollMode,viewer=this.viewer;viewer.classList.toggle("scrollHorizontal",scrollMode===_ui_utils.ScrollMode.HORIZONTAL),viewer.classList.toggle("scrollWrapped",scrollMode===_ui_utils.ScrollMode.WRAPPED),this.pdfDocument&&pageNumber&&(this._currentScaleValue&&isNaN(this._currentScaleValue)&&this._setScale(this._currentScaleValue,!0),this._setCurrentPageNumber(pageNumber,!0),this.update())}},{key:"spreadMode",get:function(){return this._spreadMode},set:function(mode){if(this._spreadMode!==mode){if(!(0,_ui_utils.isValidSpreadMode)(mode))throw new Error("Invalid spread mode: ".concat(mode));this._spreadMode=mode,this.eventBus.dispatch("spreadmodechanged",{source:this,mode:mode}),this._updateSpreadMode(this._currentPageNumber)}}},{key:"_updateSpreadMode",value:function(){var pageNumber=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;if(this.pdfDocument){var viewer=this.viewer,pages=this._pages;if(viewer.textContent="",this._spreadMode===_ui_utils.SpreadMode.NONE)for(var i=0,iMax=pages.length;i<iMax;++i)viewer.appendChild(pages[i].div);else for(var parity=this._spreadMode-1,spread=null,_i=0,_iMax=pages.length;_i<_iMax;++_i)null===spread?((spread=document.createElement("div")).className="spread",viewer.appendChild(spread)):_i%2===parity&&(spread=spread.cloneNode(!1),viewer.appendChild(spread)),spread.appendChild(pages[_i].div);pageNumber&&(this._currentScaleValue&&isNaN(this._currentScaleValue)&&this._setScale(this._currentScaleValue,!0),this._setCurrentPageNumber(pageNumber,!0),this.update())}}},{key:"_getPageAdvance",value:function(currentPageNumber){var previous=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(this.isInPresentationMode)return 1;switch(this._scrollMode){case _ui_utils.ScrollMode.WRAPPED:var _step4,_this$_getVisiblePage=this._getVisiblePages(),views=_this$_getVisiblePage.views,pageLayout=new Map,_iterator4=_createForOfIteratorHelper(views);try{for(_iterator4.s();!(_step4=_iterator4.n()).done;){var _step4$value=_step4.value,id=_step4$value.id,y=_step4$value.y,percent=_step4$value.percent,widthPercent=_step4$value.widthPercent;if(!(0===percent||widthPercent<100)){var yArray=pageLayout.get(y);yArray||pageLayout.set(y,yArray||(yArray=[])),yArray.push(id)}}}catch(err){_iterator4.e(err)}finally{_iterator4.f()}var _step5,_iterator5=_createForOfIteratorHelper(pageLayout.values());try{for(_iterator5.s();!(_step5=_iterator5.n()).done;){var _yArray=_step5.value,currentIndex=_yArray.indexOf(currentPageNumber);if(-1!==currentIndex){var numPages=_yArray.length;if(1===numPages)break;if(previous)for(var i=currentIndex-1,ii=0;i>=ii;i--){var currentId=_yArray[i],expectedId=_yArray[i+1]-1;if(currentId<expectedId)return currentPageNumber-expectedId}else for(var _i2=currentIndex+1,_ii=numPages;_i2<_ii;_i2++){var _currentId=_yArray[_i2],_expectedId=_yArray[_i2-1]+1;if(_currentId>_expectedId)return _expectedId-currentPageNumber}if(previous){var firstId=_yArray[0];if(firstId<currentPageNumber)return currentPageNumber-firstId+1}else{var lastId=_yArray[numPages-1];if(lastId>currentPageNumber)return lastId-currentPageNumber+1}break}}}catch(err){_iterator5.e(err)}finally{_iterator5.f()}break;case _ui_utils.ScrollMode.HORIZONTAL:break;case _ui_utils.ScrollMode.VERTICAL:if(this._spreadMode===_ui_utils.SpreadMode.NONE)break;var parity=this._spreadMode-1;if(previous&&currentPageNumber%2!==parity)break;if(!previous&&currentPageNumber%2===parity)break;var _step6,_this$_getVisiblePage2=this._getVisiblePages(),_views=_this$_getVisiblePage2.views,_expectedId2=previous?currentPageNumber-1:currentPageNumber+1,_iterator6=_createForOfIteratorHelper(_views);try{for(_iterator6.s();!(_step6=_iterator6.n()).done;){var _step6$value=_step6.value,_id=_step6$value.id,_percent=_step6$value.percent,_widthPercent=_step6$value.widthPercent;if(_id===_expectedId2){if(_percent>0&&100===_widthPercent)return 2;break}}}catch(err){_iterator6.e(err)}finally{_iterator6.f()}}return 1}},{key:"nextPage",value:function(){var currentPageNumber=this._currentPageNumber,pagesCount=this.pagesCount;if(currentPageNumber>=pagesCount)return!1;var advance=this._getPageAdvance(currentPageNumber,!1)||1;return this.currentPageNumber=Math.min(currentPageNumber+advance,pagesCount),!0}},{key:"previousPage",value:function(){var currentPageNumber=this._currentPageNumber;if(currentPageNumber<=1)return!1;var advance=this._getPageAdvance(currentPageNumber,!0)||1;return this.currentPageNumber=Math.max(currentPageNumber-advance,1),!0}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),BaseViewer}();exports.BaseViewer=BaseViewer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.DefaultAnnotationLayerFactory=exports.AnnotationLayerBuilder=void 0;var _pdfjsLib=__webpack_require__(6),_l10n_utils=__webpack_require__(31),_pdf_link_service=__webpack_require__(20);function _slicedToArray(arr,i){return function(arr){if(Array.isArray(arr))return arr}(arr)||function(arr,i){var _i=null==arr?null:"undefined"!=typeof Symbol&&arr[Symbol.iterator]||arr["@@iterator"];if(null==_i)return;var _s,_e,_arr=[],_n=!0,_d=!1;try{for(_i=_i.call(arr);!(_n=(_s=_i.next()).done)&&(_arr.push(_s.value),!i||_arr.length!==i);_n=!0);}catch(err){_d=!0,_e=err}finally{try{_n||null==_i.return||_i.return()}finally{if(_d)throw _e}}return _arr}(arr,i)||function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(arr,i)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _createClass(Constructor,protoProps,staticProps){return protoProps&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),Constructor}var AnnotationLayerBuilder=function(){function AnnotationLayerBuilder(_ref){var pageDiv=_ref.pageDiv,pdfPage=_ref.pdfPage,linkService=_ref.linkService,downloadManager=_ref.downloadManager,_ref$annotationStorag=_ref.annotationStorage,annotationStorage=void 0===_ref$annotationStorag?null:_ref$annotationStorag,_ref$imageResourcesPa=_ref.imageResourcesPath,imageResourcesPath=void 0===_ref$imageResourcesPa?"":_ref$imageResourcesPa,_ref$renderForms=_ref.renderForms,renderForms=void 0===_ref$renderForms||_ref$renderForms,_ref$l10n=_ref.l10n,l10n=void 0===_ref$l10n?_l10n_utils.NullL10n:_ref$l10n,_ref$enableScripting=_ref.enableScripting,enableScripting=void 0!==_ref$enableScripting&&_ref$enableScripting,_ref$hasJSActionsProm=_ref.hasJSActionsPromise,hasJSActionsPromise=void 0===_ref$hasJSActionsProm?null:_ref$hasJSActionsProm,_ref$mouseState=_ref.mouseState,mouseState=void 0===_ref$mouseState?null:_ref$mouseState;_classCallCheck(this,AnnotationLayerBuilder),this.pageDiv=pageDiv,this.pdfPage=pdfPage,this.linkService=linkService,this.downloadManager=downloadManager,this.imageResourcesPath=imageResourcesPath,this.renderForms=renderForms,this.l10n=l10n,this.annotationStorage=annotationStorage,this.enableScripting=enableScripting,this._hasJSActionsPromise=hasJSActionsPromise,this._mouseState=mouseState,this.div=null,this._cancelled=!1}return _createClass(AnnotationLayerBuilder,[{key:"render",value:function(viewport){var _this=this,intent=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"display";return Promise.all([this.pdfPage.getAnnotations({intent:intent}),this._hasJSActionsPromise]).then((function(_ref2){var _ref3=_slicedToArray(_ref2,2),annotations=_ref3[0],_ref3$=_ref3[1],hasJSActions=void 0!==_ref3$&&_ref3$;if(!_this._cancelled&&0!==annotations.length){var parameters={viewport:viewport.clone({dontFlip:!0}),div:_this.div,annotations:annotations,page:_this.pdfPage,imageResourcesPath:_this.imageResourcesPath,renderForms:_this.renderForms,linkService:_this.linkService,downloadManager:_this.downloadManager,annotationStorage:_this.annotationStorage,enableScripting:_this.enableScripting,hasJSActions:hasJSActions,mouseState:_this._mouseState};_this.div?_pdfjsLib.AnnotationLayer.update(parameters):(_this.div=document.createElement("div"),_this.div.className="annotationLayer",_this.pageDiv.appendChild(_this.div),parameters.div=_this.div,_pdfjsLib.AnnotationLayer.render(parameters),_this.l10n.translate(_this.div))}}))}},{key:"cancel",value:function(){this._cancelled=!0}},{key:"hide",value:function(){this.div&&(this.div.hidden=!0)}}]),AnnotationLayerBuilder}();exports.AnnotationLayerBuilder=AnnotationLayerBuilder;var DefaultAnnotationLayerFactory=function(){function DefaultAnnotationLayerFactory(){_classCallCheck(this,DefaultAnnotationLayerFactory)}return _createClass(DefaultAnnotationLayerFactory,[{key:"createAnnotationLayerBuilder",value:function(pageDiv,pdfPage){var annotationStorage=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,imageResourcesPath=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"",renderForms=!(arguments.length>4&&void 0!==arguments[4])||arguments[4],l10n=arguments.length>5&&void 0!==arguments[5]?arguments[5]:_l10n_utils.NullL10n,enableScripting=arguments.length>6&&void 0!==arguments[6]&&arguments[6],hasJSActionsPromise=arguments.length>7&&void 0!==arguments[7]?arguments[7]:null,mouseState=arguments.length>8&&void 0!==arguments[8]?arguments[8]:null;return new AnnotationLayerBuilder({pageDiv:pageDiv,pdfPage:pdfPage,imageResourcesPath:imageResourcesPath,renderForms:renderForms,linkService:new _pdf_link_service.SimpleLinkService,l10n:l10n,annotationStorage:annotationStorage,enableScripting:enableScripting,hasJSActionsPromise:hasJSActionsPromise,mouseState:mouseState})}}]),DefaultAnnotationLayerFactory}();exports.DefaultAnnotationLayerFactory=DefaultAnnotationLayerFactory},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.fixupLangCode=function(langCode){return PARTIAL_LANG_CODES[null==langCode?void 0:langCode.toLowerCase()]||langCode},exports.getL10nFallback=getL10nFallback,exports.NullL10n=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj};function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}var DEFAULT_L10N_STRINGS={of_pages:"of {{pagesCount}}",page_of_pages:"({{pageNumber}} of {{pagesCount}})",document_properties_kb:"{{size_kb}} KB ({{size_b}} bytes)",document_properties_mb:"{{size_mb}} MB ({{size_b}} bytes)",document_properties_date_string:"{{date}}, {{time}}",document_properties_page_size_unit_inches:"in",document_properties_page_size_unit_millimeters:"mm",document_properties_page_size_orientation_portrait:"portrait",document_properties_page_size_orientation_landscape:"landscape",document_properties_page_size_name_a3:"A3",document_properties_page_size_name_a4:"A4",document_properties_page_size_name_letter:"Letter",document_properties_page_size_name_legal:"Legal",document_properties_page_size_dimension_string:"{{width}} × {{height}} {{unit}} ({{orientation}})",document_properties_page_size_dimension_name_string:"{{width}} × {{height}} {{unit}} ({{name}}, {{orientation}})",document_properties_linearized_yes:"Yes",document_properties_linearized_no:"No",print_progress_percent:"{{progress}}%","toggle_sidebar.title":"Toggle Sidebar","toggle_sidebar_notification2.title":"Toggle Sidebar (document contains outline/attachments/layers)",additional_layers:"Additional Layers",page_landmark:"Page {{page}}",thumb_page_title:"Page {{page}}",thumb_page_canvas:"Thumbnail of Page {{page}}",find_reached_top:"Reached top of document, continued from bottom",find_reached_bottom:"Reached end of document, continued from top","find_match_count[one]":"{{current}} of {{total}} match","find_match_count[other]":"{{current}} of {{total}} matches","find_match_count_limit[one]":"More than {{limit}} match","find_match_count_limit[other]":"More than {{limit}} matches",find_not_found:"Phrase not found",error_version_info:"PDF.js v{{version}} (build: {{build}})",error_message:"Message: {{message}}",error_stack:"Stack: {{stack}}",error_file:"File: {{file}}",error_line:"Line: {{line}}",rendering_error:"An error occurred while rendering the page.",page_scale_width:"Page Width",page_scale_fit:"Page Fit",page_scale_auto:"Automatic Zoom",page_scale_actual:"Actual Size",page_scale_percent:"{{scale}}%",loading:"Loading…",loading_error:"An error occurred while loading the PDF.",invalid_file_error:"Invalid or corrupted PDF file.",missing_file_error:"Missing PDF file.",unexpected_response_error:"Unexpected server response.",printing_not_supported:"Warning: Printing is not fully supported by this browser.",printing_not_ready:"Warning: The PDF is not fully loaded for printing.",web_fonts_disabled:"Web fonts are disabled: unable to use embedded PDF fonts."};function getL10nFallback(key,args){switch(key){case"find_match_count":key="find_match_count[".concat(1===args.total?"one":"other","]");break;case"find_match_count_limit":key="find_match_count_limit[".concat(1===args.limit?"one":"other","]")}return DEFAULT_L10N_STRINGS[key]||""}var PARTIAL_LANG_CODES={en:"en-US",es:"es-ES",fy:"fy-NL",ga:"ga-IE",gu:"gu-IN",hi:"hi-IN",hy:"hy-AM",nb:"nb-NO",ne:"ne-NP",nn:"nn-NO",pa:"pa-IN",pt:"pt-PT",sv:"sv-SE",zh:"zh-CN"};function formatL10nValue(text,args){return args?text.replace(/\{\{\s*(\w+)\s*\}\}/g,(function(all,name){return name in args?args[name]:"{{"+name+"}}"})):text}var NullL10n={getLanguage:function(){return _asyncToGenerator(_regenerator.default.mark((function _callee(){return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:return _context.abrupt("return","en-us");case 1:case"end":return _context.stop()}}),_callee)})))()},getDirection:function(){return _asyncToGenerator(_regenerator.default.mark((function _callee2(){return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:return _context2.abrupt("return","ltr");case 1:case"end":return _context2.stop()}}),_callee2)})))()},get:function(key){var _arguments=arguments;return _asyncToGenerator(_regenerator.default.mark((function _callee3(){var args,fallback;return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:return args=_arguments.length>1&&void 0!==_arguments[1]?_arguments[1]:null,fallback=_arguments.length>2&&void 0!==_arguments[2]?_arguments[2]:getL10nFallback(key,args),_context3.abrupt("return",formatL10nValue(fallback,args));case 3:case"end":return _context3.stop()}}),_callee3)})))()},translate:function(element){return _asyncToGenerator(_regenerator.default.mark((function _callee4(){return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:case"end":return _context4.stop()}}),_callee4)})))()}};exports.NullL10n=NullL10n},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFPageView=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_pdfjsLib=__webpack_require__(6),_ui_utils=__webpack_require__(5),_app_options=__webpack_require__(1),_l10n_utils=__webpack_require__(31),_pdf_rendering_queue=__webpack_require__(9);function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var MAX_CANVAS_PIXELS=_app_options.compatibilityParams.maxCanvasPixels||16777216,PDFPageView=function(){function PDFPageView(options){var _options$textLayerMod,_options$annotationMo,_options$textHighligh,_this$renderingQueue;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFPageView);var container=options.container,defaultViewport=options.defaultViewport;this.id=options.id,this.renderingId="page"+this.id,this.pdfPage=null,this.pageLabel=null,this.rotation=0,this.scale=options.scale||_ui_utils.DEFAULT_SCALE,this.viewport=defaultViewport,this.pdfPageRotate=defaultViewport.rotation,this._optionalContentConfigPromise=options.optionalContentConfigPromise||null,this.hasRestrictedScaling=!1,this.textLayerMode=null!==(_options$textLayerMod=options.textLayerMode)&&void 0!==_options$textLayerMod?_options$textLayerMod:_ui_utils.TextLayerMode.ENABLE,this._annotationMode=null!==(_options$annotationMo=options.annotationMode)&&void 0!==_options$annotationMo?_options$annotationMo:_pdfjsLib.AnnotationMode.ENABLE_FORMS,this.imageResourcesPath=options.imageResourcesPath||"",this.useOnlyCssZoom=options.useOnlyCssZoom||!1,this.maxCanvasPixels=options.maxCanvasPixels||MAX_CANVAS_PIXELS,this.eventBus=options.eventBus,this.renderingQueue=options.renderingQueue,this.textLayerFactory=options.textLayerFactory,this.annotationLayerFactory=options.annotationLayerFactory,this.xfaLayerFactory=options.xfaLayerFactory,this.textHighlighter=null===(_options$textHighligh=options.textHighlighterFactory)||void 0===_options$textHighligh?void 0:_options$textHighligh.createTextHighlighter(this.id-1,this.eventBus),this.structTreeLayerFactory=options.structTreeLayerFactory,this.renderer=options.renderer||_ui_utils.RendererType.CANVAS,this.l10n=options.l10n||_l10n_utils.NullL10n,this.paintTask=null,this.paintedViewportMap=new WeakMap,this.renderingState=_pdf_rendering_queue.RenderingStates.INITIAL,this.resume=null,this._renderError=null,this._isStandalone=!(null!==(_this$renderingQueue=this.renderingQueue)&&void 0!==_this$renderingQueue&&_this$renderingQueue.hasViewer()),this.annotationLayer=null,this.textLayer=null,this.zoomLayer=null,this.xfaLayer=null,this.structTreeLayer=null;var div=document.createElement("div");div.className="page",div.style.width=Math.floor(this.viewport.width)+"px",div.style.height=Math.floor(this.viewport.height)+"px",div.setAttribute("data-page-number",this.id),div.setAttribute("role","region"),this.l10n.get("page_landmark",{page:this.id}).then((function(msg){div.setAttribute("aria-label",msg)})),this.div=div,container.appendChild(div)}var Constructor,protoProps,staticProps,_buildXfaTextContentItems2,_renderXfaLayer2,_renderAnnotationLayer2;return Constructor=PDFPageView,(protoProps=[{key:"setPdfPage",value:function(pdfPage){this.pdfPage=pdfPage,this.pdfPageRotate=pdfPage.rotate;var totalRotation=(this.rotation+this.pdfPageRotate)%360;this.viewport=pdfPage.getViewport({scale:this.scale*_ui_utils.CSS_UNITS,rotation:totalRotation}),this.reset()}},{key:"destroy",value:function(){this.reset(),this.pdfPage&&this.pdfPage.cleanup()}},{key:"_renderAnnotationLayer",value:(_renderAnnotationLayer2=_asyncToGenerator(_regenerator.default.mark((function _callee(){var error;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:return error=null,_context.prev=1,_context.next=4,this.annotationLayer.render(this.viewport,"display");case 4:_context.next=9;break;case 6:_context.prev=6,_context.t0=_context.catch(1),error=_context.t0;case 9:return _context.prev=9,this.eventBus.dispatch("annotationlayerrendered",{source:this,pageNumber:this.id,error:error}),_context.finish(9);case 12:case"end":return _context.stop()}}),_callee,this,[[1,6,9,12]])}))),function(){return _renderAnnotationLayer2.apply(this,arguments)})},{key:"_renderXfaLayer",value:(_renderXfaLayer2=_asyncToGenerator(_regenerator.default.mark((function _callee2(){var error,result;return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:return error=null,_context2.prev=1,_context2.next=4,this.xfaLayer.render(this.viewport,"display");case 4:result=_context2.sent,this.textHighlighter&&this._buildXfaTextContentItems(result.textDivs),_context2.next=11;break;case 8:_context2.prev=8,_context2.t0=_context2.catch(1),error=_context2.t0;case 11:return _context2.prev=11,this.eventBus.dispatch("xfalayerrendered",{source:this,pageNumber:this.id,error:error}),_context2.finish(11);case 14:case"end":return _context2.stop()}}),_callee2,this,[[1,8,11,14]])}))),function(){return _renderXfaLayer2.apply(this,arguments)})},{key:"_buildXfaTextContentItems",value:(_buildXfaTextContentItems2=_asyncToGenerator(_regenerator.default.mark((function _callee3(textDivs){var text,items,_iterator,_step,item;return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:return _context3.next=2,this.pdfPage.getTextContent();case 2:text=_context3.sent,items=[],_iterator=_createForOfIteratorHelper(text.items);try{for(_iterator.s();!(_step=_iterator.n()).done;)item=_step.value,items.push(item.str)}catch(err){_iterator.e(err)}finally{_iterator.f()}this.textHighlighter.setTextMapping(textDivs,items),this.textHighlighter.enable();case 8:case"end":return _context3.stop()}}),_callee3,this)}))),function(_x){return _buildXfaTextContentItems2.apply(this,arguments)})},{key:"_resetZoomLayer",value:function(){var removeFromDOM=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this.zoomLayer){var zoomLayerCanvas=this.zoomLayer.firstChild;this.paintedViewportMap.delete(zoomLayerCanvas),zoomLayerCanvas.width=0,zoomLayerCanvas.height=0,removeFromDOM&&this.zoomLayer.remove(),this.zoomLayer=null}}},{key:"reset",value:function(){var _this$annotationLayer,_this$xfaLayer,_this=this,_ref=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},_ref$keepZoomLayer=_ref.keepZoomLayer,keepZoomLayer=void 0!==_ref$keepZoomLayer&&_ref$keepZoomLayer,_ref$keepAnnotationLa=_ref.keepAnnotationLayer,keepAnnotationLayer=void 0!==_ref$keepAnnotationLa&&_ref$keepAnnotationLa,_ref$keepXfaLayer=_ref.keepXfaLayer,keepXfaLayer=void 0!==_ref$keepXfaLayer&&_ref$keepXfaLayer;this.cancelRendering({keepAnnotationLayer:keepAnnotationLayer,keepXfaLayer:keepXfaLayer}),this.renderingState=_pdf_rendering_queue.RenderingStates.INITIAL;var div=this.div;div.style.width=Math.floor(this.viewport.width)+"px",div.style.height=Math.floor(this.viewport.height)+"px";for(var childNodes=div.childNodes,zoomLayerNode=keepZoomLayer&&this.zoomLayer||null,annotationLayerNode=keepAnnotationLayer&&(null===(_this$annotationLayer=this.annotationLayer)||void 0===_this$annotationLayer?void 0:_this$annotationLayer.div)||null,xfaLayerNode=keepXfaLayer&&(null===(_this$xfaLayer=this.xfaLayer)||void 0===_this$xfaLayer?void 0:_this$xfaLayer.div)||null,i=childNodes.length-1;i>=0;i--){var node=childNodes[i];switch(node){case zoomLayerNode:case annotationLayerNode:case xfaLayerNode:continue}div.removeChild(node)}div.removeAttribute("data-loaded"),annotationLayerNode&&this.annotationLayer.hide(),xfaLayerNode&&this.xfaLayer.hide(),zoomLayerNode||(this.canvas&&(this.paintedViewportMap.delete(this.canvas),this.canvas.width=0,this.canvas.height=0,delete this.canvas),this._resetZoomLayer()),this.svg&&(this.paintedViewportMap.delete(this.svg),delete this.svg),this.loadingIconDiv=document.createElement("div"),this.loadingIconDiv.className="loadingIcon",this.loadingIconDiv.setAttribute("role","img"),this.l10n.get("loading").then((function(msg){var _this$loadingIconDiv;null===(_this$loadingIconDiv=_this.loadingIconDiv)||void 0===_this$loadingIconDiv||_this$loadingIconDiv.setAttribute("aria-label",msg)})),div.appendChild(this.loadingIconDiv)}},{key:"update",value:function(_ref2){var _ref2$scale=_ref2.scale,scale=void 0===_ref2$scale?0:_ref2$scale,_ref2$rotation=_ref2.rotation,rotation=void 0===_ref2$rotation?null:_ref2$rotation,_ref2$optionalContent=_ref2.optionalContentConfigPromise,optionalContentConfigPromise=void 0===_ref2$optionalContent?null:_ref2$optionalContent;if("object"!==_typeof(arguments[0]))return console.error("PDFPageView.update called with separate parameters, please use an object instead."),void this.update({scale:arguments[0],rotation:arguments[1],optionalContentConfigPromise:arguments[2]});if(this.scale=scale||this.scale,"number"==typeof rotation&&(this.rotation=rotation),optionalContentConfigPromise instanceof Promise&&(this._optionalContentConfigPromise=optionalContentConfigPromise),this._isStandalone){var doc=document.documentElement;doc.style.setProperty("--zoom-factor",this.scale)}var totalRotation=(this.rotation+this.pdfPageRotate)%360;if(this.viewport=this.viewport.clone({scale:this.scale*_ui_utils.CSS_UNITS,rotation:totalRotation}),this.svg)return this.cssTransform({target:this.svg,redrawAnnotationLayer:!0,redrawXfaLayer:!0}),void this.eventBus.dispatch("pagerendered",{source:this,pageNumber:this.id,cssTransform:!0,timestamp:performance.now(),error:this._renderError});var isScalingRestricted=!1;if(this.canvas&&this.maxCanvasPixels>0){var outputScale=this.outputScale;(Math.floor(this.viewport.width)*outputScale.sx|0)*(Math.floor(this.viewport.height)*outputScale.sy|0)>this.maxCanvasPixels&&(isScalingRestricted=!0)}if(this.canvas){if(this.useOnlyCssZoom||this.hasRestrictedScaling&&isScalingRestricted)return this.cssTransform({target:this.canvas,redrawAnnotationLayer:!0,redrawXfaLayer:!0}),void this.eventBus.dispatch("pagerendered",{source:this,pageNumber:this.id,cssTransform:!0,timestamp:performance.now(),error:this._renderError});this.zoomLayer||this.canvas.hidden||(this.zoomLayer=this.canvas.parentNode,this.zoomLayer.style.position="absolute")}this.zoomLayer&&this.cssTransform({target:this.zoomLayer.firstChild}),this.reset({keepZoomLayer:!0,keepAnnotationLayer:!0,keepXfaLayer:!0})}},{key:"cancelRendering",value:function(){var _this$textHighlighter,_ref3=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},_ref3$keepAnnotationL=_ref3.keepAnnotationLayer,keepAnnotationLayer=void 0!==_ref3$keepAnnotationL&&_ref3$keepAnnotationL,_ref3$keepXfaLayer=_ref3.keepXfaLayer,keepXfaLayer=void 0!==_ref3$keepXfaLayer&&_ref3$keepXfaLayer;this.paintTask&&(this.paintTask.cancel(),this.paintTask=null),this.resume=null,this.textLayer&&(this.textLayer.cancel(),this.textLayer=null),!this.annotationLayer||keepAnnotationLayer&&this.annotationLayer.div||(this.annotationLayer.cancel(),this.annotationLayer=null),!this.xfaLayer||keepXfaLayer&&this.xfaLayer.div||(this.xfaLayer.cancel(),this.xfaLayer=null,null===(_this$textHighlighter=this.textHighlighter)||void 0===_this$textHighlighter||_this$textHighlighter.disable()),this._onTextLayerRendered&&(this.eventBus._off("textlayerrendered",this._onTextLayerRendered),this._onTextLayerRendered=null)}},{key:"cssTransform",value:function(_ref4){var target=_ref4.target,_ref4$redrawAnnotatio=_ref4.redrawAnnotationLayer,redrawAnnotationLayer=void 0!==_ref4$redrawAnnotatio&&_ref4$redrawAnnotatio,_ref4$redrawXfaLayer=_ref4.redrawXfaLayer,redrawXfaLayer=void 0!==_ref4$redrawXfaLayer&&_ref4$redrawXfaLayer,width=this.viewport.width,height=this.viewport.height,div=this.div;target.style.width=target.parentNode.style.width=div.style.width=Math.floor(width)+"px",target.style.height=target.parentNode.style.height=div.style.height=Math.floor(height)+"px";var relativeRotation=this.viewport.rotation-this.paintedViewportMap.get(target).rotation,absRotation=Math.abs(relativeRotation),scaleX=1,scaleY=1;if(90!==absRotation&&270!==absRotation||(scaleX=height/width,scaleY=width/height),target.style.transform="rotate(".concat(relativeRotation,"deg) scale(").concat(scaleX,", ").concat(scaleY,")"),this.textLayer){var textLayerViewport=this.textLayer.viewport,textRelativeRotation=this.viewport.rotation-textLayerViewport.rotation,textAbsRotation=Math.abs(textRelativeRotation),scale=width/textLayerViewport.width;90!==textAbsRotation&&270!==textAbsRotation||(scale=width/textLayerViewport.height);var transX,transY,textLayerDiv=this.textLayer.textLayerDiv;switch(textAbsRotation){case 0:transX=transY=0;break;case 90:transX=0,transY="-"+textLayerDiv.style.height;break;case 180:transX="-"+textLayerDiv.style.width,transY="-"+textLayerDiv.style.height;break;case 270:transX="-"+textLayerDiv.style.width,transY=0;break;default:console.error("Bad rotation value.")}textLayerDiv.style.transform="rotate(".concat(textAbsRotation,"deg) ")+"scale(".concat(scale,") ")+"translate(".concat(transX,", ").concat(transY,")"),textLayerDiv.style.transformOrigin="0% 0%"}redrawAnnotationLayer&&this.annotationLayer&&this._renderAnnotationLayer(),redrawXfaLayer&&this.xfaLayer&&this._renderXfaLayer()}},{key:"width",get:function(){return this.viewport.width}},{key:"height",get:function(){return this.viewport.height}},{key:"getPagePoint",value:function(x,y){return this.viewport.convertToPdfPoint(x,y)}},{key:"draw",value:function(){var _this$annotationLayer2,_this$xfaLayer2,_this2=this;this.renderingState!==_pdf_rendering_queue.RenderingStates.INITIAL&&(console.error("Must be in new state before drawing"),this.reset());var div=this.div,pdfPage=this.pdfPage;if(!pdfPage)return this.renderingState=_pdf_rendering_queue.RenderingStates.FINISHED,this.loadingIconDiv&&(div.removeChild(this.loadingIconDiv),delete this.loadingIconDiv),Promise.reject(new Error("pdfPage is not loaded"));this.renderingState=_pdf_rendering_queue.RenderingStates.RUNNING;var canvasWrapper=document.createElement("div");canvasWrapper.style.width=div.style.width,canvasWrapper.style.height=div.style.height,canvasWrapper.classList.add("canvasWrapper"),null!==(_this$annotationLayer2=this.annotationLayer)&&void 0!==_this$annotationLayer2&&_this$annotationLayer2.div?div.insertBefore(canvasWrapper,this.annotationLayer.div):div.appendChild(canvasWrapper);var textLayer=null;if(this.textLayerMode!==_ui_utils.TextLayerMode.DISABLE&&this.textLayerFactory){var _this$annotationLayer3,textLayerDiv=document.createElement("div");textLayerDiv.className="textLayer",textLayerDiv.style.width=canvasWrapper.style.width,textLayerDiv.style.height=canvasWrapper.style.height,null!==(_this$annotationLayer3=this.annotationLayer)&&void 0!==_this$annotationLayer3&&_this$annotationLayer3.div?div.insertBefore(textLayerDiv,this.annotationLayer.div):div.appendChild(textLayerDiv),textLayer=this.textLayerFactory.createTextLayerBuilder(textLayerDiv,this.id-1,this.viewport,this.textLayerMode===_ui_utils.TextLayerMode.ENABLE_ENHANCE,this.eventBus,this.textHighlighter)}this.textLayer=textLayer,null!==(_this$xfaLayer2=this.xfaLayer)&&void 0!==_this$xfaLayer2&&_this$xfaLayer2.div&&div.appendChild(this.xfaLayer.div);var renderContinueCallback=null;this.renderingQueue&&(renderContinueCallback=function(cont){if(!_this2.renderingQueue.isHighestPriority(_this2))return _this2.renderingState=_pdf_rendering_queue.RenderingStates.PAUSED,void(_this2.resume=function(){_this2.renderingState=_pdf_rendering_queue.RenderingStates.RUNNING,cont()});cont()});var finishPaintTask=function(){var _ref5=_asyncToGenerator(_regenerator.default.mark((function _callee4(){var error,_args4=arguments;return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:if(error=_args4.length>0&&void 0!==_args4[0]?_args4[0]:null,paintTask===_this2.paintTask&&(_this2.paintTask=null),!(error instanceof _pdfjsLib.RenderingCancelledException)){_context4.next=5;break}return _this2._renderError=null,_context4.abrupt("return");case 5:if(_this2._renderError=error,_this2.renderingState=_pdf_rendering_queue.RenderingStates.FINISHED,_this2.loadingIconDiv&&(div.removeChild(_this2.loadingIconDiv),delete _this2.loadingIconDiv),_this2._resetZoomLayer(!0),_this2.eventBus.dispatch("pagerendered",{source:_this2,pageNumber:_this2.id,cssTransform:!1,timestamp:performance.now(),error:_this2._renderError}),!error){_context4.next=12;break}throw error;case 12:case"end":return _context4.stop()}}),_callee4)})));return function(){return _ref5.apply(this,arguments)}}(),paintTask=this.renderer===_ui_utils.RendererType.SVG?this.paintOnSvg(canvasWrapper):this.paintOnCanvas(canvasWrapper);paintTask.onRenderContinue=renderContinueCallback,this.paintTask=paintTask;var resultPromise=paintTask.promise.then((function(){return finishPaintTask(null).then((function(){if(textLayer){var readableStream=pdfPage.streamTextContent({normalizeWhitespace:!0,includeMarkedContent:!0});textLayer.setTextContentStream(readableStream),textLayer.render()}}))}),(function(reason){return finishPaintTask(reason)}));return this._annotationMode!==_pdfjsLib.AnnotationMode.DISABLE&&this.annotationLayerFactory&&(this.annotationLayer||(this.annotationLayer=this.annotationLayerFactory.createAnnotationLayerBuilder(div,pdfPage,null,this.imageResourcesPath,this._annotationMode===_pdfjsLib.AnnotationMode.ENABLE_FORMS,this.l10n,null,null,null)),this._renderAnnotationLayer()),this.xfaLayerFactory&&(this.xfaLayer||(this.xfaLayer=this.xfaLayerFactory.createXfaLayerBuilder(div,pdfPage,null)),this._renderXfaLayer()),this.structTreeLayerFactory&&this.textLayer&&this.canvas&&(this._onTextLayerRendered=function(event){event.pageNumber===_this2.id&&(_this2.eventBus._off("textlayerrendered",_this2._onTextLayerRendered),_this2._onTextLayerRendered=null,_this2.canvas&&_this2.pdfPage.getStructTree().then((function(tree){if(tree&&_this2.canvas){var treeDom=_this2.structTreeLayer.render(tree);treeDom.classList.add("structTree"),_this2.canvas.appendChild(treeDom)}})))},this.eventBus._on("textlayerrendered",this._onTextLayerRendered),this.structTreeLayer=this.structTreeLayerFactory.createStructTreeLayerBuilder(pdfPage)),div.setAttribute("data-loaded",!0),this.eventBus.dispatch("pagerender",{source:this,pageNumber:this.id}),resultPromise}},{key:"paintOnCanvas",value:function(canvasWrapper){var renderCapability=(0,_pdfjsLib.createPromiseCapability)(),result={promise:renderCapability.promise,onRenderContinue:function(cont){cont()},cancel:function(){renderTask.cancel()}},viewport=this.viewport,canvas=document.createElement("canvas");canvas.hidden=!0;var isCanvasHidden=!0,showCanvas=function(){isCanvasHidden&&(canvas.hidden=!1,isCanvasHidden=!1)};canvasWrapper.appendChild(canvas),this.canvas=canvas,canvas.mozOpaque=!0;var ctx=canvas.getContext("2d",{alpha:!1}),outputScale=(0,_ui_utils.getOutputScale)(ctx);if(this.outputScale=outputScale,this.useOnlyCssZoom){var actualSizeViewport=viewport.clone({scale:_ui_utils.CSS_UNITS});outputScale.sx*=actualSizeViewport.width/viewport.width,outputScale.sy*=actualSizeViewport.height/viewport.height,outputScale.scaled=!0}if(this.maxCanvasPixels>0){var pixelsInViewport=viewport.width*viewport.height,maxScale=Math.sqrt(this.maxCanvasPixels/pixelsInViewport);outputScale.sx>maxScale||outputScale.sy>maxScale?(outputScale.sx=maxScale,outputScale.sy=maxScale,outputScale.scaled=!0,this.hasRestrictedScaling=!0):this.hasRestrictedScaling=!1}var sfx=(0,_ui_utils.approximateFraction)(outputScale.sx),sfy=(0,_ui_utils.approximateFraction)(outputScale.sy);canvas.width=(0,_ui_utils.roundToDivide)(viewport.width*outputScale.sx,sfx[0]),canvas.height=(0,_ui_utils.roundToDivide)(viewport.height*outputScale.sy,sfy[0]),canvas.style.width=(0,_ui_utils.roundToDivide)(viewport.width,sfx[1])+"px",canvas.style.height=(0,_ui_utils.roundToDivide)(viewport.height,sfy[1])+"px",this.paintedViewportMap.set(canvas,viewport);var renderContext={canvasContext:ctx,transform:outputScale.scaled?[outputScale.sx,0,0,outputScale.sy,0,0]:null,viewport:this.viewport,annotationMode:this._annotationMode,optionalContentConfigPromise:this._optionalContentConfigPromise},renderTask=this.pdfPage.render(renderContext);return renderTask.onContinue=function(cont){showCanvas(),result.onRenderContinue?result.onRenderContinue(cont):cont()},renderTask.promise.then((function(){showCanvas(),renderCapability.resolve(void 0)}),(function(error){showCanvas(),renderCapability.reject(error)})),result}},{key:"paintOnSvg",value:function(wrapper){var _this3=this,cancelled=!1,ensureNotCancelled=function(){if(cancelled)throw new _pdfjsLib.RenderingCancelledException("Rendering cancelled, page ".concat(_this3.id),"svg")},pdfPage=this.pdfPage,actualSizeViewport=this.viewport.clone({scale:_ui_utils.CSS_UNITS});return{promise:pdfPage.getOperatorList({annotationMode:this._annotatationMode}).then((function(opList){return ensureNotCancelled(),new _pdfjsLib.SVGGraphics(pdfPage.commonObjs,pdfPage.objs,_app_options.compatibilityParams.disableCreateObjectURL).getSVG(opList,actualSizeViewport).then((function(svg){ensureNotCancelled(),_this3.svg=svg,_this3.paintedViewportMap.set(svg,actualSizeViewport),svg.style.width=wrapper.style.width,svg.style.height=wrapper.style.height,_this3.renderingState=_pdf_rendering_queue.RenderingStates.FINISHED,wrapper.appendChild(svg)}))})),onRenderContinue:function(cont){cont()},cancel:function(){cancelled=!0}}}},{key:"setPageLabel",value:function(label){this.pageLabel="string"==typeof label?label:null,null!==this.pageLabel?this.div.setAttribute("data-page-label",this.pageLabel):this.div.removeAttribute("data-page-label")}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFPageView}();exports.PDFPageView=PDFPageView},(__unused_webpack_module,exports)=>{function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _createClass(Constructor,protoProps,staticProps){return protoProps&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),Constructor}Object.defineProperty(exports,"__esModule",{value:!0}),exports.StructTreeLayerBuilder=exports.DefaultStructTreeLayerFactory=void 0;var PDF_ROLE_TO_HTML_ROLE={Document:null,DocumentFragment:null,Part:"group",Sect:"group",Div:"group",Aside:"note",NonStruct:"none",P:null,H:"heading",Title:null,FENote:"note",Sub:"group",Lbl:null,Span:null,Em:null,Strong:null,Link:"link",Annot:"note",Form:"form",Ruby:null,RB:null,RT:null,RP:null,Warichu:null,WT:null,WP:null,L:"list",LI:"listitem",LBody:null,Table:"table",TR:"row",TH:"columnheader",TD:"cell",THead:"columnheader",TBody:null,TFoot:null,Caption:null,Figure:"figure",Formula:null,Artifact:null},HEADING_PATTERN=/^H(\d+)$/,StructTreeLayerBuilder=function(){function StructTreeLayerBuilder(_ref){var pdfPage=_ref.pdfPage;_classCallCheck(this,StructTreeLayerBuilder),this.pdfPage=pdfPage}return _createClass(StructTreeLayerBuilder,[{key:"render",value:function(structTree){return this._walk(structTree)}},{key:"_setAttributes",value:function(structElement,htmlElement){void 0!==structElement.alt&&htmlElement.setAttribute("aria-label",structElement.alt),void 0!==structElement.id&&htmlElement.setAttribute("aria-owns",structElement.id)}},{key:"_walk",value:function(node){if(!node)return null;var element=document.createElement("span");if("role"in node){var role=node.role,match=role.match(HEADING_PATTERN);match?(element.setAttribute("role","heading"),element.setAttribute("aria-level",match[1])):PDF_ROLE_TO_HTML_ROLE[role]&&element.setAttribute("role",PDF_ROLE_TO_HTML_ROLE[role])}if(this._setAttributes(node,element),node.children)if(1===node.children.length&&"id"in node.children[0])this._setAttributes(node.children[0],element);else{var _step,_iterator=_createForOfIteratorHelper(node.children);try{for(_iterator.s();!(_step=_iterator.n()).done;){var kid=_step.value;element.appendChild(this._walk(kid))}}catch(err){_iterator.e(err)}finally{_iterator.f()}}return element}}]),StructTreeLayerBuilder}();exports.StructTreeLayerBuilder=StructTreeLayerBuilder;var DefaultStructTreeLayerFactory=function(){function DefaultStructTreeLayerFactory(){_classCallCheck(this,DefaultStructTreeLayerFactory)}return _createClass(DefaultStructTreeLayerFactory,[{key:"createStructTreeLayerBuilder",value:function(pdfPage){return new StructTreeLayerBuilder({pdfPage:pdfPage})}}]),DefaultStructTreeLayerFactory}();exports.DefaultStructTreeLayerFactory=DefaultStructTreeLayerFactory},(__unused_webpack_module,exports)=>{function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}Object.defineProperty(exports,"__esModule",{value:!0}),exports.TextHighlighter=void 0;var TextHighlighter=function(){function TextHighlighter(_ref){var findController=_ref.findController,eventBus=_ref.eventBus,pageIndex=_ref.pageIndex;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,TextHighlighter),this.findController=findController,this.matches=[],this.eventBus=eventBus,this.pageIdx=pageIndex,this._onUpdateTextLayerMatches=null,this.textDivs=null,this.textContentItemsStr=null,this.enabled=!1}var Constructor,protoProps,staticProps;return Constructor=TextHighlighter,(protoProps=[{key:"setTextMapping",value:function(divs,texts){this.textDivs=divs,this.textContentItemsStr=texts}},{key:"enable",value:function(){var _this=this;if(!this.textDivs||!this.textContentItemsStr)throw new Error("Text divs and strings have not been set.");if(this.enabled)throw new Error("TextHighlighter is already enabled.");this.enabled=!0,this._onUpdateTextLayerMatches||(this._onUpdateTextLayerMatches=function(evt){evt.pageIndex!==_this.pageIdx&&-1!==evt.pageIndex||_this._updateMatches()},this.eventBus._on("updatetextlayermatches",this._onUpdateTextLayerMatches)),this._updateMatches()}},{key:"disable",value:function(){this.enabled&&(this.enabled=!1,this._onUpdateTextLayerMatches&&(this.eventBus._off("updatetextlayermatches",this._onUpdateTextLayerMatches),this._onUpdateTextLayerMatches=null))}},{key:"_convertMatches",value:function(matches,matchesLength){if(!matches)return[];for(var textContentItemsStr=this.textContentItemsStr,i=0,iIndex=0,end=textContentItemsStr.length-1,result=[],m=0,mm=matches.length;m<mm;m++){for(var matchIdx=matches[m];i!==end&&matchIdx>=iIndex+textContentItemsStr[i].length;)iIndex+=textContentItemsStr[i].length,i++;i===textContentItemsStr.length&&console.error("Could not find a matching mapping");var match={begin:{divIdx:i,offset:matchIdx-iIndex}};for(matchIdx+=matchesLength[m];i!==end&&matchIdx>iIndex+textContentItemsStr[i].length;)iIndex+=textContentItemsStr[i].length,i++;match.end={divIdx:i,offset:matchIdx-iIndex},result.push(match)}return result}},{key:"_renderMatches",value:function(matches){if(0!==matches.length){var findController=this.findController,pageIdx=this.pageIdx,textContentItemsStr=this.textContentItemsStr,textDivs=this.textDivs,isSelectedPage=pageIdx===findController.selected.pageIdx,selectedMatchIdx=findController.selected.matchIdx,prevEnd=null,infinity={divIdx:-1,offset:void 0},i0=selectedMatchIdx,i1=i0+1;if(findController.state.highlightAll)i0=0,i1=matches.length;else if(!isSelectedPage)return;for(var i=i0;i<i1;i++){var match=matches[i],begin=match.begin,end=match.end,isSelected=isSelectedPage&&i===selectedMatchIdx,highlightSuffix=isSelected?" selected":"",selectedLeft=0;if(prevEnd&&begin.divIdx===prevEnd.divIdx?appendTextToDiv(prevEnd.divIdx,prevEnd.offset,begin.offset):(null!==prevEnd&&appendTextToDiv(prevEnd.divIdx,prevEnd.offset,infinity.offset),beginText(begin)),begin.divIdx===end.divIdx)selectedLeft=appendTextToDiv(begin.divIdx,begin.offset,end.offset,"highlight"+highlightSuffix);else{selectedLeft=appendTextToDiv(begin.divIdx,begin.offset,infinity.offset,"highlight begin"+highlightSuffix);for(var n0=begin.divIdx+1,n1=end.divIdx;n0<n1;n0++)textDivs[n0].className="highlight middle"+highlightSuffix;beginText(end,"highlight end"+highlightSuffix)}prevEnd=end,isSelected&&findController.scrollMatchIntoView({element:textDivs[begin.divIdx],selectedLeft:selectedLeft,pageIndex:pageIdx,matchIndex:selectedMatchIdx})}prevEnd&&appendTextToDiv(prevEnd.divIdx,prevEnd.offset,infinity.offset)}function beginText(begin,className){var divIdx=begin.divIdx;return textDivs[divIdx].textContent="",appendTextToDiv(divIdx,0,begin.offset,className)}function appendTextToDiv(divIdx,fromOffset,toOffset,className){var div=textDivs[divIdx];if(div.nodeType===Node.TEXT_NODE){var span=document.createElement("span");div.parentNode.insertBefore(span,div),span.appendChild(div),textDivs[divIdx]=span,div=span}var content=textContentItemsStr[divIdx].substring(fromOffset,toOffset),node=document.createTextNode(content);if(className){var _span=document.createElement("span");return _span.className="".concat(className," appended"),_span.appendChild(node),div.appendChild(_span),className.includes("selected")?_span.offsetLeft:0}return div.appendChild(node),0}}},{key:"_updateMatches",value:function(){if(this.enabled){for(var findController=this.findController,matches=this.matches,pageIdx=this.pageIdx,textContentItemsStr=this.textContentItemsStr,textDivs=this.textDivs,clearedUntilDivIdx=-1,i=0,ii=matches.length;i<ii;i++){for(var match=matches[i],n=Math.max(clearedUntilDivIdx,match.begin.divIdx),end=match.end.divIdx;n<=end;n++){var div=textDivs[n];div.textContent=textContentItemsStr[n],div.className=""}clearedUntilDivIdx=match.end.divIdx+1}if(null!=findController&&findController.highlightMatches){var pageMatches=findController.pageMatches[pageIdx]||null,pageMatchesLength=findController.pageMatchesLength[pageIdx]||null;this.matches=this._convertMatches(pageMatches,pageMatchesLength),this._renderMatches(this.matches)}}}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),TextHighlighter}();exports.TextHighlighter=TextHighlighter},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.TextLayerBuilder=exports.DefaultTextLayerFactory=void 0;var _pdfjsLib=__webpack_require__(6);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _createClass(Constructor,protoProps,staticProps){return protoProps&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),Constructor}var TextLayerBuilder=function(){function TextLayerBuilder(_ref){var textLayerDiv=_ref.textLayerDiv,eventBus=_ref.eventBus,pageIndex=_ref.pageIndex,viewport=_ref.viewport,_ref$highlighter=_ref.highlighter,highlighter=void 0===_ref$highlighter?null:_ref$highlighter,_ref$enhanceTextSelec=_ref.enhanceTextSelection,enhanceTextSelection=void 0!==_ref$enhanceTextSelec&&_ref$enhanceTextSelec;_classCallCheck(this,TextLayerBuilder),this.textLayerDiv=textLayerDiv,this.eventBus=eventBus,this.textContent=null,this.textContentItemsStr=[],this.textContentStream=null,this.renderingDone=!1,this.pageNumber=pageIndex+1,this.viewport=viewport,this.textDivs=[],this.textLayerRenderTask=null,this.highlighter=highlighter,this.enhanceTextSelection=enhanceTextSelection,this._bindMouse()}return _createClass(TextLayerBuilder,[{key:"_finishRendering",value:function(){if(this.renderingDone=!0,!this.enhanceTextSelection){var endOfContent=document.createElement("div");endOfContent.className="endOfContent",this.textLayerDiv.appendChild(endOfContent)}this.eventBus.dispatch("textlayerrendered",{source:this,pageNumber:this.pageNumber,numTextDivs:this.textDivs.length})}},{key:"render",value:function(){var _this$highlighter,_this=this,timeout=arguments.length>0&&void 0!==arguments[0]?arguments[0]:0;if((this.textContent||this.textContentStream)&&!this.renderingDone){this.cancel(),this.textDivs.length=0,null===(_this$highlighter=this.highlighter)||void 0===_this$highlighter||_this$highlighter.setTextMapping(this.textDivs,this.textContentItemsStr);var textLayerFrag=document.createDocumentFragment();this.textLayerRenderTask=(0,_pdfjsLib.renderTextLayer)({textContent:this.textContent,textContentStream:this.textContentStream,container:textLayerFrag,viewport:this.viewport,textDivs:this.textDivs,textContentItemsStr:this.textContentItemsStr,timeout:timeout,enhanceTextSelection:this.enhanceTextSelection}),this.textLayerRenderTask.promise.then((function(){var _this$highlighter2;_this.textLayerDiv.appendChild(textLayerFrag),_this._finishRendering(),null===(_this$highlighter2=_this.highlighter)||void 0===_this$highlighter2||_this$highlighter2.enable()}),(function(reason){}))}}},{key:"cancel",value:function(){var _this$highlighter3;this.textLayerRenderTask&&(this.textLayerRenderTask.cancel(),this.textLayerRenderTask=null),null===(_this$highlighter3=this.highlighter)||void 0===_this$highlighter3||_this$highlighter3.disable()}},{key:"setTextContentStream",value:function(readableStream){this.cancel(),this.textContentStream=readableStream}},{key:"setTextContent",value:function(textContent){this.cancel(),this.textContent=textContent}},{key:"_bindMouse",value:function(){var _this2=this,div=this.textLayerDiv,expandDivsTimer=null;div.addEventListener("mousedown",(function(evt){if(_this2.enhanceTextSelection&&_this2.textLayerRenderTask)return _this2.textLayerRenderTask.expandTextDivs(!0),void(expandDivsTimer&&(clearTimeout(expandDivsTimer),expandDivsTimer=null));var end=div.querySelector(".endOfContent");if(end){var adjustTop=evt.target!==div;if(adjustTop=adjustTop&&"none"!==window.getComputedStyle(end).getPropertyValue("-moz-user-select")){var divBounds=div.getBoundingClientRect(),r=Math.max(0,(evt.pageY-divBounds.top)/divBounds.height);end.style.top=(100*r).toFixed(2)+"%"}end.classList.add("active")}})),div.addEventListener("mouseup",(function(){if(_this2.enhanceTextSelection&&_this2.textLayerRenderTask)expandDivsTimer=setTimeout((function(){_this2.textLayerRenderTask&&_this2.textLayerRenderTask.expandTextDivs(!1),expandDivsTimer=null}),300);else{var end=div.querySelector(".endOfContent");end&&(end.style.top="",end.classList.remove("active"))}}))}}]),TextLayerBuilder}();exports.TextLayerBuilder=TextLayerBuilder;var DefaultTextLayerFactory=function(){function DefaultTextLayerFactory(){_classCallCheck(this,DefaultTextLayerFactory)}return _createClass(DefaultTextLayerFactory,[{key:"createTextLayerBuilder",value:function(textLayerDiv,pageIndex,viewport){var enhanceTextSelection=arguments.length>3&&void 0!==arguments[3]&&arguments[3],eventBus=arguments.length>4?arguments[4]:void 0,highlighter=arguments.length>5?arguments[5]:void 0;return new TextLayerBuilder({textLayerDiv:textLayerDiv,pageIndex:pageIndex,viewport:viewport,enhanceTextSelection:enhanceTextSelection,eventBus:eventBus,highlighter:highlighter})}}]),DefaultTextLayerFactory}();exports.DefaultTextLayerFactory=DefaultTextLayerFactory},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.XfaLayerBuilder=exports.DefaultXfaLayerFactory=void 0;var _pdfjsLib=__webpack_require__(6);function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _createClass(Constructor,protoProps,staticProps){return protoProps&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),Constructor}var XfaLayerBuilder=function(){function XfaLayerBuilder(_ref){var pageDiv=_ref.pageDiv,pdfPage=_ref.pdfPage,annotationStorage=_ref.annotationStorage,xfaHtml=_ref.xfaHtml;_classCallCheck(this,XfaLayerBuilder),this.pageDiv=pageDiv,this.pdfPage=pdfPage,this.annotationStorage=annotationStorage,this.xfaHtml=xfaHtml,this.div=null,this._cancelled=!1}return _createClass(XfaLayerBuilder,[{key:"render",value:function(viewport){var _this=this,intent=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"display";if("print"===intent){var parameters={viewport:viewport.clone({dontFlip:!0}),div:this.div,xfa:this.xfaHtml,page:null,annotationStorage:this.annotationStorage,intent:intent},div=document.createElement("div");this.pageDiv.appendChild(div),parameters.div=div;var result=_pdfjsLib.XfaLayer.render(parameters);return Promise.resolve(result)}return this.pdfPage.getXfa().then((function(xfa){if(_this._cancelled||!xfa)return{textDivs:[]};var parameters={viewport:viewport.clone({dontFlip:!0}),div:_this.div,xfa:xfa,page:_this.pdfPage,annotationStorage:_this.annotationStorage,intent:intent};return _this.div?_pdfjsLib.XfaLayer.update(parameters):(_this.div=document.createElement("div"),_this.pageDiv.appendChild(_this.div),parameters.div=_this.div,_pdfjsLib.XfaLayer.render(parameters))})).catch((function(error){console.error(error)}))}},{key:"cancel",value:function(){this._cancelled=!0}},{key:"hide",value:function(){this.div&&(this.div.hidden=!0)}}]),XfaLayerBuilder}();exports.XfaLayerBuilder=XfaLayerBuilder;var DefaultXfaLayerFactory=function(){function DefaultXfaLayerFactory(){_classCallCheck(this,DefaultXfaLayerFactory)}return _createClass(DefaultXfaLayerFactory,[{key:"createXfaLayerBuilder",value:function(pageDiv,pdfPage){var annotationStorage=arguments.length>2&&void 0!==arguments[2]?arguments[2]:null,xfaHtml=arguments.length>3&&void 0!==arguments[3]?arguments[3]:null;return new XfaLayerBuilder({pageDiv:pageDiv,pdfPage:pdfPage,annotationStorage:annotationStorage,xfaHtml:xfaHtml})}}]),DefaultXfaLayerFactory}();exports.DefaultXfaLayerFactory=DefaultXfaLayerFactory},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.SecondaryToolbar=void 0;var _ui_utils=__webpack_require__(5),_pdf_cursor_tools=__webpack_require__(7),_pdf_single_page_viewer=__webpack_require__(38);function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var SecondaryToolbar=function(){function SecondaryToolbar(options,mainContainer,eventBus){var _this=this;!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,SecondaryToolbar),this.toolbar=options.toolbar,this.toggleButton=options.toggleButton,this.toolbarButtonContainer=options.toolbarButtonContainer,this.buttons=[{element:options.presentationModeButton,eventName:"presentationmode",close:!0},{element:options.openFileButton,eventName:"openfile",close:!0},{element:options.printButton,eventName:"print",close:!0},{element:options.downloadButton,eventName:"download",close:!0},{element:options.viewBookmarkButton,eventName:null,close:!0},{element:options.firstPageButton,eventName:"firstpage",close:!0},{element:options.lastPageButton,eventName:"lastpage",close:!0},{element:options.pageRotateCwButton,eventName:"rotatecw",close:!1},{element:options.pageRotateCcwButton,eventName:"rotateccw",close:!1},{element:options.cursorSelectToolButton,eventName:"switchcursortool",eventDetails:{tool:_pdf_cursor_tools.CursorTool.SELECT},close:!0},{element:options.cursorHandToolButton,eventName:"switchcursortool",eventDetails:{tool:_pdf_cursor_tools.CursorTool.HAND},close:!0},{element:options.scrollVerticalButton,eventName:"switchscrollmode",eventDetails:{mode:_ui_utils.ScrollMode.VERTICAL},close:!0},{element:options.scrollHorizontalButton,eventName:"switchscrollmode",eventDetails:{mode:_ui_utils.ScrollMode.HORIZONTAL},close:!0},{element:options.scrollWrappedButton,eventName:"switchscrollmode",eventDetails:{mode:_ui_utils.ScrollMode.WRAPPED},close:!0},{element:options.spreadNoneButton,eventName:"switchspreadmode",eventDetails:{mode:_ui_utils.SpreadMode.NONE},close:!0},{element:options.spreadOddButton,eventName:"switchspreadmode",eventDetails:{mode:_ui_utils.SpreadMode.ODD},close:!0},{element:options.spreadEvenButton,eventName:"switchspreadmode",eventDetails:{mode:_ui_utils.SpreadMode.EVEN},close:!0},{element:options.documentPropertiesButton,eventName:"documentproperties",close:!0}],this.items={firstPage:options.firstPageButton,lastPage:options.lastPageButton,pageRotateCw:options.pageRotateCwButton,pageRotateCcw:options.pageRotateCcwButton},this.mainContainer=mainContainer,this.eventBus=eventBus,this.opened=!1,this.containerHeight=null,this.previousContainerHeight=null,this.reset(),this._bindClickListeners(),this._bindCursorToolsListener(options),this._bindScrollModeListener(options),this._bindSpreadModeListener(options),this.eventBus._on("resize",this._setMaxHeight.bind(this)),this.eventBus._on("baseviewerinit",(function(evt){evt.source instanceof _pdf_single_page_viewer.PDFSinglePageViewer?_this.toolbarButtonContainer.classList.add("hiddenScrollModeButtons","hiddenSpreadModeButtons"):_this.toolbarButtonContainer.classList.remove("hiddenScrollModeButtons","hiddenSpreadModeButtons")}))}var Constructor,protoProps,staticProps;return Constructor=SecondaryToolbar,(protoProps=[{key:"isOpen",get:function(){return this.opened}},{key:"setPageNumber",value:function(pageNumber){this.pageNumber=pageNumber,this._updateUIState()}},{key:"setPagesCount",value:function(pagesCount){this.pagesCount=pagesCount,this._updateUIState()}},{key:"reset",value:function(){this.pageNumber=0,this.pagesCount=0,this._updateUIState(),this.eventBus.dispatch("secondarytoolbarreset",{source:this})}},{key:"_updateUIState",value:function(){this.items.firstPage.disabled=this.pageNumber<=1,this.items.lastPage.disabled=this.pageNumber>=this.pagesCount,this.items.pageRotateCw.disabled=0===this.pagesCount,this.items.pageRotateCcw.disabled=0===this.pagesCount}},{key:"_bindClickListeners",value:function(){var _this2=this;this.toggleButton.addEventListener("click",this.toggle.bind(this));var _step,_iterator=_createForOfIteratorHelper(this.buttons);try{var _loop=function(){var _step$value=_step.value,element=_step$value.element,eventName=_step$value.eventName,close=_step$value.close,eventDetails=_step$value.eventDetails;element.addEventListener("click",(function(evt){if(null!==eventName){var details={source:_this2};for(var property in eventDetails)details[property]=eventDetails[property];_this2.eventBus.dispatch(eventName,details)}close&&_this2.close()}))};for(_iterator.s();!(_step=_iterator.n()).done;)_loop()}catch(err){_iterator.e(err)}finally{_iterator.f()}}},{key:"_bindCursorToolsListener",value:function(buttons){this.eventBus._on("cursortoolchanged",(function(_ref){var tool=_ref.tool;buttons.cursorSelectToolButton.classList.toggle("toggled",tool===_pdf_cursor_tools.CursorTool.SELECT),buttons.cursorHandToolButton.classList.toggle("toggled",tool===_pdf_cursor_tools.CursorTool.HAND)}))}},{key:"_bindScrollModeListener",value:function(buttons){var _this3=this;function scrollModeChanged(_ref2){var mode=_ref2.mode;buttons.scrollVerticalButton.classList.toggle("toggled",mode===_ui_utils.ScrollMode.VERTICAL),buttons.scrollHorizontalButton.classList.toggle("toggled",mode===_ui_utils.ScrollMode.HORIZONTAL),buttons.scrollWrappedButton.classList.toggle("toggled",mode===_ui_utils.ScrollMode.WRAPPED);var isScrollModeHorizontal=mode===_ui_utils.ScrollMode.HORIZONTAL;buttons.spreadNoneButton.disabled=isScrollModeHorizontal,buttons.spreadOddButton.disabled=isScrollModeHorizontal,buttons.spreadEvenButton.disabled=isScrollModeHorizontal}this.eventBus._on("scrollmodechanged",scrollModeChanged),this.eventBus._on("secondarytoolbarreset",(function(evt){evt.source===_this3&&scrollModeChanged({mode:_ui_utils.ScrollMode.VERTICAL})}))}},{key:"_bindSpreadModeListener",value:function(buttons){var _this4=this;function spreadModeChanged(_ref3){var mode=_ref3.mode;buttons.spreadNoneButton.classList.toggle("toggled",mode===_ui_utils.SpreadMode.NONE),buttons.spreadOddButton.classList.toggle("toggled",mode===_ui_utils.SpreadMode.ODD),buttons.spreadEvenButton.classList.toggle("toggled",mode===_ui_utils.SpreadMode.EVEN)}this.eventBus._on("spreadmodechanged",spreadModeChanged),this.eventBus._on("secondarytoolbarreset",(function(evt){evt.source===_this4&&spreadModeChanged({mode:_ui_utils.SpreadMode.NONE})}))}},{key:"open",value:function(){this.opened||(this.opened=!0,this._setMaxHeight(),this.toggleButton.classList.add("toggled"),this.toggleButton.setAttribute("aria-expanded","true"),this.toolbar.classList.remove("hidden"))}},{key:"close",value:function(){this.opened&&(this.opened=!1,this.toolbar.classList.add("hidden"),this.toggleButton.classList.remove("toggled"),this.toggleButton.setAttribute("aria-expanded","false"))}},{key:"toggle",value:function(){this.opened?this.close():this.open()}},{key:"_setMaxHeight",value:function(){this.opened&&(this.containerHeight=this.mainContainer.clientHeight,this.containerHeight!==this.previousContainerHeight&&(this.toolbarButtonContainer.style.maxHeight="".concat(this.containerHeight-_ui_utils.SCROLLBAR_PADDING,"px"),this.previousContainerHeight=this.containerHeight))}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),SecondaryToolbar}();exports.SecondaryToolbar=SecondaryToolbar},(__unused_webpack_module,exports,__webpack_require__)=>{function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFSinglePageViewer=void 0;var _base_viewer=__webpack_require__(29),_pdfjsLib=__webpack_require__(6);function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _get(target,property,receiver){return(_get="undefined"!=typeof Reflect&&Reflect.get?Reflect.get:function(target,property,receiver){var base=function(object,property){for(;!Object.prototype.hasOwnProperty.call(object,property)&&null!==(object=_getPrototypeOf(object)););return object}(target,property);if(base){var desc=Object.getOwnPropertyDescriptor(base,property);return desc.get?desc.get.call(receiver):desc.value}})(target,property,receiver||target)}function _setPrototypeOf(o,p){return(_setPrototypeOf=Object.setPrototypeOf||function(o,p){return o.__proto__=p,o})(o,p)}function _createSuper(Derived){var hasNativeReflectConstruct=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var result,Super=_getPrototypeOf(Derived);if(hasNativeReflectConstruct){var NewTarget=_getPrototypeOf(this).constructor;result=Reflect.construct(Super,arguments,NewTarget)}else result=Super.apply(this,arguments);return _possibleConstructorReturn(this,result)}}function _possibleConstructorReturn(self,call){if(call&&("object"===_typeof(call)||"function"==typeof call))return call;if(void 0!==call)throw new TypeError("Derived constructors may only return object or undefined");return function(self){if(void 0===self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return self}(self)}function _getPrototypeOf(o){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(o){return o.__proto__||Object.getPrototypeOf(o)})(o)}var PDFSinglePageViewer=function(_BaseViewer){!function(subClass,superClass){if("function"!=typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function");subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,writable:!0,configurable:!0}}),superClass&&_setPrototypeOf(subClass,superClass)}(PDFSinglePageViewer,_BaseViewer);var Constructor,protoProps,staticProps,_super=_createSuper(PDFSinglePageViewer);function PDFSinglePageViewer(options){var _this;return function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,PDFSinglePageViewer),(_this=_super.call(this,options)).eventBus._on("pagesinit",(function(evt){_this._ensurePageViewVisible()})),_this}return Constructor=PDFSinglePageViewer,(protoProps=[{key:"_viewerElement",get:function(){return(0,_pdfjsLib.shadow)(this,"_viewerElement",this._shadowViewer)}},{key:"_pageWidthScaleFactor",get:function(){return 1}},{key:"_resetView",value:function(){_get(_getPrototypeOf(PDFSinglePageViewer.prototype),"_resetView",this).call(this),this._previousPageNumber=1,this._shadowViewer=document.createDocumentFragment(),this._updateScrollDown=null}},{key:"_ensurePageViewVisible",value:function(){var pageView=this._pages[this._currentPageNumber-1],previousPageView=this._pages[this._previousPageNumber-1],viewerNodes=this.viewer.childNodes;switch(viewerNodes.length){case 0:this.viewer.appendChild(pageView.div);break;case 1:if(viewerNodes[0]!==previousPageView.div)throw new Error("_ensurePageViewVisible: Unexpected previously visible page.");if(pageView===previousPageView)break;this._shadowViewer.appendChild(previousPageView.div),this.viewer.appendChild(pageView.div),this.container.scrollTop=0;break;default:throw new Error("_ensurePageViewVisible: Only one page should be visible at a time.")}this._previousPageNumber=this._currentPageNumber}},{key:"_scrollUpdate",value:function(){this._updateScrollDown&&this._updateScrollDown(),_get(_getPrototypeOf(PDFSinglePageViewer.prototype),"_scrollUpdate",this).call(this)}},{key:"_scrollIntoView",value:function(_ref){var _this2=this,pageDiv=_ref.pageDiv,_ref$pageSpot=_ref.pageSpot,pageSpot=void 0===_ref$pageSpot?null:_ref$pageSpot,_ref$pageNumber=_ref.pageNumber,pageNumber=void 0===_ref$pageNumber?null:_ref$pageNumber;pageNumber&&this._setCurrentPageNumber(pageNumber);var scrolledDown=this._currentPageNumber>=this._previousPageNumber;this._ensurePageViewVisible(),this.update(),_get(_getPrototypeOf(PDFSinglePageViewer.prototype),"_scrollIntoView",this).call(this,{pageDiv:pageDiv,pageSpot:pageSpot,pageNumber:pageNumber}),this._updateScrollDown=function(){_this2.scroll.down=scrolledDown,_this2._updateScrollDown=null}}},{key:"_getVisiblePages",value:function(){return this._getCurrentVisiblePage()}},{key:"_updateHelper",value:function(visiblePages){}},{key:"_isScrollModeHorizontal",get:function(){return(0,_pdfjsLib.shadow)(this,"_isScrollModeHorizontal",!1)}},{key:"_updateScrollMode",value:function(){}},{key:"_updateSpreadMode",value:function(){}},{key:"_getPageAdvance",value:function(){return 1}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),PDFSinglePageViewer}(_base_viewer.BaseViewer);exports.PDFSinglePageViewer=PDFSinglePageViewer},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.Toolbar=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_ui_utils=__webpack_require__(5);function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _createForOfIteratorHelper(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var Toolbar=function(){function Toolbar(options,eventBus,l10n){!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,Toolbar),this.toolbar=options.container,this.eventBus=eventBus,this.l10n=l10n,this.buttons=[{element:options.previous,eventName:"previouspage"},{element:options.next,eventName:"nextpage"},{element:options.zoomIn,eventName:"zoomin"},{element:options.zoomOut,eventName:"zoomout"},{element:options.openFile,eventName:"openfile"},{element:options.print,eventName:"print"},{element:options.presentationModeButton,eventName:"presentationmode"},{element:options.download,eventName:"download"},{element:options.viewBookmark,eventName:null}],this.items={numPages:options.numPages,pageNumber:options.pageNumber,scaleSelect:options.scaleSelect,customScaleOption:options.customScaleOption,previous:options.previous,next:options.next,zoomIn:options.zoomIn,zoomOut:options.zoomOut},this._wasLocalized=!1,this.reset(),this._bindListeners()}var Constructor,protoProps,staticProps,fn,_adjustScaleWidth2;return Constructor=Toolbar,(protoProps=[{key:"setPageNumber",value:function(pageNumber,pageLabel){this.pageNumber=pageNumber,this.pageLabel=pageLabel,this._updateUIState(!1)}},{key:"setPagesCount",value:function(pagesCount,hasPageLabels){this.pagesCount=pagesCount,this.hasPageLabels=hasPageLabels,this._updateUIState(!0)}},{key:"setPageScale",value:function(pageScaleValue,pageScale){this.pageScaleValue=(pageScaleValue||pageScale).toString(),this.pageScale=pageScale,this._updateUIState(!1)}},{key:"reset",value:function(){this.pageNumber=0,this.pageLabel=null,this.hasPageLabels=!1,this.pagesCount=0,this.pageScaleValue=_ui_utils.DEFAULT_SCALE_VALUE,this.pageScale=_ui_utils.DEFAULT_SCALE,this._updateUIState(!0),this.updateLoadingIndicatorState()}},{key:"_bindListeners",value:function(){var _step,_this=this,_this$items=this.items,pageNumber=_this$items.pageNumber,scaleSelect=_this$items.scaleSelect,self=this,_iterator=_createForOfIteratorHelper(this.buttons);try{var _loop=function(){var _step$value=_step.value,element=_step$value.element,eventName=_step$value.eventName;element.addEventListener("click",(function(evt){null!==eventName&&_this.eventBus.dispatch(eventName,{source:_this})}))};for(_iterator.s();!(_step=_iterator.n()).done;)_loop()}catch(err){_iterator.e(err)}finally{_iterator.f()}pageNumber.addEventListener("click",(function(){this.select()})),pageNumber.addEventListener("change",(function(){self.eventBus.dispatch("pagenumberchanged",{source:self,value:this.value})})),scaleSelect.addEventListener("change",(function(){"custom"!==this.value&&self.eventBus.dispatch("scalechanged",{source:self,value:this.value})})),scaleSelect.addEventListener("click",(function(evt){var target=evt.target;this.value===self.pageScaleValue&&"OPTION"===target.tagName.toUpperCase()&&this.blur()})),scaleSelect.oncontextmenu=_ui_utils.noContextMenuHandler,this.eventBus._on("localized",(function(){_this._wasLocalized=!0,_this._adjustScaleWidth(),_this._updateUIState(!0)}))}},{key:"_updateUIState",value:function(){var resetNumPages=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(this._wasLocalized){var pageNumber=this.pageNumber,pagesCount=this.pagesCount,pageScaleValue=this.pageScaleValue,pageScale=this.pageScale,items=this.items;resetNumPages&&(this.hasPageLabels?items.pageNumber.type="text":(items.pageNumber.type="number",this.l10n.get("of_pages",{pagesCount:pagesCount}).then((function(msg){items.numPages.textContent=msg}))),items.pageNumber.max=pagesCount),this.hasPageLabels?(items.pageNumber.value=this.pageLabel,this.l10n.get("page_of_pages",{pageNumber:pageNumber,pagesCount:pagesCount}).then((function(msg){items.numPages.textContent=msg}))):items.pageNumber.value=pageNumber,items.previous.disabled=pageNumber<=1,items.next.disabled=pageNumber>=pagesCount,items.zoomOut.disabled=pageScale<=_ui_utils.MIN_SCALE,items.zoomIn.disabled=pageScale>=_ui_utils.MAX_SCALE,this.l10n.get("page_scale_percent",{scale:Math.round(1e4*pageScale)/100}).then((function(msg){var _step2,predefinedValueFound=!1,_iterator2=_createForOfIteratorHelper(items.scaleSelect.options);try{for(_iterator2.s();!(_step2=_iterator2.n()).done;){var option=_step2.value;option.value===pageScaleValue?(option.selected=!0,predefinedValueFound=!0):option.selected=!1}}catch(err){_iterator2.e(err)}finally{_iterator2.f()}predefinedValueFound||(items.customScaleOption.textContent=msg,items.customScaleOption.selected=!0)}))}}},{key:"updateLoadingIndicatorState",value:function(){var loading=arguments.length>0&&void 0!==arguments[0]&&arguments[0],pageNumberInput=this.items.pageNumber;pageNumberInput.classList.toggle("visiblePageIsLoading",loading)}},{key:"_adjustScaleWidth",value:(fn=_regenerator.default.mark((function _callee(){var items,l10n,predefinedValuesPromise,style,scaleSelectContainerWidth,scaleSelectOverflow,canvas,ctx,maxWidth,_iterator3,_step3,predefinedValue,_ctx$measureText,width;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:return items=this.items,l10n=this.l10n,predefinedValuesPromise=Promise.all([l10n.get("page_scale_auto"),l10n.get("page_scale_actual"),l10n.get("page_scale_fit"),l10n.get("page_scale_width")]),style=getComputedStyle(items.scaleSelect),scaleSelectContainerWidth=parseInt(style.getPropertyValue("--scale-select-container-width"),10),scaleSelectOverflow=parseInt(style.getPropertyValue("--scale-select-overflow"),10),(canvas=document.createElement("canvas")).mozOpaque=!0,ctx=canvas.getContext("2d",{alpha:!1}),_context.next=8,_ui_utils.animationStarted;case 8:return ctx.font="".concat(style.fontSize," ").concat(style.fontFamily),maxWidth=0,_context.t0=_createForOfIteratorHelper,_context.next=13,predefinedValuesPromise;case 13:_context.t1=_context.sent,_iterator3=(0,_context.t0)(_context.t1);try{for(_iterator3.s();!(_step3=_iterator3.n()).done;)predefinedValue=_step3.value,_ctx$measureText=ctx.measureText(predefinedValue),(width=_ctx$measureText.width)>maxWidth&&(maxWidth=width)}catch(err){_iterator3.e(err)}finally{_iterator3.f()}(maxWidth+=2*scaleSelectOverflow)>scaleSelectContainerWidth&&document.documentElement.style.setProperty("--scale-select-container-width","".concat(maxWidth,"px")),canvas.width=0,canvas.height=0,canvas=ctx=null;case 21:case"end":return _context.stop()}}),_callee,this)})),_adjustScaleWidth2=function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))},function(){return _adjustScaleWidth2.apply(this,arguments)})}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),Toolbar}();exports.Toolbar=Toolbar},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.ViewHistory=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj};function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var ViewHistory=function(){function ViewHistory(fingerprint){var _this=this,cacheSize=arguments.length>1&&void 0!==arguments[1]?arguments[1]:20;_classCallCheck(this,ViewHistory),this.fingerprint=fingerprint,this.cacheSize=cacheSize,this._initializedPromise=this._readFromStorage().then((function(databaseStr){var database=JSON.parse(databaseStr||"{}"),index=-1;if(Array.isArray(database.files)){for(;database.files.length>=_this.cacheSize;)database.files.shift();for(var i=0,ii=database.files.length;i<ii;i++){if(database.files[i].fingerprint===_this.fingerprint){index=i;break}}}else database.files=[];-1===index&&(index=database.files.push({fingerprint:_this.fingerprint})-1),_this.file=database.files[index],_this.database=database}))}var Constructor,protoProps,staticProps,_getMultiple,_get,_setMultiple,_set,_readFromStorage2,_writeToStorage2;return Constructor=ViewHistory,(protoProps=[{key:"_writeToStorage",value:(_writeToStorage2=_asyncToGenerator(_regenerator.default.mark((function _callee(){var databaseStr;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:databaseStr=JSON.stringify(this.database),localStorage.setItem("pdfjs.history",databaseStr);case 2:case"end":return _context.stop()}}),_callee,this)}))),function(){return _writeToStorage2.apply(this,arguments)})},{key:"_readFromStorage",value:(_readFromStorage2=_asyncToGenerator(_regenerator.default.mark((function _callee2(){return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:return _context2.abrupt("return",localStorage.getItem("pdfjs.history"));case 1:case"end":return _context2.stop()}}),_callee2)}))),function(){return _readFromStorage2.apply(this,arguments)})},{key:"set",value:(_set=_asyncToGenerator(_regenerator.default.mark((function _callee3(name,val){return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:return _context3.next=2,this._initializedPromise;case 2:return this.file[name]=val,_context3.abrupt("return",this._writeToStorage());case 4:case"end":return _context3.stop()}}),_callee3,this)}))),function(_x,_x2){return _set.apply(this,arguments)})},{key:"setMultiple",value:(_setMultiple=_asyncToGenerator(_regenerator.default.mark((function _callee4(properties){var name;return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:return _context4.next=2,this._initializedPromise;case 2:for(name in properties)this.file[name]=properties[name];return _context4.abrupt("return",this._writeToStorage());case 4:case"end":return _context4.stop()}}),_callee4,this)}))),function(_x3){return _setMultiple.apply(this,arguments)})},{key:"get",value:(_get=_asyncToGenerator(_regenerator.default.mark((function _callee5(name,defaultValue){var val;return _regenerator.default.wrap((function(_context5){for(;;)switch(_context5.prev=_context5.next){case 0:return _context5.next=2,this._initializedPromise;case 2:return val=this.file[name],_context5.abrupt("return",void 0!==val?val:defaultValue);case 4:case"end":return _context5.stop()}}),_callee5,this)}))),function(_x4,_x5){return _get.apply(this,arguments)})},{key:"getMultiple",value:(_getMultiple=_asyncToGenerator(_regenerator.default.mark((function _callee6(properties){var values,name,val;return _regenerator.default.wrap((function(_context6){for(;;)switch(_context6.prev=_context6.next){case 0:return _context6.next=2,this._initializedPromise;case 2:for(name in values=Object.create(null),properties)val=this.file[name],values[name]=void 0!==val?val:properties[name];return _context6.abrupt("return",values);case 5:case"end":return _context6.stop()}}),_callee6,this)}))),function(_x6){return _getMultiple.apply(this,arguments)})}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),ViewHistory}();exports.ViewHistory=ViewHistory},(__unused_webpack_module,exports,__webpack_require__)=>{function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.GenericCom=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_app=__webpack_require__(2),_preferences=__webpack_require__(42),_download_manager=__webpack_require__(43),_genericl10n=__webpack_require__(44),_generic_scripting=__webpack_require__(46);function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _classCallCheck(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _createClass(Constructor,protoProps,staticProps){return protoProps&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),Constructor}function _inherits(subClass,superClass){if("function"!=typeof superClass&&null!==superClass)throw new TypeError("Super expression must either be null or a function");subClass.prototype=Object.create(superClass&&superClass.prototype,{constructor:{value:subClass,writable:!0,configurable:!0}}),superClass&&_setPrototypeOf(subClass,superClass)}function _setPrototypeOf(o,p){return(_setPrototypeOf=Object.setPrototypeOf||function(o,p){return o.__proto__=p,o})(o,p)}function _createSuper(Derived){var hasNativeReflectConstruct=function(){if("undefined"==typeof Reflect||!Reflect.construct)return!1;if(Reflect.construct.sham)return!1;if("function"==typeof Proxy)return!0;try{return Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],(function(){}))),!0}catch(e){return!1}}();return function(){var result,Super=_getPrototypeOf(Derived);if(hasNativeReflectConstruct){var NewTarget=_getPrototypeOf(this).constructor;result=Reflect.construct(Super,arguments,NewTarget)}else result=Super.apply(this,arguments);return _possibleConstructorReturn(this,result)}}function _possibleConstructorReturn(self,call){if(call&&("object"===_typeof(call)||"function"==typeof call))return call;if(void 0!==call)throw new TypeError("Derived constructors may only return object or undefined");return function(self){if(void 0===self)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return self}(self)}function _getPrototypeOf(o){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf:function(o){return o.__proto__||Object.getPrototypeOf(o)})(o)}exports.GenericCom={};var GenericPreferences=function(_BasePreferences){_inherits(GenericPreferences,_BasePreferences);var _readFromStorage2,_writeToStorage2,_super=_createSuper(GenericPreferences);function GenericPreferences(){return _classCallCheck(this,GenericPreferences),_super.apply(this,arguments)}return _createClass(GenericPreferences,[{key:"_writeToStorage",value:(_writeToStorage2=_asyncToGenerator(_regenerator.default.mark((function _callee(prefObj){return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:localStorage.setItem("pdfjs.preferences",JSON.stringify(prefObj));case 1:case"end":return _context.stop()}}),_callee)}))),function(_x){return _writeToStorage2.apply(this,arguments)})},{key:"_readFromStorage",value:(_readFromStorage2=_asyncToGenerator(_regenerator.default.mark((function _callee2(prefObj){return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:return _context2.abrupt("return",JSON.parse(localStorage.getItem("pdfjs.preferences")));case 1:case"end":return _context2.stop()}}),_callee2)}))),function(_x2){return _readFromStorage2.apply(this,arguments)})}]),GenericPreferences}(_preferences.BasePreferences),GenericExternalServices=function(_DefaultExternalServi){_inherits(GenericExternalServices,_DefaultExternalServi);var _super2=_createSuper(GenericExternalServices);function GenericExternalServices(){return _classCallCheck(this,GenericExternalServices),_super2.apply(this,arguments)}return _createClass(GenericExternalServices,null,[{key:"createDownloadManager",value:function(options){return new _download_manager.DownloadManager}},{key:"createPreferences",value:function(){return new GenericPreferences}},{key:"createL10n",value:function(_ref){var _ref$locale=_ref.locale,locale=void 0===_ref$locale?"en-US":_ref$locale;return new _genericl10n.GenericL10n(locale)}},{key:"createScripting",value:function(_ref2){var sandboxBundleSrc=_ref2.sandboxBundleSrc;return new _generic_scripting.GenericScripting(sandboxBundleSrc)}}]),GenericExternalServices}(_app.DefaultExternalServices);_app.PDFViewerApplication.externalServices=GenericExternalServices},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.BasePreferences=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj};__webpack_require__(1);function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _typeof(obj){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(obj){return typeof obj}:function(obj){return obj&&"function"==typeof Symbol&&obj.constructor===Symbol&&obj!==Symbol.prototype?"symbol":typeof obj})(obj)}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var BasePreferences=function(){function BasePreferences(){var _this=this;if(function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,BasePreferences),this.constructor===BasePreferences)throw new Error("Cannot initialize BasePreferences.");Object.defineProperty(this,"defaults",{value:Object.freeze({annotationMode:2,cursorToolOnLoad:0,defaultZoomValue:"",disablePageLabels:!1,enablePermissions:!1,enablePrintAutoRotate:!0,enableScripting:!0,externalLinkTarget:0,historyUpdateUrl:!1,ignoreDestinationZoom:!1,pdfBugEnabled:!1,renderer:"canvas",sidebarViewOnLoad:-1,scrollModeOnLoad:-1,spreadModeOnLoad:-1,textLayerMode:1,useOnlyCssZoom:!1,viewerCssTheme:0,viewOnLoad:0,disableAutoFetch:!1,disableFontFace:!1,disableRange:!1,disableStream:!1,enableXfa:!0}),writable:!1,enumerable:!0,configurable:!1}),this.prefs=Object.create(null),this._initializedPromise=this._readFromStorage(this.defaults).then((function(prefs){for(var name in _this.defaults){var prefValue=null==prefs?void 0:prefs[name];_typeof(prefValue)===_typeof(_this.defaults[name])&&(_this.prefs[name]=prefValue)}}))}var Constructor,protoProps,staticProps,_getAll,_get,_set,_reset,_readFromStorage2,_writeToStorage2;return Constructor=BasePreferences,(protoProps=[{key:"_writeToStorage",value:(_writeToStorage2=_asyncToGenerator(_regenerator.default.mark((function _callee(prefObj){return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:throw new Error("Not implemented: _writeToStorage");case 1:case"end":return _context.stop()}}),_callee)}))),function(_x){return _writeToStorage2.apply(this,arguments)})},{key:"_readFromStorage",value:(_readFromStorage2=_asyncToGenerator(_regenerator.default.mark((function _callee2(prefObj){return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:throw new Error("Not implemented: _readFromStorage");case 1:case"end":return _context2.stop()}}),_callee2)}))),function(_x2){return _readFromStorage2.apply(this,arguments)})},{key:"reset",value:(_reset=_asyncToGenerator(_regenerator.default.mark((function _callee3(){return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:return _context3.next=2,this._initializedPromise;case 2:return this.prefs=Object.create(null),_context3.abrupt("return",this._writeToStorage(this.defaults));case 4:case"end":return _context3.stop()}}),_callee3,this)}))),function(){return _reset.apply(this,arguments)})},{key:"set",value:(_set=_asyncToGenerator(_regenerator.default.mark((function _callee4(name,value){var defaultValue,valueType,defaultType;return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:return _context4.next=2,this._initializedPromise;case 2:if(void 0!==(defaultValue=this.defaults[name])){_context4.next=7;break}throw new Error('Set preference: "'.concat(name,'" is undefined.'));case 7:if(void 0!==value){_context4.next=9;break}throw new Error("Set preference: no value is specified.");case 9:if(valueType=_typeof(value),defaultType=_typeof(defaultValue),valueType===defaultType){_context4.next=19;break}if("number"!==valueType||"string"!==defaultType){_context4.next=16;break}value=value.toString(),_context4.next=17;break;case 16:throw new Error('Set preference: "'.concat(value,'" is a ').concat(valueType,", expected a ").concat(defaultType,"."));case 17:_context4.next=21;break;case 19:if("number"!==valueType||Number.isInteger(value)){_context4.next=21;break}throw new Error('Set preference: "'.concat(value,'" must be an integer.'));case 21:return this.prefs[name]=value,_context4.abrupt("return",this._writeToStorage(this.prefs));case 23:case"end":return _context4.stop()}}),_callee4,this)}))),function(_x3,_x4){return _set.apply(this,arguments)})},{key:"get",value:(_get=_asyncToGenerator(_regenerator.default.mark((function _callee5(name){var defaultValue,prefValue;return _regenerator.default.wrap((function(_context5){for(;;)switch(_context5.prev=_context5.next){case 0:return _context5.next=2,this._initializedPromise;case 2:if(defaultValue=this.defaults[name],prefValue=this.prefs[name],void 0!==defaultValue){_context5.next=5;break}throw new Error('Get preference: "'.concat(name,'" is undefined.'));case 5:return _context5.abrupt("return",void 0!==prefValue?prefValue:defaultValue);case 6:case"end":return _context5.stop()}}),_callee5,this)}))),function(_x5){return _get.apply(this,arguments)})},{key:"getAll",value:(_getAll=_asyncToGenerator(_regenerator.default.mark((function _callee6(){var obj,name,prefValue;return _regenerator.default.wrap((function(_context6){for(;;)switch(_context6.prev=_context6.next){case 0:return _context6.next=2,this._initializedPromise;case 2:for(name in obj=Object.create(null),this.defaults)prefValue=this.prefs[name],obj[name]=void 0!==prefValue?prefValue:this.defaults[name];return _context6.abrupt("return",obj);case 5:case"end":return _context6.stop()}}),_callee6,this)}))),function(){return _getAll.apply(this,arguments)})}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),BasePreferences}();exports.BasePreferences=BasePreferences},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.DownloadManager=void 0;var _pdfjsLib=__webpack_require__(6),_app_options=__webpack_require__(1);function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function _download(blobUrl,filename){var a=document.createElement("a");if(!a.click)throw new Error('DownloadManager: "a.click()" is not supported.');a.href=blobUrl,a.target="_parent","download"in a&&(a.download=filename),(document.body||document.documentElement).appendChild(a),a.click(),a.remove()}var DownloadManager=function(){function DownloadManager(){!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,DownloadManager),this._openBlobUrls=new WeakMap}var Constructor,protoProps,staticProps;return Constructor=DownloadManager,(protoProps=[{key:"downloadUrl",value:function(url,filename){(0,_pdfjsLib.createValidAbsoluteUrl)(url,"http://example.com")&&_download(url+"#pdfjs.action=download",filename)}},{key:"downloadData",value:function(data,filename,contentType){_download((0,_pdfjsLib.createObjectURL)(data,contentType,_app_options.compatibilityParams.disableCreateObjectURL),filename)}},{key:"openOrDownloadData",value:function(element,data,filename){var isPdfData=(0,_pdfjsLib.isPdfFile)(filename),contentType=isPdfData?"application/pdf":"";if(isPdfData&&!_app_options.compatibilityParams.disableCreateObjectURL){var viewerUrl,blobUrl=this._openBlobUrls.get(element);blobUrl||(blobUrl=URL.createObjectURL(new Blob([data],{type:contentType})),this._openBlobUrls.set(element,blobUrl)),viewerUrl="?file="+encodeURIComponent(blobUrl+"#"+filename);try{return window.open(viewerUrl),!0}catch(ex){console.error("openOrDownloadData: ".concat(ex)),URL.revokeObjectURL(blobUrl),this._openBlobUrls.delete(element)}}return this.downloadData(data,filename,contentType),!1}},{key:"download",value:function(blob,url,filename){if(_app_options.compatibilityParams.disableCreateObjectURL)this.downloadUrl(url,filename);else{var blobUrl=URL.createObjectURL(blob);_download(blobUrl,filename)}}}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),DownloadManager}();exports.DownloadManager=DownloadManager},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.GenericL10n=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj};__webpack_require__(45);var _l10n_utils=__webpack_require__(31);function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}var webL10n=document.webL10n,GenericL10n=function(){function GenericL10n(lang){!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,GenericL10n),this._lang=lang,this._ready=new Promise((function(resolve,reject){webL10n.setLanguage((0,_l10n_utils.fixupLangCode)(lang),(function(){resolve(webL10n)}))}))}var Constructor,protoProps,staticProps,_translate,_get,_getDirection,_getLanguage;return Constructor=GenericL10n,(protoProps=[{key:"getLanguage",value:(_getLanguage=_asyncToGenerator(_regenerator.default.mark((function _callee(){var l10n;return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:return _context.next=2,this._ready;case 2:return l10n=_context.sent,_context.abrupt("return",l10n.getLanguage());case 4:case"end":return _context.stop()}}),_callee,this)}))),function(){return _getLanguage.apply(this,arguments)})},{key:"getDirection",value:(_getDirection=_asyncToGenerator(_regenerator.default.mark((function _callee2(){var l10n;return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:return _context2.next=2,this._ready;case 2:return l10n=_context2.sent,_context2.abrupt("return",l10n.getDirection());case 4:case"end":return _context2.stop()}}),_callee2,this)}))),function(){return _getDirection.apply(this,arguments)})},{key:"get",value:(_get=_asyncToGenerator(_regenerator.default.mark((function _callee3(key){var args,fallback,l10n,_args3=arguments;return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:return args=_args3.length>1&&void 0!==_args3[1]?_args3[1]:null,fallback=_args3.length>2&&void 0!==_args3[2]?_args3[2]:(0,_l10n_utils.getL10nFallback)(key,args),_context3.next=4,this._ready;case 4:return l10n=_context3.sent,_context3.abrupt("return",l10n.get(key,args,fallback));case 6:case"end":return _context3.stop()}}),_callee3,this)}))),function(_x){return _get.apply(this,arguments)})},{key:"translate",value:(_translate=_asyncToGenerator(_regenerator.default.mark((function _callee4(element){var l10n;return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:return _context4.next=2,this._ready;case 2:return l10n=_context4.sent,_context4.abrupt("return",l10n.translate(element));case 4:case"end":return _context4.stop()}}),_callee4,this)}))),function(_x2){return _translate.apply(this,arguments)})}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),GenericL10n}();exports.GenericL10n=GenericL10n},()=>{document.webL10n=function(window,document,undefined){var gL10nData={},gTextData="",gTextProp="textContent",gLanguage="",gMacros={},gReadyState="loading";function xhrLoadText(url,onSuccess,onFailure){onSuccess=onSuccess||function(data){},onFailure=onFailure||function(){};var xhr=new XMLHttpRequest;xhr.open("GET",url,true),xhr.overrideMimeType&&xhr.overrideMimeType("text/plain; charset=utf-8"),xhr.onreadystatechange=function(){4==xhr.readyState&&(200==xhr.status||0===xhr.status?onSuccess(xhr.responseText):onFailure())},xhr.onerror=onFailure,xhr.ontimeout=onFailure;try{xhr.send(null)}catch(e){onFailure()}}function parseResource(href,lang,successCallback,failureCallback){var baseURL=href.replace(/[^\/]*$/,"")||"./";function evalString(text){return text.lastIndexOf("\\")<0?text:text.replace(/\\\\/g,"\\").replace(/\\n/g,"\n").replace(/\\r/g,"\r").replace(/\\t/g,"\t").replace(/\\b/g,"\b").replace(/\\f/g,"\f").replace(/\\{/g,"{").replace(/\\}/g,"}").replace(/\\"/g,'"').replace(/\\'/g,"'")}xhrLoadText(href,(function(response){gTextData+=response,function(text,parsedPropertiesCallback){var dictionary={},reBlank=/^\s*|\s*$/,reComment=/^\s*#|^\s*$/,reSection=/^\s*\[(.*)\]\s*$/,reImport=/^\s*@import\s+url\((.*)\)\s*$/i,reSplit=/^([^=\s]*)\s*=\s*(.+)$/;function parseRawLines(rawText,extendedSyntax,parsedRawLinesCallback){var entries=rawText.replace(reBlank,"").split(/[\r\n]+/),currentLang="*",genericLang=lang.split("-",1)[0],skipLang=!1,match="";!function nextEntry(){for(;;){if(!entries.length)return void parsedRawLinesCallback();var line=entries.shift();if(!reComment.test(line)){if(extendedSyntax){if(match=reSection.exec(line)){currentLang=match[1].toLowerCase(),skipLang="*"!==currentLang&&currentLang!==lang&&currentLang!==genericLang;continue}if(skipLang)continue;if(match=reImport.exec(line))return void loadImport(baseURL+match[1],nextEntry)}var tmp=line.match(reSplit);tmp&&3==tmp.length&&(dictionary[tmp[1]]=evalString(tmp[2]))}}}()}function loadImport(url,callback){xhrLoadText(url,(function(content){parseRawLines(content,!1,callback)}),(function(){console.warn(url+" not found."),callback()}))}parseRawLines(text,!0,(function(){parsedPropertiesCallback(dictionary)}))}(response,(function(data){for(var key in data){var id,prop,index=key.lastIndexOf(".");index>0?(id=key.substring(0,index),prop=key.substring(index+1)):(id=key,prop=gTextProp),gL10nData[id]||(gL10nData[id]={}),gL10nData[id][prop]=data[key]}successCallback&&successCallback()}))}),failureCallback)}function loadLocale(lang,callback){lang&&(lang=lang.toLowerCase()),callback=callback||function(){},gL10nData={},gTextData="",gLanguage="",gLanguage=lang;var langLinks=document.querySelectorAll('link[type="application/l10n"]'),langCount=langLinks.length;if(0!==langCount){var script,onResourceLoaded,gResourceCount=0;onResourceLoaded=function(){++gResourceCount>=langCount&&(callback(),gReadyState="complete")};for(var i=0;i<langCount;i++){new L10nResourceLink(langLinks[i]).load(lang,onResourceLoaded)}}else{var dict=(script=document.querySelector('script[type="application/l10n"]'))?JSON.parse(script.innerHTML):null;if(dict&&dict.locales&&dict.default_locale){if(console.log("using the embedded JSON directory, early way out"),!(gL10nData=dict.locales[lang])){var defaultLocale=dict.default_locale.toLowerCase();for(var anyCaseLang in dict.locales){if((anyCaseLang=anyCaseLang.toLowerCase())===lang){gL10nData=dict.locales[lang];break}anyCaseLang===defaultLocale&&(gL10nData=dict.locales[defaultLocale])}}callback()}else console.log("no resource to load, early way out");gReadyState="complete"}function L10nResourceLink(link){var href=link.href;this.load=function(lang,callback){parseResource(href,lang,callback,(function(){console.warn(href+" not found."),console.warn('"'+lang+'" resource not found'),gLanguage="",callback()}))}}}function getL10nData(key,args,fallback){var data=gL10nData[key];if(!data){if(console.warn("#"+key+" is undefined."),!fallback)return null;data=fallback}var rv={};for(var prop in data){var str=data[prop];str=substArguments(str=substIndexes(str,args,key,prop),args,key),rv[prop]=str}return rv}function substIndexes(str,args,key,prop){var reMatch=/\{\[\s*([a-zA-Z]+)\(([a-zA-Z]+)\)\s*\]\}/.exec(str);if(!reMatch||!reMatch.length)return str;var param,macroName=reMatch[1],paramName=reMatch[2];(args&&paramName in args?param=args[paramName]:paramName in gL10nData&&(param=gL10nData[paramName]),macroName in gMacros)&&(str=(0,gMacros[macroName])(str,param,key,prop));return str}function substArguments(str,args,key){return str.replace(/\{\{\s*(.+?)\s*\}\}/g,(function(matched_text,arg){return args&&arg in args?args[arg]:arg in gL10nData?gL10nData[arg]:(console.log("argument {{"+arg+"}} for #"+key+" is undefined."),matched_text)}))}function translateElement(element){var l10n=function(element){if(!element)return{};var l10nId=element.getAttribute("data-l10n-id"),l10nArgs=element.getAttribute("data-l10n-args"),args={};if(l10nArgs)try{args=JSON.parse(l10nArgs)}catch(e){console.warn("could not parse arguments for #"+l10nId)}return{id:l10nId,args:args}}(element);if(l10n.id){var data=getL10nData(l10n.id,l10n.args);if(data){if(data[gTextProp]){if(0===function(element){if(element.children)return element.children.length;if(void 0!==element.childElementCount)return element.childElementCount;for(var count=0,i=0;i<element.childNodes.length;i++)count+=1===element.nodeType?1:0;return count}(element))element[gTextProp]=data[gTextProp];else{for(var children=element.childNodes,found=!1,i=0,l=children.length;i<l;i++)3===children[i].nodeType&&/\S/.test(children[i].nodeValue)&&(found?children[i].nodeValue="":(children[i].nodeValue=data[gTextProp],found=!0));if(!found){var textNode=document.createTextNode(data[gTextProp]);element.insertBefore(textNode,element.firstChild)}}delete data[gTextProp]}for(var k in data)element[k]=data[k]}else console.warn("#"+l10n.id+" is undefined.")}}return gMacros.plural=function(str,param,key,prop){var n=parseFloat(param);if(isNaN(n))return str;if(prop!=gTextProp)return str;gMacros._pluralRules||(gMacros._pluralRules=function(lang){function isIn(n,list){return-1!==list.indexOf(n)}function isBetween(n,start,end){return start<=n&&n<=end}var pluralRules={0:function(n){return"other"},1:function(n){return isBetween(n%100,3,10)?"few":0===n?"zero":isBetween(n%100,11,99)?"many":2==n?"two":1==n?"one":"other"},2:function(n){return 0!==n&&n%10==0?"many":2==n?"two":1==n?"one":"other"},3:function(n){return 1==n?"one":"other"},4:function(n){return isBetween(n,0,1)?"one":"other"},5:function(n){return isBetween(n,0,2)&&2!=n?"one":"other"},6:function(n){return 0===n?"zero":n%10==1&&n%100!=11?"one":"other"},7:function(n){return 2==n?"two":1==n?"one":"other"},8:function(n){return isBetween(n,3,6)?"few":isBetween(n,7,10)?"many":2==n?"two":1==n?"one":"other"},9:function(n){return 0===n||1!=n&&isBetween(n%100,1,19)?"few":1==n?"one":"other"},10:function(n){return isBetween(n%10,2,9)&&!isBetween(n%100,11,19)?"few":n%10!=1||isBetween(n%100,11,19)?"other":"one"},11:function(n){return isBetween(n%10,2,4)&&!isBetween(n%100,12,14)?"few":n%10==0||isBetween(n%10,5,9)||isBetween(n%100,11,14)?"many":n%10==1&&n%100!=11?"one":"other"},12:function(n){return isBetween(n,2,4)?"few":1==n?"one":"other"},13:function(n){return isBetween(n%10,2,4)&&!isBetween(n%100,12,14)?"few":1!=n&&isBetween(n%10,0,1)||isBetween(n%10,5,9)||isBetween(n%100,12,14)?"many":1==n?"one":"other"},14:function(n){return isBetween(n%100,3,4)?"few":n%100==2?"two":n%100==1?"one":"other"},15:function(n){return 0===n||isBetween(n%100,2,10)?"few":isBetween(n%100,11,19)?"many":1==n?"one":"other"},16:function(n){return n%10==1&&11!=n?"one":"other"},17:function(n){return 3==n?"few":0===n?"zero":6==n?"many":2==n?"two":1==n?"one":"other"},18:function(n){return 0===n?"zero":isBetween(n,0,2)&&0!==n&&2!=n?"one":"other"},19:function(n){return isBetween(n,2,10)?"few":isBetween(n,0,1)?"one":"other"},20:function(n){return!isBetween(n%10,3,4)&&n%10!=9||isBetween(n%100,10,19)||isBetween(n%100,70,79)||isBetween(n%100,90,99)?n%1e6==0&&0!==n?"many":n%10!=2||isIn(n%100,[12,72,92])?n%10!=1||isIn(n%100,[11,71,91])?"other":"one":"two":"few"},21:function(n){return 0===n?"zero":1==n?"one":"other"},22:function(n){return isBetween(n,0,1)||isBetween(n,11,99)?"one":"other"},23:function(n){return isBetween(n%10,1,2)||n%20==0?"one":"other"},24:function(n){return isBetween(n,3,10)||isBetween(n,13,19)?"few":isIn(n,[2,12])?"two":isIn(n,[1,11])?"one":"other"}},index={af:3,ak:4,am:4,ar:1,asa:3,az:0,be:11,bem:3,bez:3,bg:3,bh:4,bm:0,bn:3,bo:0,br:20,brx:3,bs:11,ca:3,cgg:3,chr:3,cs:12,cy:17,da:3,de:3,dv:3,dz:0,ee:3,el:3,en:3,eo:3,es:3,et:3,eu:3,fa:0,ff:5,fi:3,fil:4,fo:3,fr:5,fur:3,fy:3,ga:8,gd:24,gl:3,gsw:3,gu:3,guw:4,gv:23,ha:3,haw:3,he:2,hi:4,hr:11,hu:0,id:0,ig:0,ii:0,is:3,it:3,iu:7,ja:0,jmc:3,jv:0,ka:0,kab:5,kaj:3,kcg:3,kde:0,kea:0,kk:3,kl:3,km:0,kn:0,ko:0,ksb:3,ksh:21,ku:3,kw:7,lag:18,lb:3,lg:3,ln:4,lo:0,lt:10,lv:6,mas:3,mg:4,mk:16,ml:3,mn:3,mo:9,mr:3,ms:0,mt:15,my:0,nah:3,naq:7,nb:3,nd:3,ne:3,nl:3,nn:3,no:3,nr:3,nso:4,ny:3,nyn:3,om:3,or:3,pa:3,pap:3,pl:13,ps:3,pt:3,rm:3,ro:9,rof:3,ru:11,rwk:3,sah:0,saq:3,se:7,seh:3,ses:0,sg:0,sh:11,shi:19,sk:12,sl:14,sma:7,smi:7,smj:7,smn:7,sms:7,sn:3,so:3,sq:3,sr:11,ss:3,ssy:3,st:3,sv:3,sw:3,syr:3,ta:3,te:3,teo:3,th:0,ti:4,tig:3,tk:3,tl:4,tn:3,to:0,tr:0,ts:3,tzm:22,uk:11,ur:3,ve:3,vi:0,vun:3,wa:4,wae:3,wo:0,xh:3,xog:3,yo:0,zh:0,zu:3}[lang.replace(/-.*$/,"")];return index in pluralRules?pluralRules[index]:(console.warn("plural form unknown for ["+lang+"]"),function(){return"other"})}(gLanguage));var index="["+gMacros._pluralRules(n)+"]";return 0===n&&key+"[zero]"in gL10nData?str=gL10nData[key+"[zero]"][prop]:1==n&&key+"[one]"in gL10nData?str=gL10nData[key+"[one]"][prop]:2==n&&key+"[two]"in gL10nData?str=gL10nData[key+"[two]"][prop]:key+index in gL10nData?str=gL10nData[key+index][prop]:key+"[other]"in gL10nData&&(str=gL10nData[key+"[other]"][prop]),str},{get:function(key,args,fallbackString){var fallback,index=key.lastIndexOf("."),prop=gTextProp;index>0&&(prop=key.substring(index+1),key=key.substring(0,index)),fallbackString&&((fallback={})[prop]=fallbackString);var data=getL10nData(key,args,fallback);return data&&prop in data?data[prop]:"{{"+key+"}}"},getData:function(){return gL10nData},getText:function(){return gTextData},getLanguage:function(){return gLanguage},setLanguage:function(lang,callback){loadLocale(lang,(function(){callback&&callback()}))},getDirection:function(){var shortCode=gLanguage.split("-",1)[0];return["ar","he","fa","ps","ur"].indexOf(shortCode)>=0?"rtl":"ltr"},translate:function(element){for(var children=function(element){return element?element.querySelectorAll("*[data-l10n-id]"):[]}(element=element||document.documentElement),elementCount=children.length,i=0;i<elementCount;i++)translateElement(children[i]);translateElement(element)},getReadyState:function(){return gReadyState},ready:function(callback){callback&&("complete"==gReadyState||"interactive"==gReadyState?window.setTimeout((function(){callback()})):document.addEventListener&&document.addEventListener("localized",(function once(){document.removeEventListener("localized",once),callback()})))}}}(window,document)},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.docPropertiesLookup=function(_x){return _docPropertiesLookup.apply(this,arguments)},exports.GenericScripting=void 0;var obj,_regenerator=(obj=__webpack_require__(3))&&obj.__esModule?obj:{default:obj},_pdfjsLib=__webpack_require__(6);function ownKeys(object,enumerableOnly){var keys=Object.keys(object);if(Object.getOwnPropertySymbols){var symbols=Object.getOwnPropertySymbols(object);enumerableOnly&&(symbols=symbols.filter((function(sym){return Object.getOwnPropertyDescriptor(object,sym).enumerable}))),keys.push.apply(keys,symbols)}return keys}function _objectSpread(target){for(var i=1;i<arguments.length;i++){var source=null!=arguments[i]?arguments[i]:{};i%2?ownKeys(Object(source),!0).forEach((function(key){_defineProperty(target,key,source[key])})):Object.getOwnPropertyDescriptors?Object.defineProperties(target,Object.getOwnPropertyDescriptors(source)):ownKeys(Object(source)).forEach((function(key){Object.defineProperty(target,key,Object.getOwnPropertyDescriptor(source,key))}))}return target}function _defineProperty(obj,key,value){return key in obj?Object.defineProperty(obj,key,{value:value,enumerable:!0,configurable:!0,writable:!0}):obj[key]=value,obj}function _defineProperties(target,props){for(var i=0;i<props.length;i++){var descriptor=props[i];descriptor.enumerable=descriptor.enumerable||!1,descriptor.configurable=!0,"value"in descriptor&&(descriptor.writable=!0),Object.defineProperty(target,descriptor.key,descriptor)}}function asyncGeneratorStep(gen,resolve,reject,_next,_throw,key,arg){try{var info=gen[key](arg),value=info.value}catch(error){return void reject(error)}info.done?resolve(value):Promise.resolve(value).then(_next,_throw)}function _asyncToGenerator(fn){return function(){var self=this,args=arguments;return new Promise((function(resolve,reject){var gen=fn.apply(self,args);function _next(value){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"next",value)}function _throw(err){asyncGeneratorStep(gen,resolve,reject,_next,_throw,"throw",err)}_next(void 0)}))}}function _docPropertiesLookup(){return(_docPropertiesLookup=_asyncToGenerator(_regenerator.default.mark((function _callee4(pdfDocument){var url,baseUrl,_yield$pdfDocument$ge,info,metadata,contentDispositionFilename,contentLength,_yield$pdfDocument$ge2,length;return _regenerator.default.wrap((function(_context4){for(;;)switch(_context4.prev=_context4.next){case 0:return baseUrl=(url="").split("#")[0],_context4.next=3,pdfDocument.getMetadata();case 3:if(_yield$pdfDocument$ge=_context4.sent,info=_yield$pdfDocument$ge.info,metadata=_yield$pdfDocument$ge.metadata,contentDispositionFilename=_yield$pdfDocument$ge.contentDispositionFilename,contentLength=_yield$pdfDocument$ge.contentLength){_context4.next=14;break}return _context4.next=11,pdfDocument.getDownloadInfo();case 11:_yield$pdfDocument$ge2=_context4.sent,length=_yield$pdfDocument$ge2.length,contentLength=length;case 14:return _context4.abrupt("return",_objectSpread(_objectSpread({},info),{},{baseURL:baseUrl,filesize:contentLength,filename:contentDispositionFilename||(0,_pdfjsLib.getPdfFilenameFromUrl)(url),metadata:null==metadata?void 0:metadata.getRaw(),authors:null==metadata?void 0:metadata.get("dc:creator"),numPages:pdfDocument.numPages,URL:url}));case 15:case"end":return _context4.stop()}}),_callee4)})))).apply(this,arguments)}var GenericScripting=function(){function GenericScripting(sandboxBundleSrc){!function(instance,Constructor){if(!(instance instanceof Constructor))throw new TypeError("Cannot call a class as a function")}(this,GenericScripting),this._ready=(0,_pdfjsLib.loadScript)(sandboxBundleSrc,!0).then((function(){return window.pdfjsSandbox.QuickJSSandbox()}))}var Constructor,protoProps,staticProps,_destroySandbox,_dispatchEventInSandbox,_createSandbox;return Constructor=GenericScripting,(protoProps=[{key:"createSandbox",value:(_createSandbox=_asyncToGenerator(_regenerator.default.mark((function _callee(data){return _regenerator.default.wrap((function(_context){for(;;)switch(_context.prev=_context.next){case 0:return _context.next=2,this._ready;case 2:_context.sent.create(data);case 4:case"end":return _context.stop()}}),_callee,this)}))),function(_x2){return _createSandbox.apply(this,arguments)})},{key:"dispatchEventInSandbox",value:(_dispatchEventInSandbox=_asyncToGenerator(_regenerator.default.mark((function _callee2(event){return _regenerator.default.wrap((function(_context2){for(;;)switch(_context2.prev=_context2.next){case 0:return _context2.next=2,this._ready;case 2:_context2.sent.dispatchEvent(event);case 4:case"end":return _context2.stop()}}),_callee2,this)}))),function(_x3){return _dispatchEventInSandbox.apply(this,arguments)})},{key:"destroySandbox",value:(_destroySandbox=_asyncToGenerator(_regenerator.default.mark((function _callee3(){return _regenerator.default.wrap((function(_context3){for(;;)switch(_context3.prev=_context3.next){case 0:return _context3.next=2,this._ready;case 2:_context3.sent.nukeSandbox();case 4:case"end":return _context3.stop()}}),_callee3,this)}))),function(){return _destroySandbox.apply(this,arguments)})}])&&_defineProperties(Constructor.prototype,protoProps),staticProps&&_defineProperties(Constructor,staticProps),GenericScripting}();exports.GenericScripting=GenericScripting},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.PDFPrintService=PDFPrintService;var _pdfjsLib=__webpack_require__(6),_app=__webpack_require__(2),_app_options=__webpack_require__(1),_print_utils=__webpack_require__(48),activeService=null,overlayManager=null;function PDFPrintService(pdfDocument,pagesOverview,printContainer,printResolution){var optionalContentConfigPromise=arguments.length>4&&void 0!==arguments[4]?arguments[4]:null,l10n=arguments.length>5?arguments[5]:void 0;this.pdfDocument=pdfDocument,this.pagesOverview=pagesOverview,this.printContainer=printContainer,this._printResolution=printResolution||150,this._optionalContentConfigPromise=optionalContentConfigPromise||pdfDocument.getOptionalContentConfig(),this.l10n=l10n,this.currentPage=-1,this.scratchCanvas=document.createElement("canvas")}PDFPrintService.prototype={layout:function(){this.throwIfInactive();var body=document.querySelector("body");body.setAttribute("data-pdfjsprinting",!0),this.pagesOverview.every((function(size){return size.width===this.pagesOverview[0].width&&size.height===this.pagesOverview[0].height}),this)||console.warn("Not all pages have the same size. The printed result may be incorrect!"),this.pageStyleSheet=document.createElement("style");var pageSize=this.pagesOverview[0];this.pageStyleSheet.textContent="@page { size: "+pageSize.width+"pt "+pageSize.height+"pt;}",body.appendChild(this.pageStyleSheet)},destroy:function(){activeService===this&&(this.printContainer.textContent="",document.querySelector("body").removeAttribute("data-pdfjsprinting"),this.pageStyleSheet&&(this.pageStyleSheet.remove(),this.pageStyleSheet=null),this.scratchCanvas.width=this.scratchCanvas.height=0,this.scratchCanvas=null,activeService=null,ensureOverlay().then((function(){"printServiceOverlay"===overlayManager.active&&overlayManager.close("printServiceOverlay")})))},renderPages:function(){var _this=this;if(this.pdfDocument.isPureXfa)return(0,_print_utils.getXfaHtmlForPrinting)(this.printContainer,this.pdfDocument),Promise.resolve();var pageCount=this.pagesOverview.length;return new Promise((function renderNextPage(resolve,reject){if(_this.throwIfInactive(),++_this.currentPage>=pageCount)return renderProgress(pageCount,pageCount,_this.l10n),void resolve();var index=_this.currentPage;renderProgress(index,pageCount,_this.l10n),function(activeServiceOnEntry,pdfDocument,pageNumber,size,printResolution,optionalContentConfigPromise){var scratchCanvas=activeService.scratchCanvas,PRINT_UNITS=printResolution/_pdfjsLib.PixelsPerInch.PDF;scratchCanvas.width=Math.floor(size.width*PRINT_UNITS),scratchCanvas.height=Math.floor(size.height*PRINT_UNITS);var ctx=scratchCanvas.getContext("2d");return ctx.save(),ctx.fillStyle="rgb(255, 255, 255)",ctx.fillRect(0,0,scratchCanvas.width,scratchCanvas.height),ctx.restore(),pdfDocument.getPage(pageNumber).then((function(pdfPage){var renderContext={canvasContext:ctx,transform:[PRINT_UNITS,0,0,PRINT_UNITS,0,0],viewport:pdfPage.getViewport({scale:1,rotation:size.rotation}),intent:"print",annotationMode:_pdfjsLib.AnnotationMode.ENABLE_STORAGE,optionalContentConfigPromise:optionalContentConfigPromise};return pdfPage.render(renderContext).promise}))}(0,_this.pdfDocument,index+1,_this.pagesOverview[index],_this._printResolution,_this._optionalContentConfigPromise).then(_this.useRenderedPage.bind(_this)).then((function(){renderNextPage(resolve,reject)}),reject)}))},useRenderedPage:function(){this.throwIfInactive();var img=document.createElement("img"),scratchCanvas=this.scratchCanvas;"toBlob"in scratchCanvas&&!_app_options.compatibilityParams.disableCreateObjectURL?scratchCanvas.toBlob((function(blob){img.src=URL.createObjectURL(blob)})):img.src=scratchCanvas.toDataURL();var wrapper=document.createElement("div");return wrapper.className="printedPage",wrapper.appendChild(img),this.printContainer.appendChild(wrapper),new Promise((function(resolve,reject){img.onload=resolve,img.onerror=reject}))},performPrint:function(){var _this2=this;return this.throwIfInactive(),new Promise((function(resolve){setTimeout((function(){_this2.active?(print.call(window),setTimeout(resolve,20)):resolve()}),0)}))},get active(){return this===activeService},throwIfInactive:function(){if(!this.active)throw new Error("This print request was cancelled or completed.")}};var overlayPromise,print=window.print;function dispatchEvent(eventType){var event=document.createEvent("CustomEvent");event.initCustomEvent(eventType,!1,!1,"custom"),window.dispatchEvent(event)}function abort(){activeService&&(activeService.destroy(),dispatchEvent("afterprint"))}function renderProgress(index,total,l10n){var progressContainer=document.getElementById("printServiceOverlay"),progress=Math.round(100*index/total),progressBar=progressContainer.querySelector("progress"),progressPerc=progressContainer.querySelector(".relative-progress");progressBar.value=progress,l10n.get("print_progress_percent",{progress:progress}).then((function(msg){progressPerc.textContent=msg}))}if(window.print=function(){if(activeService)console.warn("Ignored window.print() because of a pending print job.");else{ensureOverlay().then((function(){activeService&&overlayManager.open("printServiceOverlay")}));try{dispatchEvent("beforeprint")}finally{if(!activeService)return console.error("Expected print service to be initialized."),void ensureOverlay().then((function(){"printServiceOverlay"===overlayManager.active&&overlayManager.close("printServiceOverlay")}));var activeServiceOnEntry=activeService;activeService.renderPages().then((function(){return activeServiceOnEntry.performPrint()})).catch((function(){})).then((function(){activeServiceOnEntry.active&&abort()}))}}},window.addEventListener("keydown",(function(event){80!==event.keyCode||!event.ctrlKey&&!event.metaKey||event.altKey||event.shiftKey&&!window.chrome&&!window.opera||(window.print(),event.preventDefault(),event.stopImmediatePropagation?event.stopImmediatePropagation():event.stopPropagation())}),!0),"onbeforeprint"in window){var stopPropagationIfNeeded=function(event){"custom"!==event.detail&&event.stopImmediatePropagation&&event.stopImmediatePropagation()};window.addEventListener("beforeprint",stopPropagationIfNeeded),window.addEventListener("afterprint",stopPropagationIfNeeded)}function ensureOverlay(){if(!overlayPromise){if(!(overlayManager=_app.PDFViewerApplication.overlayManager))throw new Error("The overlay manager has not yet been initialized.");overlayPromise=overlayManager.register("printServiceOverlay",document.getElementById("printServiceOverlay"),abort,!0),document.getElementById("printCancel").onclick=abort}return overlayPromise}_app.PDFPrintServiceFactory.instance={supportsPrinting:!0,createPrintService:function(pdfDocument,pagesOverview,printContainer,printResolution,optionalContentConfigPromise,l10n){if(activeService)throw new Error("The print service is created and active.");return activeService=new PDFPrintService(pdfDocument,pagesOverview,printContainer,printResolution,optionalContentConfigPromise,l10n)}}},(__unused_webpack_module,exports,__webpack_require__)=>{Object.defineProperty(exports,"__esModule",{value:!0}),exports.getXfaHtmlForPrinting=function(printContainer,pdfDocument){var _step,xfaHtml=pdfDocument.allXfaHtml,factory=new _xfa_layer_builder.DefaultXfaLayerFactory,scale=Math.round(100*_ui_utils.CSS_UNITS)/100,_iterator=function(o,allowArrayLike){var it="undefined"!=typeof Symbol&&o[Symbol.iterator]||o["@@iterator"];if(!it){if(Array.isArray(o)||(it=function(o,minLen){if(!o)return;if("string"==typeof o)return _arrayLikeToArray(o,minLen);var n=Object.prototype.toString.call(o).slice(8,-1);"Object"===n&&o.constructor&&(n=o.constructor.name);if("Map"===n||"Set"===n)return Array.from(o);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return _arrayLikeToArray(o,minLen)}(o))||allowArrayLike&&o&&"number"==typeof o.length){it&&(o=it);var i=0,F=function(){};return{s:F,n:function(){return i>=o.length?{done:!0}:{done:!1,value:o[i++]}},e:function(_e){throw _e},f:F}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var err,normalCompletion=!0,didErr=!1;return{s:function(){it=it.call(o)},n:function(){var step=it.next();return normalCompletion=step.done,step},e:function(_e2){didErr=!0,err=_e2},f:function(){try{normalCompletion||null==it.return||it.return()}finally{if(didErr)throw err}}}}(xfaHtml.children);try{for(_iterator.s();!(_step=_iterator.n()).done;){var xfaPage=_step.value,page=document.createElement("div");page.className="xfaPrintedPage",printContainer.appendChild(page);var builder=factory.createXfaLayerBuilder(page,null,pdfDocument.annotationStorage,xfaPage),viewport=(0,_pdfjsLib.getXfaPageViewport)(xfaPage,{scale:scale});builder.render(viewport,"print")}}catch(err){_iterator.e(err)}finally{_iterator.f()}};var _ui_utils=__webpack_require__(5),_xfa_layer_builder=__webpack_require__(36),_pdfjsLib=__webpack_require__(6);function _arrayLikeToArray(arr,len){(null==len||len>arr.length)&&(len=arr.length);for(var i=0,arr2=new Array(len);i<len;i++)arr2[i]=arr[i];return arr2}}],__webpack_module_cache__={};function __webpack_require__(moduleId){var cachedModule=__webpack_module_cache__[moduleId];if(void 0!==cachedModule)return cachedModule.exports;var module=__webpack_module_cache__[moduleId]={id:moduleId,loaded:!1,exports:{}};return __webpack_modules__[moduleId](module,module.exports,__webpack_require__),module.loaded=!0,module.exports}__webpack_require__.nmd=module=>(module.paths=[],module.children||(module.children=[]),module);var __webpack_exports__={};(()=>{var exports=__webpack_exports__;Object.defineProperty(exports,"__esModule",{value:!0}),Object.defineProperty(exports,"PDFViewerApplicationOptions",{enumerable:!0,get:function(){return _app_options.AppOptions}}),Object.defineProperty(exports,"PDFViewerApplication",{enumerable:!0,get:function(){return _app.PDFViewerApplication}});var _app_options=__webpack_require__(1),_app=__webpack_require__(2);function webViewerLoad(){var errorWrapper,config=(errorWrapper={container:document.getElementById("errorWrapper"),errorMessage:document.getElementById("errorMessage"),closeButton:document.getElementById("errorClose"),errorMoreInfo:document.getElementById("errorMoreInfo"),moreInfoButton:document.getElementById("errorShowMore"),lessInfoButton:document.getElementById("errorShowLess")},{appContainer:document.body,mainContainer:document.getElementById("viewerContainer"),viewerContainer:document.getElementById("viewer"),eventBus:null,toolbar:{container:document.getElementById("toolbarViewer"),numPages:document.getElementById("numPages"),pageNumber:document.getElementById("pageNumber"),scaleSelect:document.getElementById("scaleSelect"),customScaleOption:document.getElementById("customScaleOption"),previous:document.getElementById("previous"),next:document.getElementById("next"),zoomIn:document.getElementById("zoomIn"),zoomOut:document.getElementById("zoomOut"),viewFind:document.getElementById("viewFind"),openFile:document.getElementById("openFile"),print:document.getElementById("print"),presentationModeButton:document.getElementById("presentationMode"),download:document.getElementById("download"),viewBookmark:document.getElementById("viewBookmark")},secondaryToolbar:{toolbar:document.getElementById("secondaryToolbar"),toggleButton:document.getElementById("secondaryToolbarToggle"),toolbarButtonContainer:document.getElementById("secondaryToolbarButtonContainer"),presentationModeButton:document.getElementById("secondaryPresentationMode"),openFileButton:document.getElementById("secondaryOpenFile"),printButton:document.getElementById("secondaryPrint"),downloadButton:document.getElementById("secondaryDownload"),viewBookmarkButton:document.getElementById("secondaryViewBookmark"),firstPageButton:document.getElementById("firstPage"),lastPageButton:document.getElementById("lastPage"),pageRotateCwButton:document.getElementById("pageRotateCw"),pageRotateCcwButton:document.getElementById("pageRotateCcw"),cursorSelectToolButton:document.getElementById("cursorSelectTool"),cursorHandToolButton:document.getElementById("cursorHandTool"),scrollVerticalButton:document.getElementById("scrollVertical"),scrollHorizontalButton:document.getElementById("scrollHorizontal"),scrollWrappedButton:document.getElementById("scrollWrapped"),spreadNoneButton:document.getElementById("spreadNone"),spreadOddButton:document.getElementById("spreadOdd"),spreadEvenButton:document.getElementById("spreadEven"),documentPropertiesButton:document.getElementById("documentProperties")},sidebar:{outerContainer:document.getElementById("outerContainer"),viewerContainer:document.getElementById("viewerContainer"),toggleButton:document.getElementById("sidebarToggle"),thumbnailButton:document.getElementById("viewThumbnail"),outlineButton:document.getElementById("viewOutline"),attachmentsButton:document.getElementById("viewAttachments"),layersButton:document.getElementById("viewLayers"),thumbnailView:document.getElementById("thumbnailView"),outlineView:document.getElementById("outlineView"),attachmentsView:document.getElementById("attachmentsView"),layersView:document.getElementById("layersView"),outlineOptionsContainer:document.getElementById("outlineOptionsContainer"),currentOutlineItemButton:document.getElementById("currentOutlineItem")},sidebarResizer:{outerContainer:document.getElementById("outerContainer"),resizer:document.getElementById("sidebarResizer")},findBar:{bar:document.getElementById("findbar"),toggleButton:document.getElementById("viewFind"),findField:document.getElementById("findInput"),highlightAllCheckbox:document.getElementById("findHighlightAll"),caseSensitiveCheckbox:document.getElementById("findMatchCase"),entireWordCheckbox:document.getElementById("findEntireWord"),findMsg:document.getElementById("findMsg"),findResultsCount:document.getElementById("findResultsCount"),findPreviousButton:document.getElementById("findPrevious"),findNextButton:document.getElementById("findNext")},passwordOverlay:{overlayName:"passwordOverlay",container:document.getElementById("passwordOverlay"),label:document.getElementById("passwordText"),input:document.getElementById("password"),submitButton:document.getElementById("passwordSubmit"),cancelButton:document.getElementById("passwordCancel")},documentProperties:{overlayName:"documentPropertiesOverlay",container:document.getElementById("documentPropertiesOverlay"),closeButton:document.getElementById("documentPropertiesClose"),fields:{fileName:document.getElementById("fileNameField"),fileSize:document.getElementById("fileSizeField"),title:document.getElementById("titleField"),author:document.getElementById("authorField"),subject:document.getElementById("subjectField"),keywords:document.getElementById("keywordsField"),creationDate:document.getElementById("creationDateField"),modificationDate:document.getElementById("modificationDateField"),creator:document.getElementById("creatorField"),producer:document.getElementById("producerField"),version:document.getElementById("versionField"),pageCount:document.getElementById("pageCountField"),pageSize:document.getElementById("pageSizeField"),linearized:document.getElementById("linearizedField")}},errorWrapper:errorWrapper,printContainer:document.getElementById("printContainer"),openFileInputName:"fileInput",debuggerScriptPath:"./debugger.js"}),event=document.createEvent("CustomEvent");event.initCustomEvent("webviewerloaded",!0,!0,{source:window});try{parent.document.dispatchEvent(event)}catch(ex){console.error("webviewerloaded: ".concat(ex)),document.dispatchEvent(event)}_app.PDFViewerApplication.run(config)}window.PDFViewerApplication=_app.PDFViewerApplication,window.PDFViewerApplicationOptions=_app_options.AppOptions,__webpack_require__(41),__webpack_require__(47),document.blockUnblockOnload&&document.blockUnblockOnload(!0),"interactive"===document.readyState||"complete"===document.readyState?webViewerLoad():document.addEventListener("DOMContentLoaded",webViewerLoad,!0)})()})();
